# pyhmcode

This library provides a convenient interface to Alexander Mead's library, which underlies the HMCode and HMx codes to predict non-linear power spectra. For details on the Fortran version, refer to https://github.com/alexander-mead/HMcode.
The `pyhmcode` interface uses the excellent [f90wrap](https://github.com/jameskermode/f90wrap) library to generate the python interface. This allows access to virtually all functionality in the library, although to speed up compilation, the interface is limited to commonly-used subroutines.
If you use `pyhmcode`, please cite [Tröster, Mead et al. 2021]() and the relevant papers describing the model:
- HMCode2015: Mead et al. (2015; https://arxiv.org/abs/1505.07833)
- HMCode2016: Mead et al. (2016; https://arxiv.org/abs/1602.02154)
- HMCode2020: Mead et al. (2021; https://arxiv.org/abs/2009.01858)
- HMx: Mead, Tröster et al. (2020; https://arxiv.org/abs/2005.00009)

## Installation
`pyhmcode` is `pip`-installable, so
```
pip install pyhmcode
```
should do the trick. For more control over the installation and access to the alternative interface, as well as CosmoSIS support, the repository can be cloned with
```
git clone --recursive https://github.com/tilmantroester/pyhmcode
```

## Alternative interface and CosmoSIS support
There is an alternative interface to compute powerspectra in the `powerspectrum_interface` subdirectory. This interface uses `ctypes` and a thin Fortran wrapper to access the main functionality of HMCode and HMx, namely predicting the non-linear power spectra.
Installation proceeds by
```
cd powerspectrum_interface
pip install .
```
This installs the `pyhmx` python module, which in turn is interfaced with CosmoSIS using the `cosmosis_interface.py` module.

## Demos

The `notebooks` and `example` subdirectories include a number of examples on how to use the the interfaces. 
A basic example (from `examples/basic_example.py`) showing the use of `pyhmcode` to generate non-linear power specta, as well as its integration with CCL is shown below.
```python
import pyhmcode
import pyhmcode.halo_profile_utils

# We use CCL to generate the linear power spectrum
import pyccl as ccl

import numpy as np


ccl_cosmology = ccl.CosmologyVanillaLCDM()

k = np.logspace(-4, 1.5, 100)
a = np.linspace(1/(1+6), 1, 10)
z = 1/a - 1

pofk_lin = np.array([ccl.linear_matter_power(ccl_cosmology, k=k, a=a_)
                     for a_ in a])

# CCL uses units of Mpc, while pyhmcode uses Mpc/h. Hence we need to convert
# the units here.
h = ccl_cosmology["h"]
k = k/h
pofk_lin = pofk_lin * h**3

# Create the pyhmcode cosmology object. Beside the cosmology parameters, it
# also holds the linear power spectrum.
hmcode_cosmology = pyhmcode.halo_profile_utils.ccl2hmcode_cosmo(
                        ccl_cosmo=ccl_cosmology,
                        pofk_lin_k_h=k,
                        pofk_lin_z=z[::-1],
                        pofk_lin=pofk_lin[::-1],
                        log10_T_heat=7.8)

# Create the halo model object, which holds information on the specific halo
# model to use. E.g., the HMCode or HMx version.
hmcode_model = pyhmcode.Halomodel(
                    pyhmcode.HMx2020_matter_pressure_w_temp_scaling)

# Now we can compute the non-linear power spectrum, given the cosmology,
# halo model, and a list of fields.
hmcode_pofk = pyhmcode.calculate_nonlinear_power_spectrum(
                                    cosmology=hmcode_cosmology,
                                    halomodel=hmcode_model, 
                                    fields=[pyhmcode.field_matter,
                                            pyhmcode.field_electron_pressure])

# The output of calculate_nonlinear_power_spectrum has
# shape (n_field, n_field, n_z, n_k).
matter_matter_pofk = hmcode_pofk[0, 0]
matter_electron_pressure_pofk = hmcode_pofk[0, 1]

# We can also use the halo profiles from HMCode or HMx and use them in another
# halo model code.
profile_generator = pyhmcode.halo_profile_utils.HMxProfileGenerator(
                        hmcode_cosmology,
                        a_arr=a, k_arr=k,
                        fields=[pyhmcode.field_matter,
                                pyhmcode.field_cdm,
                                pyhmcode.field_electron_pressure],
                        add_diffuse=False)

# Here we use the halo profile in the CCL halo model framework. 
# First setup the CCL halo model specification
mass_def = ccl.halos.MassDef("vir", 'matter')
hmf = ccl.halos.MassFuncSheth99(ccl_cosmology, mass_def=mass_def,
                                mass_def_strict=False, use_delta_c_fit=True)
hbf = ccl.halos.HaloBiasSheth99(ccl_cosmology, mass_def=mass_def,
                                mass_def_strict=False, use_delta_c_fit=True)
hmc = ccl.halos.HMCalculator(ccl_cosmology, hmf, hbf, mass_def)

# Compute the CCL halo model power spectrum, using the halo profile from HMx
ccl_halomodel_pofk = ccl.halos.halomod_Pk2D(
                            cosmo=ccl_cosmology,
                            hmc=hmc, 
                            prof=profile_generator.matter_profile,
                            normprof1=False,
                            a_arr=a, lk_arr=np.log(k*h))
```

MODULE constants

   USE precision
   
   IMPLICIT NONE

   PUBLIC

   !!

   ! Mathematical constants
   REAL, PARAMETER :: pi = 3.14159265359_dp ! pi
   REAL, PARAMETER :: em = 0.5772156649_dp  ! Euler–Mascheroni
   REAL, PARAMETER :: zero = 0._dp          ! zero
   REAL, PARAMETER :: one = 1._dp           ! one
   REAL, PARAMETER :: degrees = 360._dp     ! Degrees in a circle

   ! Mathematical derived constants
   REAL, PARAMETER :: twopi = 2._dp*pi        ! 2pi or tau ~6.283
   REAL, PARAMETER :: rad2deg = degrees/twopi ! radians-to-degrees conversion
   REAL, PARAMETER :: deg2rad = 1._dp/rad2deg ! degress-to-radians conversion
   REAL, PARAMETER :: Riemann_3 = 1.202056903 ! Riemann Zeta function with n=3

   !!

   !!

   ! Physical constants in SI units
   REAL, PARAMETER :: kB = 1.38064852e-23_dp        ! Boltzmann constant [kg m^2 s^-2 K^-1]
   REAL, PARAMETER :: mp = 1.6726219e-27_dp         ! proton mass [kg]
   REAL, PARAMETER :: me = 9.10938356e-31_dp        ! electron mass [kg]
   REAL, PARAMETER :: bigG = 6.67408e-11_dp         ! Gravitational constant [kg^-1 m^3 s^-2]
   REAL, PARAMETER :: eV = 1.60218e-19_dp           ! electronvolt [kg m^2 s^-2]
   REAL, PARAMETER :: SBconst = 5.670367e-8_dp      ! Steffan-Boltzmann constant [kg s^-3 K^-4]
   REAL, PARAMETER :: c_light = 2.99792458e8_dp     ! speed of light [m/s]
   REAL, PARAMETER :: sigma_T = 6.6524587158e-29_dp ! Thompson-scatter cross section [m^2]
   REAL, PARAMETER :: h_Planck = 6.62607004e-34_dp  ! Planck constant [kg m^2/s]

   ! Derived physical constants in eV units
   REAL, PARAMETER :: mp_eV = mp*(c_light)**2/eV ! Proton rest mass in eV [~938 MeV]
   REAL, PARAMETER :: me_eV = me*(c_light)**2/eV ! Electron rest mass in eV [~511 keV]

   !!

   !!

   ! Astronomy constants
   REAL, PARAMETER :: au = 149597870700._dp  ! Astronomical unit [m] (https://en.wikipedia.org/wiki/Astronomical_unit)
   REAL, PARAMETER :: H0_cos = 100._dp       ! Hubble parameter [km s^-1 (Mpc/h)^-1]
   REAL, PARAMETER :: Msun = 1.98847e30_dp   ! Solar mass [kg] (https://en.wikipedia.org/wiki/Solar_mass)
   REAL, PARAMETER :: Jansky = 1e-26_dp      ! [W m^-2 Hz^-1 / Jy]

   ! Derived astronomy constants
   REAL, PARAMETER :: parsec = 60.*60.*180.*au/pi                          ! Parsec [m] ~3.086e16 m
   REAL, PARAMETER :: kpc = parsec*1e3                                     ! kpc [m] ~3.086e19 m
   REAL, PARAMETER :: Mpc = kpc*1e3                                        ! Mpc [m] ~3.086e22 m
   REAL, PARAMETER :: Gpc = Mpc*1e3                                        ! Gpc [m] ~3.086e25 m
   REAL, PARAMETER :: H0 = H0_cos*1e3/Mpc                                  ! Hubble constant [s^-1] ~3.241e-18 s^-1 (1e3 is km -> m)
   REAL, PARAMETER :: bigG_cos = bigG*Msun/(Mpc*1e3**2)                    ! Gravitational constant [(Msun/h)^-1 (km/s)^2 (Mpc/h)] ~4.301e-9 (1e3**2 m -> km)
   REAL, PARAMETER :: critical_density = 3.*H0**2/(8.*pi*bigG)             ! Critical density [h^2 kg/m^3] ~1.878e-26 [h^2 kg/m^3]
   REAL, PARAMETER :: critical_density_cos = 3.*H0_cos**2/(8.*pi*bigG_cos) ! Universal critical density at (equal to 3*H0^2 / 8piG) [(M_sun/h)/(Mpc/h)^3] ~2.776e11
   REAL, PARAMETER :: Hdist = c_light/(H0_cos*1e3)                         ! Hubble distance (c/H0) [Mpc/h] ~3000 Mpc/h (1e3 km -> m)
   REAL, PARAMETER :: Htime = 1./(H0*60.*60.*24.*365.25*1e9)               ! Hubble time (1/H0) [Gyr/h] ~9.78 Gyr/h
   REAL, PARAMETER :: yfac = sigma_T/(me*c_light**2)                       ! sigma_T/m_e*c^2 [kg^-1 s^2], prefactor of Compton-y integral over *pressure*
   REAL, PARAMETER :: dc0 = (3./20.)*(12.*pi)**(2./3.)                     ! Einstein-de Sitter linear collapse density ~1.686
   REAL, PARAMETER :: Dv0 = 18.*pi**2                                      ! Einsten-de Sitter virialised collapse threshold ~178
   
   !!

END MODULE constants

MODULE HOD_functions

   USE basic_operations
   USE array_operations
   USE special_functions
   USE random_numbers

   IMPLICIT NONE

   PRIVATE

   ! Type
   PUBLIC :: hodmod

   ! Theory
   PUBLIC :: assign_HOD
   PUBLIC :: mean_centrals
   PUBLIC :: mean_satellites
   PUBLIC :: mean_galaxies
   PUBLIC :: variance_centrals
   PUBLIC :: variance_satellites
   PUBLIC :: covariance_centrals_satellites
   PUBLIC :: variance_galaxies

   ! Realisation
   !PUBLIC :: random_number_of_centrals
   !PUBLIC :: random_number_of_satellites
   PUBLIC :: random_number_of_galaxies

   ! HOD models
   PUBLIC :: ihod_toy
   PUBLIC :: ihod_toy_int
   PUBLIC :: ihod_toy_noscatter
   PUBLIC :: ihod_Zehavi
   PUBLIC :: ihod_Zheng
   PUBLIC :: ihod_Zhai

   ! Type for HOD
   TYPE hodmod
      INTEGER :: ihod
      REAL :: Mmin, Mmax
      REAL :: M0, M1, Mcen, Mcut, sigma, alpha
      INTEGER :: stats_cen, stats_sat
   END TYPE hodmod

   ! Statistical models
   INTEGER, PARAMETER :: stats_delta = 0           ! Delta function statistics
   INTEGER, PARAMETER :: stats_Bernoulli = 1       ! Bernoulli statistics (central galaxies if only 0 or 1 possible)
   INTEGER, PARAMETER :: stats_Poisson = 2         ! Poisson statistics (usual for satellite galaxies)
   INTEGER, PARAMETER :: stats_Poisson_central = 3 ! Modified Poisson via central condition

   ! Defaults
   REAL, PARAMETER :: Mmin_def = 1e7
   REAL, PARAMETER :: Mmax_def = 1e17
   REAL, PARAMETER :: Mcen_def = 1e13
   REAL, PARAMETER :: sigma_def = 0.5
   REAL, PARAMETER :: M0_def = Mcen_def
   REAL, PARAMETER :: M1_def = Mcen_def
   REAL, PARAMETER :: alpha_def = 1.
   REAL, PARAMETER :: Mcut_def = 1e14

   ! Satellite occupation
   REAL, PARAMETER :: eps_sat = 1e-6

   ! HOD models
   INTEGER, PARAMETER :: ihod_Zehavi = 1        ! Zehavi et al. (2005; https://arxiv.org/abs/astro-ph/0408569)
   INTEGER, PARAMETER :: ihod_Zheng = 2         ! Zheng et al. (2005; https://arxiv.org/abs/astro-ph/0408564)
   INTEGER, PARAMETER :: ihod_toy = 3           ! Toy model
   INTEGER, PARAMETER :: ihod_toy_int = 4       ! Toy model with integer numbers of galaxies
   INTEGER, PARAMETER :: ihod_toy_noscatter = 5 ! Toy model with integer numbers of galaxies and no scatter
   INTEGER, PARAMETER :: ihod_Zhai = 6          ! Zhai et al. (2017; https://arxiv.org/abs/1607.05383)

   CONTAINS

   SUBROUTINE assign_HOD(ihod, hod)

      ! Assign a halo-occupation model
      INTEGER, INTENT(IN) :: ihod      ! Integer to choose model
      TYPE(hodmod), INTENT(OUT) :: hod ! HOD model

      ! Set HOD model
      IF (ihod == -1) THEN
         WRITE(*, *) '1 - Zehavi et al. (2005)'
         WRITE(*, *) '2 - Zheng et al. (2005)'
         WRITE(*, *) '3 - Toy HOD'
         WRITE(*, *) '4 - Toy HOD with no scatter'
         WRITE(*, *) '5 - Toy HOD'
         WRITE(*, *) '6 - Zhai et al. (2017)'
         READ(*, *) hod%ihod
      ELSE
         hod%ihod = ihod
      END IF

      ! Set the statistical models for the distribution of central and satellite galaxies
      hod%stats_cen = stats_Bernoulli
      hod%stats_sat = stats_Poisson_central

      ! Minimum and maximum halo masses to host a galaxy
      hod%Mmin = Mmin_def
      hod%Mmax = Mmax_def

      ! Default HOD parameters
      hod%Mcen = Mcen_def
      hod%sigma = sigma_def
      hod%M0 = M0_def
      hod%M1 = M1_def
      hod%alpha = alpha_def
      hod%Mcut = Mcut_def

      ! Set specific HOD model parameters
      IF (hod%ihod == ihod_toy_noscatter) hod%stats_sat = stats_delta

   END SUBROUTINE assign_HOD

   REAL FUNCTION mean_centrals(M, hod)

      ! Mean number of central galaxies in a halo
      ! Note that this is the mean, not necessarily 0 or 1, but should (probably) be between 0 and 1
      REAL, INTENT(IN) :: M           ! Halo mass [Msun/h]
      TYPE(hodmod), INTENT(IN) :: hod ! HOD model

      IF (between(M, hod%Mmin, hod%Mmax)) THEN
         IF (is_in_array(hod%ihod, [ihod_Zheng, ihod_Zhai])) THEN
            IF (hod%sigma == 0.) THEN
               mean_centrals = Heaviside(M-hod%Mcen, 1.)
            ELSE
               mean_centrals = 0.5*(1.+erf(log10(M/hod%Mcen)/hod%sigma)) ! Weird combination of erf with log10
            END IF
         ELSE IF (is_in_array(hod%ihod, [ihod_Zehavi, ihod_toy, ihod_toy_int, ihod_toy_noscatter])) THEN
            mean_centrals = Heaviside(M-hod%Mcen, 1.) ! mean_centrals is only ever 0 or 1 in these HOD models
         ELSE
            STOP 'MEAN_CENTRALS: Error, HOD not recognised'
         END IF
      ELSE
         mean_centrals = 0.
      END IF

   END FUNCTION mean_centrals

   REAL FUNCTION mean_satellites(M, hod)

      ! Mean number of satellite galaxies in a halo
      ! Note that this is not an integer in general
      ! Note that this may be reduced from the expectation from the HOD if the central condition is imposed
      REAL, INTENT(IN) :: M            ! Halo mass [Msun/h]
      TYPE(hodmod), INTENT(IN) :: hod  ! HOD model
      REAL, PARAMETER :: eps = eps_sat ! To stop negative values: TODO: Necessary?

      IF (between(M, hod%Mmin, hod%Mmax)) THEN
         IF (hod%ihod == ihod_Zehavi) THEN
            mean_satellites = (M/hod%M1)**hod%alpha
         ELSE IF (hod%ihod == ihod_Zheng) THEN
            ! No satellite galaxies if M < M0
            ! It is annoying that the denominator is not M1-M0
            mean_satellites = Heaviside(M-hod%M0)*((M-hod%M0)/hod%M1)**hod%alpha
         ELSE IF (hod%ihod == ihod_Zhai) THEN
            mean_satellites = ((M/hod%M1)**hod%alpha)*exp(-hod%Mcut/M)
         ELSE IF (is_in_array(hod%ihod, [ihod_toy, ihod_toy_int, ihod_toy_noscatter])) THEN
            mean_satellites = M/hod%M1
            IF (is_in_array(hod%ihod, [ihod_toy_int, ihod_toy_noscatter])) mean_satellites = floor(mean_satellites)
         ELSE
            STOP 'MEAN_SATELLITES: Error, HOD not recognised'
         END IF
      ELSE
         mean_satellites = 0.
      END IF

      ! Note very carefully this in this case the mean you get from the standard HOD is *not* the actual mean
      ! The actual mean is always less; this is very important
      IF (hod%stats_sat == stats_Poisson_central) mean_satellites = mean_satellites*mean_centrals(M, hod)

   END FUNCTION mean_satellites

   REAL FUNCTION mean_galaxies(M, hod)

      ! Mean number of galaxies in a halo
      ! Calculated as the sum of the means of central and satellite galaxies
      REAL, INTENT(IN) :: M           ! Halo mass [Msun/h]
      TYPE(hodmod), INTENT(IN) :: hod ! HOD model

      mean_galaxies = mean_centrals(M, hod)+mean_satellites(M, hod)

   END FUNCTION mean_galaxies

   REAL FUNCTION variance_centrals(M, hod)

      ! Variance in the number of central galaxies in a halo
      REAL, INTENT(IN) :: M           ! Halo mass [Msun/h]
      TYPE(hodmod), INTENT(IN) :: hod ! HOD model
      REAL :: p

      p = mean_centrals(M, hod)
      IF (p .NE. 0.) THEN
         IF (hod%stats_cen == stats_delta) THEN
            variance_centrals = 0.
         ELSE IF (hod%stats_cen == stats_Bernoulli) THEN
            ! Variance for a Bernoulli distribution is p-p^2
            ! If p = 1 or p = 0 then the variance is automatically 0, as expected  
            variance_centrals = p*(1.-p)
         ELSE
            STOP 'VARIANCE_CENTRALS: Error, central statistics not recognised'
         END IF
      ELSE
         variance_centrals = 0.
      END IF

   END FUNCTION variance_centrals

   REAL FUNCTION variance_satellites(M, hod)

      ! Variance in the number of satellite galaxies in a halo
      REAL, INTENT(IN) :: M           ! Halo mass [Msun/h]
      TYPE(hodmod), INTENT(IN) :: hod ! HOD model
      REAL :: p, lam, lam_old

      lam = mean_satellites(M, hod)
      IF (lam .NE. 0.) THEN
         IF (hod%stats_sat == stats_delta) THEN
            variance_satellites = 0.
         ELSE IF (hod%stats_sat == stats_Poisson) THEN
            variance_satellites = lam ! Variance for a Poisson distribution is equal to the mean
         ELSE IF (hod%stats_sat == stats_Poisson_central) THEN
            p = mean_centrals(M, hod)
            IF (p == 0.) THEN
               variance_satellites = 0.
            ELSE
               lam_old = lam/p ! Mean of underlying Poisson distribution
               variance_satellites = p*lam_old*(1.+lam_old*(1.-p)) ! See notes; if Nc=1 then this is Poisson result
            END IF
         ELSE
            STOP 'VARIANCE_SATELLITES: Error, satellite statistics not recognised'
         END IF
      ELSE
         variance_satellites = 0.
      END IF

   END FUNCTION variance_satellites

   REAL FUNCTION covariance_centrals_satellites(M, hod)

      ! Covariance between the number of central and satellite galaxies in a halo
      REAL, INTENT(IN) :: M           ! Halo mass [Msun/h]
      TYPE(hodmod), INTENT(IN) :: hod ! HOD model
      REAL :: p, lam, lam_old

      IF (hod%stats_sat == stats_Poisson_central) THEN
         p = mean_centrals(M, hod)
         lam = mean_satellites(M, hod)
         IF (p /= 0.) THEN
            lam_old = lam/p ! Mean of underlying Poisson distribution
            covariance_centrals_satellites = lam_old*(1.-p)
         ELSE
            covariance_centrals_satellites = 0.
         END IF
      ELSE
         covariance_centrals_satellites = 0.
      END IF

   END FUNCTION covariance_centrals_satellites

   REAL FUNCTION variance_galaxies(M, hod)

      ! Variance in the total number of galaxies in a halo
      ! Ignores any possible covariance between the number of centrals and number of satellites
      REAL, INTENT(IN) :: M           ! Halo mass [Msun/h]
      TYPE(hodmod), INTENT(IN) :: hod ! HOD model

      variance_galaxies = variance_centrals(M, hod)+variance_satellites(M, hod)
      variance_galaxies = variance_galaxies+2.*covariance_centrals_satellites(M, hod)

   END FUNCTION variance_galaxies

   SUBROUTINE random_number_of_galaxies(Nc, Ns, M, hod)

      ! Draw random numbers of central and satellite galaxies
      ! This must be done jointly if the central condition is to be imposed
      INTEGER, INTENT(OUT) :: Nc, Ns  ! Numbers of central and satellite galaxies
      REAL, INTENT(IN) :: M           ! Halo mass [Msun/h]
      TYPE(hodmod), INTENT(IN) :: hod ! HOD model
      REAL :: p, lam, lam_old

      p = mean_centrals(M, hod)
      IF (hod%stats_cen == stats_delta) THEN
         Nc = nint(p)
      ELSE IF (hod%stats_cen == stats_Bernoulli) THEN
         Nc = random_Bernoulli(p)
      ELSE
         STOP 'RANDOM_NUMBER_OF_GALAXIES: Error, central statistics not recognised'
      END IF

      lam = mean_satellites(M, hod)
      IF (hod%stats_sat == stats_delta) THEN
         Ns = nint(lam)
      ELSE IF (hod%stats_sat == stats_Poisson) THEN
         Ns = random_Poisson(lam)
      ELSE IF (hod%stats_sat == stats_Poisson_central) THEN
         IF (p == 0) THEN
            Ns = 0 ! Central condition
         ELSE
            lam_old = lam/p ! Mean of the underlying Poisson distribution
            Ns = random_Poisson(lam_old) ! Use underlying mean here, which is *not* the actual mean of the distribution
         END IF
      ELSE
         STOP 'RANDOM_NUMBER_OF_GALAXIES: Error, satellite statistics not recognised'
      END IF

   END SUBROUTINE random_number_of_galaxies

   ! INTEGER FUNCTION random_number_of_centrals(M, hod)

   !    ! Draw from the random distribution to get a number of central galaxies in a halo
   !    ! This should probably be either 0 or 1
   !    REAL, INTENT(IN) :: M           ! Halo mass [Msun/h]
   !    TYPE(hodmod), INTENT(IN) :: hod ! HOD model
   !    REAL :: Nc, Ns

   !    !mean = mean_centrals(M, hod)
   !    !IF (hod%stats_cen == stats_delta) THEN
   !    !   random_number_of_centrals = nint(mean)
   !    !ELSE IF (hod%stats_cen == stats_Bernoulli) THEN
   !    !   random_number_of_centrals = random_Bernoulli(mean)
   !    !ELSE
   !    !   STOP 'RANDOM_NUMBER_OF_CENTRALS: Error, central statistics not recognised'
   !    !END IF
   !    CALL draw_random_number_of_galaxies(Nc, Ns, M, hod)
   !    random_number_of_satellites = Nc

   ! END FUNCTION random_number_of_centrals

   ! INTEGER FUNCTION random_number_of_satellites(M, hod)

   !    ! Draw from the random distribution to get a number of satellite galaxies in a halo
   !    REAL, INTENT(IN) :: M           ! Halo mass [Msun/h]
   !    TYPE(hodmod), INTENT(IN) :: hod ! HOD model
   !    REAL :: Nc, Ns

   !    !mean = mean_satellites(M, hod)
   !    !IF (hod%stats_sat == stats_delta) THEN
   !    !   random_number_of_satellites = nint(mean)
   !    !ELSE IF (hod%stats_sat == stats_Poisson) THEN
   !    !   random_number_of_satellites = random_Poisson(mean)
   !    !ELSE IF (hod%stats_sat == stats_Poisson_central) THEN
   !    !   STOP 'RANDOM_NUMBER_OF_SATELLITES: Error, if the central condition is imposed you must jointly draw central and satellite galaxies'
   !    !ELSE
   !    !   STOP 'RANDOM_NUMBER_OF_SATELLITES: Error, satellite statistics not recognised'
   !    !END IF
   !    CALL draw_random_number_of_galaxies(Nc, Ns, M, hod)
   !    random_number_of_satellites = Ns

   ! END FUNCTION random_number_of_satellites

   ! INTEGER FUNCTION random_number_of_galaxies(M, hod)

   !    ! Draw from the random distribution to get a total number of galaxies in a halo
   !    REAL, INTENT(IN) :: M           ! Halo mass [Msun/h]
   !    TYPE(hodmod), INTENT(IN) :: hod ! HOD model
   !    INTEGER :: Nc, Ns

   !    !Nc = random_number_of_centrals(M, hod)
   !    !Ns = random_number_of_satellites(M, hod)
   !    CALL draw_random_number_of_galaxies(Nc, Ns, M, hod)
   !    random_number_of_galaxies = Nc+Ns

   ! END FUNCTION random_number_of_galaxies

END MODULE HOD_functions

MODULE array_operations

   USE basic_operations

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: insert_in_array
   PUBLIC :: within_array
   PUBLIC :: swap_arrays
   PUBLIC :: append
   PUBLIC :: add_to_array
   PUBLIC :: splay
   PUBLIC :: write_array_list
   PUBLIC :: repeated_entries
   PUBLIC :: array_position
   PUBLIC :: reverse_array
   PUBLIC :: remove_array_element
   PUBLIC :: array_positions
   PUBLIC :: amputate_array
   PUBLIC :: unique_index
   PUBLIC :: reduce_array
   PUBLIC :: fill_pixels
   PUBLIC :: binning
   PUBLIC :: merge_arrays
   PUBLIC :: create_mask
   PUBLIC :: apply_mask
   PUBLIC :: smooth_array_tophat
   PUBLIC :: smooth_array_Gaussian
   PUBLIC :: if_allocated_deallocate
   PUBLIC :: regular_spacing
   PUBLIC :: safe_allocate
   PUBLIC :: greater_than_all
   PUBLIC :: greater_than_any
   PUBLIC :: is_in_array
   PUBLIC :: integer_sequence
   PUBLIC :: unique_entries
   PUBLIC :: number_of_appearances
   PUBLIC :: remove_repeated_array_elements
   PUBLIC :: remove_repeated_two_array_elements
   PUBLIC :: fill_array
   PUBLIC :: fill_array_log ! TODO: Remove
   PUBLIC :: outside_array_range
   PUBLIC :: sum_logical
   PUBLIC :: monotonic_array

   INTERFACE is_in_array
      MODULE PROCEDURE is_in_array_integer
      MODULE PROCEDURE is_in_array_character
   END INTERFACE is_in_array

   INTERFACE array_position
      MODULE PROCEDURE array_position_int
      MODULE PROCEDURE array_position_real
   END INTERFACE array_position

   INTERFACE add_to_array
      MODULE PROCEDURE add_to_array_2D
      MODULE PROCEDURE add_to_array_3D
   END INTERFACE add_to_array

   INTERFACE reverse_array
      MODULE PROCEDURE reverse_array_1D
      MODULE PROCEDURE reverse_array_2D
      MODULE PROCEDURE reverse_array_3D
   END INTERFACE reverse_array

   INTERFACE splay
      PROCEDURE splay_2D
      PROCEDURE splay_3D
   END INTERFACE splay

   INTERFACE write_array_list
      PROCEDURE write_array_list_real
      PROCEDURE write_2array_list_real
      PROCEDURE write_array2D_list_real
      PROCEDURE write_array_list_int
   END INTERFACE write_array_list

   INTERFACE apply_mask
      PROCEDURE apply_mask_1D
      PROCEDURE apply_mask_2D
   END INTERFACE apply_mask

   INTERFACE if_allocated_deallocate
      PROCEDURE if_allocated_deallocate_real_1D
      PROCEDURE if_allocated_deallocate_real_2D
      PROCEDURE if_allocated_deallocate_real_3D
      PROCEDURE if_allocated_deallocate_integer_1D
      PROCEDURE if_allocated_deallocate_logical_1D
      PROCEDURE if_allocated_deallocate_character_1D
   END INTERFACE if_allocated_deallocate

   INTERFACE safe_allocate
      PROCEDURE safe_allocate_real
      PROCEDURE safe_allocate2_real
      PROCEDURE safe_allocate_integer
      PROCEDURE safe_allocate_logical
      PROCEDURE safe_allocate_character
   END INTERFACE safe_allocate

   INTERFACE remove_array_element
      PROCEDURE remove_array_element_real
      PROCEDURE remove_array_element_int
   END INTERFACE remove_array_element

   INTERFACE amputate_array
      PROCEDURE amputate_array_real
      PROCEDURE amputate_array_int
   END INTERFACE amputate_array

   INTERFACE concatenate_arrays
      PROCEDURE concatenate_arrays_real
      PROCEDURE concatenate_arrays_int
   END INTERFACE concatenate_arrays

CONTAINS

   LOGICAL FUNCTION monotonic_array(x)

      ! Returns true if sequential array entries are monotonically increasing (or equal) from low to high
      REAL, INTENT(IN) :: x(:)
      INTEGER :: i

      monotonic_array = .TRUE.
      DO i = 1, size(x)-1
         IF (x(i+1) < x(i)) THEN
            monotonic_array = .FALSE.
            EXIT
         END IF
      END DO

   END FUNCTION monotonic_array

   LOGICAL FUNCTION outside_array_range(x, xtab)

      ! Assumes xtab is an array of x values going from low to high
      ! Returns TRUE if x is outside the range of xtab (either low or high) and FALSE if within
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xtab(:)

      IF (x < xtab(1) .OR. x > xtab(size(xtab))) THEN
         outside_array_range = .TRUE.
      ELSE
         outside_array_range = .FALSE.
      END IF

   END FUNCTION outside_array_range

   SUBROUTINE insert_in_array(x, i, a)

      REAL, INTENT(IN) :: x                    ! Value to insert
      INTEGER, INTENT(IN) :: i                 ! Position to insert
      REAL, ALLOCATABLE, INTENT(INOUT) :: a(:) ! Array in which to insert
      REAL, ALLOCATABLE :: b(:)
      INTEGER :: j, n
      
      n = size(a)
      IF(i < 1 .OR. i > n) THEN
         STOP 'INSERT_IN_ARRAY: Error, integer is outside array'
      END IF
      ALLOCATE(b(n))
      b = a
      DEALLOCATE(a)
      ALLOCATE(a(n+1))

      DO j = 1, n+1
         IF (j < i) THEN
            a(j) = b(j)
         ELSE IF (j == i) THEN
            a(j) = x
         ELSE IF (j > i) THEN
            a(j) = b(j-1)
         END IF
      END DO

   END SUBROUTINE insert_in_array

   LOGICAL FUNCTION greater_than_any(x, a)

      ! Returns TRUE if x is greater than any one of the values in array
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: a(:)
      INTEGER :: i, n

      n = size(a)

      STOP 'GREATER_THAN_ANY: Test this'

      greater_than_any = .FALSE.
      DO i = 1, n
         IF(x > a(i)) THEN
            greater_than_any = .TRUE.
            EXIT
         END IF
      END DO

   END FUNCTION greater_than_any

   LOGICAL FUNCTION greater_than_all(x, a)

      ! Returns TRUE if x is greater than all of the values in array
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: a(:)
      INTEGER :: i, n

      STOP 'GREATER_THAN_ALL: Test this'

      greater_than_all = .TRUE.
      DO i = 1, n
         IF(x <= a(i)) THEN
            greater_than_all = .FALSE.
            EXIT
         END IF
      END DO

   END FUNCTION greater_than_all

   SUBROUTINE safe_allocate_real(x, n)

      ! Checks array for allocation status, deallocates if necessary, then allocates
      REAL, ALLOCATABLE, INTENT(INOUT) :: x(:)
      INTEGER, INTENT(IN) :: n

      CALL if_allocated_deallocate(x)
      ALLOCATE(x(n))

   END SUBROUTINE safe_allocate_real

   SUBROUTINE safe_allocate2_real(x, nx, ny)

      ! Checks array for allocation status, deallocates if necessary, then allocates
      REAL, ALLOCATABLE, INTENT(INOUT) :: x(:, :)
      INTEGER, INTENT(IN) :: nx
      INTEGER, INTENT(IN) :: ny

      CALL if_allocated_deallocate(x)
      ALLOCATE(x(nx, ny))

   END SUBROUTINE safe_allocate2_real

   SUBROUTINE safe_allocate_integer(i, n)

      ! Checks array for allocation status, deallocates if necessary, then allocates
      INTEGER, ALLOCATABLE, INTENT(INOUT) :: i(:)
      INTEGER, INTENT(IN) :: n

      CALL if_allocated_deallocate(i)
      ALLOCATE(i(n))

   END SUBROUTINE safe_allocate_integer

   SUBROUTINE safe_allocate_logical(l, n)

      ! Checks array for allocation status, deallocates if necessary, then allocates
      LOGICAL, ALLOCATABLE, INTENT(INOUT) :: l(:)
      INTEGER, INTENT(IN) :: n

      CALL if_allocated_deallocate(l)
      ALLOCATE(l(n))

   END SUBROUTINE safe_allocate_logical

   SUBROUTINE safe_allocate_character(c, n)

      ! Checks array for allocation status, deallocates if necessary, then allocates
      CHARACTER(len=*), ALLOCATABLE, INTENT(INOUT) :: c(:)
      INTEGER, INTENT(IN) :: n

      CALL if_allocated_deallocate(c)
      ALLOCATE(c(n))

   END SUBROUTINE safe_allocate_character

   SUBROUTINE if_allocated_deallocate_real_1D(x)

      ! Deallocates an array if it is already allocated
      REAL, ALLOCATABLE, INTENT(INOUT) :: x(:)

      IF(allocated(x)) DEALLOCATE(x)

   END SUBROUTINE if_allocated_deallocate_real_1D

   SUBROUTINE if_allocated_deallocate_real_2D(x)

      ! Deallocates an array if it is already allocated
      REAL, ALLOCATABLE, INTENT(INOUT) :: x(:, :)

      IF(allocated(x)) DEALLOCATE(x)

   END SUBROUTINE if_allocated_deallocate_real_2D

   SUBROUTINE if_allocated_deallocate_real_3D(x)

      ! Deallocates an array if it is already allocated
      REAL, ALLOCATABLE, INTENT(INOUT) :: x(:, :, :)

      IF(allocated(x)) DEALLOCATE(x)

   END SUBROUTINE if_allocated_deallocate_real_3D

   SUBROUTINE if_allocated_deallocate_integer_1D(i)

      ! Deallocates an array if it is already allocated
      INTEGER, ALLOCATABLE, INTENT(INOUT) :: i(:)

      IF(allocated(i)) DEALLOCATE(i)

   END SUBROUTINE if_allocated_deallocate_integer_1D

   SUBROUTINE if_allocated_deallocate_logical_1D(l)

      ! Deallocates an array if it is already allocated
      LOGICAL, ALLOCATABLE, INTENT(INOUT) :: l(:)

      IF(allocated(l)) DEALLOCATE(l)

   END SUBROUTINE if_allocated_deallocate_logical_1D

   SUBROUTINE if_allocated_deallocate_character_1D(c)

      ! Deallocates an array if it is already allocated
      CHARACTER(len=*), ALLOCATABLE, INTENT(INOUT) :: c(:)

      IF(allocated(c)) DEALLOCATE(c)

   END SUBROUTINE if_allocated_deallocate_character_1D

   SUBROUTINE smooth_array_tophat(x, f, dx)

      ! Take an array f(x) and smooth it over a fixed width in x
      REAL, INTENT(IN) :: x(:)    ! x coordinates
      REAL, INTENT(INOUT) :: f(:) ! Array to smooth
      REAL, INTENT(IN) :: dx      ! Half-width of top hat
      INTEGER :: i, j, n
      REAL, ALLOCATABLE :: ff(:)
      REAL :: total, weight

      IF (dx .NE. 0.) THEN

         n = size(x)
         IF (n /= size(f)) STOP 'GAUSSIAN_SMOOTH_ARRAY: Error, x and y should be the same size'

         ! Save the original input array
         ff = f

         ! Delete the original array
         f = 0.

         ! Apply top-hat smoothing
         DO i = 1, n
            total = 0.
            IF (abs(x(i)-x(1)) < dx .OR. abs(x(i)-x(n)) < dx) THEN
               f(i) = ff(i)
            ELSE
               DO j = 1, n
                  IF (abs(x(i)-x(j)) < dx) THEN
                     weight = 1.
                  ELSE
                     weight = 0.
                  END IF
                  f(i) = f(i)+ff(j)*weight
                  total = total+weight
               END DO
               f(i) = f(i)/total
            END IF
         END DO

         DEALLOCATE(ff)

      END IF

   END SUBROUTINE smooth_array_tophat

   SUBROUTINE smooth_array_Gaussian(x, f, sigma)

      ! Smooth an array f(x) using a Gaussian kernel
      REAL, INTENT(IN) :: x(:)    ! x coordinates
      REAL, INTENT(INOUT) :: f(:) ! Array to smooth
      REAL, INTENT(IN) :: sigma   ! Width of smoothing Gaussian
      INTEGER :: i, j, n
      REAL, ALLOCATABLE :: ff(:)
      REAL :: weight, total
      REAL, PARAMETER :: nsig = 3. ! Do not smooth if point lies within this number of sigma from edge

      IF (sigma  .NE. 0.) THEN

         n = size(x)
         IF (n /= size(f)) STOP 'GAUSSIAN_SMOOTH_ARRAY: Error, x and y should be the same size'

         ! Save the original input array
         ff = f

         ! Delete the original array
         f = 0.

         ! Apply Gaussian smoothing
         DO i = 1, n
            total = 0.
            IF (abs(x(i)-x(1)) < nsig*sigma .OR. abs(x(i)-x(n)) < nsig*sigma) THEN
               f(i) = ff(i)
            ELSE
               DO j = 1, n
                  weight = exp(-(x(i)-x(j))**2/(2.*sigma**2))
                  f(i) = f(i)+ff(j)*weight
                  total = total+weight
               END DO
               f(i) = f(i)/total
            END IF
         END DO

         DEALLOCATE(ff)

      END IF

   END SUBROUTINE smooth_array_Gaussian

   LOGICAL FUNCTION within_array(x, a)

      ! Checks to see if x falls within the range of values in array a
      REAL, INTENT(IN) :: x    ! Value to check
      REAL, INTENT(IN) :: a(:) ! Array (of x values, presumably)
      INTEGER :: n

      n = size(a)

      IF (x >= minval(a) .AND. x <= maxval(a)) THEN
         within_array = .TRUE.
      ELSE
         within_array = .FALSE.
      END IF

   END FUNCTION within_array

   SUBROUTINE swap_arrays(x, y)

      ! Swap arrays x<->y in a memory-efficient way
      ! Only one excess real number is ever stored
      REAL, INTENT(INOUT) :: x(:) ! Array 1
      REAL, INTENT(INOUT) :: y(:) ! Array 2
      INTEGER :: i, n
      REAL :: h

      n = size(x)
      IF (n /= size(y)) STOP 'SWAP_ARRAYS: Error, input arrays are different sizes'

      ! Loop over array and swap element by element
      DO i = 1, n
         h = x(i)
         x(i) = y(i)
         y(i) = h
      END DO

   END SUBROUTINE swap_arrays

   SUBROUTINE append(x, a)

      ! Append value b to the end of array a(n) to make a new array a(n+1)
      INTEGER, INTENT(IN) :: x
      INTEGER, ALLOCATABLE, INTENT(INOUT) :: a(:)    
      INTEGER, ALLOCATABLE :: hold(:)
      INTEGER :: i, n

      n = size(a)
      ALLOCATE(hold(n))

      hold = a
      DEALLOCATE (a)
      ALLOCATE (a(n+1))

      DO i = 1, n
         a(i) = hold(i)
      END DO
      a(n+1) = x

   END SUBROUTINE append

   SUBROUTINE add_to_array_2D(a, v, i)

      ! Add value 'v' to array 'a' at location 'i' in array
      ! If 'i' is outside the array range then this routine does nothing
      REAL, INTENT(INOUT) :: a(:, :) 
      REAL, INTENT(IN) :: v
      INTEGER, INTENT(IN) :: i(2)
      INTEGER :: j
      LOGICAL :: bin
      INTEGER, PARAMETER :: dim = 2

      bin = .TRUE.
      DO j = 1, dim
         IF (i(j) < 1 .OR. i(j) > size(a, j)) THEN
            bin = .FALSE.
            EXIT
         END IF
      END DO

      IF (bin) a(i(1), i(2)) = a(i(1), i(2))+v

   END SUBROUTINE add_to_array_2D

   SUBROUTINE add_to_array_3D(a, v, i)

      ! Add value 'v' to array 'a' at location 'i' in array
      ! If 'i' is outside the array range then this routine does nothing
      REAL, INTENT(INOUT) :: a(:, :, :)
      REAL, INTENT(IN) :: v
      INTEGER, INTENT(IN) :: i(3)
      INTEGER :: j
      LOGICAL :: bin
      INTEGER, PARAMETER :: dim = 3

      bin = .TRUE.
      DO j = 1, dim
         IF (i(j) < 1 .OR. i(j) > size(a, j)) THEN
            bin = .FALSE.
            EXIT
         END IF
      END DO

      IF (bin) a(i(1), i(2), i(3)) = a(i(1), i(2), i(3))+v

   END SUBROUTINE add_to_array_3D

   INTEGER FUNCTION array_position_int(x, a)

      ! Returns the location in a(n) of value x
      ! If x is not in array then returns zero
      INTEGER, INTENT(IN) :: x    ! Value to check if it is in array
      INTEGER, INTENT(IN) :: a(:) ! Array to check
      INTEGER :: i, n

      n = size(a)

      array_position_int = 0

      DO i = 1, n
         IF (a(i) == x) THEN
            array_position_int = i
            EXIT
         END IF
      END DO

   END FUNCTION array_position_int

   INTEGER FUNCTION array_position_real(x, a, eps)

      ! Returns the location in a(n) of value x
      ! If x is not in array then returns zero
      REAL, INTENT(IN) :: x    ! Value to check if it is in array
      REAL, INTENT(IN) :: a(:) ! Array to check
      REAL, INTENT(IN) :: eps  ! Difference to tolerate
      INTEGER :: i, n

      n = size(a)

      array_position_real = 0

      DO i = 1, n
         IF(requal(x, a(i), eps)) THEN
            array_position_real = i
            EXIT
         END IF
      END DO

   END FUNCTION array_position_real

   INTEGER FUNCTION number_of_appearances(x, a)

      ! Returns the number of appearances in a(n) of value x
      ! If x is not in a(n) then returns zero
      INTEGER, INTENT(IN) :: x    ! Value to check if it is in array
      INTEGER, INTENT(IN) :: a(:) ! Array to check
      INTEGER :: i, n

      n = size(a)

      number_of_appearances = 0

      DO i = 1, n
         IF (a(i) == x) THEN
            number_of_appearances = number_of_appearances+1
         END IF
      END DO

   END FUNCTION number_of_appearances

   SUBROUTINE array_positions(x, a, b, m)

      ! Returns the locations in the array of integer value x
      ! If x is not in array then returns zero
      INTEGER, INTENT(IN) :: x    ! Value to check if it is in array
      INTEGER, INTENT(IN) :: a(:) ! Array to check
      INTEGER, ALLOCATABLE, INTENT(OUT) :: b(:)
      INTEGER, INTENT(OUT) :: m
      INTEGER :: i, p, n

      n = size(a)

      m = number_of_appearances(x, a)
      ALLOCATE (b(m))

      p = 0
      DO i = 1, n
         IF (a(i) == x) THEN
            p = p+1
            b(p) = i
         END IF
      END DO

   END SUBROUTINE array_positions

   SUBROUTINE amputate_array_real(a, i1, i2)

      ! Chop an array of size a(n) down to a smaller size demarked by indices i1, i2
      ! If i1=1 and i2=n then this does nothing
      REAL, ALLOCATABLE, INTENT(INOUT) :: a(:)
      INTEGER, INTENT(IN) :: i1
      INTEGER, INTENT(IN) :: i2
      REAL, ALLOCATABLE :: b(:)
      INTEGER :: i, m, n

      IF (.NOT. allocated(a)) STOP 'AMPUTATE_ARRAY: Error, array a must be initially allocated'
      n = size(a)

      IF (i2 < i1) THEN
         STOP 'AMPUTATE: Error, i2 should be greater than i1'
      END IF

      m = i2-i1+1
      IF (n < m) THEN
         STOP 'AMPUTATE: Error, new array should be smaller than the old one'
      END IF

      ! Store input array and then deallocate
      ALLOCATE (b(n))
      b = a
      DEALLOCATE (a)

      ! Allocate new output array
      ALLOCATE (a(m))

      ! Fill new output array
      DO i = 1, m
         a(i) = b(i+i1-1)
      END DO

      ! Deallocate holding array
      DEALLOCATE (b)

   END SUBROUTINE amputate_array_real

   SUBROUTINE amputate_array_int(a, i1, i2)

      ! Chop an array of size a(n) down to a smaller size demarked by indices i1, i2
      ! If i1=1 and i2=n then this does nothing
      INTEGER, ALLOCATABLE, INTENT(INOUT) :: a(:)
      INTEGER, INTENT(IN) :: i1
      INTEGER, INTENT(IN) :: i2
      INTEGER, ALLOCATABLE :: b(:)
      INTEGER :: i, m, n

      IF (.NOT. allocated(a)) STOP 'AMPUTATE_ARRAY: Error, array a must be initially allocated'
      n = size(a)

      IF (i2 < i1) THEN
         STOP 'AMPUTATE: Error, i2 should be greater than i1'
      END IF

      m = i2-i1+1
      IF (n < m) THEN
         STOP 'AMPUTATE: Error, new array should be smaller than the old one'
      END IF

      ! Store input array and then deallocate
      ALLOCATE (b(n))
      b = a
      DEALLOCATE (a)

      ! Allocate new output array
      ALLOCATE (a(m))

      ! Fill new output array
      DO i = 1, m
         a(i) = b(i+i1-1)
      END DO

      ! Deallocate holding array
      DEALLOCATE (b)

   END SUBROUTINE amputate_array_int

   SUBROUTINE reduce_array(a1, a2)

      ! Reduces the size of array1 to the size of array2
      ! This will not preserve the spacing of entries in array1 and might be a terrible idea in many cases
      ! TODO: Remove this  
      REAL, INTENT(IN) :: a1(:)
      REAL, INTENT(OUT) :: a2(:)
      INTEGER :: i, j, n1, n2

      n1 = size(a1)
      n2 = size(a2)

      IF (n2 > n1) STOP 'REDUCE_ARRAY: Error, n2 > n1'

      DO i = 1, n2
         j = 1+ceiling(real((n1-1)*(i-1))/real(n2-1))
         a2(i) = a1(j)
      END DO

   END SUBROUTINE reduce_array

   SUBROUTINE reverse_array_1D(a)

      ! Reverses the contents of array
      REAL, INTENT(INOUT) :: a(:)
      INTEGER :: i, n
      REAL, ALLOCATABLE :: hold(:)

      n = size(a)

      hold = a

      DO i = 1, n
         a(i) = hold(n-i+1)
      END DO

   END SUBROUTINE reverse_array_1D

   SUBROUTINE reverse_array_2D(a, dim)

      ! Reverses the contents of array
      REAL, INTENT(INOUT) :: a(:, :)
      INTEGER, INTENT(IN) :: dim
      INTEGER :: ix, iy
      INTEGER :: nx, ny
      REAL, ALLOCATABLE :: b(:, :)

      IF ((dim /= 1) .AND. (dim /= 2)) THEN
         STOP 'REVERSE_ARRAY_2D: Error, dim must be either 1 or 2'
      END IF

      b = a

      nx = size(a, 1)
      ny = size(a, 2)

      DO iy = 1, ny
         DO ix = 1, nx
            IF (dim == 1) THEN
               a(ix, iy) = b(nx-ix+1, iy)
            ELSE IF (dim == 2) THEN
               a(ix, iy) = b(ix, ny-iy+1)
            ELSE
               STOP 'REVERSE_ARRAY_2D: Error, something went wrong'
            END IF
         END DO
      END DO

   END SUBROUTINE reverse_array_2D

   SUBROUTINE reverse_array_3D(a, dim)

      ! Reverses the contents of array
      REAL, INTENT(INOUT) :: a(:, :, :)
      INTEGER, INTENT(IN) :: dim
      INTEGER :: ix, iy, iz
      INTEGER :: nx, ny, nz
      REAL, ALLOCATABLE :: b(:, :, :)

      IF ((dim /= 1) .AND. (dim /= 2) .AND. (dim /= 3)) THEN
         STOP 'REVERSE_ARRAY_3D: Error, dim must be either 1, 2, or 3'
      END IF

      b = a

      nx = size(a, 1)
      ny = size(a, 2)
      nz = size(a, 3)

      DO iz = 1, nz
         DO iy = 1, ny
            DO ix = 1, nx
               IF (dim == 1) THEN
                  a(ix, iy, iz) = b(nx-ix+1, iy, iz)
               ELSE IF (dim == 2) THEN
                  a(ix, iy, iz) = b(ix, ny-iy+1, iz)
               ELSE IF (dim == 3) THEN
                  a(ix, iy, iz) = b(ix, iy, nz-iz+1)
               ELSE
                  STOP 'REVERSE_ARRAY_3D: Error, something went wrong'
               END IF
            END DO
         END DO
      END DO

   END SUBROUTINE reverse_array_3D

   SUBROUTINE remove_array_element_real(i, a)

      ! Remove element i from array a(n) returning an array of size n-1
      INTEGER, INTENT(IN) :: i                 ! Element to remove
      REAL, ALLOCATABLE, INTENT(INOUT) :: a(:) ! Input array     
      REAL :: b(size(a)-1)
      INTEGER :: j, jj, n

      n = size(a)

      IF (i < 1 .OR. i > n) THEN
         WRITE (*, *) 'Array size:', n
         WRITE (*, *) 'Element to remove:', i
         STOP 'REMOVE_ARRAY_ELEMENT: Error, element to remove is outside array bounds'
      END IF

      jj = 0
      DO j = 1, n
         IF (j == i) THEN
            CYCLE
         ELSE
            jj = jj+1
            b(jj) = a(j)
         END IF
      END DO

      DEALLOCATE (a)
      ALLOCATE (a(n-1))
      a = b

   END SUBROUTINE remove_array_element_real

   SUBROUTINE remove_array_element_int(i, a)

      ! Remove element i from array a(n) returning an array of size n-1
      INTEGER, INTENT(IN) :: i                    ! Element to remove
      INTEGER, ALLOCATABLE, INTENT(INOUT) :: a(:) ! Input array     
      INTEGER :: b(size(a)-1)
      INTEGER :: j, jj, n

      n = size(a)

      IF (i < 1 .OR. i > n) THEN
         WRITE (*, *) 'Array size:', n
         WRITE (*, *) 'Element to remove:', i
         STOP 'REMOVE_ARRAY_ELEMENT: Error, element to remove is outside array bounds'
      END IF

      jj = 0
      DO j = 1, n
         IF (j == i) THEN
            CYCLE
         ELSE
            jj = jj+1
            b(jj) = a(j)
         END IF
      END DO

      DEALLOCATE (a)
      ALLOCATE (a(n-1))
      a = b

   END SUBROUTINE remove_array_element_int

   SUBROUTINE remove_repeated_array_elements(a, m)

      ! Remove any repeated entries from the array
      ! Assumes the array is sorted
      REAL, ALLOCATABLE, INTENT(INOUT) :: a(:) ! Array to consider
      INTEGER, INTENT(OUT) :: m                ! Final size of array
      INTEGER :: i, n
      LOGICAL :: remove(size(a))

      n = size(a)

      remove = .FALSE.

      m = n
      DO i = 1, n-1
         IF (a(i) == a(i+1)) THEN
            remove(i+1) = .TRUE.
            m = m-1
         END IF
      END DO

      a = PACK(a, .NOT. remove)

   END SUBROUTINE remove_repeated_array_elements

   SUBROUTINE remove_repeated_two_array_elements(a, b, m)

      ! Remove any repeated entries in the array a from both a and b
      ! Assumes the array a is sorted
      REAL, ALLOCATABLE, INTENT(INOUT) :: a(:)
      REAL, ALLOCATABLE, INTENT(INOUT) :: b(:)
      INTEGER, INTENT(OUT) :: m
      INTEGER :: i, n
      LOGICAL :: remove(size(a))

      n = size(a)
      IF (n /= size(b)) STOP 'REMOVE_REPEATED_TWO_ARRAY_ELEMENTS: Error, arrays a and b are differnt sizes'

      remove = .FALSE.

      m = n
      DO i = 1, n-1
         IF (a(i) == a(i+1)) THEN
            remove(i+1) = .TRUE.
            m = m-1
         END IF
      END DO

      a = PACK(a,.NOT. remove)
      b = PACK(b,.NOT. remove)

   END SUBROUTINE remove_repeated_two_array_elements

   SUBROUTINE write_array_list_real(a)

      ! Write out a list of array elements in a neat way
      REAL, INTENT(IN) :: a(:)
      INTEGER :: i, n

      n = size(a)

      WRITE (*, *) 'WRITE_ARRAY_LIST: Writing array'
      DO i = 1, n
         WRITE (*, *) 'WRITE_ARRAY_LIST:', i, a(i)
      END DO
      WRITE (*, *) 'WRITE_ARRAY_LIST: Done'
      WRITE (*, *)

   END SUBROUTINE write_array_list_real

   SUBROUTINE write_array2D_list_real(a)

      ! Write out a list of array elements in a neat way
      REAL, INTENT(IN) :: a(:, :)
      INTEGER :: ix, iy, nx, ny

      nx = size(a, 1)
      ny = size(a, 2)

      WRITE (*, *) 'WRITE_ARRAY_LIST: Writing array'
      DO iy = 1, ny
         DO ix = 1, nx
            WRITE (*, *) 'WRITE_ARRAY_LIST:', ix, iy, a(ix, iy)
         END DO
      END DO
      WRITE (*, *) 'WRITE_ARRAY_LIST: Done'
      WRITE (*, *)

   END SUBROUTINE write_array2D_list_real

   SUBROUTINE write_2array_list_real(a, b)

      ! Write out a list of array elements in a neat way
      REAL, INTENT(IN) :: a(:)
      REAL, INTENT(IN) :: b(:)
      INTEGER :: i, n

      n = size(a)
      IF (n /= size(b)) STOP 'Arrays must be the same size'

      WRITE (*, *) 'WRITE_ARRAY_LIST: Writing array'
      DO i = 1, n
         WRITE (*, *) 'WRITE_ARRAY_LIST:', i, a(i), b(i)
      END DO
      WRITE (*, *) 'WRITE_ARRAY_LIST: Done'
      WRITE (*, *)

   END SUBROUTINE write_2array_list_real

   SUBROUTINE write_array_list_int(a)

      ! Write out a list of array elements in a neat way
      INTEGER, INTENT(IN) :: a(:)
      INTEGER :: i, n

      n = size(a)

      WRITE (*, *) 'WRITE_ARRAY_LIST: Writing array'
      DO i = 1, n
         WRITE (*, *) 'WRITE_ARRAY_LIST:', i, a(i)
      END DO
      WRITE (*, *) 'WRITE_ARRAY_LIST: Done'
      WRITE (*, *)

   END SUBROUTINE write_array_list_int

   FUNCTION splay_2D(a, n1, n2)

      ! This splays out a 2D array 'a' into a 1d array 'b' of the same size (n1*n2)
      ! TODO: Ugly order of arguments (convert to subroutine?)
      INTEGER, INTENT(IN) :: n1, n2
      REAL :: splay_2D(n1*n2)
      REAL, INTENT(IN) :: a(n1, n2)
      INTEGER :: i, j, ii

      ! Set sum integer to zero
      ii = 0

      DO j = 1, n2
         DO i = 1, n1
            ii = ii+1
            splay_2D(ii) = a(i, j)
         END DO
      END DO

   END FUNCTION splay_2D

   FUNCTION splay_3D(a, n1, n2, n3)

      ! This splays out a 3D array 'a' into a 1d array 'b' of the same size (n1*n2*n3)
      ! TODO: Should i, j, k order of loops be reversed?
      ! TODO: Ugly order of arguments (convert to subroutine?)
      INTEGER, INTENT(IN) :: n1, n2, n3
      REAL :: splay_3D(n1*n2*n3)
      REAL, INTENT(IN) :: a(n1, n2, n3)
      INTEGER :: i, j, k, ii

      ! Set sum integer to zero
      ii = 0

      DO i = 1, n1
         DO j = 1, n2
            DO k = 1, n3
               ii = ii+1
               splay_3D(ii) = a(i, j, k)
            END DO
         END DO
      END DO

   END FUNCTION splay_3D

   SUBROUTINE binning(a, a1, a2, b, c, ilog)

      ! Histogram? bin numbers in array a in bins b with height c between a1 and a2
      ! TODO: Is this a repeat of a different subroutine called histogram in statistics.f90?
      REAL, INTENT(IN) :: a(:)
      REAL, INTENT(IN) :: a1
      REAL, INTENT(IN) :: a2
      REAL, INTENT(OUT) :: b(:)
      REAL, INTENT(OUT) :: c(:)
      INTEGER, INTENT(IN) :: ilog
      REAL :: min, max
      REAL, ALLOCATABLE :: binlim(:)
      INTEGER :: i, j, n

      n = size(b)

      min = a1
      max = a2

      WRITE (*, *) 'Binning'
      WRITE (*, *) 'Min:', min
      WRITE (*, *) 'Max:', max

      IF (ilog == 1) THEN
         min = log10(min)
         max = log10(max)
      END IF

      ! This sets the limits for the bins!
      CALL fill_array(min, max, binlim, n+1)

      ! This sets the centre value for each bin!
      DO i = 1, n
         b(i) = (binlim(i)+binlim(i+1))/2.
      END DO

      IF (ilog == 1) THEN
         binlim = 10.**binlim
         b = 10.**b
      END IF

      c = 0.

      DO i = 1, size(a)
         DO j = 1, n
            IF (a(i) >= binlim(j) .AND. a(i) <= binlim(j+1)) THEN
               c(j) = c(j)+1.
            END IF
         END DO
      END DO

      WRITE (*, *) 'Binning complete'
      WRITE (*, *)

   END SUBROUTINE binning

   SUBROUTINE merge_arrays(a, b, c, nc)

      ! Takes arrays a and b and merges them together to make c with length SIZE(a)+SIZE(b)
      REAL, INTENT(IN) :: a(:)
      REAL, INTENT(IN) :: b(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: c(:)
      INTEGER, INTENT(OUT) :: nc
      INTEGER :: i, na, nb

      na = size(a)
      nb = size(b)
      nc = na+nb

      IF (allocated(c)) DEALLOCATE (c)
      ALLOCATE (c(nc))

      DO i = 1, na
         c(i) = a(i)
      END DO

      DO i = 1, nb
         c(i+na) = b(i)
      END DO

   END SUBROUTINE merge_arrays

   FUNCTION concatenate_arrays_real(a, b)

      ! Concatenate arrays a and b to form new array with length SIZE(a)+SIZE(b)
      ! TODO: Ugly definition for type of function (convert to subroutine?)
      REAL, INTENT(IN) :: a(:)
      REAL, INTENT(IN) :: b(:)
      REAL :: concatenate_arrays_real(size(a)+size(b))
      INTEGER :: i, na, nb

      na = size(a)
      nb = size(b)

      DO i = 1, na
         concatenate_arrays_real(i) = a(i)
      END DO

      DO i = 1, nb
         concatenate_arrays_real(i+na) = b(i)
      END DO

   END FUNCTION concatenate_arrays_real

   FUNCTION concatenate_arrays_int(a, b)

      ! Concatenate arrays a and b to form new array with length SIZE(a)+SIZE(b)
      ! TODO: Ugly definition for type of function (convert to subroutine?)
      INTEGER, INTENT(IN) :: a(:)
      INTEGER, INTENT(IN) :: b(:)
      INTEGER :: concatenate_arrays_int(size(a)+size(b))
      INTEGER :: i, na, nb

      na = size(a)
      nb = size(b)

      DO i = 1, na
         concatenate_arrays_int(i) = a(i)
      END DO

      DO i = 1, nb
         concatenate_arrays_int(i+na) = b(i)
      END DO

   END FUNCTION concatenate_arrays_int

   SUBROUTINE fill_array(min, max, arr, n, ilog)

      ! Fills array 'arr' in linearly spaced intervals
      ! e.g., 4 values between 0 and 1 would be 0, 1/3, 2/3, and 1
      ! This means that min and max are included in the array
      REAL, INTENT(IN) :: min ! Minimum value for array
      REAL, INTENT(IN) :: max ! Maximum value for array
      REAL, ALLOCATABLE, INTENT(INOUT) :: arr(:) ! Output array
      INTEGER, INTENT(IN) :: n ! Number of entries in array
      LOGICAL, OPTIONAL, INTENT(IN) :: ilog
      INTEGER :: i

      ! Allocate the array, and deallocate it if it is full
      CALL safe_allocate(arr, n)
      arr = 0.

      IF (n == 1) THEN
         IF (min /= max) STOP 'FILL_ARRAY: If array is to be filled with a single value then min and max must be equal'
         arr(1) = min
      ELSE IF (n > 1) THEN
         DO i = 1, n
            arr(i) = progression(min, max, i, n, ilog)
         END DO
      ELSE
         STOP 'FILL_ARRAY: Error, n cannot be negative'
      END IF

   END SUBROUTINE fill_array

   SUBROUTINE fill_array_log(xmin, xmax, x, nx)

      ! Fill an array x in n log-space intervals between xmin and xmax (inclusive)
      ! TODO: Remove
      REAL, INTENT(IN) :: xmin
      REAL, INTENT(IN) :: xmax
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:)
      INTEGER, INTENT(IN) :: nx

      CALL fill_array(log(xmin), log(xmax), x, nx)
      x = exp(x)

   END SUBROUTINE fill_array_log

   SUBROUTINE integer_sequence(is, i1, i2, n)

      ! Reutrns an array of all the integers between i1 and i2 (inclusive)
      INTEGER, ALLOCATABLE, INTENT(OUT) :: is(:)
      INTEGER, INTENT(IN) :: i1
      INTEGER, INTENT(IN) :: i2
      INTEGER, INTENT(OUT) :: n
      INTEGER :: i, j

      IF(i2 < i1) STOP 'INTEGER_SEQUENCE: Error, i2 is less than i1'

      n = i2-i1+1

      CALL safe_allocate(is, n)
      DO j = 1, n
         i = i1+j-1
         is(j) = i
      END DO

   END SUBROUTINE integer_sequence

   SUBROUTINE fill_pixels(min, max, arr, n)

      ! Fill an array between min and max as if the values should correspond to central pixel values
      ! e.g., 3 pixel values between 0 and 1 would be 1/6, 1/2 and 5/6
      ! This means that min and max are not included in the array
      REAL, INTENT(IN) :: min                  ! Minimum value bordering array
      REAL, INTENT(IN) :: max                  ! Maximum value bordering array
      REAL, ALLOCATABLE, INTENT(OUT) :: arr(:) ! Output array
      INTEGER, INTENT(IN) :: n                 ! Number of pixels in array
      REAL :: mmin, mmax, pixel_size

      pixel_size = (max-min)/real(n) ! Calculate the pixel size
      mmin = min+pixel_size/2.       ! Offset minimum value by half a pixel into the region
      mmax = max-pixel_size/2.       ! Offset maximum value by half a pixel into the region

      CALL fill_array(mmin, mmax, arr, n) ! Linearly fill array

   END SUBROUTINE fill_pixels

   SUBROUTINE create_mask(min, max, m, mask)

      ! Flags objects that make the cut as true in mask
      REAL, INTENT(IN) :: min
      REAL, INTENT(IN) :: max
      REAL, INTENT(IN) :: m(:)
      LOGICAL, INTENT(OUT) :: mask(:)
      INTEGER :: i, o, n

      n = size(m)
      IF (n /= size(mask)) STOP 'CREATE_MASK: Error, real and logical array should be the same size'

      WRITE (*, *) 'MASK: Imposing property cut'
      WRITE (*, *) 'MASK: Minimum value:', min
      WRITE (*, *) 'MASK: Maximum value:', max
      WRITE (*, *) 'MASK: Original number of objects', n

      mask = .FALSE.
      DO i = 1, n
         IF (m(i) >= min .AND. m(i) <= max) mask(i) = .TRUE.
      END DO

      o = count(mask)

      WRITE (*, *) 'MASK: Final number of objects:', o
      WRITE (*, *) 'MASK: Fraction remaining:', real(o)/real(n)
      WRITE (*, *) 'MASK: Fraction culled:', 1.-real(o)/real(n)
      WRITE (*, *) 'MASK: Done'
      WRITE (*, *)

   END SUBROUTINE create_mask

   SUBROUTINE apply_mask_1D(x, a, nx, xmask)

      ! Use the xmask to resize arrays x and a(x) according to only true elements of the mask
      ! TODO: Ugly argument list
      REAL, ALLOCATABLE, INTENT(INOUT) :: x(:) ! Input x array
      REAL, ALLOCATABLE, INTENT(INOUT) :: a(:) ! Input a(x) array
      INTEGER, INTENT(INOUT) :: nx
      LOGICAL, INTENT(IN) :: xmask(nx)
      INTEGER :: i, ii, nx_new
      REAL :: a_old(nx), x_old(nx) ! Not necessary, could use x, but makes easier to read
      INTEGER :: nx_old            ! Not necessary, could use n, but makes easier to read
      REAL, ALLOCATABLE :: a_new(:), x_new(:)

      IF(size(a) .NE. nx) STOP 'APPLY_MASK_1D: Error, you have specified array dimension incorrectly'

      ! Save original arrays (unnecessary)
      x_old = x
      a_old = a
      nx_old = nx

      ! Make new arrays
      nx_new = count(xmask)
      ALLOCATE(x_new(nx_new), a_new(nx_new))
      ii = 0
      DO i = 1, nx
         IF(xmask(i)) THEN
            ii = ii+1
            x_new(ii) = x_old(i)
            a_new(ii) = a_old(i)
         END IF
      END DO

      DEALLOCATE(x, a)
      ALLOCATE(x(nx_new), a(nx_new))
      x = x_new
      a = a_new
      nx = nx_new

      DEALLOCATE(x_new, a_new)

   END SUBROUTINE apply_mask_1D

   SUBROUTINE apply_mask_2D(x, y, a, nx, ny, xmask, ymask)

      ! Use xmask and ymask to resize arrays x, y and a(x, y) according to only true elements of the masks
      ! TODO: Ugly argument list
      REAL, ALLOCATABLE, INTENT(INOUT) :: x(:)
      REAL, ALLOCATABLE, INTENT(INOUT) :: y(:)
      REAL, ALLOCATABLE, INTENT(INOUT) :: a(:, :)
      INTEGER, INTENT(INOUT) :: nx
      INTEGER, INTENT(INOUT) :: ny
      LOGICAL, INTENT(IN) :: xmask(nx)
      LOGICAL, INTENT(IN) :: ymask(ny)
      INTEGER :: i, ii, j, jj, nx_new, ny_new
      REAL :: x_old(nx), y_old(ny), a_old(nx, ny) ! Not necessary, could use x, but makes easier to read
      INTEGER :: nx_old, ny_old ! Not necessary, could use n, but makes easier to read
      REAL, ALLOCATABLE :: x_new(:), y_new(:), a_new(:, :)

      IF(size(a(:,1)) .NE. nx) THEN
         WRITE(*, *) 'APPLY_MASK_2D: nx:', nx
         WRITE(*, *) 'APPLY_MASK_2D: size of array first dimension:', size(a(:,1))
         STOP 'APPLY_MASK_2D: Error, you have specified x array dimension incorrectly'
      END IF
      IF(size(a(1,:)) .NE. ny) THEN
         WRITE(*, *) 'APPLY_MASK_2D: ny:', ny
         WRITE(*, *) 'APPLY_MASK_2D: size of array second dimension:', size(a(1,:))
         STOP 'APPLY_MASK_2D: Error, you have specified y array dimension incorrectly'
      END IF

      ! Save original array
      x_old = x
      y_old = y
      a_old = a
      nx_old = nx
      ny_old = ny

      ! Make new array
      nx_new = count(xmask)
      ny_new = count(ymask)
      ALLOCATE(x_new(nx_new), y_new(ny_new), a_new(nx_new, ny_new))
      jj=0
      DO j = 1, ny
         IF(ymask(j)) THEN
            jj=jj+1
            y_new(jj) = y_old(j)
            ii = 0
            DO i = 1, nx
               IF(xmask(i)) THEN
                  ii = ii+1
                  x_new(ii) = x_old(i)
                  a_new(ii, jj) = a_old(i, j)
               END IF
            END DO
         END IF
      END DO

      DEALLOCATE(x, y, a)
      ALLOCATE(x(nx_new), y(ny_new), a(nx_new, ny_new))
      x = x_new
      y = y_new
      a = a_new
      nx = nx_new
      ny = ny_new

      DEALLOCATE(x_new, y_new, a_new)

   END SUBROUTINE apply_mask_2D

   INTEGER FUNCTION unique_entries(a)

      ! Counts the total number of unique entries in array 'a'
      INTEGER, INTENT(IN) :: a(:) ! Input array
      INTEGER :: i, j, n

      n = size(a)

      ! Initially assume all entries are unique
      unique_entries = n

      ! Double loop to each each pair against each other
      DO i = 1, n
         DO j = i+1, n
            IF (a(j) == a(i)) THEN
               unique_entries = unique_entries-1 ! A non-unique entry has been discovered, so subtract one
               EXIT
            END IF
         END DO
      END DO

   END FUNCTION unique_entries

   SUBROUTINE unique_index(array, n, unique, m, match)

      ! Create an indexing scheme to only the unique elements
      INTEGER, INTENT(IN) :: n                       ! Number of entries in input array
      INTEGER, INTENT(IN) :: array(n)                ! Array to find the unique indices of
      INTEGER, ALLOCATABLE, INTENT(OUT) :: unique(:) ! Output array of unique indices
      INTEGER, INTENT(OUT) :: m                      ! Number of unique indices
      INTEGER, INTENT(OUT) :: match(n)               ! Array for matching input and unique arrays
      INTEGER :: i, j, p
      LOGICAL :: inc

      ! First count the number of unique entries
      m = unique_entries(array)
      ALLOCATE (unique(m))

      ! Set the first unique entry to be the first entry
      unique(1) = array(1)

      p = 1
      DO i = 1, n
         inc = .FALSE.
         DO j = 1, p
            IF (array(i) /= unique(j)) THEN
               unique(p+1) = array(i)
               inc = .TRUE.
               EXIT
            END IF
         END DO
         IF (inc) p = p+1
         IF (p == m) EXIT ! Added this in haste
      END DO

      ! Now fill the matching array
      DO j = 1, m
         DO i = 1, n
            IF (unique(j) == array(i)) THEN
               match(i) = j
            END IF
         END DO
      END DO

   END SUBROUTINE unique_index

   LOGICAL FUNCTION is_in_array_integer(x, a)

      ! Test to see if integer value x is in a(n)
      ! This is very useful in IF statements where otherwise there would be a long chain of .OR.s
      INTEGER, INTENT(IN) :: x
      INTEGER, INTENT(IN) :: a(:)
      INTEGER :: i

      is_in_array_integer = .FALSE.
      DO i = 1, size(a)
         IF (x == a(i)) THEN
            is_in_array_integer = .TRUE.
            EXIT
         END IF     
      END DO

   END FUNCTION is_in_array_integer

   LOGICAL FUNCTION is_in_array_character(x, a)

      ! Test to see if integer value x is in a(n)
      ! This is very useful in IF statements where otherwise there would be a long chain of .OR.'s
      CHARACTER(len=*), INTENT(IN) :: x
      CHARACTER(len=*), INTENT(IN) :: a(:)
      INTEGER :: i

      is_in_array_character = .FALSE.
      DO i = 1, size(a)
         IF (trim(x) == trim(a(i))) THEN
            is_in_array_character = .TRUE.
            EXIT
         END IF     
      END DO

   END FUNCTION is_in_array_character

   LOGICAL FUNCTION repeated_entries(a)

      ! Checks for repeated entries in a(n) either true or false
      INTEGER, INTENT(IN) :: a(:)
      INTEGER :: i, j, n

      n = size(a)

      repeated_entries = .FALSE.

      DO i = 1, n
         DO j = i+1, n
            IF (a(i) == a(j)) THEN
               repeated_entries = .TRUE.
               EXIT
            END IF
         END DO
         IF (repeated_entries) EXIT
      END DO

   END FUNCTION repeated_entries

   LOGICAL FUNCTION regular_spacing(a)

      ! Returns true if array a is regularly spaced
      REAL, INTENT(IN) :: a(:)
      REAL :: amin, amax, b
      INTEGER :: i, n
      REAL, PARAMETER :: eps = 1e-5

      n = size(a)

      amin = a(1)
      amax = a(n)

      regular_spacing = .TRUE.
      DO i = 1, n
         b = progression(amin, amax, i, n)
         IF (.NOT. requal(b, a(i), eps)) THEN
            regular_spacing = .FALSE.
            EXIT
         END IF
      END DO

   END FUNCTION regular_spacing

   INTEGER FUNCTION sum_logical(a)

      ! Count the number of true entries in a logical array
      LOGICAL, INTENT(IN) :: a(:)
      INTEGER :: i

      sum_logical = 0
      DO i = 1, size(a)
         IF (a(i)) sum_logical = sum_logical+1
      END DO

   END FUNCTION sum_logical

END MODULE array_operations

MODULE field_operations

   USE precision
   USE constants
   USE basic_operations
   USE array_operations
   USE fft

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: NGP_cell
   PUBLIC :: cell_position
   PUBLIC :: make_Gaussian_random_field
   PUBLIC :: generate_displacement_fields
   PUBLIC :: write_3D_field_projection_ascii
   PUBLIC :: compress_field
   PUBLIC :: add_to_stack_3D
   PUBLIC :: project_3D_to_2D
   PUBLIC :: clip
   PUBLIC :: anticlip
   PUBLIC :: periodic_distance
   PUBLIC :: check_Hermiticity

   PUBLIC :: box_mode_power
   PUBLIC :: compute_power_spectrum_pole ! Remove?
   !PUBLIC :: compute_power_spectrum_rsd
   !PUBLIC :: compute_power_spectrum_rsd2

   PUBLIC :: field_correlation_function

   PUBLIC :: read_field_binary
   PUBLIC :: write_field_binary
   PUBLIC :: write_field_ascii
   PUBLIC :: compute_power_spectrum
   PUBLIC :: compute_multipole_power_spectrum
   PUBLIC :: smooth
   PUBLIC :: sharpen
   PUBLIC :: sharpen_k
   PUBLIC :: empty_cells

   INTERFACE read_field_binary
      MODULE PROCEDURE read_field_binary_2D
      MODULE PROCEDURE read_field_binary_3D
   END INTERFACE read_field_binary

   INTERFACE write_field_binary
      MODULE PROCEDURE write_field_binary_2D
      MODULE PROCEDURE write_field_binary_3D
   END INTERFACE write_field_binary

   INTERFACE write_field_ascii
      MODULE PROCEDURE write_field_ascii_2D
   END INTERFACE write_field_ascii

   INTERFACE compute_power_spectrum
      MODULE PROCEDURE compute_power_spectrum_2D
      MODULE PROCEDURE compute_power_spectrum_3D
   END INTERFACE compute_power_spectrum

   INTERFACE compute_multipole_power_spectrum
      MODULE PROCEDURE compute_multipole_power_spectrum_3D
   END INTERFACE compute_multipole_power_spectrum

   INTERFACE smooth
      MODULE PROCEDURE smooth_2D
      MODULE PROCEDURE smooth_3D
   END INTERFACE smooth

   INTERFACE sharpen
      MODULE PROCEDURE sharpen_2D
      MODULE PROCEDURE sharpen_3D
   END INTERFACE sharpen

   INTERFACE sharpen_k
      MODULE PROCEDURE sharpen_k_2D
      MODULE PROCEDURE sharpen_k_3D
   END INTERFACE sharpen_k

   INTERFACE empty_cells
      MODULE PROCEDURE empty_cells_3D
   END INTERFACE empty_cells

   ! Full complex Fourier transforms, or assume real and therefore Hermitian arrays
   LOGICAL, PARAMETER :: complex = .TRUE.

   ! Gaussian random mode generation
   ! 1 - Assign mode amplitude and phase
   ! 2 - Assign mode real and imaginary part
   ! 3 - Mean variance to all modes
   INTEGER, PARAMETER :: imode_GRF = 1

CONTAINS

   INTEGER FUNCTION NGP_cell(x, L, m)

      ! Find the integer coordinates of the cell that coordinate x is in
      REAL, INTENT(IN) :: x    ! Particle position
      REAL, INTENT(IN) :: L    ! Box size (could be Mpc/h or angle or something else)
      INTEGER, INTENT(IN) :: m ! Number of mesh cells in grid

      IF (x == 0.) THEN
         ! Catch this edge case
         NGP_cell = 1
      ELSE
         NGP_cell = ceiling(x*real(m)/L)
      END IF

   END FUNCTION NGP_cell

   REAL FUNCTION cell_position(i, L, m)

      ! Gets the coordinates of cell centre i in box of length L with m cells
      INTEGER, INTENT(IN) :: i ! Integer label for cell
      REAL, INTENT(IN) :: L    ! Actual size corresponding to volume
      INTEGER, INTENT(IN) :: m ! Number of mesh cells

      cell_position = L*(i-0.5)/real(m)

   END FUNCTION cell_position

   ! REAL FUNCTION random_mode_amplitude(Pk, use_average)

   !    ! This calculates the Fourier amplitudes of the density field
   !    USE interpolate
   !    USE constants
   !    USE random_numbers
   !    REAL, INTENT(IN) :: Pk             ! NOTE: Not Delta^2(k)
   !    LOGICAL, INTENT(IN) :: use_average
   !    REAL :: sigma

   !    ! Sigma parameter in the Rayleigh distribution
   !    sigma = sqrt(Pk/2.) ! Half the variance to each of the real and imaginary parts

   !    IF (use_average) THEN
   !       ! Fixed mode amplitudes
   !       ! TODO: The mean of Rayleigh is sqrt(pi/2)*sigma, shouldn't this be here instead?
   !       random_mode_amplitude = sigma*sqrt(2.)
   !    ELSE
   !       ! Correctly assigned random mode amplitudes
   !       random_mode_amplitude = random_Rayleigh(sigma)
   !    END IF

   ! END FUNCTION random_mode_amplitude

   SUBROUTINE make_Gaussian_random_modes(dk, m, L, k_tab, Pk_tab)

      ! Uses a tablulated P(k) to make a Gaussian Random Field realisation
      ! Assumes that P(k) is real and corresponds to a real array, so the output modes are Hermitian
      ! TODO: Upgrade so that reduced arrays (mn, m, m) can be filled as well as full (m, m, m) arrays
      USE constants
      USE FFT
      USE random_numbers
      USE interpolate

      COMPLEX, ALLOCATABLE, INTENT(OUT) :: dk(:, :, :)
      INTEGER, INTENT(IN) :: m
      REAL, INTENT(IN) :: L
      REAL, INTENT(IN) :: k_tab(:)
      REAL, INTENT(IN) :: Pk_tab(:)
      INTEGER :: ix, iy, iz
      REAL :: kx, ky, kz, k
      REAL :: amp, D2, Pk, sig, modes(2)
      COMPLEX :: rot
      TYPE(interpolator1D) :: Pk_interp
      INTEGER, PARAMETER :: iorder = 3
      INTEGER, PARAMETER :: iextrap = iextrap_lin
      LOGICAL, PARAMETER :: store = .TRUE.
      LOGICAL, PARAMETER :: logk = .TRUE.
      LOGICAL, PARAMETER :: logPk = .TRUE.

      ! Write useful things to screen
      WRITE (*, *) 'MAKE_GAUSSIAN_RANDOM_MODES: Creating Fourier realisation of Gaussian field'
      WRITE (*, *) 'MAKE_GAUSSIAN_RANDOM_MODES: Mesh size:', m
      WRITE (*, *) 'MAKE_GAUSSIAN_RANDOM_MODES: Box size [Mpc/h]:', L

      ! Create an interpolator for P(k)
      CALL init_interpolator(k_tab, Pk_tab, Pk_interp, iorder, iextrap, store, logk, logPk)

      ! Allocate the Fourier array
      ALLOCATE(dk(m, m, m))

      ! This fills up all of k space, no Hermiticity imposed
      DO iz = 1, m
         DO iy = 1, m
            DO ix = 1, m

               ! Wavenumber
               CALL k_fft(ix, iy, iz, m, kx, ky, kz, k, L)

               IF (ix == 1 .AND. iy == 1 .AND. iz == 1) THEN

                  ! Set the zero mode to zero
                  dk(ix, iy, iz) = (0.d0, 0.d0)

               ELSE

                  ! Get mode standard error
                  D2 = evaluate_interpolator(k, Pk_interp)
                  Pk = D2/(4.*pi*(k*L/twopi)**3)
                  sig = sqrt(Pk/2.) ! Half of the variance to each of the real and imaginary part

                  IF (imode_GRF == 1) THEN
                     amp = random_Rayleigh(sig)
                     rot = random_complex_unit()
                     dk(ix, iy, iz) = amp*rot
                  ELSE IF (imode_GRF == 2)  THEN                 
                     modes = random_Gaussian_pair(0., sig) 
                     dk(ix, iy, iz) = cmplx(modes(1), modes(2))
                  ELSE IF (imode_GRF == 3) THEN
                     !amp = sig*sqrt(2.)
                     amp = sqrt(pi/2.)*sig
                     rot = random_complex_unit()
                     dk(ix, iy, iz) = amp*rot
                  ELSE
                     STOP 'MAKE_GAUSSIAN_RANDOM_MODES: Error, mode creation scheme not specified'
                  END IF

               END IF

            END DO
         END DO
      END DO

      WRITE (*, *) 'MAKE_GAUSSIAN_RANDOM_MODES: Initial modes generated'

      ! Make the array Hermitian
      CALL enforce_Hermiticity(dk, verbose=.FALSE.)  

      WRITE (*, *) 'MAKE_GAUSSIAN_RANDOM_MODES: Hermitian field generated'
      WRITE (*, *)

   END SUBROUTINE make_Gaussian_random_modes

   SUBROUTINE enforce_Hermiticity(dk, verbose)

      ! Take an input complex array and force it in to a Hermitian state
      USE FFT
      COMPLEX, INTENT(INOUT) :: dk(:, :, :)
      LOGICAL, INTENT(IN) :: verbose
      INTEGER :: ix, iy, iz
      INTEGER :: jx, jy, jz
      INTEGER :: mx, my, mz

      IF (verbose) WRITE (*, *) 'ENFORCE_HERMITICITY: Enforcing Hermiticity'

      mx = size(dk, 1)
      my = size(dk, 2)
      mz = size(dk, 3)

      ! Enforce Hermiticity - probably could save a load of operations above
      DO iz = 1, mz
         jz = conjugate_mode_location(iz, mz)
         DO iy = 1, my
            jy = conjugate_mode_location(iy, my)
            DO ix = 1, mx
               jx = conjugate_mode_location(ix, mx)
               IF ((ix == jx) .AND. (iy == jy) .AND. (iz == jz)) THEN
                  dk(ix, iy, iz) = real(dk(ix, iy, iz)) ! Nyquist modes should be real
               ELSE
                  dk(ix, iy, iz) = conjg(dk(jx, jy, jz)) ! Other modes should be conjugate
               END IF
            END DO
         END DO
      END DO

      ! Because all modes have been conjugated above
      dk = conjg(dk)

      IF (verbose) THEN
         WRITE (*, *) 'ENFORCE_HERMITICITY: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE enforce_Hermiticity

   LOGICAL FUNCTION check_Hermiticity(dk)

      ! TODO: Should there be a tolerance parameter here?
      USE FFT
      COMPLEX, INTENT(IN) :: dk(:, :, :)
      INTEGER :: ix, iy, iz
      INTEGER :: mx, my, mz
      INTEGER :: jx, jy, jz

      mx = size(dk, 1)
      my = size(dk, 2)
      mz = size(dk, 3)

      check_Hermiticity = .TRUE.
      DO iz = 1, mz
         jz = conjugate_mode_location(iz, mz)
         DO iy = 1, my
            jy = conjugate_mode_location(iy, my)
            DO ix = 1, mx
               jx = conjugate_mode_location(ix, mx)
               IF ((ix == jx) .AND. (iy == jy) .AND. (iz == jz)) THEN
                  IF (aimag(dk(ix, iy, iz)) .NE. 0.) THEN
                     check_Hermiticity = .FALSE. ! Nyquist modes should be real
                     RETURN
                  END IF
               ELSE
                  IF (dk(ix, iy, iz) .NE. conjg(dk(jx, jy, jz))) THEN
                     check_Hermiticity = .FALSE. ! Other modes should be conjugate
                     RETURN
                  END IF
               END IF
            END DO
         END DO
      END DO

   END FUNCTION check_Hermiticity

   SUBROUTINE apodise_field(dk, L, ka)

      ! Remove Fourier modes that exist beyond ka
      ! These modes are not fully sampled in k space because the shell is cut off
      ! TODO: Different choices for apodising function
      USE constants
      USE FFT

      COMPLEX, INTENT(INOUT) :: dk(:, :, :)
      REAL, INTENT(IN) :: L
      REAL, INTENT(IN) :: ka
      REAL :: kx, ky, kz, k
      INTEGER :: ix, iy, iz
      INTEGER :: m

      m = size(dk, 1)
      IF ((m .NE. size(dk, 2)) .OR. (m .NE. size(dk, 3))) STOP

      DO iz = 1, m
         DO iy = 1, m
            DO ix = 1, m
               CALL k_FFT(ix, iy, iz, m, kx, ky, kz, k, L)
               IF (k > ka) dk(ix, iy, iz) = (0., 0.)
            END DO
         END DO
      END DO

   END SUBROUTINE apodise_field

   SUBROUTINE make_Gaussian_random_field(d, m, L, k_tab, Pk_tab)

      ! Uses a tablulated P(k) to make a Gaussian Random Field realisation
      ! TODO: Should modes be removed beyond the Nyquist frequency?

      REAL, ALLOCATABLE, INTENT(OUT) :: d(:, :, :)
      INTEGER, INTENT(IN) :: m
      REAL, INTENT(IN) :: L
      REAL, INTENT(IN) :: k_tab(:)
      REAL, INTENT(IN) :: Pk_tab(:)
      COMPLEX, ALLOCATABLE :: dk(:, :, :)
      COMPLEX :: dk_new(m, m, m)

      CALL make_Gaussian_random_modes(dk, m, L, k_tab, Pk_tab)

      WRITE (*, *) 'MAKE_GAUSSIAN_RANDOM_FIELD: Transform to real space'

      ! FT the displacement field from k-space to real space!
      CALL fft3(dk, dk_new, m, m, m, 1)
      dk = dk_new
      d = real(dk)

      WRITE (*, *) 'MAKE_GAUSSIAN_RANDOM_FIELD: Done'
      WRITE (*, *)

   END SUBROUTINE make_Gaussian_random_field

   SUBROUTINE generate_displacement_fields(f, m, L, k_tab, Pk_tab)

      REAL, ALLOCATABLE, INTENT(OUT) :: f(:, :, :, :)
      INTEGER, INTENT(IN) :: m
      REAL, INTENT(IN) :: L
      REAL, INTENT(IN) :: k_tab(:)
      REAL, INTENT(IN) :: Pk_tab(:)
      COMPLEX :: d(m, m, m), fk(3, m, m, m)
      COMPLEX, ALLOCATABLE :: dk(:, :, :)
      INTEGER :: i, ix, iy, iz
      REAL :: kx, ky, kz, k, kNy

      ! Make a Gaussian realisation of overdensity modes
      CALL make_Gaussian_random_modes(dk, m, L, k_tab, Pk_tab)

      ! Remove modes above the Nyquist frequency
      ! TODO: Think about this
      kNy = Nyquist_frequency(L, m)
      CALL apodise_field(dk, L, kNy)

      WRITE (*, *) 'GENERATE_DISPLACEMENT_FIELDS: Creating realisation of displacement field'

      ! Allocate displacement field array
      ALLOCATE(f(3, m, m, m))

      ! This fills up displacement array in all of k space!
      DO iz = 1, m
         DO iy = 1, m
            DO ix = 1, m

               ! Get the wave vectors
               CALL k_fft(ix, iy, iz, m, kx, ky, kz, k, L)

               IF (ix == 1 .AND. iy == 1 .AND. iz == 1) THEN

                  ! Fix the zero mode to zero, avoiding a division by zero
                  fk(1, ix, iy, iz) = (0.d0, 0.d0)
                  fk(2, ix, iy, iz) = (0.d0, 0.d0)
                  fk(3, ix, iy, iz) = (0.d0, 0.d0)

               ! ELSE IF (ix == 1+m/2 .OR. iy == 1+m/2 .OR. iz == 1+m/2) THEN

               !    ! Sets Nyquist modes to 0.!
               !    ! Maybe all modes with mod(k)>k_ny should be set to 0.?!
               !    ! Bridit Falck wrote a 'corner modes' paper about this
               !    ! https://arxiv.org/abs/1610.04862
               !    fk(1, ix, iy, iz) = (0.d0, 0.d0)
               !    fk(2, ix, iy, iz) = (0.d0, 0.d0)
               !    fk(3, ix, iy, iz) = (0.d0, 0.d0)

               ELSE

                  ! Assign values to the displacement field
                  fk(1, ix, iy, iz) = (0.d0, -1.d0)*dk(ix, iy, iz)*kx/k**2
                  fk(2, ix, iy, iz) = (0.d0, -1.d0)*dk(ix, iy, iz)*ky/k**2
                  fk(3, ix, iy, iz) = (0.d0, -1.d0)*dk(ix, iy, iz)*kz/k**2

               END IF

            END DO
         END DO
      END DO
      WRITE (*, *) 'GENERATE_DISPLACEMENT_FIELDS: Fourier displacement fields done'

      ! Reverse Fourier transform back to configuration space
      DO i = 1, 3
         dk = fk(i, :, :, :)
         CALL fft3(dk, d, m, m, m, 1)
         f(i, :, :, :) = real(d(:, :, :))
      END DO

      WRITE (*, *) 'GENERATE_DISPLACEMENT_FIELDS: Minimum 1D displacement [Mpc/h]:', minval(f)
      WRITE (*, *) 'GENERATE_DISPLACEMENT_FIELDS: Maximum 1D displacement [Mpc/h]:', maxval(f)
      WRITE (*, *) 'GENERATE_DISPLACEMENT_FIELDS: Real-space displacement fields generated'
      WRITE (*, *)

   END SUBROUTINE generate_displacement_fields

   SUBROUTINE read_field_binary_2D(d, m, L, infile)

      ! Read in a binary 'field' file
      USE statistics

      REAL, ALLOCATABLE, INTENT(OUT) :: d(:, :)
      INTEGER, INTENT(OUT) :: m
      REAL, INTENT(OUT) :: L
      CHARACTER(len=*), INTENT(IN) :: infile
      LOGICAL :: lexist

      ! Write file name to screen and check it exists
      WRITE (*, *) 'READ_FIELD_BINARY_2D: Binary input: ', trim(infile)
      INQUIRE (file=infile, exist=lexist)
      IF (.NOT. lexist) STOP 'READ_SIMULATION_POWER_SPECTRUM: File does not exist'

      ! First get mesh size and physical size
      OPEN (7, file=infile, form='unformatted', access='stream', status='old')
      READ (7) m
      READ (7) L
      CLOSE (7)
      WRITE (*, *) 'READ_FIELD_BINARY_2D: Mesh size:', m
      WRITE (*, *) 'READ_FIELD_BINARY_2D: Field size:', L

      ALLOCATE (d(m, m))

      ! Read unformatted data
      OPEN (7, file=infile, form='unformatted', access='stream', status='old')
      READ (7) m
      READ (7) L
      READ (7) d
      CLOSE (7)
      WRITE (*, *) 'READ_FIELD_BINARY_2D: Minimum field value:', minval(d)
      WRITE (*, *) 'READ_FIELD_BINARY_2D: Maximum field value:', maxval(d)
      WRITE (*, *) 'READ_FIELD_BINARY_2D: Average:', mean(splay(d, m, m))
      WRITE (*, *) 'READ_FIELD_BINARY_2D: Variance:', variance(splay(d, m, m))
      WRITE (*, *) 'READ_FIELD_BINARY_2D: Done'
      WRITE (*, *)

   END SUBROUTINE read_field_binary_2D

   SUBROUTINE read_field_binary_3D(d, m, L, infile)

      ! Read in a binary 'field' file
      USE statistics

      REAL, ALLOCATABLE, INTENT(OUT) :: d(:, :, :)
      INTEGER, INTENT(OUT) :: m
      REAL, INTENT(OUT) :: L
      CHARACTER(len=*), INTENT(IN) :: infile
      LOGICAL :: lexist

      ! Write file name to screen and check it exists
      WRITE (*, *) 'READ_FIELD_BINARY_3D: Binary input: ', trim(infile)
      INQUIRE (file=infile, exist=lexist)
      IF (.NOT. lexist) STOP 'READ_SIMULATION_POWER_SPECTRUM: File does not exist'

      ! First get mesh size and physical size
      OPEN (7, file=infile, form='unformatted', access='stream', status='old')
      READ (7) m
      READ (7) L
      CLOSE (7)
      WRITE (*, *) 'READ_FIELD_BINARY_3D: Mesh size:', m
      WRITE (*, *) 'READ_FIELD_BINARY_3D: Field size:', L

      ALLOCATE (d(m, m, m))

      ! Read unformatted data
      OPEN (7, file=infile, form='unformatted', access='stream', status='old')
      READ (7) m
      READ (7) L
      READ (7) d
      CLOSE (7)
      WRITE (*, *) 'READ_FIELD_BINARY_3D: Minval:', minval(d)
      WRITE (*, *) 'READ_FIELD_BINARY_3D: Maxval:', maxval(d)
      WRITE (*, *) 'READ_FIELD_BINARY_3D: Average:', mean(splay(d, m, m, m))
      WRITE (*, *) 'READ_FIELD_BINARY_3D: Variance:', variance(splay(d, m, m, m))
      WRITE (*, *) 'READ_FIELD_BINARY_3D: Done'
      WRITE (*, *)

   END SUBROUTINE read_field_binary_3D

   SUBROUTINE write_field_binary_2D(d, m, L, outfile)

      ! Write out a binary 'field' file
      INTEGER, INTENT(IN) :: m
      REAL, INTENT(IN) :: d(m, m)
      REAL, INTENT(IN) :: L
      CHARACTER(len=*), INTENT(IN) :: outfile

      WRITE (*, *) 'WRITE_FIELD_BINARY_2D: Binary output: ', trim(outfile)
      WRITE (*, *) 'WRITE_FIELD_BINARY_2D: Mesh size:', m
      WRITE (*, *) 'WRITE_FIELD_BINARY_2D: Field size:', L
      WRITE (*, *) 'WRITE_FIELD_BINARY_2D: Minimum field value:', minval(d)
      WRITE (*, *) 'WRITE_FIELD_BINARY_2D: Maximum field value:', maxval(d)
      WRITE (*, *) 'WRITE_FIELD_BINARY_2D: Using new version with access=stream'
      OPEN (7, file=outfile, form='unformatted', access='stream', status='replace')
      WRITE (7) m
      WRITE (7) L
      WRITE (7) d
      CLOSE (7)
      WRITE (*, *) 'WRITE_FIELD_BINARY_2D: Done'
      WRITE (*, *)

   END SUBROUTINE write_field_binary_2D

   SUBROUTINE write_field_binary_3D(d, m, L, outfile)

      ! Write out a binary 'field' file
      ! Used to be called write_field
      INTEGER, INTENT(IN) :: m
      REAL, INTENT(IN) :: d(m, m, m) 
      REAL, INTENT(IN) :: L
      CHARACTER(len=*), INTENT(IN) :: outfile

      WRITE (*, *) 'WRITE_FIELD_BINARY_3D: Binary output: ', trim(outfile)
      WRITE (*, *) 'WRITE_FIELD_BINARY_3D: Mesh size:', m
      WRITE (*, *) 'WRITE_FIELD_BINARY_3D: Field size:', L
      WRITE (*, *) 'WRITE_FIELD_BINARY_3D: Minimum field value:', minval(d)
      WRITE (*, *) 'WRITE_FIELD_BINARY_3D: Maximum field value:', maxval(d)
      WRITE (*, *) 'WRITE_FIELD_BINARY_3D: Using new version with access=stream'
      OPEN (7, file=outfile, form='unformatted', access='stream', status='replace')
      WRITE (7) m
      WRITE (7) L
      WRITE (7) d
      CLOSE (7)
      WRITE (*, *) 'WRITE_FIELD_BINARY_3D: Done'
      WRITE (*, *)

   END SUBROUTINE write_field_binary_3D

   SUBROUTINE write_field_ascii_2D(d, m, L, outfile)

      ! Used to be called print_2D_field
      INTEGER, INTENT(IN) :: m
      REAL, INTENT(IN) :: d(m, m), L   
      CHARACTER(len=*), INTENT(IN) :: outfile
      INTEGER :: i, j
      REAL :: x, y

      WRITE (*, *) 'WRITE_FIELD_ASCII_2D: Writing to: ', trim(outfile)
      WRITE (*, *) 'WRITE_FIELD_ASCII_2D: Field mesh size:', m
      WRITE (*, *) 'WRITE_FIELD_ASCII_2D: Field physical size:', L
      WRITE (*, *) 'WRITE_FIELD_ASCII_2D: Minimum field value:', minval(d)
      WRITE (*, *) 'WRITE_FIELD_ASCII_2D: Maximum field value:', maxval(d)

      OPEN (8, file=outfile)
      DO j = 1, m
         DO i = 1, m

            x = cell_position(i, L, m)
            y = cell_position(j, L, m)

            WRITE (8, *) x, y, d(i, j)

         END DO
      END DO
      CLOSE (8)

      WRITE (*, *) 'WRITE_FIELD_ASCII_2D: Done'
      WRITE (*, *)

   END SUBROUTINE write_field_ascii_2D

   SUBROUTINE write_3D_field_projection_ascii(d, m, L, nz, outfile)

      ! Used to be called print_projected_field
      INTEGER, INTENT(IN) :: m
      REAL, INTENT(IN) :: d(m, m, m)
      REAL, INTENT(IN) :: L
      INTEGER, INTENT(IN) :: nz
      CHARACTER(len=*), INTENT(IN) :: outfile
      INTEGER :: i, j, k
      REAL :: x, y
      REAL :: sum

      WRITE (*, *) 'WRITE_3D_FIELD_PROJECTION_ASCII: Writing to: ', trim(outfile)
      WRITE (*, *) 'WRITE_3D_FIELD_PROJECTION_ASCII: Cells projecting:', nz

      OPEN (8, file=outfile)
      DO j = 1, m
         DO i = 1, m

            x = cell_position(i, L, m)
            y = cell_position(j, L, m)

            sum = 0.
            DO k = 1, nz
               sum = sum+d(i, j, k)
            END DO
            sum = sum/real(nz)

            WRITE (8, *) x, y, sum

         END DO
      END DO
      CLOSE (8)

      WRITE (*, *) 'WRITE_3D_FIELD_PROJECTION_ASCII: Done'
      WRITE (*, *)

   END SUBROUTINE write_3D_field_projection_ascii

   SUBROUTINE compress_field(d, ds, m)

      ! Shrinks a 3D field size by a factor of 2
      INTEGER, INTENT(IN) :: m
      REAL, INTENT(IN) :: d(m, m, m)
      REAL, ALLOCATABLE, INTENT(OUT) :: ds(:, :, :)
      INTEGER :: i, j, k

      ! Allocate the small array
      ALLOCATE (ds(m/2, m/2, m/2))
      ds = 0.

      ! Fill up the small array by summing blocks of 8 from the larger array
      DO k = 1, m/2
         DO j = 1, m/2
            DO i = 1, m/2
               ds(i, j, k) = ds(i, j, k)+d(2*i-1, 2*j-1, 2*k-1)
               ds(i, j, k) = ds(i, j, k)+d(2*i, 2*j-1, 2*k-1)
               ds(i, j, k) = ds(i, j, k)+d(2*i-1, 2*j, 2*k-1)
               ds(i, j, k) = ds(i, j, k)+d(2*i-1, 2*j-1, 2*k)
               ds(i, j, k) = ds(i, j, k)+d(2*i, 2*j, 2*k-1)
               ds(i, j, k) = ds(i, j, k)+d(2*i, 2*j-1, 2*k)
               ds(i, j, k) = ds(i, j, k)+d(2*i-1, 2*j, 2*k)
               ds(i, j, k) = ds(i, j, k)+d(2*i, 2*j, 2*k)
            END DO
         END DO
      END DO

      ! Divide by the number of blocks that are being averaged over
      ds = ds/8.

   END SUBROUTINE compress_field

   SUBROUTINE sharpen_2D(d, m, ibin)

      ! Sharpen a 3D configuration-space array to account for the binning
      INTEGER, INTENT(IN) :: m
      REAL, INTENT(INOUT) :: d(m, m)  
      INTEGER, INTENT(IN) :: ibin
      COMPLEX, ALLOCATABLE :: dk(:, :)
      COMPLEX :: dkout(m, m)
      REAL :: dc(m, m)
      INTEGER :: mn

      WRITE (*, *) 'SHARPEN_2D: Correcting for binning by sharpening field'
      WRITE (*, *) 'SHARPEN_2D: Mesh size:', m

      IF (complex) THEN
         mn = m
         WRITE (*, *) 'SHARPEN_2D: Doing complex->complex FFT'
      ELSE
         mn = m/2+1
         WRITE (*, *) 'SHARPEN_2D: Doing real->complex FFT'
      END IF
      WRITE (*, *) 'SHARPEN_2D: Mesh size general:', m
      WRITE (*, *) 'SHARPEN_2D: Mesh size first-dimension:', mn

      ALLOCATE (dk(mn, m))

      IF (complex) THEN
         dk = d
         CALL fft2(dk, dkout, m, m, -1)
         dk = dkout
      ELSE
         dc = d
         CALL fft2(dc, dk, m, m, -1)
      END IF

      CALL sharpen_k_2D(dk, ibin)

      IF (complex) THEN
         CALL fft2(dk, dkout, m, m, 1)
         dk = dkout
         d = real(real(dk))/real(m**2)
      ELSE
         CALL fft2(dc, dk, m, m, 1)
         d = real(dc)
      END IF

      WRITE (*, *) 'SHARPEN_2D: Sharpening complete'
      WRITE (*, *)

   END SUBROUTINE sharpen_2D

   SUBROUTINE sharpen_3D(d, m, ibin)

      ! Sharpen a 3D configuration-space array to account for the binning
      INTEGER, INTENT(IN) :: m
      REAL, INTENT(INOUT) :: d(m, m, m)
      INTEGER, INTENT(IN) :: ibin
      COMPLEX, ALLOCATABLE :: dk(:, :, :)
      COMPLEX :: dkout(m, m, m)
      REAL :: dc(m, m, m)
      INTEGER :: mn

      WRITE (*, *) 'SHARPEN_3D: Correcting for binning by sharpening field'
      WRITE (*, *) 'SHARPEN_3D: Mesh size:', m

      IF (complex) THEN
         mn = m
         WRITE (*, *) 'SHARPEN_3D: Doing complex->complex FFT'
      ELSE
         mn = m/2+1
         WRITE (*, *) 'SHARPEN_3D: Doing real->complex FFT'
      END IF
      WRITE (*, *) 'SHARPEN_3D: Mesh size general:', m
      WRITE (*, *) 'SHARPEN_3D: Mesh size first-dimension:', mn

      ALLOCATE (dk(mn, m, m))

      IF (complex) THEN
         dk = d
         CALL fft3(dk, dkout, m, m, m, -1)
         dk = dkout
      ELSE
         dc = d
         CALL fft3(dc, dk, m, m, m, -1)
      END IF

      CALL sharpen_k_3D(dk, ibin)

      IF (complex) THEN
         CALL fft3(dk, dkout, m, m, m, 1)
         dk = dkout
         d = real(real(dk))/real(m**3)
      ELSE
         CALL fft3(dc, dk, m, m, m, 1)
         d = real(dc)
      END IF

      WRITE (*, *) 'SHARPEN_3D: Sharpening complete'
      WRITE (*, *)

   END SUBROUTINE sharpen_3D

   SUBROUTINE sharpen_k_2D(dk, ibin)

      USE special_functions

      ! Sharpens a 3D Fourier array to account for the binning
      COMPLEX, INTENT(INOUT) :: dk(:, :)
      INTEGER, INTENT(IN) :: ibin
      INTEGER :: i, j, mn, m
      REAL :: kx, ky, kmod
      REAL :: kxh, kyh
      REAL :: fcx, fcy, fcorr
      REAL :: crap
      REAL, PARAMETER :: L = 1. ! This does not matter for this routine

      mn = size(dk, 1)
      m = size(dk, 2)

      ! Check that the array is sensible
      IF (mn == m .OR. mn == m/2+1) THEN
         ! Do nothing
      ELSE
         WRITE (*, *) 'SHARPEN_K_2D: Array first-dimension size:', mn
         WRITE (*, *) 'SHARPEN_K_2D: Array general size:', m
         STOP 'SHARPEN_K_2D: Error, the array is not sensible'
      END IF

      ! Now correct for binning
      DO j = 1, m
         DO i = 1, mn

            CALL k_fft(i, j, 1, m, kx, ky, crap, kmod, L)

            kxh = L*kx/(2.*real(m))
            kyh = L*ky/(2.*real(m))

            fcx = sinc(kxh)
            fcy = sinc(kyh)

            IF (ibin == 1) THEN
               fcorr = fcx*fcy
            ELSE IF (ibin == 2) THEN
               fcorr = (fcx*fcy)**2
            ELSE
               STOP 'SHARPEN_K_2D: Error, ibin specified incorrectly'
            END IF

            dk(i, j) = dk(i, j)/fcorr

         END DO
      END DO

   END SUBROUTINE sharpen_k_2D

   SUBROUTINE sharpen_k_3D(dk, ibin)

      USE special_functions

      ! Sharpens a 3D array to account for the binning
      COMPLEX, INTENT(INOUT) :: dk(:, :, :)    
      INTEGER, INTENT(IN) :: ibin
      INTEGER :: i, j, k, m, mn
      REAL :: kx, ky, kz, kmod
      REAL :: kxh, kyh, kzh
      REAL :: fcx, fcy, fcz, fcorr
      REAL, PARAMETER :: L = 1. ! This does not matter for this routine

      mn = size(dk, 1)
      m = size(dk, 2)

      ! Check that the array is sensible
      IF (mn == m .OR. mn == m/2+1) THEN
         ! Do nothing; array is sensible
      ELSE
         WRITE (*, *) 'SHARPEN_K_3D: Array first-dimension size:', mn
         WRITE (*, *) 'SHARPEN_K_3D: Array general size:', m
         STOP 'SHARPEN_K_3D: Error, the array is not sensible'
      END IF

      ! Now correct for binning
      DO k = 1, m
         DO j = 1, m
            DO i = 1, mn

               CALL k_fft(i, j, k, m, kx, ky, kz, kmod, L)

               kxh = L*kx/(2.*real(m))
               kyh = L*ky/(2.*real(m))
               kzh = L*kz/(2.*real(m))

               fcx = sinc(kxh)
               fcy = sinc(kyh)
               fcz = sinc(kzh)

               IF (ibin == 1) THEN
                  fcorr = fcx*fcy*fcz
               ELSE IF (ibin == 2) THEN
                  fcorr = (fcx*fcy*fcz)**2
               ELSE
                  STOP 'SHARPEN_K_3D: Error, ibin specified incorrectly'
               END IF

               dk(i, j, k) = dk(i, j, k)/fcorr

            END DO
         END DO
      END DO

   END SUBROUTINE sharpen_k_3D

   SUBROUTINE smooth_2D(d, m, r, L)

      !arr(n,n): input array of size n x n
      !r: smoothing scale in Mpc/h
      !L: box size in Mpc/h
      INTEGER, INTENT(IN) :: m
      REAL, INTENT(INOUT) :: d(m, m)
      REAL, INTENT(IN) :: r
      REAL, INTENT(IN) :: L
      REAL :: kx, ky, kz, k
      COMPLEX, ALLOCATABLE :: dk(:, :)
      COMPLEX :: dkout(m, m)
      REAL :: dc(m, m)
      INTEGER :: i, j, mn

      WRITE (*, *) 'SMOOTH_2D: Smoothing array'
      WRITE (*, *) 'SMOOTH_2D: Assuming array is periodic'
      WRITE (*, *) 'SMOOTH_2D: Smoothing scale [Mpc/h]:', r

      IF (complex) THEN
         mn = m
         WRITE (*, *) 'SMOOTH_2D: Doing complex->complex FFT'
      ELSE
         mn = m/2+1
         WRITE (*, *) 'SMOOTH_2D: Doing real->complex FFT'
      END IF
      WRITE (*, *) 'SMOOTH_2D: Mesh size:', m
      WRITE (*, *) 'SMOOTH_2D: Mesh size x:', mn
      ALLOCATE (dk(mn, m))

      ! Fourier transform
      IF (complex) THEN
         dk = d
         CALL fft2(dk, dkout, m, m, -1)
         dk = dkout
      ELSE
         dc = d
         CALL fft2(dc, dk, m, m, -1)
      END IF

      DO j = 1, m
         DO i = 1, mn
            CALL k_fft(i, j, 1, m, kx, ky, kz, k, L)
            dk(i, j) = dk(i, j)*exp(-((k*r)**2)/2.)
         END DO
      END DO

      ! Normalise post Fourier transform
      IF (complex) THEN
         CALL fft2(dk, dkout, m, m, 1)
         dk = dkout
         dk = dk/real(m**2)
         d = real(real(dk))
      ELSE
         CALL fft2(dc, dk, m, m, 1)
         dc = dc/real(m**2)
         d = real(dc)
      END IF
      DEALLOCATE (dk)

      WRITE (*, *) 'SMOOTH_2D: Done'
      WRITE (*, *)

   END SUBROUTINE smooth_2D

!!$  SUBROUTINE smooth2D_nonperiodic(arr,n,r,L)
!!$
!!$    !arr(n,n): input array of size n x n
!!$    !r: smoothing scale in Mpc/h
!!$    !L: box size in Mpc/h
!!$    USE fft
!!$    IMPLICIT NONE
!!$    INTEGER, INTENT(IN) :: n
!!$    REAL, INTENT(INOUT) :: arr(n,n)
!!$    REAL, INTENT(IN) :: r, L
!!$    REAL :: kx, ky, kz, k
!!$    DOUBLE COMPLEX, ALLOCATABLE :: ac(:,:), ac_out(:,:)
!!$    INTEGER :: i, j, m
!!$
!!$    INTEGER, PARAMETER :: pad=2 !Padding because we generally will not be continuous
!!$
!!$    WRITE(*,*) 'SMOOTH2D: Smoothing array'
!!$    WRITE(*,*) 'SMOOTH2D: Smoothing scale [Mpc/h]:', r
!!$
!!$    !For padding, I cant imagine that x2 would ever be insufficient!
!!$    m=pad*n
!!$
!!$    ALLOCATE(ac(m,m),ac_out(m,m))
!!$
!!$    !Not sure if this is necessary
!!$    ac=(0.d0,0.d0)
!!$    ac_out=(0.d0,0.d0)
!!$
!!$    !Put image into complex array, padded with zeroes where image is not!
!!$    DO j=1,n
!!$       DO i=1,n
!!$          ac(i,j)=arr(i,j)
!!$       END DO
!!$    END DO
!!$
!!$    CALL fft2(ac,ac_out,m,m,-1)
!!$    ac=ac_out
!!$
!!$    !Smoothing length in terms of image(m x m) size!
!!$    !r=pix/float(m)
!!$    DO j=1,m
!!$       DO i=1,m
!!$          CALL k_fft(i,j,1,m,kx,ky,kz,k,pad*L)
!!$          ac(i,j)=ac(i,j)*exp(-((k*r)**2)/2.)
!!$       END DO
!!$    END DO
!!$
!!$    CALL fft2(ac,ac_out,m,m,1)
!!$    ac=ac_out
!!$    DEALLOCATE(ac_out)
!!$
!!$    !Normalise post Fourier transform!
!!$    ac=ac/real(m**2)
!!$
!!$    !Retrieve smooth image from complex array!
!!$    !Need a loop because arr and ac will have different sizes
!!$    DO j=1,n
!!$       DO i=1,n
!!$          arr(i,j)=real(real(ac(i,j)))
!!$       END DO
!!$    END DO
!!$
!!$    WRITE(*,*) 'SMOOTH2D: Done'
!!$    WRITE(*,*)
!!$
!!$  END SUBROUTINE smooth2D_nonperiodic

   SUBROUTINE smooth_3D(d, m, r, L)

      INTEGER, INTENT(IN) :: m
      REAL, INTENT(INOUT) :: d(m, m, m)
      REAL, INTENT(IN) :: r
      REAL, INTENT(IN) :: L
      REAL :: kx, ky, kz, kmod
      COMPLEX, ALLOCATABLE :: dk(:, :, :)
      COMPLEX :: dkout(m, m, m)
      REAL :: dc(m/2+1, m, m)
      INTEGER :: i, j, k, mn

      WRITE (*, *) 'SMOOTH_3D: Smoothing array'

      IF (complex) THEN
         mn = m
         WRITE (*, *) 'SMOOTH_3D: Doing complex->complex FFT'
      ELSE
         mn = m/2+1
         WRITE (*, *) 'SMOOTH_3D: Doing real->complex FFT'
      END IF
      WRITE (*, *) 'SMOOTH_3D: Mesh size:', m
      WRITE (*, *) 'SMOOTH_3D: Mesh size x:', mn
      ALLOCATE (dk(mn, m, m))

      ! Move to Fourier space
      IF (complex) THEN
         dk = d
         CALL fft3(dk, dkout, m, m, m, -1)
         dk = dkout
      ELSE
         dc = d
         CALL fft3(dc, dk, m, m, m, -1)
      END IF

      DO k = 1, m
         DO j = 1, m
            DO i = 1, mn
               CALL k_fft(i, j, k, m, kx, ky, kz, kmod, L)
               !dk(i,j,k)=dk(i,j,k)*sinc(kx*r/2.)*sinc(ky*r/2.)*sinc(kz*r/2.) ! Surely this should be a Gaussian?
               dk(i, j, k) = dk(i, j, k)*exp(-((kmod*r)**2)/2.)
            END DO
         END DO
      END DO

      ! Move back to real space and normalise
      IF (complex) THEN
         CALL fft3(dk, dkout, m, m, m, 1)
         dk = dkout
         dk = dk/(real(m)**3)
         d = real(real(dk))
      ELSE
         CALL fft3(dc, dk, m, m, m, 1)
         dc = dc/real(m)**3
         d = real(dc)
      END IF
      DEALLOCATE (dk)

      WRITE (*, *) 'SMOOTH_3D: Done'
      WRITE (*, *)

   END SUBROUTINE smooth_3D

   SUBROUTINE add_to_stack_3D(x, stack, Ls, ms, back, Lb, mb)

      ! Adds some points in a density field to a stack
      ! Assumes the background field is periodic
      ! 'stack' should have been previously allocated
      ! 'stack' should be set to zero before using this subroutine
      ! '*s' variables refer to the stacked field
      ! '*_back' variables refer to the background field
      INTEGER :: i, j, k, is(3), ib(3), d
      INTEGER, INTENT(IN) :: ms, mb
      REAL, INTENT(IN) :: x(3), Ls, Lb
      REAL, INTENT(INOUT) :: stack(ms, ms, ms)
      REAL, INTENT(IN) :: back(mb, mb, mb)
      REAL :: xb(3)

      ! Loop over cells on stacking mesh
      DO i = 1, ms
         DO j = 1, ms
            DO k = 1, ms

               ! Set the stack integer array
               is(1) = i
               is(2) = j
               is(3) = k

               DO d = 1, 3

                  ! Get coordinates of position on the stack
                  ! This changes coordiantes from stack to simulation coordinates
                  xb(d) = x(d)+Ls*(0.5+real(is(d)-1))/real(ms)-Ls/2.

                  ! Bring the coordinates back into the simulation box if they are outside
                  IF (xb(d) <= 0.) THEN
                     xb(d) = xb(d)+Lb
                  ELSE IF (xb(d) > Lb) THEN
                     xb(d) = xb(d)-Lb
                  END IF

                  ! Find the integer coordinates of mesh cell in the background mesh
                  ! This is just an NGP-type scheme. Could/should be improved?
                  ib(d) = ceiling(real(mb)*xb(d)/Lb)

               END DO

               ! Add the value to the stack
               ! Should there be a volume factor here?
               stack(is(1), is(2), is(3)) = stack(is(1), is(2), is(3))+back(ib(1), ib(2), ib(3))

            END DO
         END DO
      END DO

   END SUBROUTINE add_to_stack_3D

   SUBROUTINE project_3D_to_2D(d3d, d2d, m)

      INTEGER, INTENT(IN) :: m
      REAL, INTENT(IN) :: d3d(m, m, m) 
      REAL, INTENT(OUT) :: d2d(m, m)
      INTEGER :: i, j, k

      WRITE (*, *) 'PROJECT_3D_TO_2D: Projecting 3D stack into 2D'
      d2d = 0.
      DO i = 1, m
         DO j = 1, m
            DO k = 1, m
               d2d(i, j) = d2d(i, j)+d3d(i, j, k)
            END DO
         END DO
      END DO
      d2d = d2d/real(m)
      WRITE (*, *) 'PROJECT_3D_TO_2D: Minimum value of 2D stack:', minval(d2d)
      WRITE (*, *) 'PROJECT_3D_TO_2D: Maximum value of 2D stack:', maxval(d2d)
      WRITE (*, *) 'PROJECT_3D_TO_2D: Done'
      WRITE (*, *)

   END SUBROUTINE project_3D_to_2D

   SUBROUTINE clip(d, m1, m2, m3, d0, verbose)

      USE statistics

      REAL, INTENT(INOUT) :: d(:, :, :)
      REAL, INTENT(IN) :: d0
      INTEGER, INTENT(IN) :: m1, m2, m3
      LOGICAL, INTENT(IN) :: verbose
      REAL :: var1, av1, max1, var2, av2, max2
      INTEGER :: i, j, k

      IF (verbose) THEN
         WRITE (*, *) 'CLIP: Clipping density field'
         WRITE (*, *) 'CLIP: Threshold:', d0
         WRITE (*, *) 'CLIP: Mesh:', m1, m2, m3
      END IF

      av1 = mean(splay(d, m1, m2, m3))
      var1 = variance(splay(d, m1, m2, m3))
      max1 = maxval(d)

      IF (verbose) THEN
         WRITE (*, *) 'CLIP: Average over-density pre-clipping:', av1
         WRITE (*, *) 'CLIP: Variance in over-density pre-clipping:', var1
         WRITE (*, *) 'CLIP: Maximum density pre-clipping:', max1
      END IF

      !    dep=0.25*(1.+erf(d0/(sqrt(2.*var1))))**2.
      !    IF(verbose==1) WRITE(*,*) 'Expected large-scale power depletion factor:', dep

      ! Now do the clipping
      DO k = 1, m3
         DO j = 1, m2
            DO i = 1, m1
               IF (d(i, j, k) > d0) d(i, j, k) = d0
            END DO
         END DO
      END DO

      IF (verbose) WRITE (*, *) 'CLIP: Density field clipped'

      av2 = mean(splay(d, m1, m2, m3))
      var2 = variance(splay(d, m1, m2, m3))
      max2 = maxval(d)

      IF (verbose) THEN
         WRITE (*, *) 'CLIP: Average over-density post-clipping:', av2
         WRITE (*, *) 'CLIP: Variance in over-density post-clipping:', var2
         WRITE (*, *) 'CLIP: Maximum density post-clipping:', max2
         WRITE (*, *)
      END IF

   END SUBROUTINE clip

   SUBROUTINE anticlip(d, m1, m2, m3, d0, verbose)

      USE statistics

      INTEGER, INTENT(IN) :: m1, m2, m3
      REAL, INTENT(INOUT) :: d(m1, m2, m3) 
      REAL, INTENT(IN) :: d0
      LOGICAL, INTENT(IN) :: verbose
      REAL :: var1, av1, min1, var2, av2, min2
      INTEGER :: i, j, k, m

      IF (verbose) THEN
         WRITE (*, *) 'Anti-clipping over-density field'
         WRITE (*, *) 'Threshold:', d0
         WRITE (*, *) 'Mesh:', m
      END IF

      av1 = mean(splay(d, m1, m2, m3))
      var1 = variance(splay(d, m1, m2, m3))
      min1 = minval(d)

      IF (verbose) THEN
         WRITE (*, *) 'Average over-density pre-clipping:', av1
         WRITE (*, *) 'Variance in over-density pre-clipping:', var1
         WRITE (*, *) 'Minimum over-density pre-clipping:', min1
      END IF

      !    dep=0.25*(1.+erf(d0/(sqrt(2.*var1))))**2.
      !    IF(verbose==1) WRITE(*,*) 'Expected large-scale power depletion factor:', dep

      ! Now do the clipping
      DO k = 1, m
         DO j = 1, m
            DO i = 1, m
               IF (d(i, j, k) < d0) d(i, j, k) = d0
            END DO
         END DO
      END DO

      IF (verbose) WRITE (*, *) 'Over-density field clipped'

      av2 = mean(splay(d, m1, m2, m3))
      var2 = variance(splay(d, m1, m2, m3))
      min2 = minval(d)

      IF (verbose) THEN
         WRITE (*, *) 'Average over-density post-clipping:', av2
         WRITE (*, *) 'Variance in over-density post-clipping:', var2
         WRITE (*, *) 'Minimum over-density post-clipping:', min2
         WRITE (*, *)
      END IF

   END SUBROUTINE anticlip

   INTEGER FUNCTION count_empty_cells(d, m)

      USE precision
      INTEGER, INTENT(IN) :: m
      REAL, INTENT(IN) :: d(m, m, m)
      INTEGER(int8) :: sum
      INTEGER :: i, j, k

      sum = 0
      DO k = 1, m
         DO j = 1, m
            DO i = 1, m
               IF (d(i, j, k) == 0.) THEN
                  sum = sum+1
               END IF
            END DO
         END DO
      END DO

      count_empty_cells = INT(sum)

   END FUNCTION count_empty_cells

   SUBROUTINE compute_power_spectrum_2D(dk1, dk2, m, L, kmin, kmax, nk, k, pow, nmodes, sigma, linear_k_range)

      USE table_integer 

      ! Takes in a dk(m,m) array and computes the power spectrum
      ! NOTE: Leave the double complex as it allows the running to determine complex vs real
      COMPLEX, INTENT(IN) :: dk1(:, :) ! Fourier components of field 1
      COMPLEX, INTENT(IN) :: dk2(:, :) ! Fourier components of field 2
      INTEGER, INTENT(IN) :: m         ! mesh size for fields
      REAL, INTENT(IN) :: L            ! box size [Mpc/h]
      REAL, INTENT(IN) :: kmin         ! minimum and maximum wavenumber [h/Mpc]
      REAL, INTENT(IN) :: kmax         ! minimum and maximum wavenumber [h/Mpc]
      INTEGER, INTENT(IN) :: nk        ! number of k bins
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)         ! Output k values
      REAL, ALLOCATABLE, INTENT(OUT) :: pow(:)       ! Output Delta^2(k) values
      INTEGER, ALLOCATABLE, INTENT(OUT) :: nmodes(:) ! Output Number of modes contributing to the k bin
      REAL, ALLOCATABLE, INTENT(OUT) :: sigma(:)     ! Output varaicnce in bin
      LOGICAL, OPTIONAL, INTENT(IN) :: linear_k_range
      INTEGER :: i, ix, iy, n, mn
      REAL :: kx, ky, kmod, Dk, f, crap
      REAL, ALLOCATABLE :: kbin(:)
      !INTEGER(int8) :: nmodes8(nk)

      REAL, PARAMETER :: dbin = 1e-3 ! Bin slop parameter for first and last bin edges
      LOGICAL, PARAMETER :: logmeank = .FALSE. ! Enable this to assign k to the log-mean of the bin (foolish)

      ERROR STOP 'COMPUTE_POWER_SPECTRUM_2D: Check this subroutine very carefully'
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_2D: Computing isotropic power spectrum'

      ! Set summation variables to 0.d0
      !k8 = 0.d0
      !pow8 = 0.d0
      !nmodes8 = 0
      !sigma8 = 0.d0

      ! Allocate arrays
      ALLOCATE (k(nk), pow(nk), nmodes(nk), sigma(nk))
      k = 0.; pow = 0.; nmodes = 0; sigma = 0.

      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_2D: Binning power'
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_2D: Mesh:', m
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_2D: Bins:', nk
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_2D: k_min [h/Mpc]:', kmin
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_2D: k_max [h/Mpc]:', kmax

      ! Fill array of k bins with linear/log spacing
      IF (present_and_correct(linear_k_range)) THEN
         CALL fill_array(kmin, kmax, kbin, nk+1)
      ELSE
         CALL fill_array_log(kmin, kmax, kbin, nk+1)
      END IF

      ! Explicitly extend the first and last bins to be sure to include *all* modes
      ! This is necessary due to rounding errors!
      kbin(1) = kbin(1)*(1.-dbin)
      kbin(nk+1) = kbin(nk+1)*(1.+dbin)

      ! Cell location of Nyquist
      mn = m/2+1

      ! Loop over all independent elements of dk
      DO iy = 1, m
         DO ix = 1, mn

            ! Cycle for the zero mode (k=0)
            IF (ix == 1 .AND. iy == 1) CYCLE

            ! Cycle for the repeated zero modes and Nyquist modes
            ! I *think* this is correct to avoid double counting zero modes and Nyquist modes
            ! For example 0,1 is the same as 0,-1
            IF ((ix == 1 .OR. ix == mn) .AND. iy > mn) CYCLE

            CALL k_fft(ix, iy, 1, m, kx, ky, crap, kmod, L)

            ! Find integer 'n' in bins from place in table
            IF (kmod >= kbin(1) .AND. kmod <= kbin(nk+1)) THEN
               n = find_table_integer(kmod, kbin, ifind_split)
               IF (n < 1 .OR. n > nk) THEN
                  CYCLE
               ELSE
                  k(n) = k(n)+kmod
                  f = real(conjg(dk1(ix, iy))*dk2(ix, iy))
                  f = f/real(m)**2 ! Note the division by m^4 here
                  pow(n) = pow(n)+f
                  sigma(n) = sigma(n)+f**2
                  nmodes(n) = nmodes(n)+1
               END IF
            END IF

         END DO
      END DO

      ! Deallocate and reallocate arrays
      ! TODO: Do I need to bother deallocating these arrays?
      ! TODO: Should I pass in allocatable arrays or should they already be allocated?
      !IF (ALLOCATED(k))      DEALLOCATE (k)
      !IF (ALLOCATED(pow))    DEALLOCATE (pow)
      !IF (ALLOCATED(nmodes)) DEALLOCATE (nmodes)
      !IF (ALLOCATED(sigma))  DEALLOCATE (sigma)

      ! Now create the power spectrum and k array
      DO i = 1, nk
         IF (nmodes(i) == 0) THEN
            k(i) = sqrt(kbin(i+1)*kbin(i))
            pow(i) = 0.d0
            sigma(i) = 0.d0
         ELSE
            IF (logmeank) THEN
               k(i) = sqrt(kbin(i+1)*kbin(i))
            ELSE
               k(i) = real(k(i))/real(nmodes(i))
            END IF
            pow(i) = pow(i)/real(nmodes(i))
            IF (nmodes(i) == 1) THEN
               sigma(i) = 0
            ELSE
               sigma(i) = sigma(i)/real(nmodes(i)) ! Create <P(k)^2>
               sigma(i) = sqrt(sigma(i)-pow(i)**2) ! Create biased estimate of sigma
               sigma(i) = sigma(i)*real(nmodes(i))/real(nmodes(i)-1) ! Correct for bias
               sigma(i) = sigma(i)/sqrt(real(nmodes(i))) ! Convert to error on the mean
            END IF
            Dk = twopi*(k(i)*L/twopi)**2
            pow(i) = pow(i)*Dk
            sigma(i) = sigma(i)*Dk
         END IF
      END DO

      ! Convert from double to single
      !pow = real(pow8)
      !sigma = real(sigma8)
      !nmodes = INT(nmodes8)

      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_2D: Power computed'
      WRITE (*, *)

   END SUBROUTINE compute_power_spectrum_2D

   !SUBROUTINE pk(dk1,dk2,m,L,kmin,kmax,bins,k,pow,nbin)
   SUBROUTINE compute_power_spectrum_3D(dk1, dk2, m, L, kmin, kmax, nk, k, pow, nmodes, sigma, linear_k_range)

      ! Takes in a dk(m,m,m) array and computes the power spectrum
      ! TODO: Care with large sums
      USE table_integer

      COMPLEX, INTENT(IN) :: dk1(:, :, :) ! Fourier components of field 1
      COMPLEX, INTENT(IN) :: dk2(:, :, :) ! Fourier components of field 2
      INTEGER, INTENT(IN) :: m            ! Mesh size for fields
      REAL, INTENT(IN) :: L               ! Box size [Mpc/h]
      REAL, INTENT(IN) :: kmin            ! Minimum wavenumber [h/Mpc]
      REAL, INTENT(IN) :: kmax            ! Maximum wavenumber [h/Mpc]
      INTEGER, INTENT(IN) :: nk           ! Number of k bins
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)         ! Output k values
      REAL, ALLOCATABLE, INTENT(OUT) :: pow(:)       ! Output Delta^2(k) values
      INTEGER, ALLOCATABLE, INTENT(OUT) :: nmodes(:) ! Output Number of modes contributing to the k bin
      REAL, ALLOCATABLE, INTENT(OUT) :: sigma(:)     ! Output varaicnce in bin
      LOGICAL, OPTIONAL, INTENT(IN) :: linear_k_range
      INTEGER :: i, ix, iy, iz, n, mn
      REAL :: kx, ky, kz, kmod, Dk, f
      REAL, ALLOCATABLE :: kbin(:)

      REAL, PARAMETER :: dbin = 1e-3           ! Bin slop parameter for first and last bin edges
      LOGICAL, PARAMETER :: logmeank = .FALSE. ! Enable this to assign k to the log-mean of the bin (foolish)

      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_3D: Computing isotropic power spectrum'
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_3D: Binning power'
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_3D: Mesh:', m
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_3D: Bins:', nk
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_3D: k_min [h/Mpc]:', kmin
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_3D: k_max [h/Mpc]:', kmax

      ! Fill array of k bins with linear/log spacing
      IF (present_and_correct(linear_k_range)) THEN
         CALL fill_array(kmin, kmax, kbin, nk+1)
      ELSE
         CALL fill_array_log(kmin, kmax, kbin, nk+1)
      END IF

      ! Explicitly extend the first and last bins to be sure to include *all* modes
      ! This is necessary due to rounding errors!
      kbin(1) = kbin(1)*(1.-dbin)
      kbin(nk+1) = kbin(nk+1)*(1.+dbin)

      ! Allocate arrays and set to zero because they are used for large sums
      ALLOCATE (k(nk), pow(nk), nmodes(nk), sigma(nk))
      k = 0.
      pow = 0.
      nmodes = 0
      sigma = 0.

      ! Cell location of Nyquist
      !IF (.NOT. even(m)) STOP 'COMPUTE_POWER_SPECTRUM_3D: Error, m must be even'
      mn = m/2+1

      ! Loop over all independent elements of dk
      DO iz = 1, m
         DO iy = 1, m
            DO ix = 1, mn

               ! Cycle for the zero mode (k=0)
               IF (ix == 1 .AND. iy == 1 .AND. iz == 1) CYCLE

               ! Cycle for the repeated Nyquist modes
               ! I *think* this is correct to avoid double counting zero modes and Nyquist modes
               ! For example (0, 1, 0) is the same as (0, -1, 0)
               IF ((ix == 1 .OR. ix == mn) .AND. (iy > mn .OR. iz > mn)) CYCLE

               ! Get the wavenumbers corresponding to the array position
               CALL k_FFT(ix, iy, iz, m, kx, ky, kz, kmod, L)

               ! Find integer 'n' in bins from place in table
               IF (kmod >= kbin(1) .AND. kmod <= kbin(nk+1)) THEN
                  n = find_table_integer(kmod, kbin, ifind_split)
                  IF (n < 1 .OR. n > nk) THEN
                     CYCLE
                  ELSE
                     k(n) = k(n)+kmod
                     f = real(conjg(dk1(ix, iy, iz))*dk2(ix, iy, iz))
                     f = f/real(m)**6
                     pow(n) = pow(n)+f
                     sigma(n) = sigma(n)+f**2
                     nmodes(n) = nmodes(n)+1
                  END IF
               END IF

            END DO
         END DO
      END DO

      ! Now create the power spectrum and k array
      DO i = 1, nk
         IF (nmodes(i) == 0) THEN
            k(i) = sqrt(kbin(i+1)*kbin(i))
            pow(i) = 0.d0
            sigma(i) = 0.d0
         ELSE
            IF (logmeank) THEN
               k(i) = sqrt(kbin(i+1)*kbin(i))
            ELSE
               k(i) = k(i)/nmodes(i)
            END IF
            pow(i) = pow(i)/nmodes(i) ! Create <P(k)>
            IF (nmodes(i) == 1) THEN
               sigma(i) = 0.
            ELSE
               sigma(i) = sigma(i)/nmodes(i) ! Create <P(k)^2>
               sigma(i) = sigma(i)-pow(i)**2 ! Create biased estimate of variance
               sigma(i) = sigma(i)*nmodes(i)/(nmodes(i)-1) ! Correct for bias
               sigma(i) = sqrt(sigma(i)) ! Create estimate of standard deviation
               sigma(i) = sigma(i)/sqrt(real(nmodes(i))) ! Convert to error-on-the-mean
            END IF
            Dk = 4.*pi*(k(i)*L/twopi)**3
            pow(i) = pow(i)*Dk
            sigma(i) = sigma(i)*Dk
         END IF
      END DO

      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_3D: Delta^2 at min k:', pow(1)
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_3D: Delta^2 at max k:', pow(nk)
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_3D: Power computed'
      WRITE (*, *)

   END SUBROUTINE compute_power_spectrum_3D

   SUBROUTINE compute_multipole_power_spectrum_3D(dk1, dk2, m, L, ipole, izz, kmin, kmax, nk, k, pow, nmodes, sigma, linear_k_range)

      ! Takes in a dk(m,m,m) array and computes the power spectrum
      USE table_integer
      USE special_functions
      COMPLEX, INTENT(IN) :: dk1(:, :, :) ! Fourier components of field 1
      COMPLEX, INTENT(IN) :: dk2(:, :, :) ! Fourier components of field 2
      INTEGER, INTENT(IN) :: m     ! Mesh size for fields
      REAL, INTENT(IN) :: L        ! Box size [Mpc/h]
      INTEGER, INTENT(IN) :: ipole ! Multipole to compute
      INTEGER, INTENT(IN) :: izz   ! Redshift direction
      REAL, INTENT(IN) :: kmin     ! Minimum wavenumber [h/Mpc]
      REAL, INTENT(IN) :: kmax     ! Maximum wavenumber [h/Mpc]
      INTEGER, INTENT(IN) :: nk    ! Number of k bins
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)         ! Output k values
      REAL, ALLOCATABLE, INTENT(OUT) :: pow(:)       ! Output Delta^2(k) values
      INTEGER, ALLOCATABLE, INTENT(OUT) :: nmodes(:) ! Output Number of modes contributing to the k bin
      REAL, ALLOCATABLE, INTENT(OUT) :: sigma(:)     ! Output varaicnce in bin
      LOGICAL, OPTIONAL, INTENT(IN) :: linear_k_range
      INTEGER :: i, ix, iy, iz, n, mn
      REAL :: kx, ky, kz, kmod, Dk, mu, f
      REAL, ALLOCATABLE :: kbin(:)
      REAL, PARAMETER :: dbin = 1e-3           ! Bin slop parameter for first and last bin edges
      LOGICAL, PARAMETER :: logmeank = .FALSE. ! Enable this to assign k to the log-mean of the bin (foolish)

      ERROR STOP 'COMPUTE_MULTIPOLE_POWER_SPECTRUM_3D: Check this subroutine very carefully'
      WRITE (*, *) 'COMPUTE_MULTIPOLE_POWER_SPECTRUM_3D: Computing isotropic power spectrum'

      ! Set summation variables to 0.d0
      !k8 = 0.d0
      !pow8 = 0.d0
      !nmodes8 = 0
      !sigma8 = 0.d0
      ALLOCATE (k(nk), pow(nk), nmodes(nk), sigma(nk))
      k = 0.; pow = 0.; nmodes = 0; sigma = 0.

      WRITE (*, *) 'COMPUTE_MULTIPOLE_POWER_SPECTRUM_3D: Binning power'
      WRITE (*, *) 'COMPUTE_MULTIPOLE_POWER_SPECTRUM_3D: Mesh:', m
      WRITE (*, *) 'COMPUTE_MULTIPOLE_POWER_SPECTRUM_3D: Bins:', nk
      WRITE (*, *) 'COMPUTE_MULTIPOLE_POWER_SPECTRUM_3D: k_min [h/Mpc]:', kmin
      WRITE (*, *) 'COMPUTE_MULTIPOLE_POWER_SPECTRUM_3D: k_max [h/Mpc]:', kmax

      ! Fill array of k bins with linear/log spacing
      IF (present_and_correct(linear_k_range)) THEN
         CALL fill_array(kmin, kmax, kbin, nk+1)
      ELSE
         CALL fill_array_log(kmin, kmax, kbin, nk+1)
      END IF

      ! Explicitly extend the first and last bins to be sure to include *all* modes
      ! This is necessary due to rounding errors!
      kbin(1) = kbin(1)*(1.-dbin)
      kbin(nk+1) = kbin(nk+1)*(1.+dbin)

      ! Cell location of Nyquist
      mn = m/2+1

      ! Loop over all independent elements of dk
      DO iz = 1, m
         DO iy = 1, m
            DO ix = 1, mn

               ! Cycle for the zero mode (k=0)
               IF (ix == 1 .AND. iy == 1 .AND. iz == 1) CYCLE

               ! Cycle for the repeated zero modes and Nyquist modes
               ! I *think* this is correct to avoid double counting zero modes and Nyquist modes
               ! For example 0,1,0 is the same as 0,-1,0
               IF ((ix == 1 .OR. ix == mn) .AND. (iy > mn .OR. iz > mn)) CYCLE

               CALL k_fft(ix, iy, iz, m, kx, ky, kz, kmod, L)

               IF (izz == 1) THEN
                  mu = kx/kmod
               ELSE IF (izz == 2) THEN
                  mu = ky/kmod
               ELSE IF (izz == 3) THEN
                  mu = kz/kmod
               ELSE
                  STOP 'COMPUTE_MULTIPOLE_POWER_SPECTRUM_3D: Error, iz not specified correctly'
               END IF

               ! Find integer 'n' in bins from place in table
               IF (kmod >= kbin(1) .AND. kmod <= kbin(nk+1)) THEN
                  n = find_table_integer(kmod, kbin, ifind_split)
                  IF (n < 1 .OR. n > nk) THEN
                     CYCLE
                  ELSE
                     k(n) = k(n)+kmod
                     f = real(conjg(dk1(ix, iy, iz))*dk2(ix, iy, iz))
                     f = f/real(m)**6
                     f = f*Legendre_polynomial(ipole, mu)*(2.*ipole+1.)
                     pow(n) = pow(n)+f
                     sigma(n) = sigma(n)+f**2
                     nmodes(n) = nmodes(n)+1
                  END IF
               END IF

            END DO
         END DO
      END DO

      ! Deallocate and reallocate arrays
      ! TODO: Do I need to bother deallocating these arrays?
      ! TODO: Should I pass in allocatable arrays or should they already be allocated?
      !IF (ALLOCATED(k))      DEALLOCATE (k)
      !IF (ALLOCATED(pow))    DEALLOCATE (pow)
      !IF (ALLOCATED(nmodes)) DEALLOCATE (nmodes)
      !IF (ALLOCATED(sigma))  DEALLOCATE (sigma)
      !ALLOCATE (k(nk), pow(nk), nmodes(nk), sigma(nk))

      ! Now create the power spectrum and k array
      DO i = 1, nk
         IF (nmodes(i) == 0) THEN
            k(i) = sqrt(kbin(i+1)*kbin(i))
            pow(i) = 0.d0
            sigma(i) = 0.d0
         ELSE
            IF (logmeank) THEN
               k(i) = sqrt(kbin(i+1)*kbin(i))
            ELSE
               k(i) = real(k(i))/real(nmodes(i))
            END IF
            pow(i) = pow(i)/real(nmodes(i)) ! Create <P(k)>
            IF (nmodes(i) == 1) THEN
               sigma(i) = 0.
            ELSE
               sigma(i) = sigma(i)/real(nmodes(i)) ! Create <P(k)^2>
               sigma(i) = sigma(i)-pow(i)**2 ! Create biased estimate of variance
               sigma(i) = sigma(i)*real(nmodes(i))/real(nmodes(i)-1) ! Correct for bias
               sigma(i) = sqrt(sigma(i)) ! Create estimate of standard deviation
               sigma(i) = sigma(i)/sqrt(real(nmodes(i))) ! Convert to error-on-the-mean
            END IF
            Dk = 4.*pi*(k(i)*L/twopi)**3
            pow(i) = pow(i)*Dk
            sigma(i) = sigma(i)*Dk
         END IF
      END DO

      ! Convert from double to single
      !pow = real(pow8)
      !sigma = real(sigma8)
      !nmodes = INT(nmodes8)

      WRITE (*, *) 'COMPUTE_MULTIPOLE_POWER_SPECTRUM_3D: Power computed'
      WRITE (*, *)

   END SUBROUTINE compute_multipole_power_spectrum_3D

   SUBROUTINE compute_power_spectrum_pole(d, m, L, ipole, iz, kmin, kmax, nk, kval, pow, nmodes)

      USE special_functions
      INTEGER, INTENT(IN) :: m
      COMPLEX, INTENT(IN) :: d(m, m, m)
      REAL, INTENT(IN) :: kmin, kmax, L
      INTEGER, INTENT(IN) :: iz, ipole, nk
      REAL, ALLOCATABLE, INTENT(OUT) :: pow(:), kval(:)
      INTEGER, ALLOCATABLE, INTENT(OUT) :: nmodes(:)
      INTEGER :: i, j, k, n
      REAL :: kx, ky, kz, kmod, mu
      REAL :: kbin(nk+1)

      STOP 'COMPUTE_POWER_SPECTRUM_POLE: Check this subroutine very carefully, see notes in code'
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_POLE: Computing isotropic power spectrum'

      ALLOCATE(pow(nk), kval(nk), nmodes(nk))
      kval = 0.; pow = 0.; nmodes = 0

      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_POLE: Binning power'
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_POLE: Bins:', nk
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_POLE: k_min:', kmin
      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_POLE: k_max:', kmax

      ! Log-spaced bins
      ! TODO: Surely this needs to be in a loop? Use allocate function?
      kbin(i) = progression(kmin, kmax, i, nk+1, ilog=.TRUE.)

      !Explicitly extend the bins to be sure to include all modes
      !This is necessary due to rounding errors!
      !    kbin(1)=kbin(1)*0.999
      !    kbin(bins+1)=kbin(bins+1)*1.001
      !m=SIZE(d(:,1,1))

      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_POLE: Mesh:', m

      DO k = 1, m
         DO j = 1, m
            DO i = 1, m

               IF (i == 1 .AND. j == 1 .AND. k == 1) CYCLE

               CALL k_fft(i, j, k, m, kx, ky, kz, kmod, L)

               IF (iz == 1) THEN
                  mu = kx/kmod
               ELSE IF (iz == 2) THEN
                  mu = ky/kmod
               ELSE IF (iz == 3) THEN
                  mu = kz/kmod
               END IF

               !             DO o=1,bins
               !                IF(kmod>=kbin(o) .AND. kmod<=kbin(o+1)) THEN
               !                   pow8(o)=pow8(o)+(abs(d(i,j,k))**2.)*legendre(ipole,mu)*(2.*float(ipole)+1.)!/2.
               !                   kval(o)=kval(o)+kmod
               !                   nbin8(o)=nbin8(o)+1
               !                   EXIT
               !                END IF
               !             END DO

               ! Find integer automatically from place in table. Assumes log-spaced bins
               ! Implemented (27/08/15) so could be a source of bugs
               ! Differences will appear due to k modes that are on the boundary
               n = 1+floor(real(nk)*log(kmod/kmin)/log(kmax/kmin))
               IF (n < 1 .OR. n > nk) THEN
                  CYCLE
               ELSE
                  pow(n) = pow(n)+(abs(d(i, j, k))**2)*Legendre_polynomial(ipole, mu)*(2.*ipole+1.)
                  kval(n) = kval(n)+kmod
                  nmodes(n) = nmodes(n)+1
               END IF

            END DO
         END DO
      END DO

      !Deallocate and re-allocate arrays
      !IF (ALLOCATED(kval)) DEALLOCATE (kval)
      !IF (ALLOCATED(pow)) DEALLOCATE (pow)
      !IF (ALLOCATED(nmodes)) DEALLOCATE (nmodes)
      !ALLOCATE (kval(nk), pow(nk), nmodes(nk))

      DO i = 1, nk
         kval(i) = (kbin(i+1)+kbin(i))/2. ! Should be sqrt(kmax*kmin) for log
         IF (nmodes(i) == 0) THEN
            pow(i) = 0.
         ELSE
            pow(i) = pow(i)/real(nmodes(i))
            pow(i) = pow(i)*((L*kval(i))**3)/(2.*pi**2) ! Not sure this is good; create P(k) and then Delta(k)?
         END IF
      END DO

      pow = pow/real(m)**6

      !Divide by 2 because double count Hermitian conjugates
      nmodes = nmodes/2

      WRITE (*, *) 'COMPUTE_POWER_SPECTRUM_POLE: Power computed'
      WRITE (*, *)

   END SUBROUTINE compute_power_spectrum_pole

   ! SUBROUTINE compute_power_spectrum_rsd(d, L, kmin, kmax, nk, kv, mu, pow, nmodes, iz)

   !    INTEGER :: i, j, k, m, ii, jj, nk, iz
   !    REAL :: kx, ky, kz, kmod, L, kmin, kmax, a, b, mus
   !    REAL :: pow(nk, nk), kv(nk), kbin(nk+1), mu(nk), mubin(nk+1)
   !    !DOUBLE PRECISION :: pow8(nk, nk)
   !    INTEGER :: nmodes(nk, nk)
   !    !INTEGER*8 :: nmodes8(nk, nk)
   !    INTEGER(int8) :: nmodes8(nk, nk)
   !    !DOUBLE COMPLEX :: d(:, :, :)
   !    COMPLEX :: d(:, :, :)

   !    STOP 'COMPUTE_POWER_SPECTRUM_RSD: Check this very carefully'

   !    WRITE (*, *) 'Computing RSD power spectrum'

   !    kbin = 0.
   !    mubin = 0.
   !    kv = 0.
   !    mu = 0.
   !    pow = 0.
   !    nmodes = 0

   !    pow8 = 0.d0
   !    nmodes8 = 0

   !    WRITE (*, *) 'Binning power'
   !    WRITE (*, *) 'Bins:', nk
   !    WRITE (*, *) 'k_min:', kmin
   !    WRITE (*, *) 'k_max:', kmax

   !    a = kmin
   !    b = kmax

   !    a = log10(a)
   !    b = log10(b)

   !    !DO i=1,bins+1
   !    !   kbin(i)=a+(b-a)*float(i-1)/float(bins)
   !    !END DO
   !    kbin(i) = progression(a, b, i, nk+1)

   !    !DO i=1,bins+1
   !    !   mubin(i)=float(i-1)/float(bins)
   !    !END DO
   !    mubin(i) = progression(0., 1., i, nk+1)

   !    DO i = 1, nk
   !       kv(i) = (kbin(i)+kbin(i+1))/2.
   !       mu(i) = (mubin(i)+mubin(i+1))/2.
   !    END DO

   !    kbin = 10.**kbin
   !    kv = 10.**kv

   !    !Explicitly extend the bins to be sure to include all modes
   !    !This is necessary due to rounding errors!
   !    kbin(1) = kbin(1)*0.999
   !    kbin(nk+1) = kbin(nk+1)*1.001
   !    mubin(1) = -0.001
   !    mubin(nk+1) = 1.001

   !    m = SIZE(d(:, 1, 1))

   !    WRITE (*, *) 'Mesh:', m

   !    DO k = 1, m
   !       DO j = 1, m
   !          DO i = 1, m

   !             IF (i == 1 .AND. j == 1 .AND. k == 1) CYCLE

   !             CALL k_fft(i, j, k, m, kx, ky, kz, kmod, L)

   !             IF (iz == 1) THEN
   !                mus = kx/kmod
   !             ELSE IF (iz == 2) THEN
   !                mus = ky/kmod
   !             ELSE IF (iz == 3) THEN
   !                mus = kz/kmod
   !             ELSE
   !                STOP 'COMPUTE_POWER_SPECTRUM_RSD: Error, iz not specified correctly'
   !             END IF

   !             mus = abs(mus)

   !             !             WRITE(*,*) mus, kbin(1), kbin(2), kmod
   !             !             IF(i==10) STOP

   !             DO jj = 1, nk
   !                IF (kmod >= kbin(jj) .AND. kmod <= kbin(jj+1)) THEN
   !                   DO ii = 1, nk
   !                      IF (mus >= mubin(ii) .AND. mus <= mubin(ii+1)) THEN
   !                         pow8(ii, jj) = pow8(ii, jj)+abs(d(i, j, k))**2.
   !                         nmodes8(ii, jj) = nmodes8(ii, jj)+1
   !                         EXIT
   !                      END IF
   !                   END DO
   !                   EXIT
   !                END IF
   !             END DO

   !          END DO
   !       END DO
   !    END DO

   !    DO jj = 1, nk
   !       DO ii = 1, nk
   !          IF (nmodes8(ii, jj) == 0) THEN
   !             pow8(ii, jj) = 0.
   !          ELSE
   !             pow8(ii, jj) = pow8(ii, jj)/real(nmodes8(ii, jj))
   !             pow8(ii, jj) = pow8(ii, jj)*((L*kv(jj))**3.)/(2.*pi**2.)
   !          END IF
   !       END DO
   !    END DO

   !    pow = real(pow8)/(real(m)**6)

   !    !Divide by 2 because double count Hermitian conjugates
   !    nmodes = INT(nmodes8)/2

   !    WRITE (*, *) 'Power computed'
   !    WRITE (*, *)

   ! END SUBROUTINE compute_power_spectrum_rsd

   ! SUBROUTINE compute_power_spectrum_rsd2(d, L, kmin, kmax, nk, kpar, kper, pow, nmodes, iz)

   !    INTEGER :: i, j, k, m, ii, jj, nk, iz
   !    REAL :: kx, ky, kz, kmod, L, kmin, kmax, a, b, kpers, kpars
   !    REAL :: pow(nk, nk), kpar(nk), kparbin(nk+1), kper(nk), kperbin(nk+1)
   !    !DOUBLE PRECISION :: pow8(nk, nk)
   !    REAL :: pow8(nk, nk)
   !    INTEGER :: nmodes(nk, nk)
   !    !INTEGER*8 :: nmodes8(nk, nk)
   !    INTEGER(int8) :: nmodes8(nk, nk)
   !    !DOUBLE COMPLEX :: d(:, :, :)
   !    COMPLEX :: d(:, :, :)

   !    STOP 'COMPUTE_POWER_SPECTRUM_RSD2: Check this very carefully'

   !    WRITE (*, *) 'Computing rsd power spectrum'

   !    kparbin = 0.
   !    kperbin = 0.
   !    kpar = 0.
   !    kper = 0.
   !    pow = 0.
   !    nmodes = 0

   !    pow8 = 0.d0
   !    nmodes8 = 0

   !    WRITE (*, *) 'Binning power'
   !    WRITE (*, *) 'Bins:', nk
   !    WRITE (*, *) 'k_min:', kmin
   !    WRITE (*, *) 'k_max:', kmax

   !    a = kmin
   !    b = kmax

   !    a = log10(a)
   !    b = log10(b)

   !    !DO i=1,bins+1
   !    !   kparbin(i)=a+(b-a)*float(i-1)/float(bins)
   !    !END DO
   !    kparbin(i) = progression(a, b, i, nk+1)

   !    DO i = 1, nk
   !       kpar(i) = (kparbin(i)+kparbin(i+1))/2.
   !    END DO

   !    kparbin = 10.**kparbin
   !    kpar = 10.**kpar

   !    !Explicitly extend the bins to be sure to include all modes
   !    !This is necessary due to rounding errors!
   !    kparbin(1) = kparbin(1)*0.999
   !    kparbin(nk+1) = kparbin(nk+1)*1.001

   !    kperbin = kparbin
   !    kper = kpar

   !    m = SIZE(d(:, 1, 1))

   !    WRITE (*, *) 'Mesh:', m

   !    DO k = 1, m
   !       DO j = 1, m
   !          DO i = 1, m

   !             IF (i == 1 .AND. j == 1 .AND. k == 1) CYCLE

   !             CALL k_fft(i, j, k, m, kx, ky, kz, kmod, L)

   !             IF (iz == 1) THEN
   !                kpars = abs(kx)
   !                kpers = sqrt(ky**2.+kz**2.)
   !             ELSE IF (iz == 2) THEN
   !                kpars = abs(ky)
   !                kpers = sqrt(kz**2.+kx**2.)
   !             ELSE IF (iz == 3) THEN
   !                kpars = abs(kz)
   !                kpers = sqrt(kx**2.+ky**2.)
   !             ELSE
   !                STOP 'COMPUTE_POWER_SPECTRUM_RSD2: Error, iz not specified correctly'
   !             END IF

   !             DO jj = 1, nk
   !                IF (kpars >= kparbin(jj) .AND. kpars <= kparbin(jj+1)) THEN
   !                   DO ii = 1, nk
   !                      IF (kpers >= kperbin(ii) .AND. kpers <= kperbin(ii+1)) THEN
   !                         pow8(ii, jj) = pow8(ii, jj)+abs(d(i, j, k))**2.
   !                         nmodes8(ii, jj) = nmodes8(ii, jj)+1
   !                         EXIT
   !                      END IF
   !                   END DO
   !                   EXIT
   !                END IF
   !             END DO

   !          END DO
   !       END DO
   !    END DO

   !    !    DO jj=1,bins
   !    !       DO ii=1,bins
   !    !          pow(ii,jj)=pow(ii,jj)/log(kperbin(ii+1)/kperbin(ii))
   !    !          pow(ii,jj)=pow(ii,jj)/log(kparbin(jj+1)/kparbin(jj))
   !    !       END DO
   !    !    END DO

   !    DO jj = 1, nk
   !       DO ii = 1, nk
   !          IF (nmodes8(ii, jj) == 0) THEN
   !             pow8(ii, jj) = 0.
   !          ELSE
   !             pow8(ii, jj) = pow8(ii, jj)/real(nmodes8(ii, jj))
   !             pow8(ii, jj) = pow8(ii, jj)*(L**3.*kpar(jj)*kper(ii)**2.)/(2.*pi**2.)
   !          END IF
   !       END DO
   !    END DO

   !    pow = real(pow8)/(real(m)**6)

   !    !Divide by 2 because double count Hermitian conjugates
   !    nmodes = INT(nmodes8)/2

   !    WRITE (*, *) 'Power computed'
   !    WRITE (*, *)

   ! END SUBROUTINE compute_power_spectrum_rsd2

   REAL FUNCTION box_mode_power(dk)

      COMPLEX, INTENT(IN) :: dk(:, :, :)    

      box_mode_power = real(abs(dk(2, 1, 1))**2+abs(dk(1, 2, 1))**2+abs(dk(1, 1, 2))**2)/3.

   END FUNCTION box_mode_power

   FUNCTION periodic_distance(x1, x2, L)

      ! Calculates the distance between x1 and x2 assuming that they are coordinates in a periodic box
      ! This is in field_operations because it needs coordinates, *not* necessarily particles
      REAL :: periodic_distance
      REAL, INTENT(IN) :: x1(3), x2(3), L
      REAL :: dx(3)
      INTEGER :: i

      ! Initially dx is just the absolute vector difference
      dx = abs(x2-x1)

      ! Now check if any legs are greater than half-box size
      ! Note the Cartesian distance *cannot* be larger than L/2
      DO i = 1, 3
         IF (dx(i) > L/2.) THEN
            dx(i) = L-dx(i)
         END IF
      END DO

      periodic_distance = sqrt(dx(1)**2+dx(2)**2+dx(3)**2)

   END FUNCTION periodic_distance

   FUNCTION periodic_mean(x1, x2, L)

      ! Calculates the periodic mean of two coordinates in a box
      ! This is in field_operations because it needs coordinates, *not* necessarily particles
      REAL :: periodic_mean(3)
      REAL, INTENT(IN) :: x1(3), x2(3), L
      REAL :: dx(3)
      INTEGER :: i

      ! Initially dx is just the absolute vector difference
      dx = abs(x2-x1)

      DO i = 1, 3
         periodic_mean(i) = 0.5*(x1(i)+x2(i))
         IF (dx(i) > L/2.) THEN
            periodic_mean(i) = periodic_mean(i)+L/2.
         END IF
      END DO

   END FUNCTION periodic_mean

   SUBROUTINE field_correlation_function(r_array, xi_array, n_array, n, d, m, L)

      ! This double counts, so time could be at least halved
      ! Also could be parrallelised
      ! Also could just not be complete shit, but it should get the job done
      USE precision
      USE table_integer

      INTEGER, INTENT(IN) :: n, m
      REAL, INTENT(OUT) :: xi_array(n)
      REAL, INTENT(IN) :: L, d(m, m, m), r_array(n)
      !INTEGER*8, INTENT(OUT) :: n_array(n)
      INTEGER(int8), INTENT(OUT) :: n_array(n)
      REAL:: rmin, rmax
      !DOUBLE PRECISION :: xi8_array(n)
      INTEGER :: i1, i2, i3, j1, j2, j3, i(3), j(3), k, dim
      REAL :: r, x1(3), x2(3)

      ERROR STOP 'FIELD_CORRELATION_FUNCTION: Check this very carefully'

      rmin = r_array(1)
      rmax = r_array(n)

      WRITE (*, *) 'FIELD_CORRELATION_FUNCTION: rmin [Mpc/h]:', rmin
      WRITE (*, *) 'FIELD_CORRELATION_FUNCTION: rmax [Mpc/h]:', rmax
      WRITE (*, *) 'FIELD_CORRELATION_FUNCTION: number of r bins:', n

      xi_array = 0.d0
      n_array = 0

      DO i3 = 1, m
         DO i2 = 1, m
            DO i1 = 1, m

               i(1) = i1
               i(2) = i2
               i(3) = i3

               DO dim = 1, 3
                  x1(dim) = cell_position(i(dim), L, m)
               END DO

               DO j3 = 1, m
                  DO j2 = 1, m
                     DO j1 = 1, m

                        j(1) = j1
                        j(2) = j2
                        j(3) = j3

                        DO dim = 1, 3
                           x2(dim) = cell_position(j(dim), L, m)
                        END DO

                        r = periodic_distance(x1, x2, L)

                        IF (r < rmin .OR. r > rmax) THEN
                           CYCLE
                        ELSE
                           k = find_table_integer(r, r_array, ifind_split)
                           IF (k < 1 .OR. k > n) ERROR STOP 'FIELD_CORRELATION_FUNCTION: Integer finding has failed'
                           xi_array(k) = xi_array(k)+d(i(1), i(2), i(3))*d(j(1), j(2), j(3))
                           n_array(k) = n_array(k)+1
                        END IF

                     END DO
                  END DO
               END DO

            END DO
         END DO
      END DO
      xi_array = xi_array/n_array

      WRITE (*, *) 'FIELD_CORRELATION_FUNCTION: done'
      WRITE (*, *)

   END SUBROUTINE field_correlation_function

   INTEGER FUNCTION empty_cells_3D(d, m)

      USE precision

      INTEGER, INTENT(IN) :: m
      REAL, INTENT(IN) :: d(m, m, m)   
      !INTEGER*8 :: sum
      INTEGER(int8) :: sum
      INTEGER :: i, j, k

      sum = 0
      DO k = 1, m
         DO j = 1, m
            DO i = 1, m
               IF (d(i, j, k) == 0.) THEN
                  sum = sum+1
               END IF
            END DO
         END DO
      END DO

      empty_cells_3D = int(sum)

   END FUNCTION empty_cells_3D

END MODULE field_operations

MODULE string_operations

   USE basic_operations

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: number_file
   PUBLIC :: number_file2
   PUBLIC :: number_file_zeroes
   PUBLIC :: integer_to_string
   PUBLIC :: real_to_string
   PUBLIC :: exp_to_string
   PUBLIC :: snippet_in_string

CONTAINS

!!$  ! I cannot remember where (or why) I stole this from
!!$  elemental subroutine str2int(str,int,stat)
!!$
!!$    implicit none
!!$    character(len=*),intent(in) :: str
!!$    integer,intent(out)         :: int
!!$    integer,intent(out)         :: stat
!!$
!!$    read(str,*,iostat=stat) int
!!$
!!$  end subroutine str2int

   LOGICAL FUNCTION snippet_in_string(snip, string)

      ! Returns true if 'str1' exists within 'str2'
      CHARACTER(len=*), INTENT(IN) :: snip
      CHARACTER(len=*), INTENT(IN) :: string
      INTEGER :: i
      INTEGER :: l1, l2

      l1 = len(trim(snip))
      l2 = len(trim(string))

      snippet_in_string = .FALSE.

      DO i = 1, l2-l1+1
         IF (trim(snip) == string(i:i+l1-1)) THEN
            snippet_in_string = .TRUE.
            EXIT
         END IF
      END DO

   END FUNCTION snippet_in_string

   CHARACTER(len=8) FUNCTION integer_to_string(i, n)

      INTEGER, INTENT(IN) :: i
      INTEGER, OPTIONAL, INTENT(IN) :: n
      CHARACTER(len=8) :: fmt 

      IF (present(n)) THEN

         IF (i < 0) STOP 'INTEGER_TO_STRING: Error, cannot pad with negative number'
         IF (log10(real(i)) >= n) STOP 'INTEGER_TO_STRING: Error, number greater than padding size'
      
         IF (n == 1) THEN
            fmt = '(I0.1)'
         ELSE IF (n == 2) THEN
            fmt = '(I0.2)'
         ELSE IF (n == 3) THEN
            fmt = '(I0.3)'
         ELSE IF (n == 4) THEN
            fmt = '(I0.4)'
         ELSE
            STOP 'INTEGER_TO_STRING: Error, need to support padding > 4'
         END IF

      ELSE

         IF (i < 0) THEN
            IF (between(i, -9, -1)) THEN
               fmt = '(I2)'
            ELSE
               STOP 'INTEGER_TO_STRING: Error, your integer is not supported'
            END IF
         ELSE
            IF (between(i, 0, 9)) THEN
               fmt = '(I1)'
            ELSE IF (between(i, 10, 99)) THEN
               fmt = '(I2)'
            ELSE IF (between(i, 100, 999)) THEN
               fmt = '(I3)'
            ELSE IF (between(i, 1000, 9999)) THEN
               fmt = '(I4)'
            ELSE
               STOP 'INTEGER_TO_STRING: Error, your integer is not supported'
            END IF
         END IF

      END IF

      WRITE (integer_to_string, fmt=fmt) i

   END FUNCTION integer_to_string

   CHARACTER(len=8) FUNCTION real_to_string(x, pre_decimal, post_decimal)

      REAL, INTENT(IN) :: x               ! Real number to convert to string
      INTEGER, INTENT(IN) :: pre_decimal  ! Number of characters pre decimal point
      INTEGER, INTENT(IN) :: post_decimal ! Number of characters post decimal point
      CHARACTER(len=8) :: fmt

      IF (pre_decimal < 0 .OR. post_decimal < 0) THEN
         STOP 'REAL_TO_STRING: Error, neither pre or post decimal should be negative'
      ELSE IF (post_decimal == 0) THEN
         real_to_string = integer_to_string(int(x))
      ELSE
         IF (x < 0) THEN
            fmt = '(F'//trim(integer_to_string(pre_decimal+post_decimal+2))//'.'//trim(integer_to_string(post_decimal))//')'
         ELSE
            fmt = '(F'//trim(integer_to_string(pre_decimal+post_decimal+1))//'.'//trim(integer_to_string(post_decimal))//')'
         END IF
         WRITE (real_to_string, fmt=fmt) x
      END IF

   END FUNCTION real_to_string

   CHARACTER(len=16) FUNCTION exp_to_string(x, pre_decimal, post_decimal, exponent)

      REAL, INTENT(IN) :: x               ! Real number to convert to string
      INTEGER, INTENT(IN) :: pre_decimal  ! Number of characters pre decimal point
      INTEGER, INTENT(IN) :: post_decimal ! Number of characters post decimal point
      INTEGER, INTENT(IN) :: exponent     ! Exponent to write with

      exp_to_string = trim(real_to_string(x/10.**exponent, pre_decimal, post_decimal))//'e'//trim(integer_to_string(exponent))

   END FUNCTION exp_to_string

   FUNCTION number_file(fbase, i, fext)

      CHARACTER(len=256) :: number_file
      CHARACTER(len=*), INTENT(IN) :: fbase, fext
      INTEGER, INTENT(IN) :: i
      CHARACTER(len=8) num

      num = integer_to_string(i)
      number_file = trim(fbase)//trim(num)//trim(fext)

   END FUNCTION number_file

   FUNCTION number_file2(fbase, i1, mid, i2, fext)

      CHARACTER(len=256) ::number_file2
      CHARACTER(len=*), INTENT(IN) :: fbase, fext, mid
      INTEGER, INTENT(IN) :: i1, i2
      CHARACTER(len=8) :: num1, num2

      num1 = integer_to_string(i1)
      num2 = integer_to_string(i2)
      number_file2 = trim(fbase)//trim(num1)//trim(mid)//trim(num2)//trim(fext)

   END FUNCTION number_file2

   FUNCTION number_file_zeroes(fbase, i, num, fext)

      !Number a file with zero padding
      !Num specifies the number of digits
      CHARACTER(len=256) :: number_file_zeroes
      CHARACTER(len=*), INTENT(IN) :: fbase, fext
      CHARACTER(len=4) :: num4
      CHARACTER(len=3) :: num3
      CHARACTER(len=2) :: num2
      CHARACTER(len=1) :: num1
      INTEGER, INTENT(IN) :: i
      INTEGER, INTENT(IN) :: num
      INTEGER, PARAMETER :: maxnum = 4

      IF (i < 0) STOP 'NUMBER_FILE_ZEROES: Error: cannot write negative number file names'

      IF (num > maxnum) STOP 'NUMBER_FILE_ZEROES: Error: need to add extra number capacity'

      IF (num == 1) THEN
         IF (i >= 10) STOP 'NUMBER_FILE_ZEROES: Error: i is too large a number for space (i>num)'
         WRITE (num1, fmt='(I0.1)') i
         number_file_zeroes = trim(fbase)//num1//trim(fext)
      ELSE IF (num == 2) THEN
         IF (i >= 100) STOP 'NUMBER_FILE_ZEROES: Error: i is too large a number for space (i>num)'
         WRITE (num2, fmt='(I0.2)') i
         number_file_zeroes = trim(fbase)//num2//trim(fext)
      ELSE IF (num == 3) THEN
         IF (i >= 1000) STOP 'NUMBER_FILE_ZEROES: Error: i is too large a number for space (i>num)'
         WRITE (num3, fmt='(I0.3)') i
         number_file_zeroes = trim(fbase)//num3//trim(fext)
      ELSE IF (num == 4) THEN
         IF (i >= 10000) STOP 'NUMBER_FILE_ZEROES: Error: i is too large a number for space (i>num)'
         WRITE (num4, fmt='(I0.4)') i
         number_file_zeroes = trim(fbase)//trim(num4)//trim(fext)
      END IF

   END FUNCTION number_file_zeroes

END MODULE string_operations

MODULE owls_stuff

   USE constants
   USE basic_operations

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: read_mccarthy
   PUBLIC :: read_mccarthy_gas
   PUBLIC :: convert_kT_to_comoving_electron_pressure
   PUBLIC :: write_mccarthy
   PUBLIC :: BAHAMAS_snapshot
   PUBLIC :: BAHAMAS_scale_factor
   PUBLIC :: BAHAMAS_scale_factors

   PUBLIC :: nh_cut
   PUBLIC :: mue

   ! BAHAMAS simulation parameters
   REAL, PARAMETER :: fh = 0.752      ! Hydrogen mass fraction
   REAL, PARAMETER :: mup = 0.61      ! Mean particle mass relative to proton
   REAL, PARAMETER :: Xeh = 1.17      ! Number of electrons per hydrogen (X_{e/H} in my notation)
   REAL, PARAMETER :: Xih = 1.08      ! Number of ions per hydrogen (X_{i/H}; all gas particles are either electrons or ions)
   REAL, PARAMETER :: mfac = 1e10     ! Mass conversion factor to get Msun/h
   REAL, PARAMETER :: eV_erg = eV*1e7 ! eV in ergs

   ! BAHAMAS derived parameters
   REAL, PARAMETER :: mue = mup*(Xeh+Xih)/Xeh ! Mean particle mass per electron relative to proton

   ! Cuts to remove neutral gas
   LOGICAL, PARAMETER :: apply_nh_cut = .TRUE. ! Apply a cut in hydrogen density?
   REAL, PARAMETER :: nh_cut = 0.1             ! Cut in the hydrogen number density [#/cm^3] gas denser than this is not ionised

CONTAINS

   SUBROUTINE read_mccarthy(x, m, n, infile)

      ! Read in a McCarthy format particle data file
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:, :)
      REAL, ALLOCATABLE, INTENT(OUT) :: m(:)
      INTEGER, INTENT(OUT) :: n
      CHARACTER(len=*), INTENT(IN) :: infile
      LOGICAL :: lexist

      ! Open the file using stream
      WRITE (*, *) 'READ_MCCARTHY: Reading in binary file: ', trim(infile)
      INQUIRE (file=infile, exist=lexist)
      IF (.NOT. lexist) STOP 'READ_MCCARTHY: Error, input file does not exist'
      OPEN (7, file=infile, form='unformatted', access='stream', status='old')
      READ (7) n
      CLOSE (7)

      ! In case the array is empty, but actually Ian has n=1 set (e.g., UVB_stars)
      IF (n == 1) THEN
         n = 0
      END IF

      ! Write information to screen
      WRITE (*, *) 'READ_MCCARTHY: Particle number:', n
      WRITE (*, *) 'READ_MCCARTHY: Which is ~', nint(n**(1./3.)), 'cubed.'

      ! Allocate arrays
      ALLOCATE (x(3, n), m(n))

      IF (n .NE. 0) THEN

         ! Need to read in 'n' again with stream access
         OPEN (7, file=infile, form='unformatted', access='stream', status='old')
         READ (7) n
         READ (7) m
         READ (7) x
         CLOSE (7)

         ! Multiply by mass factor
         m = m*mfac

         ! Write information to screen
         WRITE (*, *) 'READ_MCCARTHY: Minimum particle mass [Msun/h]:', minval(m)
         WRITE (*, *) 'READ_MCCARTHY: Maximum particle mass [Msun/h]:', maxval(m)
         WRITE (*, *) 'READ_MCCARTHY: Total particle mass [Msun/h]:', sum(m)
         WRITE (*, *) 'READ_MCCARTHY: Minimum particle x coordinate [Mpc/h]:', minval(x(1, :))
         WRITE (*, *) 'READ_MCCARTHY: Maximum particle x coordinate [Mpc/h]:', maxval(x(1, :))
         WRITE (*, *) 'READ_MCCARTHY: Minimum particle y coordinate [Mpc/h]:', minval(x(2, :))
         WRITE (*, *) 'READ_MCCARTHY: Maximum particle y coordinate [Mpc/h]:', maxval(x(2, :))
         WRITE (*, *) 'READ_MCCARTHY: Minimum particle z coordinate [Mpc/h]:', minval(x(3, :))
         WRITE (*, *) 'READ_MCCARTHY: Maximum particle z coordinate [Mpc/h]:', maxval(x(3, :))
         WRITE (*, *) 'READ_MCCARTHY: Finished reading in file'

      END IF

      ! Final white space
      WRITE (*, *)

   END SUBROUTINE read_mccarthy

   SUBROUTINE write_mccarthy(x, m, n, outfile)

      ! Write a particle data file using McCarthy format
      INTEGER, INTENT(IN) :: n
      REAL, INTENT(IN) :: x(3, n)
      REAL, INTENT(IN) :: m(n)
      CHARACTER(len=*), INTENT(IN) :: outfile

      WRITE (*, *) 'WRITE_MCCARTHY: Outputting binary file: ', trim(outfile)

      WRITE (*, *) 'WRITE_MCCARTHY: Particle number:', n
      WRITE (*, *) 'WRITE_MCCARTHY: Which is ~', nint(n**(1./3.)), 'cubed.'

      OPEN (7, file=outfile, form='unformatted', access='stream', status='replace')
      WRITE (7) n
      WRITE (7) m/mfac
      WRITE (7) x
      CLOSE (7)

      WRITE (*, *) 'WRITE_MCCARTHY: Finished writing file'
      WRITE (*, *)

   END SUBROUTINE write_mccarthy

   SUBROUTINE read_mccarthy_gas(x, m, kT, rho, n, infile)

      ! Read in a McCarthy format gas file
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:, :) ! Particle positions [Mpc/h]
      REAL, ALLOCATABLE, INTENT(OUT) :: m(:)   ! Particle mass [Msun/h]
      REAL, ALLOCATABLE, INTENT(OUT) :: kT(:)  ! Particle internal energy [eV]
      REAL, ALLOCATABLE, INTENT(OUT) :: rho(:) ! Particle SPH physical density [mp/cm^3]
      INTEGER, INTENT(OUT) :: n                ! Total number of gas particles
      CHARACTER(len=*), INTENT(IN) :: infile   ! Input file name
      REAL, ALLOCATABLE :: nh(:), ep(:)
      LOGICAL :: lexist

      ! Read in the binary file
      WRITE (*, *) 'READ_MCCARTHY_GAS: Reading in binary file: ', trim(infile)
      INQUIRE (file=infile, exist=lexist)
      IF (.NOT. lexist) STOP 'READ_MCCARTHY: Error, input file does not exist'
      OPEN (7, file=infile, form='unformatted', access='stream', status='old')
      READ (7) n
      CLOSE (7)
      WRITE (*, *) 'READ_MCCARTHY_GAS: Particle number:', n
      WRITE (*, *) 'READ_MCCARTHY_GAS: Which is ~', nint(n**(1./3.)), 'cubed.'

      ! Allocate arrays for quantities in the file
      ALLOCATE (x(3, n), m(n), ep(n), nh(n))

      ! Need to read in 'n' again with stream access
      OPEN (7, file=infile, form='unformatted', access='stream', status='old')
      READ (7) n
      READ (7) m
      READ (7) x
      READ (7) ep ! physical electron pressure for the particle [erg/cm^3]
      READ (7) nh ! physical hydrogen number density for the partcle in [/cm^3]
      CLOSE (7)

      ! Convert particle masses
      m = m*mfac ! [Msun/h]

      ! Write information to the screen
      WRITE (*, *) 'READ_MCCARTHY_GAS: Calculating kT from physical electron pressure'
      WRITE (*, *) 'READ_MCCARTHY_GAS: Note that the electron pressure calcuated here is *not* comoving'
      WRITE (*, *) 'READ_MCCARTHY_GAS: Using numbers appropriate for BAHAMAS'
      WRITE (*, *) 'READ_MCCARTHY_GAS: Hydrogen mass fraction: f_H, Y_H:', fh
      WRITE (*, *) 'READ_MCCARTHY_GAS: Mean particle mass: mu_p [m_p]:', mup
      WRITE (*, *) 'READ_MCCARTHY_GAS: Number of electrons per hydrogen: X_e/X_H:', Xeh
      WRITE (*, *) 'READ_MCCARTHY_GAS: Number of ions per hydrogen: X_i/X_H:', Xih
      WRITE (*, *) 'READ_MCCARTHY_GAS: Mean particle mass per electron: mu_e [m_p]:', mue

      ! Convert the physical hydrogen number density into a physical particle mass density [mp/cm^3]
      ! Note that these densities are physical *not* comoving
      ALLOCATE (rho(n))
      rho = nh/fh ! Convert physical hydrogen number density [#/cm^3] to physsical particle SPH density [mp/cm^3]
      DEALLOCATE (nh) ! Deallocate the physical electron pressure array

      ! Convert the physical electron pressure [erg/cm^3] and hydrogen density [#/cm^3] into kT [erg]
      ! This is the temperature of gas particles (equal for all species)
      ! Temperature is neither comoving nor physical
      ALLOCATE (kT(n))
      kT = (ep/rho)*mue
      kT = kT/eV_erg ! Convert internal energy from erg to eV
      DEALLOCATE (ep) ! Deallocate the physical electron pressure array

      ! Write information to the screen
      WRITE (*, *) 'READ_MCCARTHY_GAS: Minimum particle mass [Msun/h]:', minval(m)
      WRITE (*, *) 'READ_MCCARTHY_GAS: Maximum particle mass [Msun/h]:', maxval(m)
      WRITE (*, *) 'READ_MCCARTHY_GAS: Total mass of all particles [Msun/h]:', sum(m)
      WRITE (*, *) 'READ_MCCARTHY_GAS: Minimum particle x coordinate [Mpc/h]:', minval(x(1, :))
      WRITE (*, *) 'READ_MCCARTHY_GAS: Maximum particle x coordinate [Mpc/h]:', maxval(x(1, :))
      WRITE (*, *) 'READ_MCCARTHY_GAS: Minimum particle y coordinate [Mpc/h]:', minval(x(2, :))
      WRITE (*, *) 'READ_MCCARTHY_GAS: Maximum particle y coordinate [Mpc/h]:', maxval(x(2, :))
      WRITE (*, *) 'READ_MCCARTHY_GAS: Minimum particle z coordinate [Mpc/h]:', minval(x(3, :))
      WRITE (*, *) 'READ_MCCARTHY_GAS: Maximum particle z coordinate [Mpc/h]:', maxval(x(3, :))
      WRITE (*, *) 'READ_MCCARTHY_GAS: Minimum particle internal energy [eV]:', minval(kT)
      WRITE (*, *) 'READ_MCCARTHY_GAS: Maximum particle internal energy [eV]:', maxval(kT)
      WRITE (*, *) 'READ_MCCARTHY_GAS: Minimum particle SPH density [mp/cm^3]:', minval(rho)
      WRITE (*, *) 'READ_MCCARTHY_GAS: Maximum particle SPH density [mp/cm^3]:', maxval(rho)
      WRITE (*, *) 'READ_MCCARTHY_GAS: Finished reading in file'
      WRITE (*, *)

   END SUBROUTINE read_mccarthy_gas

   SUBROUTINE convert_kT_to_comoving_electron_pressure(kT, rho, m, n, L, h)

      ! This routine converts the input particle internal energy kT [eV] to comoving electron pressure, Pe [eV/cm^3]
      ! Note very well that Pe will be the contribution to the total pressure in the volume per particle
      ! CARE: I removed factors of 'm', pressure is now contribution to entire volume, rather than the contribution per mesh cell
      INTEGER, INTENT(IN) :: n     ! total number of particles
      REAL, INTENT(INOUT) :: kT(n) ! particle internal energy [eV], output as electron pressure [eV/cm^3]
      REAL, INTENT(IN) :: rho(n)   ! physical gas particle SPH density [mp/cm^3]
      REAL, INTENT(IN) :: m(n)     ! hydrodynamic particle mass [Msun/h] 
      REAL, INTENT(IN) :: L        ! box size [Mpc/h]
      REAL, INTENT(IN) :: h        ! Hubble parameter (necessary because pressure will be in eV/cm^3 without h factors)
      REAL :: V
      REAL :: units, kT_dble(n) ! CARE: Previously this was double precision
      INTEGER, PARAMETER :: scheme = 3

      ! Exclude gas that is sufficiently dense to not be ionised and be forming stars
      IF (apply_nh_cut) CALL exclude_nh(nh_cut, kT, rho, n)

      WRITE (*, *) 'CONVERT_KT_TO_ELECTRON_PRESSURE: Converting kT to comoving electron pressure'
      WRITE (*, *) 'CONVERT_KT_TO_ELECTRON_PRESSURE: Using numbers appropriate for BAHAMAS'
      WRITE (*, *) 'CONVERT_KT_TO_ELECTRON_PRESSURE: Note that this is COMOVING'
      WRITE (*, *) 'CONVERT_KT_TO_ELECTRON_PRESSURE: Y_H:', fh
      WRITE (*, *) 'CONVERT_KT_TO_ELECTRON_PRESSURE: mu_p [mp]:', mup
      WRITE (*, *) 'CONVERT_KT_TO_ELECTRON_PRESSURE: X_e/X_H:', Xeh
      WRITE (*, *) 'CONVERT_KT_TO_ELECTRON_PRESSURE: X_i/X_H:', Xih
      WRITE (*, *) 'CONVERT_KT_TO_ELECTRON_PRESSURE: mu_e [mp]:', mue

      ! Use double precision because all the constants are dreadful
      kT_dble = kT ! [eV]

      IF (scheme == 1 .OR. scheme == 2) THEN

         ! Convert to particle internal energy that can be mapped to grid
         IF (scheme == 1) THEN
            kT_dble = kT_dble*(m/mue) ! [eV*Msun/h] BUG: I think there should be a factor of h here due to Msun/h units
         ELSE IF (scheme == 2) THEN
            kT_dble = kT_dble*(m/(h*mue)) ! [eV*Msun]
         ELSE
            STOP 'CONVERT_KT_TO_ELECTRON_PRESSURE: Error, scheme specified incorrectly'
         END IF

         ! Comoving volume
         V = (L/h)**3 ! [(Mpc)^3]

         ! This is now comoving electron pressure
         kT_dble = kT_dble/V ! [eV*Msun/Mpc^3]

         ! Convert units of comoving electron pressure
         ! Note that there are no h factors here
         units = msun             ! [kg]
         units = units/mp         ! Divide out proton mass here [dimensionless]
         units = units/(Mpc/0.01) ! Necessary to do this in stages due to overflow [kg/cm^1]
         units = units/(Mpc/0.01) ! Necessary to do this in stages due to overflow [kg/cm^2]
         units = units/(Mpc/0.01) ! Necessary to do this in stages due to overflow [kg/cm^3]
         kT_dble = kT_dble*units  ! [eV/cm^3]

      ELSE IF (scheme == 3) THEN

         ! Comoving volume
         V = L**3 ! [(Mpc)^3]

         ! Big blob of units (see notes)
         units = (Msun*(h**2)*(0.01)**3)
         units = units/Mpc
         units = units/Mpc
         units = units/Mpc

         ! Final quantity
         kT_dble = units*(m/(mue*mp))*kT_dble/V ! [eV/cm^3]

      ELSE
         STOP 'CONVERT_KT_TO_ELECTRON_PRESSURE: Error, scheme specified incorrectly'
      END IF

      ! Go back to single precision
      kT = real(kT_dble) ! [eV/cm^3]

      WRITE (*, *) 'CONVERT_KT_TO_ELECTRON_PRESSURE: Minimum electron pressure [eV/cm^3]: ', minval(kT)
      WRITE (*, *) 'CONVERT_KT_TO_ELECTRON_PRESSURE: Maximum electron pressure [eV/cm^3]: ', maxval(kT)
      WRITE (*, *) 'CONVERT_KT_TO_ELECTRON_PRESSURE: Done'
      WRITE (*, *)

   END SUBROUTINE convert_kT_to_comoving_electron_pressure

   SUBROUTINE exclude_nh(nhcut, kT, rho, n)

      ! Set the gas particle internal energy to zero for high-density particles that have nh > nhcut
      INTEGER, INTENT(IN) :: n      ! Total number of particles
      REAL, INTENT(IN) :: nhcut     ! Cut to impose on hydrogen number density [#/cm^3]
      REAL, INTENT(INOUT) :: kT(n)  ! Gas particle internal energy [eV]
      REAL, INTENT(IN) :: rho(n)    ! Gap particle SPH density [mp/cm^3]
      INTEGER :: i
      REAL :: rhocut

      ! Convert the hydrogen number density cut into a cut on particle SPH density
      rhocut = nhcut/fh

      DO i = 1, n
         IF (rho(i) > rhocut) kT(i) = 0.
      END DO

   END SUBROUTINE exclude_nh

   CHARACTER(len=32) FUNCTION BAHAMAS_snapshot(z)

      ! Set the redshift corresponding to the snapsho
      REAL, INTENT(IN) :: z
      REAL, PARAMETER :: eps = 1e-3
   
      IF (requal(z, 0.0, eps)) THEN
         BAHAMAS_snapshot = 'snap32'
      ELSE IF (requal(z, 0.125, eps)) THEN
         BAHAMAS_snapshot = 'snap31'
      ELSE IF (requal(z, 0.25, eps)) THEN
         BAHAMAS_snapshot = 'snap30'
      ELSE IF (requal(z, 0.375, eps)) THEN
         BAHAMAS_snapshot = 'snap29'
      ELSE IF (requal(z, 0.5, eps)) THEN
         BAHAMAS_snapshot = 'snap28'
      ELSE IF (requal(z, 0.75, eps)) THEN
         BAHAMAS_snapshot = 'snap27'
      ELSE IF (requal(z, 1.0, eps)) THEN
         BAHAMAS_snapshot = 'snap26'
      ELSE IF (requal(z, 1.25, eps)) THEN
         BAHAMAS_snapshot = 'snap25'
      ELSE IF (requal(z, 1.5, eps)) THEN
         BAHAMAS_snapshot = 'snap24'
      ELSE IF (requal(z, 1.75, eps)) THEN
         BAHAMAS_snapshot = 'snap23'
      ELSE IF (requal(z, 2.0, eps)) THEN
         BAHAMAS_snapshot = 'snap22'
      ELSE IF (requal(z, 2.25, eps)) THEN
         BAHAMAS_snapshot = 'snap21'
      ELSE IF (requal(z, 2.5, eps)) THEN
         BAHAMAS_snapshot = 'snap20'
      ELSE IF (requal(z, 2.75, eps)) THEN
         BAHAMAS_snapshot = 'snap19'
      ELSE IF (requal(z, 3.0, eps)) THEN
         BAHAMAS_snapshot = 'snap18'
      ELSE
         WRITE (*, *) 'BAHAMAS_SNAPSHOT: z', z
         STOP 'BAHAMAS_SNAPSHOT: Error, redshift specified incorrectly'
      END IF

   END FUNCTION BAHAMAS_snapshot

   ELEMENTAL REAL FUNCTION BAHAMAS_scale_factor(isnap)

      USE cosmology_functions
      INTEGER, INTENT(IN) :: isnap
      REAL :: z

      IF (isnap == 18) THEN
         z = 3.000
      ELSE IF (isnap == 19) THEN
         z = 2.750
      ELSE IF (isnap == 20) THEN
         z = 2.500
      ELSE IF (isnap == 21) THEN
         z = 2.250
      ELSE IF (isnap == 22) THEN
         z = 2.000
      ELSE IF (isnap == 23) THEN
         z = 1.750
      ELSE IF (isnap == 24) THEN
         z = 1.500
      ELSE IF (isnap == 25) THEN
         z = 1.250
      ELSE IF (isnap == 26) THEN
         z = 1.000
      ELSE IF (isnap == 27) THEN
         z = 0.750
      ELSE IF (isnap == 28) THEN
         z = 0.500
      ELSE IF (isnap == 29) THEN
         z = 0.375
      ELSE IF (isnap == 30) THEN
         z = 0.250
      ELSE IF (isnap == 31) THEN
         z = 0.125
      ELSE IF (isnap == 32) THEN
         z = 0.000
      !ELSE
      !   STOP 'BAHAMAS_scale_factors'
      END IF

      BAHAMAS_scale_factor = scale_factor_z(z)

   END FUNCTION BAHAMAS_scale_factor

   SUBROUTINE BAHAMAS_scale_factors(a, n)

      ! Returns an array of all the BAHAMAS scale factors for a given set of n
      USE cosmology_functions    
      REAL, ALLOCATABLE, INTENT(INOUT) :: a(:)
      INTEGER, INTENT(IN) :: n
      INTEGER :: snaps(n)

      IF (ALLOCATED(a)) DEALLOCATE(a)
      ALLOCATE(a(n))

      IF (n == 4) THEN
         snaps = [22, 26, 28, 32]
      ELSE IF (n == 11) THEN
         snaps = [22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32]
      ELSE IF (n == 15) THEN
         snaps = [18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32]
      ELSE
         STOP 'BAHAMAS_SCALE_FACTORS: Error, n must be either 4, 11 or 15'
      END IF

      a = BAHAMAS_scale_factor(snaps)

   END SUBROUTINE BAHAMAS_scale_factors

END MODULE owls_stuff

MODULE precision

   !USE, INTRINSIC :: iso_fortran_env

   IMPLICIT NONE

   PRIVATE

   ! Integer precision
   PUBLIC :: int4
   PUBLIC :: int8

   ! Real precision
   PUBLIC :: sp
   PUBLIC :: dp
   PUBLIC :: qp

   ! Integer precision
   INTEGER, PARAMETER :: int4 = selected_int_kind(4)
   INTEGER, PARAMETER :: int8 = selected_int_kind(8)

   ! Hmmm....
   !INTEGER, PARAMETER :: sp = KIND(1.0)
   !INTEGER, PARAMETER :: dp = KIND(1.d0)

   ! Taken from http://fortranwiki.org/fortran/show/Real+precision
   INTEGER, PARAMETER :: sp = selected_real_kind(6, 37)    ! Single precision
   INTEGER, PARAMETER :: dp = selected_real_kind(15, 307)  ! Double precision
   INTEGER, PARAMETER :: qp = selected_real_kind(33, 4931) ! Quadruple precision

   ! Fortran 2008 http://fortranwiki.org/fortran/show/Real+precision
   ! Needs to USE, INTRINSIC :: iso_fortran_env which conflicts with default double precision
   !INTEGER, PARAMETER :: sp = REAL32
   !INTEGER, PARAMETER :: dp = REAL64
   !INTEGER, PARAMETER :: qp = REAL128
  
END MODULE precision

MODULE io

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: VD20_read_power

   CONTAINS

   SUBROUTINE VD20_read_power(k, z, Pk, nk, nz, name)

      USE file_info
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: z(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:, :)
      INTEGER, INTENT(OUT) :: nk
      INTEGER, INTENT(OUT) :: nz
      CHARACTER(len=*), INTENT(IN) :: name
      CHARACTER(len=128), PARAMETER :: dir = '/Users/Mead/Physics/data/VD20'
      CHARACTER(len=256) :: infile
      INTEGER :: i, n, ik, iz
      INTEGER :: u
      REAL :: zin, zrem
      REAL :: crap
      INTEGER, PARAMETER :: header_size = 1
      LOGICAL, PARAMETER :: verbose = .FALSE.

      ! Create the input file name
      infile = trim(dir)//'/'//trim(name)//'.dat'
      CALL check_file_exists(infile)

      ! Count the length of the file
      n = file_length(infile, verbose)
      n = n-header_size

      ! Should be initialised
      zrem = -1.

      ! Calculate how many k and z values there are from the file
      OPEN(newunit=u, file=infile, status='old')
      READ(u, *)
      nk = 0
      DO
         nk = nk+1
         READ(u, *) zin
         IF (nk == 1) THEN
            zrem = zin
         ELSE IF (zin .NE. zrem) THEN
            nk = nk-1
            EXIT
         END IF
      END DO
      CLOSE(u)
      IF (verbose) WRITE(*, *) 'VD20_READ_POWER: nk:', nk     
      IF(mod(n, nk) .NE. 0) STOP 'VD20_READ_POWER: Error, could not figure out how many k, z values there were'
      nz = n/nk
      IF (verbose) WRITE(*, *) 'VD20_READ_POWER: nk:', nz

      ! Allocate arrays for k, z and power
      ALLOCATE(k(nk), z(nz), Pk(nk, nz))

      ! Fill arrays
      ik = 0
      iz = 0
      OPEN(newunit=u, file=infile, status='old')
      READ(u, *) ! Read header
      DO i = 1, n       
         IF(MOD(i-1, nk) == 0) THEN
            ik = 0
            iz = iz+1
         END IF
         ik = ik+1
         READ(u, *) z(iz), k(ik), crap, Pk(ik, iz)
      END DO
      CLOSE(u)

   END SUBROUTINE VD20_read_power

END MODULE io

MODULE vectors

   IMPLICIT NONE

   PRIVATE

   ! Functions
   PUBLIC :: shift_angle_to_circle
   
   ! Vectors
   PUBLIC :: distance
   PUBLIC :: cross_product
   PUBLIC :: unit
   PUBLIC :: modulus
   PUBLIC :: rotate_vector
   PUBLIC :: rotate_vector_fast

   ! Matrices
   PUBLIC :: trace
   PUBLIC :: determinant
   PUBLIC :: matrix_multiply
   PUBLIC :: matrix_vector
   PUBLIC :: rotation
   PUBLIC :: symmetrize_matrix
   PUBLIC :: antisymmetrize_matrix
   PUBLIC :: write_matrix
   PUBLIC :: square_matrix
   PUBLIC :: symmetric_matrix
   PUBLIC :: antisymmetric_matrix
   PUBLIC :: Hermitian_matrix

   ! Unit vectors
   PUBLIC  :: xhat
   PUBLIC  :: yhat
   PUBLIC  :: zhat

   ! Parameters
   REAL, PARAMETER :: xhat(3) = [1., 0., 0.]
   REAL, PARAMETER :: yhat(3) = [0., 1., 0.]
   REAL, PARAMETER :: zhat(3) = [0., 0., 1.]

   !INTERFACE determinant
   !   PROCEDURE determinant_2
   !   PROCEDURE determinant_3
   !END INTERFACE determinant

   INTERFACE square_matrix
      MODULE PROCEDURE square_matrix_real
      MODULE PROCEDURE square_matrix_complex
   END INTERFACE square_matrix

CONTAINS

   REAL FUNCTION trace(A)

      REAL, INTENT(IN) :: A(:, :)
      INTEGER :: i

      IF(size(A, 1) /= size(A, 2)) STOP 'TRACE: Error, trace only defined for square matrices'
      trace = 0.
      DO i = 1, size(A)
         trace = trace+A(i, i)
      END DO

   END FUNCTION trace

   REAL FUNCTION determinant(A)

      ! TODO: Write a general recursive function
      REAL, INTENT(IN) :: A(:, :)
      INTEGER :: n

      n = size(A, 1)
      IF (n /= size(A,2)) STOP 'DETERMINANT: Error, determinant only defined for square matrices'
      IF (n == 1) THEN
         determinant = A(1, 1) ! NOTE: Can be negative, should not have abs
      ELSE IF (n == 2) THEN
         determinant = determinant_2(A)
      ELSE IF (n == 3) THEN
         determinant = determinant_3(A)
      ELSE
         STOP 'DETERMINANT: Function not written for this size of matix'
      END IF

   END FUNCTION determinant

   REAL FUNCTION determinant_2(A)

      REAL, INTENT(IN) :: A(2, 2)

      determinant_2 = A(1, 1)*A(2, 2)-A(1, 2)*A(2, 1)

   END FUNCTION determinant_2

   REAL FUNCTION determinant_3(A)

      ! TODO: Surely this can be much neater
      REAL, INTENT(IN) :: A(3, 3)
      REAL :: B(2, 2), M
      INTEGER :: i

      determinant_3 = 0.
      DO i = 1, 3
         IF (i == 1) THEN
            M = A(1, 1)
            B(1, 1) = A(2, 2)
            B(1, 2) = A(2, 3)
            B(2, 1) = A(3, 2)
            B(2, 2) = A(3, 3)
         ELSE IF (i == 2) THEN
            M = -A(1, 2)
            B(1, 1) = A(2, 1)
            B(1, 2) = A(2, 3)
            B(2, 1) = A(3, 1)
            B(2, 2) = A(3, 3)
         ELSE IF (i == 3) THEN
            M = A(1, 3)
            B(1, 1) = A(2, 1)
            B(1, 2) = A(2, 2)
            B(2, 1) = A(3, 1)
            B(2, 2) = A(3, 2)
         ELSE
            STOP 'DETERMINANT_3: Error, something went very wrong'
         END IF
         determinant_3 = determinant_3+M*determinant_2(B)
      END DO

   END FUNCTION determinant_3

   REAL FUNCTION shift_angle_to_circle(theta)

      ! Changes an angle thetta [rad] to be in the interval [0:2pi]
      ! e.g., if t is -pi/2 it gets shifted to 3pi/2
      USE constants
      REAL, INTENT(IN) :: theta

      shift_angle_to_circle = theta-twopi*floor(theta/twopi)

   END FUNCTION shift_angle_to_circle

   FUNCTION unit(x)

      ! Returns the unit vector of 'x'
      REAL, INTENT(IN) :: x(:)
      REAL :: unit(size(x))

      unit = x/modulus(x)

   END FUNCTION unit

   REAL FUNCTION modulus(x)

      ! Returns the modulus of vector 'x'
      REAL, INTENT(IN) :: x(:)

      modulus = sqrt(sum(x**2))

   END FUNCTION modulus

!!$  !Note - in F95 there is an intrinsic dot_product function
!!$  !Therefore this is now obsolete
!!$  FUNCTION dot_product(x,y)
!!$
!!$    IMPLICIT NONE
!!$    REAL :: dot_product
!!$    REAL, INTENT(IN) :: x(3), y(3)
!!$
!!$    dot_product=x(1)*y(1)+x(2)*y(2)+x(3)*y(3)
!!$
!!$  END FUNCTION dot_product

   FUNCTION cross_product(x, y)

      ! Computes the cross produce of 3-vectors x and y
      REAL :: cross_product(3)
      REAL, INTENT(IN) :: x(3)
      REAL, INTENT(IN) :: y(3)

      cross_product(1) = x(2)*y(3)-x(3)*y(2)
      cross_product(2) = x(3)*y(1)-x(1)*y(3)
      cross_product(3) = x(1)*y(2)-x(2)*y(1)

   END FUNCTION cross_product

   FUNCTION rotation(u, t)

      ! Creates a rotation matrix for rotation about vector 'u' by angle 't'
      ! u must be a unit vector
      REAL :: rotation(3, 3)
      REAL, INTENT(IN) :: u(3)
      REAL, INTENT(IN) :: t
      REAL :: s, c

      ! Pre-compute sine and cosine for speed
      s = sin(t)
      c = cos(t)

      rotation(1, 1) = c+(1.-c)*u(1)**2.
      rotation(1, 2) = u(1)*u(2)*(1.-c)-u(3)*s
      rotation(1, 3) = u(1)*u(3)*(1.-c)+u(2)*s

      rotation(2, 1) = u(2)*u(1)*(1.-c)+u(3)*s
      rotation(2, 2) = c+(1.-c)*u(2)**2.
      rotation(2, 3) = u(2)*u(3)*(1.-c)-u(1)*s

      rotation(3, 1) = u(3)*u(1)*(1.-c)-u(2)*s
      rotation(3, 2) = u(3)*u(2)*(1.-c)+u(1)*s
      rotation(3, 3) = c+(1.-c)*u(3)**2.

   END FUNCTION rotation

   FUNCTION matrix_multiply(A, B) result(C)

      ! Multiplies matrices 'A' and 'B' C=A*B
      REAL, INTENT(IN) :: A(:, :), B(:, :)
      REAL :: C(size(A, 1), size(B, 2))
      INTEGER :: i, j, k, ni, nj, nk

      ni = size(A, 1)
      nj = size(B, 2)
      nk = size(A, 2)
      IF (nk /= size(B, 1)) STOP 'MATRIX_MULTIPLY: Error, you cannot multiply these matrices'

      ! Fix this 'sum' variable to zero
      C = 0.

      DO i = 1, ni
         DO j = 1, nj
            DO k = 1, nk
               C(i, j) = C(i, j)+A(i, k)*B(k, j)
            END DO
         END DO
      END DO

      !matrix_multiply = C

   END FUNCTION matrix_multiply

   FUNCTION matrix_vector(A, b) result(c)

      ! Multiplies matrix a and vector b (c=A*b) 
      REAL, INTENT(IN) :: A(:, :)
      REAL, INTENT(IN) :: b(:)  
      REAL :: c(size(A, 1))
      INTEGER :: ix, iy, nx, ny

      nx = size(A, 1)
      ny = size(A, 2)
      IF (ny /= size(b)) STOP 'MATRIX_VECTOR: Error, array wrong sizes'

      ! Fix this 'sum' variable to zero
      c = 0.

      DO ix = 1, nx
         DO iy = 1, ny
            c(ix) = c(ix)+A(ix, iy)*b(iy)
         END DO
      END DO

   END FUNCTION matrix_vector

   REAL FUNCTION distance(x1, x2)

      ! Calculates the scalar distance between vectors x1 and x2
      ! Note that this is always a positive number
      REAL, INTENT(IN) :: x1(:)
      REAL, INTENT(IN) :: x2(:)
      INTEGER :: i, n

      n = size(x1)
      IF (n /= size(x2)) STOP 'DISTANCE: Error, x1 and x2 must be the same size'

      ! Fix this 'sum' variable to zero
      distance = 0.

      DO i = 1, n
         distance = distance+(x1(i)-x2(i))**2
      END DO

      distance = sqrt(distance)

   END FUNCTION distance

   FUNCTION rotate_vector(v, k, theta)

      ! Rotates vector 'v' about axis 'k' by angle 'theta'
      REAL :: rotate_vector(3)
      REAL, INTENT(IN) :: v(3)
      REAL, INTENT(IN) :: k(3)
      REAL, INTENT(IN) :: theta
      REAL :: R(3, 3)

      ! Get the rotation matrix
      ! Infact, I think you do not need the whole matrix to do this
      ! Look up Rodriguez Formula in case this is important
      ! Probably it is faster
      R = rotation(k, theta)

      ! Perform the rotation
      rotate_vector = matrix_vector(R, v)

   END FUNCTION rotate_vector

   FUNCTION rotate_vector_fast(v, k, theta)

      ! Rotates vector 'v' about axis 'k' by angle 'theta'
      ! Note that 'k' needs to be a unit vector
      ! See https://en.wikipedia.org/wiki/Rodrigues%27_rotation_formula
      REAL :: rotate_vector_fast(3)
      REAL, INTENT(IN) :: v(3)
      REAL, INTENT(IN) :: k(3)
      REAL, INTENT(IN) :: theta
      REAL :: r1(3), r2(3), r3(3), s, c

      s = sin(theta)
      c = cos(theta)

      r1 = v*c
      r2 = cross_product(k, v)*s
      r3 = k*(dot_product(k, v))*(1.-c)

      rotate_vector_fast = r1+r2+r3

   END FUNCTION rotate_vector_fast

   SUBROUTINE symmetrize_matrix(M)

      ! Forces the upper-triangle half of matrix to equal the lower-triangle half of matrix
      ! When filling a symmetric matrix it would be Fortran standard to do: DO j=1,n // DO i=j,n
      ! which fills the lower-triangle half, thus this routine uses that information to fill the upper triangle half
      REAL, INTENT(INOUT) :: M(:, :)
      INTEGER :: i, j, n

      IF (.NOT. square_matrix(M)) STOP 'SYMMETRIZE_MATRIX: Error, matrix must be square'
      n = size(M, 1)

      DO j = 1, n
         DO i = j+1, n
            M(j, i) = M(i, j)
         END DO
      END DO

   END SUBROUTINE symmetrize_matrix

   SUBROUTINE antisymmetrize_matrix(M)

      ! Forces the upper-triangle half of matrix to equal the negative of the lower-triangle half of matrix
      ! Also forces the diagonal to be zero
      ! When filling an anti-symmetric matrix it would be Fortran standard to do: DO j=1,n // DO i=j,n
      ! which fills the lower-triangle half, thus this routine uses that information to fill the upper triangle half
      REAL, INTENT(INOUT) :: M(:, :)
      INTEGER :: i, j, n

      IF (.NOT. square_matrix(M)) STOP 'ANTISYMMETRIZE_MATRIX: Error, matrix must be square'
      n = size(M, 1)

      DO j = 1, n
         DO i = j, n
            IF (i == j) THEN
               M(i, j) = 0.
            ELSE
               M(j, i) = -M(i, j)
            END IF
         END DO
      END DO

   END SUBROUTINE antisymmetrize_matrix

   SUBROUTINE write_matrix(M)

      ! Write a matrix to screen using the standard matrix row-column (ij) index convention
      ! M11, M12, ..., M1N // M21, M22, ..., M2N // ... // MN1, MN2, ..., MNN
      REAL, INTENT(IN) :: M(:, :)
      INTEGER :: i, j

      DO i = 1, size(M, 1)
         WRITE(*, *) (M(i, j), j=1,size(M,2))
      END DO

   END SUBROUTINE write_matrix

   LOGICAL FUNCTION square_matrix_real(M)

      ! Returns true if the matrix is square
      REAL, INTENT(IN) :: M(:, :)

      IF (size(M, 1) == size(M, 2)) THEN
         square_matrix_real = .TRUE.
      ELSE
         square_matrix_real = .FALSE.
      END IF

   END FUNCTION square_matrix_real

   LOGICAL FUNCTION square_matrix_complex(M)

      ! Returns true if the matrix is square
      COMPLEX, INTENT(IN) :: M(:, :)

      IF (size(M, 1) == size(M, 2)) THEN
         square_matrix_complex = .TRUE.
      ELSE
         square_matrix_complex = .FALSE.
      END IF

   END FUNCTION square_matrix_complex

   LOGICAL FUNCTION symmetric_matrix(M)

      ! Returns true if the matrix is symmetric
      REAL, INTENT(IN) :: M(:, :)
      INTEGER :: i, j, n

      IF (.NOT. square_matrix(M)) STOP 'SYMMETRIC_MATRIX: Error, matrix must be square in order to be symmetric'
      n = size(M, 1)

      symmetric_matrix = .TRUE.
      loop: DO j = 1, n
         DO i = j+1, n
            IF (M(i, j) /= M(j, i)) THEN
               symmetric_matrix = .FALSE.
               EXIT loop
            END IF
         END DO
      END DO loop

   END FUNCTION symmetric_matrix

   LOGICAL FUNCTION antisymmetric_matrix(M)

      ! Returns true if the matrix is antisymmetric
      REAL, INTENT(IN) :: M(:, :)
      INTEGER :: i, j, n

      IF (.NOT. square_matrix(M)) STOP 'ANTISYMMETRIC_MATRIX: Error, matrix must be square in order to be antisymmetric'
      n = size(M, 1)

      antisymmetric_matrix = .TRUE.
      loop: DO j = 1, n
         DO i = j, n
            IF ((i == j) .AND. (M(i, j) /= 0.)) THEN
               antisymmetric_matrix = .FALSE.
               EXIT loop
            ELSE IF (M(i, j) /= -M(j, i)) THEN
               antisymmetric_matrix = .FALSE.
               EXIT loop
            END IF
         END DO
      END DO loop

   END FUNCTION antisymmetric_matrix

   LOGICAL FUNCTION Hermitian_matrix(M)

      ! Returns true if the matrix is symmetric
      COMPLEX, INTENT(IN) :: M(:, :)
      INTEGER :: i, j, n

      IF (.NOT. square_matrix(M)) STOP 'SYMMETRIC_MATRIX: Error, matrix must be square in order to be symmetric'
      n = size(M, 1)

      Hermitian_matrix = .TRUE.
      loop: DO j = 1, n
         DO i = j+1, n
            IF (M(i, j) /= conjg(M(j, i))) THEN
               Hermitian_matrix = .FALSE.
               EXIT loop
            END IF
         END DO
      END DO loop

   END FUNCTION Hermitian_matrix

END MODULE vectors

MODULE ODE_solvers

   USE basic_operations
   USE array_operations

   IMPLICIT NONE

   PRIVATE

   ! ODE integration routines
   PUBLIC :: ODE1
   PUBLIC :: ODE2
   PUBLIC :: ODEcoupled
   PUBLIC :: ODE1_adaptive
   PUBLIC :: ODE2_adaptive
   PUBLIC :: ODEcoupled_adaptive

   ! ODE integration methods
   PUBLIC :: iode_crude
   PUBLIC :: iode_mid
   PUBLIC :: iode_RK4

   ! ODE integration methods
   INTEGER, PARAMETER :: iode_crude = 1
   INTEGER, PARAMETER :: iode_mid = 2
   INTEGER, PARAMETER :: iode_RK4 = 3

   ! Adaptive ODE
   INTEGER, PARAMETER :: jmax_adapt = 20 ! Maximum number of attempts at solution
   INTEGER, PARAMETER :: nmin_adapt = 10 ! Minimum number of points in solution

CONTAINS

   SUBROUTINE ODE1(x, t, ti, tf, xi, fx, n, iode, ilog)

      ! Solves 2nd order ODE d2x/dt2 from ti to tf and creates arrays of x, v, t values
      ! I have sometimes called this ODE_crass because it has a fixed number of time steps, n
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: t(:)
      REAL, INTENT(IN) :: ti
      REAL, INTENT(IN) :: tf
      REAL, INTENT(IN) :: xi
      REAL, EXTERNAL :: fx
      REAL, EXTERNAL :: fv
      INTEGER, INTENT(IN) :: n
      INTEGER, INTENT(IN) :: iode
      LOGICAL, OPTIONAL, INTENT(IN) :: ilog
      INTEGER :: i

      ! x' = fx
      INTERFACE       
         FUNCTION fx(x_in, t_in)
            REAL, INTENT(IN) :: x_in, t_in
         END FUNCTION fx
      END INTERFACE

      ! Allocate and set xi and vi to the initial values of x and v (i.e. x(ti), v(ti))
      ALLOCATE(x(n))
      x(1) = xi

      ! Fill the time array
      CALL fill_array(ti, tf, t, n, ilog)

      ! Advance the system through all n-1 time steps
      DO i = 1, n-1
         CALL ODE1_advance(x(i), x(i+1), t(i), t(i+1), fx, iode)
      END DO

   END SUBROUTINE ODE1

   SUBROUTINE ODE2(x, v, t, ti, tf, xi, vi, fv, n, iode, ilog)

      ! Integrates second-order ODE: x'' + ax' + bx = c from ti to tf
      ! Outputs array of x(t) and v(t)
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: v(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: t(:)
      REAL, INTENT(IN) :: ti
      REAL, INTENT(IN) :: tf
      REAL, INTENT(IN) :: xi
      REAL, INTENT(IN) :: vi
      REAL, EXTERNAL :: fv
      INTEGER, INTENT(IN) :: n
      INTEGER, INTENT(IN) :: iode
      LOGICAL, OPTIONAL, INTENT(IN) :: ilog
      INTEGER :: i

      ! x'' = v' = fv(x, x', t)
      INTERFACE        
         FUNCTION fv(x_in, v_in, t_in)
            REAL, INTENT(IN) :: x_in, v_in, t_in
         END FUNCTION fv
      END INTERFACE
   
      ! Allocate and set xi and vi to the initial values of x and v
      ALLOCATE(x(n), v(n))
      x(1) = xi
      v(1) = vi

      ! Fill the time array
      CALL fill_array(ti, tf, t, n, ilog)

      ! Advance the system through all n-1 time steps
      DO i = 1, n-1
         CALL ODE2_advance(x(i), x(i+1), v(i), v(i+1), t(i), t(i+1), velocity, fv, iode)
      END DO

   END SUBROUTINE ODE2

   SUBROUTINE ODEcoupled(x, v, t, ti, tf, xi, vi, fx, fv, n, iode, ilog)

      ! Solves 2nd order ODE d2x/dt2 from ti to tf and creates arrays of x, v, t values
      ! I have sometimes called this ODE_crass because it has a fixed number of time steps, n
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: v(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: t(:)
      REAL, INTENT(IN) :: ti
      REAL, INTENT(IN) :: tf
      REAL, INTENT(IN) :: xi
      REAL, INTENT(IN) :: vi
      REAL, EXTERNAL :: fx
      REAL, EXTERNAL :: fv
      INTEGER, INTENT(IN) :: n
      INTEGER, INTENT(IN) :: iode
      LOGICAL, OPTIONAL, INTENT(IN) :: ilog
      INTEGER :: i

      ! x' = fx; fx = v for a second-order ODE
      ! v' = fv
      INTERFACE        
         FUNCTION fx(x_in, v_in, t_in)
            REAL, INTENT(IN) :: x_in, v_in, t_in
         END FUNCTION fx        
         FUNCTION fv(x_in, v_in, t_in)
            REAL, INTENT(IN) :: x_in, v_in, t_in
         END FUNCTION fv
      END INTERFACE
   
      ! Allocate and set xi and vi to the initial values of x and v (i.e. x(ti), v(ti))
      ALLOCATE(x(n), v(n))
      x(1) = xi
      v(1) = vi

      ! Fill the time array
      CALL fill_array(ti, tf, t, n, ilog)

      ! Advance the system through all n-1 time steps
      DO i = 1, n-1
         CALL ODE2_advance(x(i), x(i+1), v(i), v(i+1), t(i), t(i+1), fx, fv, iode)
      END DO

   END SUBROUTINE ODEcoupled

   SUBROUTINE ODE1_adaptive(x, t, ti, tf, xi, fx, n, iode, acc, ilog)

      ! Solves 2nd order ODE x''(t) from ti to tf and writes out array of x, v, t values
      ! acc is the desired accuracy across the entire solution
      ! time steps are increased until convergence is achieved
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: t(:)
      REAL, INTENT(IN) :: ti
      REAL, INTENT(IN) :: tf
      REAL, INTENT(IN) :: xi
      REAL, EXTERNAL :: fx
      INTEGER, INTENT(IN) :: n
      INTEGER, INTENT(IN) :: iode
      REAL, INTENT(IN) :: acc
      LOGICAL, OPTIONAL, INTENT(IN) :: ilog
      REAL, ALLOCATABLE :: xh(:), th(:)
      INTEGER :: j, in, ip, nn, np
      LOGICAL :: fail
      INTEGER, PARAMETER :: jmax = jmax_adapt ! Maximum number of goes
      INTEGER, PARAMETER :: nmin = nmin_adapt ! Minimum number of points

      ! x' = fx
      INTERFACE       
         FUNCTION fx(x_in, t_in)
            REAL, INTENT(IN) :: x_in, t_in
         END FUNCTION fx
      END INTERFACE

      IF (n <= 1) STOP 'ODE1_ADAPTIVE: Error, you cannot solve an ODE with n=1 (or less)'

      ! Loop over attemps for number of time steps
      DO j = 1, jmax

         ! Set the new number of time steps
         nn = 1+(n-1)*2**(j-1)

         ! Solve the ODE with 'nn' time steps
         CALL ODE1(x, t, ti, tf, xi, fx, nn, iode, ilog)

         ! Automatically fail on the first go; or check for convergence with respect to previous solution
         ! TODO: Replace fail conditions with requal?
         IF (j == 1 .OR. nn < nmin) THEN          
            fail = .TRUE.
         ELSE
            fail = .FALSE.     
            DO ip = 1, np       
               in = 2*ip-1   
               IF (.NOT. almost_equal(xh(ip), x(in), acc)) THEN
               !IF ((.NOT. requal(xh(k), x(kn), acc))) THEN 
                  fail = .TRUE.
                  DEALLOCATE (xh, th)
                  EXIT
               END IF
            END DO

         END IF
        
         IF (fail) THEN
            ! If fail then store this solution and move on to the next attempt
            xh = x
            th = t
            np = nn
         ELSE
            EXIT ! If the integration was successful then exit
         END IF

      END DO

      IF (fail) THEN
         STOP 'ODE1_ADAPTIVE: Error, failed to converge'
      ELSE
         xh = x
         th = t
         DEALLOCATE(x, t)
         ALLOCATE(x(n), t(n))
         DO ip = 1, n
            in = 1+(ip-1)*(nn-1)/(n-1)
            x(ip) = xh(in)
            t(ip) = th(in)
         END DO
      END IF

   END SUBROUTINE ODE1_adaptive

   SUBROUTINE ODE2_adaptive(x, v, t, ti, tf, xi, vi, fv, n, iode, acc, ilog)

      ! Solves 2nd order ODE x''(t) from ti to tf and writes out array of x, v, t values
      ! acc is the desired accuracy across the entire solution
      ! time steps are increased until convergence is achieved
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: v(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: t(:)
      REAL, INTENT(IN) :: ti
      REAL, INTENT(IN) :: tf
      REAL, INTENT(IN) :: xi
      REAL, INTENT(IN) :: vi
      REAL, EXTERNAL :: fv
      INTEGER, INTENT(IN) :: n
      INTEGER, INTENT(IN) :: iode
      REAL, INTENT(IN) :: acc
      LOGICAL, OPTIONAL, INTENT(IN) :: ilog
      REAL, ALLOCATABLE :: xh(:), vh(:), th(:)
      INTEGER :: j, ip, in, np, nn
      LOGICAL :: fail
      INTEGER, PARAMETER :: jmax = jmax_adapt ! Maximum number of goes
      INTEGER, PARAMETER :: nmin = nmin_adapt ! Minimum number of points

      ! v' = fv
      INTERFACE       
         FUNCTION fv(x_in, v_in, t_in)
            REAL, INTENT(IN) :: x_in, v_in, t_in
         END FUNCTION fv
      END INTERFACE

      IF (n <= 1) STOP 'ODE2_ADAPTIVE: Error, you cannot solve an ODE with n=1 (or less)'

      ! Loop over attemps for number of time steps
      DO j = 1, jmax

         ! Set the new number of time steps and save the old number
         nn = 1+(n-1)*2**(j-1)

         ! Solve the ODE with 'n' points
         CALL ODE2(x, v, t, ti, tf, xi, vi, fv, nn, iode, ilog)

         ! Either automatically fail or check for convergence with respect to previous solution
         ! TODO: Replace fail conditions with requal?
         IF (j == 1 .OR. nn < nmin) THEN
            fail = .TRUE.
         ELSE
            fail = .FALSE.
            DO ip = 1, np       
               in = 2*ip-1
               IF ((.NOT. almost_equal(xh(ip), x(in), acc)) .OR. (.NOT. almost_equal(vh(ip), v(in), acc))) THEN
               !IF ((.NOT. requal(xh(k), x(kn), acc)) .OR. (.NOT. requal(vh(k), v(kn), acc))) THEN 
                  fail = .TRUE.
                  DEALLOCATE (xh, vh, th)
                  EXIT
               END IF
            END DO

         END IF
        
         IF (fail) THEN
            ! If fail then store this solution and move on to the next attempt
            xh = x
            vh = v
            th = t
            np = nn
         ELSE
            EXIT ! If the integration was successful then exit
         END IF

      END DO

      IF (fail) THEN
         STOP 'ODE2_ADAPTIVE: Error, failed to converge'
      ELSE
         xh = x
         vh = v
         th = t
         DEALLOCATE(x, v, t)
         ALLOCATE(x(n), v(n), t(n))
         DO ip = 1, n
            in = 1+(ip-1)*(nn-1)/(n-1)
            x(ip) = xh(in)
            v(ip) = vh(in)
            t(ip) = th(in)
         END DO
      END IF

   END SUBROUTINE ODE2_adaptive

   SUBROUTINE ODEcoupled_adaptive(x, v, t, ti, tf, xi, vi, fx, fv, n, iode, acc, ilog)

      ! Solves 2nd order ODE x''(t) from ti to tf and writes out array of x, v, t values
      ! acc is the desired accuracy across the entire solution
      ! time steps are increased until convergence is achieved
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: v(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: t(:)
      REAL, INTENT(IN) :: ti
      REAL, INTENT(IN) :: tf
      REAL, INTENT(IN) :: xi
      REAL, INTENT(IN) :: vi
      REAL, EXTERNAL :: fx
      REAL, EXTERNAL :: fv
      INTEGER, INTENT(IN) :: n
      INTEGER, INTENT(IN) :: iode
      REAL, INTENT(IN) :: acc
      LOGICAL, OPTIONAL, INTENT(IN) :: ilog
      REAL, ALLOCATABLE :: xh(:), vh(:), th(:)
      INTEGER :: j, ip, in, np, nn
      LOGICAL :: fail
      INTEGER, PARAMETER :: jmax = jmax_adapt ! Maximum number of attempts
      INTEGER, PARAMETER :: nmin = nmin_adapt ! Minimum number of points

      ! x' = fx; v' = fv
      INTERFACE       
         FUNCTION fx(x_in, v_in, t_in)
            REAL, INTENT(IN) :: x_in, v_in, t_in
         END FUNCTION fx
         FUNCTION fv(x_in, v_in, t_in)
            REAL, INTENT(IN) :: x_in, v_in, t_in
         END FUNCTION fv
      END INTERFACE

      IF (n <= 1) STOP 'ODECOUPLED_ADAPTIVE: Error, you cannot solve an ODE with n=1 (or less)'

      ! Loop over attemps for number of time steps
      DO j = 1, jmax

         ! Set the number of time steps
         nn = 1+(n-1)*2**(j-1)

         ! Solve the ODE with 'nn' time steps
         CALL ODEcoupled(x, v, t, ti, tf, xi, vi, fx, fv, nn, iode, ilog)

         ! Automatically fail on the first go, otherwise check with previous attempt for convergence
         ! TODO: Replace fail conditions with requal?
         IF (j == 1 .OR. nn < nmin) THEN      
            fail = .TRUE.
         ELSE
            fail = .FALSE.
            DO ip = 1, np       
               in = 2*ip-1 ! kn is k-new      
               IF ((.NOT. almost_equal(xh(ip), x(in), acc)) .OR. (.NOT. almost_equal(vh(ip), v(in), acc))) THEN
               !IF ((.NOT. requal(xh(k), x(kn), acc)) .OR. (.NOT. requal(vh(k), v(kn), acc))) THEN 
                  fail = .TRUE.
                  DEALLOCATE (xh, vh, th)
                  EXIT
               END IF
            END DO
         END IF
        
         IF (fail) THEN
            ! If fail then store this solution and move on to the next attempt
            xh = x
            vh = v
            th = t
            np = nn
         ELSE
            EXIT ! If the integration was successful then exit
         END IF

      END DO

      IF (fail) THEN
         STOP 'ODECOUPLED_ADAPTIVE: Error, failed to converge'
      ELSE
         xh = x
         vh = v
         th = t
         DEALLOCATE(x, v, t)
         ALLOCATE(x(n), v(n), t(n))
         DO ip = 1, n
            in = 1+(ip-1)*(nn-1)/(n-1)
            x(ip) = xh(in)
            v(ip) = vh(in)
            t(ip) = th(in)
         END DO
      END IF

   END SUBROUTINE ODEcoupled_adaptive

   SUBROUTINE ODE1_advance(x1, x2, t1, t2, fx, iode)

      ! Advances the ODE system from t1 to t2, updating x1 to x2 and v1 to v2
      REAL, INTENT(IN) :: x1
      REAL, INTENT(OUT) :: x2
      REAL, INTENT(IN) :: t1
      REAL, INTENT(IN) :: t2
      REAL, EXTERNAL :: fx
      INTEGER, INTENT(IN) :: iode ! ODE solving method
      REAL :: x, t, dt
      REAL :: kx1, kx2, kx3, kx4

      ! fx is what dx/dt is equal to=
      INTERFACE     
         FUNCTION fx(x_in, t_in)
            REAL, INTENT(IN) :: x_in, t_in
         END FUNCTION fx
      END INTERFACE

      ! Set x, v, t to be the initial state of the system
      x = x1
      t = t1

      ! Calculate dt between the final and intial state
      dt = t2-t1
   
      IF (iode == iode_crude) THEN

         ! Crude method
         kx1 = dt*fx(x, t)

         x2 = x1+kx1
       
      ELSE IF (iode == iode_mid) THEN

         ! Mid-point method
         kx1 = dt*fx(x, t)
         kx2 = dt*fx(x+kx1/2., t+dt/2.)

         x2 = x1+kx2
        
      ELSE IF (iode == iode_RK4) THEN

         ! 4th order Rungge-Kutta
         kx1 = dt*fx(x, t)
         kx2 = dt*fx(x+kx1/2., t+dt/2.)
         kx3 = dt*fx(x+kx2/2., t+dt/2.)
         kx4 = dt*fx(x+kx3, t+dt)

         x2 = x1+(kx1+(2.*kx2)+(2.*kx3)+kx4)/6.

      ELSE

         STOP 'ODE_ADVANCE: Error, iode specified incorrectly'

      END IF

   END SUBROUTINE ODE1_advance

   SUBROUTINE ODE2_advance(x1, x2, v1, v2, t1, t2, fx, fv, iode)

      ! Advances the ODE system from t1 to t2, updating x1 to x2 and v1 to v2
      REAL, INTENT(IN) :: x1
      REAL, INTENT(OUT) :: x2
      REAL, INTENT(IN) :: v1
      REAL, INTENT(OUT) :: v2
      REAL, INTENT(IN) :: t1
      REAL, INTENT(IN) :: t2
      REAL, EXTERNAL :: fx
      REAL, EXTERNAL :: fv
      INTEGER, INTENT(IN) :: iode ! ODE solving method
      REAL :: x, v, t, dt
      REAL :: kx1, kx2, kx3, kx4
      REAL :: kv1, kv2, kv3, kv4

      ! x' = fx; v' = fv
      INTERFACE
         FUNCTION fx(x_in, v_in, t_in)
            REAL, INTENT(IN) :: x_in, v_in, t_in
         END FUNCTION fx
         FUNCTION fv(x_in, v_in, t_in)
            REAL, INTENT(IN) :: x_in, v_in, t_in
         END FUNCTION fv
      END INTERFACE

      ! Set x, v, t to be the initial state of the system
      x = x1
      v = v1
      t = t1

      ! Calculate dt between the final and intial state
      dt = t2-t1
   
      IF (iode == iode_crude) THEN

         ! Crude method
         kx1 = dt*fx(x, v, t)
         kv1 = dt*fv(x, v, t)

         x2 = x1+kx1
         v2 = v1+kv1
         
      ELSE IF (iode == iode_mid) THEN

         ! Mid-point method
         kx1 = dt*fx(x, v, t)
         kv1 = dt*fv(x, v, t)
         kx2 = dt*fx(x+kx1/2., v+kv1/2., t+dt/2.)
         kv2 = dt*fv(x+kx1/2., v+kv1/2., t+dt/2.)

         x2 = x1+kx2
         v2 = v1+kv2
         
      ELSE IF (iode == iode_RK4) THEN

         ! 4th order Rungge-Kutta
         kx1 = dt*fx(x, v, t)
         kv1 = dt*fv(x, v, t)
         kx2 = dt*fx(x+kx1/2., v+kv1/2., t+dt/2.)
         kv2 = dt*fv(x+kx1/2., v+kv1/2., t+dt/2.)
         kx3 = dt*fx(x+kx2/2., v+kv2/2., t+dt/2.)
         kv3 = dt*fv(x+kx2/2., v+kv2/2., t+dt/2.)
         kx4 = dt*fx(x+kx3, v+kv3, t+dt)
         kv4 = dt*fv(x+kx3, v+kv3, t+dt)

         x2 = x1+(kx1+(2.*kx2)+(2.*kx3)+kx4)/6.
         v2 = v1+(kv1+(2.*kv2)+(2.*kv3)+kv4)/6.

      ELSE

         STOP 'ODE_ADVANCE: Error, iode specified incorrectly'

      END IF

   END SUBROUTINE ODE2_advance

   REAL FUNCTION velocity(x, v, t)

      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: v
      REAL, INTENT(IN) :: t
      REAL :: crap

      ! Prevent compile-time warnings
      crap = x
      crap = t

      velocity = v

   END FUNCTION velocity

   LOGICAL FUNCTION almost_equal(x, y, eps)

      ! TODO: Surely requal can be used instead of this?
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: y
      REAL, INTENT(IN) :: eps

      IF ((x > eps) .AND. (y > eps) .AND. (abs(-1.+x/y) > eps)) THEN
         almost_equal = .FALSE.
      ELSE
         almost_equal = .TRUE.
      END IF

   END FUNCTION almost_equal

END MODULE ODE_solvers

MODULE special_functions

   USE precision
   USE constants
   USE basic_operations

   IMPLICIT NONE

   PRIVATE

   ! Integer functions
   PUBLIC :: triangle_number
   PUBLIC :: factorial
   PUBLIC :: get_factorials
   PUBLIC :: Fibonacci
   PUBLIC :: get_Fibonaccis
   PUBLIC :: binomial_coefficient

   ! Real functions
   PUBLIC :: polynomial
   PUBLIC :: fix_polynomial
   PUBLIC :: centred_polynomial
   PUBLIC :: fix_centred_polynomial
   PUBLIC :: Legendre_polynomial
   PUBLIC :: Lagrange_polynomial
   PUBLIC :: Si
   PUBLIC :: Ci
   PUBLIC :: Bessel
   PUBLIC :: spherical_Bessel
   PUBLIC :: sinc
   PUBLIC :: wk_tophat
   PUBLIC :: wk_tophat_deriv
   PUBLIC :: wk_tophat_dderiv
   PUBLIC :: cbrt
   PUBLIC :: Heaviside

   ! Minima testing
   PUBLIC :: Rosenbrock
   PUBLIC :: Himmelblau

   ! Probability distributions
   PUBLIC :: Gaussian_distribution
   PUBLIC :: lognormal_distribution
   PUBLIC :: uniform_distribution
   PUBLIC :: Rayleigh_distribution
   PUBLIC :: exponential_distribution
   PUBLIC :: Lorentzian_distribution
   PUBLIC :: polynomial_distribution

   ! Integer probability distributions
   PUBLIC :: Poisson_distribution
   PUBLIC :: Bernoulli_distribution
   PUBLIC :: geometric_distribution
   PUBLIC :: shifted_geometric_distribution
   PUBLIC :: Binomial_distribution

   ! Complex functions
   PUBLIC :: complex_number
   PUBLIC :: complex_phase

   ! Silly functions
   PUBLIC :: apodise
   PUBLIC :: smooth_apodise
   PUBLIC :: blob
   PUBLIC :: smooth_blob
   PUBLIC :: sigmoid_tanh
   PUBLIC :: sigmoid_log

   ! Taylor expansion below this
   REAL, PARAMETER :: dx_sinc = 1e-3
   REAL, PARAMETER :: dx_tophat = 1e-3
   REAL, PARAMETER :: dx_Bessel = 1e-3

   ! Numerical approximation parameters
   REAL, PARAMETER :: x0_SiCi = 4.
   REAL, PARAMETER :: xbig_Bessel = 1e15

   INTERFACE polynomial
      MODULE PROCEDURE linear_polynomial
      MODULE PROCEDURE quadratic_polynomial
      MODULE PROCEDURE cubic_polynomial
   END INTERFACE polynomial

   INTERFACE centred_polynomial
      MODULE PROCEDURE centred_linear_polynomial
      MODULE PROCEDURE centred_quadratic_polynomial
      MODULE PROCEDURE centred_cubic_polynomial
   END INTERFACE centred_polynomial

   INTERFACE fix_polynomial
      MODULE PROCEDURE fix_linear_polynomial
      MODULE PROCEDURE fix_quadratic_polynomial
      MODULE PROCEDURE fix_cubic_polynomial
   END INTERFACE fix_polynomial

   INTERFACE fix_centred_polynomial
      MODULE PROCEDURE fix_centred_linear_polynomial
      MODULE PROCEDURE fix_centred_quadratic_polynomial
      MODULE PROCEDURE fix_centred_cubic_polynomial
   END INTERFACE fix_centred_polynomial

   INTERFACE cbrt
      MODULE PROCEDURE cbrt_real
      MODULE PROCEDURE cbrt_int
   END INTERFACE cbrt

CONTAINS

   REAL FUNCTION Heaviside(x, Hzero_opt)

      REAL, INTENT(IN) :: x
      REAL, OPTIONAL, INTENT(IN) :: Hzero_opt
      REAL, PARAMETER :: Hzero_def = 0.5

      IF (x == 0.) THEN
         Heaviside = default_or_optional(Hzero_def, Hzero_opt)
      ELSE IF (x < 0.) THEN
         Heaviside = 0.
      ELSE
         Heaviside = 1.
      END IF

   END FUNCTION Heaviside

   COMPLEX FUNCTION complex_number(r, theta)

      ! Complex number r*e^{i theta} in Fortran format
      ! Analogy of inbuilt cmplx(x, y) function
      REAL, INTENT(IN) :: r
      REAL, INTENT(IN) :: theta

      complex_number = r*cos(theta)+(0., 1.)*sin(theta)

   END FUNCTION complex_number

   REAL FUNCTION complex_phase(z)
            
      ! Phase of complex number z in radians
      ! Result lies in the range -pi to pi
      ! Commented-out bit would return result in 0 to 2pi
      COMPLEX, INTENT(IN) :: z

      complex_phase = atan2(aimag(z), real(z))
      !IF (complex_phase < 0.) complex_phase = twopi-complex_phase

   END FUNCTION complex_phase

   ELEMENTAL REAL FUNCTION cbrt_real(x)

      ! Cube root, analogy of sqrt()
      REAL, INTENT(IN) :: x

      cbrt_real = x**(1./3.)

   END FUNCTION cbrt_real

   ELEMENTAL REAL FUNCTION cbrt_int(x)

      ! Cube root, analogy of sqrt()
      INTEGER, INTENT(IN) :: x

      cbrt_int = x**(1./3.)

   END FUNCTION cbrt_int

   ELEMENTAL REAL FUNCTION linear_polynomial(x, a1, a0)

      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: a1
      REAL, INTENT(IN) :: a0

      linear_polynomial = a1*x+a0

   END FUNCTION linear_polynomial

   ELEMENTAL REAL FUNCTION quadratic_polynomial(x, a2, a1, a0)

      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: a2
      REAL, INTENT(IN) :: a1
      REAL, INTENT(IN) :: a0

      quadratic_polynomial = a2*x**2+a1*x+a0

   END FUNCTION quadratic_polynomial

   ELEMENTAL REAL FUNCTION cubic_polynomial(x, a3, a2, a1, a0)

      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: a3
      REAL, INTENT(IN) :: a2
      REAL, INTENT(IN) :: a1
      REAL, INTENT(IN) :: a0

      cubic_polynomial = a3*x**3+a2*x**2+a1*x+a0

   END FUNCTION cubic_polynomial

   ELEMENTAL REAL FUNCTION centred_linear_polynomial(x, x0, a1, a0)

      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: x0
      REAL, INTENT(IN) :: a1
      REAL, INTENT(IN) :: a0
      REAL :: xx

      xx = x-x0
      centred_linear_polynomial = linear_polynomial(xx, a1, a0)

   END FUNCTION centred_linear_polynomial

   ELEMENTAL REAL FUNCTION centred_quadratic_polynomial(x, x0, a2, a1, a0)

      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: x0
      REAL, INTENT(IN) :: a2
      REAL, INTENT(IN) :: a1
      REAL, INTENT(IN) :: a0
      REAL :: xx

      xx = x-x0
      centred_quadratic_polynomial = quadratic_polynomial(xx, a2, a1, a0)

   END FUNCTION centred_quadratic_polynomial

   ELEMENTAL REAL FUNCTION centred_cubic_polynomial(x, x0, a3, a2, a1, a0)

      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: x0
      REAL, INTENT(IN) :: a3
      REAL, INTENT(IN) :: a2
      REAL, INTENT(IN) :: a1
      REAL, INTENT(IN) :: a0
      REAL :: xx

      xx = x-x0
      centred_cubic_polynomial = cubic_polynomial(xx, a3, a2,  a1, a0)

   END FUNCTION centred_cubic_polynomial

   SUBROUTINE fix_linear_polynomial(a1, a0, x, y)

      ! Given xi, yi i=1,2 fixes a line between these points
      REAL, INTENT(OUT) :: a1
      REAL, INTENT(OUT) :: a0 
      REAL, INTENT(IN) :: x(2)
      REAL, INTENT(IN) :: y(2)

      a1 = (y(2)-y(1))/(x(2)-x(1))
      a0 = y(1)-a1*x(1)

   END SUBROUTINE fix_linear_polynomial

   SUBROUTINE fix_quadratic_polynomial(a2, a1, a0, x, y)

      ! Given xi, yi i=1,2,3 fixes a quadratic between these points
      REAL, INTENT(OUT) :: a2
      REAL, INTENT(OUT) :: a1
      REAL, INTENT(OUT) :: a0
      REAL, INTENT(IN) :: x(3)
      REAL, INTENT(IN) :: y(3)

      a2 = ((y(2)-y(1))/(x(2)-x(1))-(y(3)-y(1))/(x(3)-x(1)))/(x(2)-x(3))
      a1 = (y(2)-y(1))/(x(2)-x(1))-a2*(x(2)+x(1))
      a0 = y(1)-a2*x(1)**2-a1*x(1)

   END SUBROUTINE fix_quadratic_polynomial

   SUBROUTINE fix_cubic_polynomial(a3, a2, a1, a0, x, y)

      ! Given xi, yi i=1,2,3,4 fixes a cubic between these points
      REAL, INTENT(OUT) :: a3
      REAL, INTENT(OUT) :: a2
      REAL, INTENT(OUT) :: a1
      REAL, INTENT(OUT) :: a0
      REAL, INTENT(IN) :: x(4)
      REAL, INTENT(IN) :: y(4)
      REAL :: f1, f2, f3

      f1 = (y(4)-y(1))/((x(4)-x(2))*(x(4)-x(1))*(x(4)-x(3)))
      f2 = (y(3)-y(1))/((x(3)-x(2))*(x(3)-x(1))*(x(4)-x(3)))
      f3 = (y(2)-y(1))/((x(2)-x(1))*(x(4)-x(3)))*(1./(x(4)-x(2))-1./(x(3)-x(2)))

      a3 = f1-f2-f3

      f1 = (y(3)-y(1))/((x(3)-x(2))*(x(3)-x(1)))
      f2 = (y(2)-y(1))/((x(2)-x(1))*(x(3)-x(2)))
      f3 = a3*(x(3)+x(2)+x(1))

      a2 = f1-f2-f3

      f1 = (y(4)-y(1))/(x(4)-x(1))
      f2 = a3*(x(4)**2+x(4)*x(1)+x(1)**2)
      f3 = a2*(x(4)+x(1))

      a1 = f1-f2-f3

      a0 = y(1)-a3*x(1)**3-a2*x(1)**2-a1*x(1)

   END SUBROUTINE fix_cubic_polynomial

   SUBROUTINE fix_centred_linear_polynomial(a1, a0, x0, x, y)

      REAL, INTENT(OUT) :: a1
      REAL, INTENT(OUT) :: a0
      REAL, INTENT(IN) :: x0
      REAL, INTENT(IN) :: x(2)
      REAL, INTENT(IN) :: y(2)

      CALL fix_linear_polynomial(a1, a0, x-x0, y)

   END SUBROUTINE fix_centred_linear_polynomial

   SUBROUTINE fix_centred_quadratic_polynomial(a2, a1, a0, x0, x, y)

      REAL, INTENT(OUT) :: a2
      REAL, INTENT(OUT) :: a1
      REAL, INTENT(OUT) :: a0
      REAL, INTENT(IN) :: x0
      REAL, INTENT(IN) :: x(3)
      REAL, INTENT(IN) :: y(3)

      CALL fix_quadratic_polynomial(a2, a1, a0, x-x0, y)

   END SUBROUTINE fix_centred_quadratic_polynomial

   SUBROUTINE fix_centred_cubic_polynomial(a3, a2, a1, a0, x0, x, y)

      REAL, INTENT(OUT) :: a3
      REAL, INTENT(OUT) :: a2
      REAL, INTENT(OUT) :: a1
      REAL, INTENT(OUT) :: a0
      REAL, INTENT(IN) :: x0
      REAL, INTENT(IN) :: x(4)
      REAL, INTENT(IN) :: y(4)

      CALL fix_cubic_polynomial(a3, a2, a1, a0, x-x0, y)

   END SUBROUTINE fix_centred_cubic_polynomial

   INTEGER FUNCTION triangle_number(n)

      ! Calculates the nth triangle number
      ! T(1) = 1, T(2) = 3, T(3) = 6, T(4) = 10, ..., T(n)=(1/2)*n*(n+1)
      INTEGER, INTENT(IN) :: n

      triangle_number = n*(n+1)/2

   END FUNCTION triangle_number

   SUBROUTINE get_Fibonaccis(F, n)

      ! Provides a sequence of the first n Fibonacci numbers
      ! F(0)=0 is not provided
      ! F(1)=1; F(2)=1; F(3)=2; F(4)=3; ...; F(n)=F(n-1)+F(n-2)
      INTEGER, INTENT(OUT) :: F(:)
      INTEGER, INTENT(IN) :: n   
      INTEGER :: i

      IF (size(F) /= n) STOP 'GET_FIBONACCIS: Error, F should be of size n'

      IF (n <= 0) THEN
         STOP 'GET_FIBONACCIS: Error, this cannot be called for n<=0'
      ELSE
         DO i = 1, n
            IF (i == 1 .OR. i == 2) THEN
               F(i) = 1
            ELSE
               F(i) = F(i-1)+F(i-2)
            END IF
         END DO
      END IF

   END SUBROUTINE get_Fibonaccis

   INTEGER FUNCTION Fibonacci(n)

      ! Returns the nth Fibonacci number
      ! F(0)=0, F(1)=1, F(2)=1, F(3)=2, F(4)=3, ..., F(n)=F(n-1)+F(n-2)
      INTEGER, INTENT(IN) :: n
      INTEGER :: F(n)

      IF (n < 0) THEN
         STOP 'FIBONACCI: Error, Fibonacci numbers undefined for n<0'
      ELSE IF (n == 0) THEN
         Fibonacci = 0
      ELSE
         CALL get_Fibonaccis(F, n)
         Fibonacci = F(n)
      END IF

   END FUNCTION Fibonacci

   SUBROUTINE get_factorials(f, n)

      ! Provides a sequence of factorial numbers up to n
      ! f(0)=1 is not provided
      ! f(1)=1, f(2)=2, f(3)=6, f(4)=24, ..., f(n)=n*f(n-1)
      ! TODO: Should this really be INT8 here?    
      INTEGER(int8), INTENT(OUT) :: f(:)
      INTEGER, INTENT(IN) :: n
      INTEGER :: i

      IF (size(f) /= n) STOP 'GET_FIBONACCIS: Error, F should be of size n'

      IF (n <= 0) THEN
         STOP 'GET_FACTORIALS: Error, this cannot be called for n<=0'
      ELSE
         DO i = 1, n
            IF (i == 1) THEN
               f(i) = 1
            ELSE
               f(i) = i*f(i-1)
            END IF
         END DO
      END IF

   END SUBROUTINE get_factorials

   INTEGER(int8) FUNCTION factorial(n)

      ! Calculates the nth factorial number
      INTEGER, INTENT(IN) :: n
      INTEGER(int8) :: f8(n)

      IF (n < 0) THEN
         STOP 'FACTORIAL: Error, factorials not defined for n<0'
      ELSE IF (n == 0) THEN
         factorial = 1
      ELSE
         CALL get_factorials(f8, n)
         factorial = f8(n)
      END IF

   END FUNCTION factorial

   INTEGER FUNCTION multiply_integers(a, b)

      ! Multiply the integers a through to b (inclusive)
      INTEGER, INTENT(IN) :: a, b
      INTEGER :: i, m

      m = 1
      DO i = a, b
         m = m*i
      END DO
      multiply_integers = m

   END FUNCTION multiply_integers

   INTEGER FUNCTION binomial_coefficient(n, k)

      ! Evalues binomial coefficient (n, k): n-choose-k
      INTEGER, INTENT(IN) :: n
      INTEGER, INTENT(IN) :: k

      !choose = factorial(n)/(factorial(k)*factorial(n-k)) ! Inefficient
      binomial_coefficient = multiply_integers(n-k+1, n)/factorial(k)

   END FUNCTION binomial_coefficient

   REAL FUNCTION sigmoid_tanh(x)

      ! A function that smoothly transitions from 0 to 1 around x
      REAL, INTENT(IN) :: x

      sigmoid_tanh = 0.5*(1.+tanh(x))

   END FUNCTION sigmoid_tanh

   REAL FUNCTION sigmoid_log(x, a)

      ! A function that smoothly transitions from 0 to 1 around x
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: a
      REAL :: xp, xm

      xp = x**a
      xm = x**(-a)

      sigmoid_log = 0.5*(1.+(xp-xm)/(xp+xm))

   END FUNCTION sigmoid_log

   REAL FUNCTION Legendre_polynomial(n, x)

      ! Returns the nth order Legendre polynomail: P_n(x)
      REAL, INTENT(IN) :: x
      INTEGER, INTENT(IN) :: n

      IF (n == 0) THEN
         Legendre_polynomial = 1.
      ELSE IF (n == 1) THEN
         Legendre_polynomial = x
      ELSE IF (n == 2) THEN
         Legendre_polynomial = (3.*x**2-1.)/2.
      ELSE IF (n == 3) THEN
         Legendre_polynomial = (5.*x**3-3.*x)/2.
      ELSE IF (n == 4) THEN
         Legendre_polynomial = (35.*x**4-30.*x**2+3.)/8.
      ELSE
         STOP 'LEGENDRE_POLYNOMIAL: polynomial of this order not stored'
      END IF

   END FUNCTION Legendre_polynomial

   REAL FUNCTION Lagrange_polynomial(x, xv, yv)

      ! Computes the result of the nth order Lagrange polynomial at point x, L(x)
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xv(:)
      REAL, INTENT(IN) :: yv(:)
      REAL :: l(size(xv))
      INTEGER :: i, j, n

      n = size(xv)
      IF (n /= size(yv)) STOP 'LAGRANGE_POLYNOMIAL: Error, xv and yv should have the same size'
      n = n-1

      IF (n == 0) THEN
         Lagrange_polynomial = yv(1)
      ELSE IF (n == 1) THEN
         Lagrange_polynomial = Lagrange_polynomial_1(x, xv, yv)
      ELSE IF (n == 2) THEN
         Lagrange_polynomial = Lagrange_polynomial_2(x, xv, yv)
      ELSE IF (n == 3) THEN
         Lagrange_polynomial = Lagrange_polynomial_3(x, xv, yv)
      ELSE

         ! Initialise variables, one for sum and one for multiplication
         Lagrange_polynomial = 0.
         l = 1.

         ! Loops to find the polynomials, one is a sum and one is a multiple
         DO i = 0, n
            DO j = 0, n
               IF (i .NE. j) l(i+1) = l(i+1)*(x-xv(j+1))/(xv(i+1)-xv(j+1))
            END DO
            Lagrange_polynomial = Lagrange_polynomial+l(i+1)*yv(i+1)
         END DO

      END IF

   END FUNCTION Lagrange_polynomial

   REAL FUNCTION Lagrange_polynomial_1(x, xv, yv)

      ! Dedicated function for linear interpolation polynomial
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xv(2)
      REAL, INTENT(IN) :: yv(2)
      REAL :: x01, x02
      REAL :: x12
      REAL :: f1, f2

      x01 = x-xv(1)
      x02 = x-xv(2)

      x12 = xv(1)-xv(2)

      f1 = x02*yv(1)
      f2 = x01*yv(2)

      Lagrange_polynomial_1 = (f1-f2)/x12

   END FUNCTION Lagrange_polynomial_1

   REAL FUNCTION Lagrange_polynomial_2(x, xv, yv)

      ! Dedicated function for quadratic interpolation polynomial
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xv(3)
      REAL, INTENT(IN) :: yv(3)
      REAL :: x01, x02, x03
      REAL :: x12, x13, x23
      REAL :: f1, f2, f3

      x01 = x-xv(1)
      x02 = x-xv(2) 
      x03 = x-xv(3)

      x12 = xv(1)-xv(2)
      x13 = xv(1)-xv(3)
      x23 = xv(2)-xv(3)

      f1 = yv(1)*x02*x03/(x12*x13)
      f2 = x01*yv(2)*x03/(x12*x23)
      f3 = x01*x02*yv(3)/(x13*x23)

      Lagrange_polynomial_2 = f1-f2+f3

   END FUNCTION Lagrange_polynomial_2

   REAL FUNCTION Lagrange_polynomial_3(x, xv, yv)

      ! Dedicated function for cubic interpolation polynomial
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xv(4)
      REAL, INTENT(IN) :: yv(4)
      REAL :: x01, x02, x03, x04
      REAL :: x12, x13, x14, x23, x24, x34
      REAL :: f1, f2, f3, f4

      x01 = x-xv(1)
      x02 = x-xv(2) 
      x03 = x-xv(3)
      x04 = x-xv(4)

      x12 = xv(1)-xv(2)
      x13 = xv(1)-xv(3)
      x14 = xv(1)-xv(4)
      x23 = xv(2)-xv(3)
      x24 = xv(2)-xv(4)
      x34 = xv(3)-xv(4)

      f1 = yv(1)*x02*x03*x04/(x12*x13*x14)
      f2 = x01*yv(2)*x03*x04/(x12*x23*x24)
      f3 = x01*x02*yv(3)*x04/(x13*x23*x34)
      f4 = x01*x02*x03*yv(4)/(x14*x24*x34)

      Lagrange_polynomial_3 = f1-f2+f3-f4

   END FUNCTION Lagrange_polynomial_3

   REAL FUNCTION sinc(x)

      ! sinc function: sin(x)/x
      ! TODO: Is the Taylor expansion here unnecessary?
      REAL, INTENT(IN) :: x
      REAL, PARAMETER :: dx = dx_sinc ! small |x| below which to use Taylor expansion

      IF (abs(x) < dx) THEN
         sinc = 1.-(x**2)/6.+(x**4)/120.
      ELSE
         sinc = sin(x)/x
      END IF

   END FUNCTION sinc

   REAL FUNCTION wk_tophat(x)

      ! The normlaised Fourier Transform of a spherical top-hat
      REAL, INTENT(IN) :: x
      REAL, PARAMETER :: dx = dx_tophat ! Taylor expansion for |x|<dx

      ! Taylor expansion used for low x to avoid cancelation problems
      IF (abs(x) < dx) THEN
         wk_tophat = 1.-x**2/10.
      ELSE
         wk_tophat = (3./x**3)*(sin(x)-x*cos(x))
      END IF

   END FUNCTION wk_tophat

   REAL FUNCTION wk_tophat_deriv(x)

      ! The derivative of a normlaised Fourier Transform of a spherical top-hat
      REAL, INTENT(IN) :: x
      REAL, PARAMETER :: dx = dx_tophat ! Taylor expansion for |x|<dx

      ! Taylor expansion used for low x to avoid cancelation problems
      IF (abs(x) < dx) THEN
         wk_tophat_deriv = -x/5.+x**3/70.
      ELSE
         wk_tophat_deriv = (3./x**4)*((x**2-3.)*sin(x)+3.*x*cos(x))
      END IF

   END FUNCTION wk_tophat_deriv

   REAL FUNCTION wk_tophat_dderiv(x)

      ! The second derivative of a normlaised Fourier Transform of a spherical top-hat
      REAL, INTENT(IN) :: x
      REAL, PARAMETER :: dx = dx_tophat ! Taylor expansion for |x|<dx

      ! Taylor expansion used for low x to avoid cancelation problems
      IF (abs(x) < dx) THEN
         wk_tophat_dderiv = -0.2+3.*x**2/70.
      ELSE
         wk_tophat_dderiv = (3./x**5)*((12.-5.*x**2)*sin(x)+x*(x**2-12.)*cos(x))
      END IF

   END FUNCTION wk_tophat_dderiv

   REAL FUNCTION apodise(x, x1, x2, n)

      ! Apodises a function between x1 and x2
      ! Goes to one smoothly at x1
      ! Goes to zero linearly at x2, so the gradient change is discontinous
      ! n govenrns the severity of the transition
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: x1
      REAL, INTENT(IN) :: x2
      REAL, INTENT(IN) :: n

      IF (n <= 0.) STOP 'APODISE: Error, n must be greater than zero'

      IF (x < x1) THEN
         apodise = 1.
      ELSE IF (x > x2) THEN
         apodise = 0.
      ELSE
         apodise = cos((pi/2.)*(x-x1)/(x2-x1))
         apodise = apodise**n
      END IF

   END FUNCTION apodise

   REAL FUNCTION smooth_apodise(x, x1, x2, n)

      ! Apodises a function between x1 and x2
      ! Goes to one smoothly at x1 and zero smoothly at x2
      ! n govenrns the severity of the transition
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: x1
      REAL, INTENT(IN) :: x2
      REAL, INTENT(IN) :: n

      IF (n <= 0.) STOP 'APODISE: Error, n must be greater than zero'

      IF (x < x1) THEN
         smooth_apodise = 1.
      ELSE IF (x > x2) THEN
         smooth_apodise = 0.
      ELSE
         smooth_apodise = 0.5*(1.+cos(pi*(x-x1)/(x2-x1)))
         smooth_apodise = smooth_apodise**n
      END IF

   END FUNCTION smooth_apodise

   REAL FUNCTION blob(x, x1, x2, n)

      ! Makes a blob between x1 and x2, with zero elsewhere
      ! Blob goes to zero linearly at x1 and x2, so the gradient change is discontinous
      ! n governs the severity (blobiness) of the blob
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: x1
      REAL, INTENT(IN) :: x2
      REAL, INTENT(IN) :: n

      IF (n <= 0.) STOP 'APODISE: Error, n must be greater than zero'

      IF (x < x1) THEN
         blob = 0.
      ELSE IF (x > x2) THEN
         blob = 0.
      ELSE
         blob = sin(pi*(x-x1)/(x2-x1))
         blob = blob**n
      END IF

   END FUNCTION blob

   REAL FUNCTION smooth_blob(x, x1, x2, n)

      ! Makes a blob between x1 and x2, with zero elsewhere
      ! Blob goes to zero smoothly at x1 and x2
      ! n governs the severity (blobiness) of the blob
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: x1
      REAL, INTENT(IN) :: x2
      REAL, INTENT(IN) :: n

      IF (n <= 0.) STOP 'APODISE: Error, n must be greater than zero'

      IF (x < x1) THEN
         smooth_blob = 0.
      ELSE IF (x > x2) THEN
         smooth_blob = 0.
      ELSE
         smooth_blob = (1.+cos(twopi*(x-x1)/(x2-x1)))/2.
         smooth_blob = (1.-smooth_blob)**n
      END IF

   END FUNCTION smooth_blob

   REAL FUNCTION Si(x)

      ! Returns the 'sine integral' function: Si(x)=int_0^x sin(t)/t dt
      REAL, INTENT(IN) :: x
      REAL :: x2, y, f, g, si8
      REAL, PARAMETER :: x0 = x0_SiCi ! Transition between two different approximations

      ! Expansions for high and low x thieved from Wikipedia, two different expansions for above and below 4.
      IF (abs(x) <= x0) THEN

         x2 = x*x

         si8 = x*(1.d0+x2*(-4.54393409816329991d-2+x2*(1.15457225751016682d-3 &
               +x2*(-1.41018536821330254d-5+x2*(9.43280809438713025d-8+x2*(-3.53201978997168357d-10 &
               +x2*(7.08240282274875911d-13+x2*(-6.05338212010422477d-16))))))))/ &
               (1.+x2*(1.01162145739225565d-2+x2*(4.99175116169755106d-5+ &
               x2*(1.55654986308745614d-7+x2*(3.28067571055789734d-10+x2*(4.5049097575386581d-13 &
               +x2*(3.21107051193712168d-16)))))))

         Si = real(si8)

      ELSE IF (abs(x) > x0) THEN

         y = 1.d0/(x*x)

         f = (1.d0+y*(7.44437068161936700618d2+y*(1.96396372895146869801d5+ &
               y*(2.37750310125431834034d7+y*(1.43073403821274636888d9+y*(4.33736238870432522765d10 &
               +y*(6.40533830574022022911d11+y*(4.20968180571076940208d12+ &
               y*(1.00795182980368574617d13+y*(4.94816688199951963482d12+ &
               y*(-4.94701168645415959931d11)))))))))))/(x*(1.+y*(7.46437068161927678031d2+ &
               y*(1.97865247031583951450d5+y*(2.41535670165126845144d7+ &
               y*(1.47478952192985464958d9+y*(4.58595115847765779830d10+ &
               y*(7.08501308149515401563d11+y*(5.06084464593475076774d12+ &
               y*(1.43468549171581016479d13+y*(1.11535493509914254097d13)))))))))))

         g = y*(1.d0+y*(8.1359520115168615d2+y*(2.35239181626478200d5+ &
               y*(3.12557570795778731d7+y*(2.06297595146763354d9+y*(6.83052205423625007d10+ &
               y*(1.09049528450362786d12+y*(7.57664583257834349d12+y*(1.81004487464664575d13+ &
               y*(6.43291613143049485d12+y*(-1.36517137670871689d12)))))))))))/ &
               (1.+y*(8.19595201151451564d2+y*(2.40036752835578777d5+y*(3.26026661647090822d7 &
               +y*(2.23355543278099360d9+y*(7.87465017341829930d10+y*(1.39866710696414565d12 &
               +y*(1.17164723371736605d13+y*(4.01839087307656620d13+y*(3.99653257887490811d13))))))))))

         Si = real(pi/2.d0-f*cos(x)-g*sin(x))

      ELSE

         STOP 'SI: Something went very wrong'

      END IF

   END FUNCTION Si

   REAL FUNCTION Ci(x)

      ! Returns the 'cosine integral' function Ci(x): -int_x^inf cos(t)/t dt
      REAL, INTENT(IN) :: x
      REAL :: x2, y, f, g, ci8
      REAL, PARAMETER :: x0 = x0_SiCi ! Transition between two different approximations

      ! Expansions for high and low x thieved from Wikipedia, two different expansions for above and below 4.
      IF (abs(x) <= x0) THEN

         x2 = x*x

         ci8 = em+log(x)+x2*(-0.25d0+x2*(7.51851524438898291d-3+x2*(-1.27528342240267686d-4 &
               +x2*(1.05297363846239184d-6+x2*(-4.68889508144848019d-9+x2*(1.06480802891189243d-11 &
               +x2*(-9.93728488857585407d-15)))))))/(1.+x2*(1.1592605689110735d-2+ &
               x2*(6.72126800814254432d-5+x2*(2.55533277086129636d-7+x2*(6.97071295760958946d-10+ &
               x2*(1.38536352772778619d-12+x2*(1.89106054713059759d-15+x2*(1.39759616731376855d-18))))))))

         Ci = real(ci8)

      ELSE IF (abs(x) > x0) THEN

         y = 1./(x*x)

         f = (1.d0+y*(7.44437068161936700618d2+y*(1.96396372895146869801d5+ &
               y*(2.37750310125431834034d7+y*(1.43073403821274636888d9+y*(4.33736238870432522765d10 &
               +y*(6.40533830574022022911d11+y*(4.20968180571076940208d12+y*(1.00795182980368574617d13 &
               +y*(4.94816688199951963482d12+y*(-4.94701168645415959931d11)))))))))))/ &
               (x*(1.+y*(7.46437068161927678031d2+y*(1.97865247031583951450d5+ &
               y*(2.41535670165126845144d7+y*(1.47478952192985464958d9+ &
               y*(4.58595115847765779830d10+y*(7.08501308149515401563d11+y*(5.06084464593475076774d12 &
               +y*(1.43468549171581016479d13+y*(1.11535493509914254097d13)))))))))))

         g = y*(1.d0+y*(8.1359520115168615d2+y*(2.35239181626478200d5+y*(3.12557570795778731d7 &
               +y*(2.06297595146763354d9+y*(6.83052205423625007d10+ &
               y*(1.09049528450362786d12+y*(7.57664583257834349d12+ &
               y*(1.81004487464664575d13+y*(6.43291613143049485d12+y*(-1.36517137670871689d12))))))))))) &
               /(1.+y*(8.19595201151451564d2+y*(2.40036752835578777d5+ &
               y*(3.26026661647090822d7+y*(2.23355543278099360d9+y*(7.87465017341829930d10 &
               +y*(1.39866710696414565d12+y*(1.17164723371736605d13+y*(4.01839087307656620d13+y*(3.99653257887490811d13))))))))))

         Ci = real(f*sin(x)-g*cos(x))

      ELSE

         STOP 'CI: Something went very wrong'

      END IF

   END FUNCTION Ci

   REAL FUNCTION Bessel(n, x)

      ! Returns the Bessel function of order 'n'
      ! Wraps the Fortran intrinsic functions
      INTEGER, INTENT(IN) :: n
      REAL, INTENT(IN) :: x  
      REAL, PARAMETER :: xbig = xbig_Bessel ! Set to zero for large values

      IF (x > xbig) THEN

         ! To stop it going mental for very large values of x
         Bessel = 0.

      ELSE

         IF (n < 0) THEN
            WRITE(*,*) 'BESSEL: Order:', n
            STOP 'BESSEL: cannot call for negative n'
         END IF

         IF (n == 0) THEN
            Bessel = Bessel_J0(x)
         ELSE IF (n == 1) THEN
            Bessel = Bessel_J1(x)
         ELSE
            Bessel = Bessel_JN(n, x)
         END IF

      END IF

   END FUNCTION Bessel

   REAL FUNCTION spherical_Bessel(x, n)

      ! Spherical Bessel function of order n: j_n(x)
      ! Unlike the standard Bessel functions, these are expressible in terms of sin(x) and cos(x)
      ! Copied from https://en.wikipedia.org/wiki/Bessel_function
      ! Limits from https://www.wolframalpha.com/input/?i=series+expand+j_0%28x%29
      REAL, INTENT(IN) :: x
      INTEGER, INTENT(IN) :: n
      REAL, PARAMETER :: dx = dx_Bessel

      IF (abs(x) < dx) THEN
         IF (n == 0) THEN
            spherical_Bessel = 1.-x**2/6.
         ELSE IF (n == 1) THEN
            spherical_Bessel = x/3.-x**3/30.
         ELSE IF (n == 2) THEN
            spherical_Bessel = x**2/15.-x**4/210.
         ELSE IF (n == 3) THEN
            spherical_Bessel = x**3/105.-x**5/1890.
         ELSE
            WRITE(*, *) 'SPHERICAL_BESSEL: n:', n
            STOP 'SPHERICAL_BESSEL: Error, value of n not currently supported'
         END IF
      ELSE
         IF (n == 0) THEN
            spherical_Bessel = sin(x)/x
         ELSE IF (n == 1) THEN
            spherical_Bessel = sin(x)/x**2-cos(x)/x
         ELSE IF (n == 2) THEN
            spherical_Bessel = (3./x**2-1.)*sin(x)/x-3.*cos(x)/x**2
         ELSE IF (n == 3) THEN
            spherical_Bessel = (15./x**3-6./x)*sin(x)/x-(15./x**2-1.)*cos(x)/x
         ELSE
            WRITE(*, *) 'SPHERICAL_BESSEL: n:', n
            STOP 'SPHERICAL_BESSEL: Error, value of n not currently supported'
         END IF
      END IF

   END FUNCTION spherical_Bessel

   REAL FUNCTION Gaussian_distribution(x, mu, sigma)

      ! Returns the integral-normalised Gaussian
      REAL, INTENT(IN) :: x     ! [-inf:inf]
      REAL, INTENT(IN) :: mu    ! Mean value
      REAL, INTENT(IN) :: sigma ! Root-variance
      REAL :: f1, f2

      f1 = exp(-((x-mu)**2)/(2.*sigma**2))
      f2 = sigma*sqrt(twopi)

      Gaussian_distribution = f1/f2

   END FUNCTION Gaussian_distribution

   REAL FUNCTION lognormal_distribution(x, mean, sd)

      ! Returns integral-normalised lognormal distribution
      REAL, INTENT(IN) :: x    ! x [0,inf]
      REAL, INTENT(IN) :: mean ! Mean value of x
      REAL, INTENT(IN) :: sd   ! Standard deviation of x
      REAL :: mu, sigma

      IF (mean <= 0.) STOP 'LOGNORMAL_DISTRIBUTION: Error, mean cannot be less than or equal to zero'
      IF (sd < 0.)    STOP 'LOGNORMAL_DISTRIBUTION: Error, standard deviation cannot be less than zero'

      mu = log(mean/sqrt(1.+(sd/mean)**2))
      sigma = sqrt(log(1.+(sd/mean)**2))
      lognormal_distribution = Gaussian_distribution(log(x), mu, sigma)/x

   END FUNCTION lognormal_distribution

   REAL FUNCTION uniform_distribution(x, x1, x2)

      ! Returns integral-normalised one-dimensional top-hat function between x1 and x2
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: x1 ! Lower limit
      REAL, INTENT(IN) :: x2 ! Upper limit

      IF (x < x1 .OR. x > x2) THEN
         uniform_distribution = 0.
      ELSE
         uniform_distribution = 1./(x2-x1)
      END IF

   END FUNCTION uniform_distribution

   REAL FUNCTION Rayleigh_distribution(x, sigma)

      ! Returns integral-normalised Rayleigh distribution
      REAL, INTENT(IN) :: x     ! [0:inf]
      REAL, INTENT(IN) :: sigma ! Sigma parameter (*not* root-variance for this distribution)

      IF (sigma <= 0.) STOP 'RAYLEIGH_DISTRIBUTION: Error, sigma cannot be less than or equal to zero'

      IF (x < 0.) THEN
         STOP 'RAYLEIGH_DISTRIBUTION: Error, x cannot be less than zero'
      ELSE
         Rayleigh_distribution = x*exp(-(x**2)/(2.*(sigma**2)))/(sigma**2)
      END IF

   END FUNCTION Rayleigh_distribution

   REAL FUNCTION Poisson_distribution(n, nbar)

      ! Normalised discrete Poisson probability distribution
      INTEGER, INTENT(IN) :: n ! Number of events to evaluate P_n at, n>=0
      REAL, INTENT(IN) :: nbar ! Mean number of events >0

      Poisson_distribution = exp(-nbar)*(nbar**n)/int(factorial(n))

   END FUNCTION Poisson_distribution

   REAL FUNCTION Bernoulli_distribution(k, p)

      ! One trial with probability of success: p
      INTEGER, INTENT(IN) :: k ! 0 or 1 only
      REAL, INTENT(IN) :: p    ! Must be between 0 and 1.

      Bernoulli_distribution = (p**k)*(1.-p)**(1-k)
      !IF (k == 0) THEN
      !   Bernoulli_distribution = 1.-p
      !ELSE IF (k == 1) THEN
      !   Bernoulli_distribution = p
      !ELSE
      !   STOP 'BERNOULLI_DISTRIBUTION: Error, k can only be zero or one'
      !END IF

   END FUNCTION Bernoulli_distribution

   REAL FUNCTION geometric_distribution(k, p)

      ! Probability for number of failures until the first success
      ! Each of k trials is independent and has chance of success k
      INTEGER, INTENT(IN) :: k ! Must be 0 or greater
      REAL, INTENT(IN) :: p    ! Must be between 0 and 1.

      geometric_distribution = p*(1.-p)**k

   END FUNCTION geometric_distribution

   REAL FUNCTION shifted_geometric_distribution(k, p)

      ! Probability for number of trials until the first success
      ! Each of k trials is independent and has chance of success k
      INTEGER, INTENT(IN) :: k ! Must be 1 or greater
      REAL, INTENT(IN) :: p    ! Must be between 0 and 1.

      !shifted_geometric_distribution = p*(1.-p)**(k-1)
      shifted_geometric_distribution = geometric_distribution(k-1, p)

   END FUNCTION shifted_geometric_distribution

   REAL FUNCTION Binomial_distribution(k, n, p)

      INTEGER, INTENT(IN) :: k
      INTEGER, INTENT(IN) :: n
      REAL, INTENT(IN) :: p

      Binomial_distribution = binomial_coefficient(n, k)*(p**k)*(1.-p)**(n-k)

   END FUNCTION Binomial_distribution

   REAL FUNCTION exponential_distribution(x, mean)

      ! Returns integral-normalised exponential distribution
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: mean

      exponential_distribution = exp(-x/mean)/mean

   END FUNCTION exponential_distribution

   REAL FUNCTION Lorentzian_distribution(x)

      ! Returns integral-normalised Lorentzian distribution
      REAL, INTENT(IN) :: x

      Lorentzian_distribution = 2./(pi*(1.+x**2))

   END FUNCTION Lorentzian_distribution

   REAL FUNCTION polynomial_distribution(x, n)

      ! Returns integral-normalised polynomial distribution
      REAL, INTENT(IN) :: x ! x[0->1]
      REAL, INTENT(IN) :: n ! Polynomail order [n>-1]

      IF (n < -1) STOP 'POLYNOMIAL_DISTRIBUTION: Error, index is less than -1'

      IF (x < 0. .OR. x > 1.) THEN
         STOP 'POLYNOMIAL_DISTRIBUTION: Error, x is outside range 0 to 1'
      ELSE
         polynomial_distribution = (n+1.)*x**n
      END IF

   END FUNCTION polynomial_distribution

   REAL FUNCTION Rosenbrock(x, y)

      ! https://en.wikipedia.org/wiki/Rosenbrock_function
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: y

      Rosenbrock = (1.-x)**2+100.*(y-x**2)**2

   END FUNCTION Rosenbrock

   REAL FUNCTION Himmelblau(x, y)
   
      ! https://en.wikipedia.org/wiki/Himmelblau%27s_function
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: y

      Himmelblau = (x**2+y-11.)**2+(x+y**2-7.)**2

   END FUNCTION Himmelblau

END MODULE special_functions

MODULE calculus_table

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: derivative_table
   PUBLIC :: integrate_table

   INTERFACE integrate_table
      MODULE PROCEDURE integrate_table_1D
      MODULE PROCEDURE integrate_table_2D
   END INTERFACE integrate_table

CONTAINS

   REAL FUNCTION derivative_table(x, xin, yin, iorder, ifind)

      ! Given two arrays x and y such that y=y(x) this uses interpolation to calculate the derivative y'(x_i) at position x_i
      USE table_integer
      USE special_functions
      USE array_operations
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xin(:)
      REAL, INTENT(IN) :: yin(:)
      INTEGER, INTENT(IN) :: iorder
      INTEGER, INTENT(IN) :: ifind
      REAL, ALLOCATABLE ::  xtab(:), ytab(:)
      REAL :: a, b, c, d
      REAL :: x1, x2, x3, x4
      REAL :: y1, y2, y3, y4
      INTEGER :: i, n

      ! This version interpolates if the value is off either end of the array!
      ! Care should be chosen to insert x, xtab, ytab as log if this might give better!
      ! Results from the interpolation!

      ! ifind = 1 => find x in xtab by crudely searching
      ! ifind = 2 => find x in xtab quickly assuming the table is linearly spaced
      ! ifind = 3 => find x in xtab using midpoint splitting (iterations=ceiling(log2(n)))

      ! iorder = 1 => linear interpolation
      ! iorder = 2 => quadratic interpolation
      ! iorder = 3 => cubic interpolation

      n = size(xin)
      IF (n /= size(yin)) STOP 'DERIVATIVE_TABLE: Input x and y arrays should be of the same size'
      ALLOCATE(xtab(n), ytab(n))

      xtab = xin
      ytab = yin

      IF (xtab(1) > xtab(n)) THEN
         ! Reverse the arrays in this case
         CALL reverse_array(xtab)
         CALL reverse_array(ytab)
      END IF

      IF (iorder == 1) THEN

         IF (n < 2) STOP 'DERIVATIVE_TABLE: Not enough points in your table for linear interpolation'

         IF (x <= xtab(2)) THEN

            x2 = xtab(2)
            x1 = xtab(1)

            y2 = ytab(2)
            y1 = ytab(1)

         ELSE IF (x >= xtab(n-1)) THEN

            x2 = xtab(n)
            x1 = xtab(n-1)

            y2 = ytab(n)
            y1 = ytab(n-1)

         ELSE

            i = find_table_integer(x, xtab, ifind)

            x2 = xtab(i+1)
            x1 = xtab(i)

            y2 = ytab(i+1)
            y1 = ytab(i)

         END IF

         CALL fix_polynomial(a, b, [x1, x2], [y1, y2])
         derivative_table = a

      ELSE IF (iorder == 2) THEN

         IF (n < 3) STOP 'DERIVATIVE_TABLE: Not enough points in your table'

         IF (x <= xtab(2) .OR. x >= xtab(n-1)) THEN

            IF (x <= xtab(2)) THEN

               x3 = xtab(3)
               x2 = xtab(2)
               x1 = xtab(1)

               y3 = ytab(3)
               y2 = ytab(2)
               y1 = ytab(1)

            ELSE IF (x >= xtab(n-1)) THEN

               x3 = xtab(n)
               x2 = xtab(n-1)
               x1 = xtab(n-2)

               y3 = ytab(n)
               y2 = ytab(n-1)
               y1 = ytab(n-2)

            ELSE

               STOP 'DERIVATIVE_TABLE: Error, something went wrong'

            END IF

            CALL fix_polynomial(a, b, c, [x1, x2, x3], [y1, y2, y3])

            derivative_table = 2.*a*x+b

         ELSE

            i = find_table_integer(x, xtab, ifind)

            x1 = xtab(i-1)
            x2 = xtab(i)
            x3 = xtab(i+1)
            x4 = xtab(i+2)

            y1 = ytab(i-1)
            y2 = ytab(i)
            y3 = ytab(i+1)
            y4 = ytab(i+2)

            ! In this case take the average of two separate quadratic spline values

            derivative_table = 0.

            CALL fix_polynomial(a, b, c, [x1, x2, x3], [y1, y2, y3])
            derivative_table = derivative_table+(2.*a*x+b)/2.

            CALL fix_polynomial(a, b, c, [x2, x3, x4], [y2, y3, y4])
            derivative_table = derivative_table+(2.*a*x+b)/2.

         END IF

      ELSE IF (iorder == 3) THEN

         IF (n < 4) STOP 'DERIVATIVE_TABLE: Not enough points in your table'

         IF (x <= xtab(3)) THEN

            x4 = xtab(4)
            x3 = xtab(3)
            x2 = xtab(2)
            x1 = xtab(1)

            y4 = ytab(4)
            y3 = ytab(3)
            y2 = ytab(2)
            y1 = ytab(1)

         ELSE IF (x >= xtab(n-2)) THEN

            x4 = xtab(n)
            x3 = xtab(n-1)
            x2 = xtab(n-2)
            x1 = xtab(n-3)

            y4 = ytab(n)
            y3 = ytab(n-1)
            y2 = ytab(n-2)
            y1 = ytab(n-3)

         ELSE

            i = find_table_integer(x, xtab, ifind)

            x1 = xtab(i-1)
            x2 = xtab(i)
            x3 = xtab(i+1)
            x4 = xtab(i+2)

            y1 = ytab(i-1)
            y2 = ytab(i)
            y3 = ytab(i+1)
            y4 = ytab(i+2)

         END IF

         CALL fix_polynomial(a, b, c, d, [x1, x2, x3, x4], [y1, y2, y3, y4])
         derivative_table = 3.*a*(x**2.)+2.*b*x+c

      ELSE

         STOP 'DERIVATIVE_TABLE: Error, order not specified correctly'

      END IF

   END FUNCTION derivative_table

   REAL FUNCTION integrate_table_1D(x, y, n1, n2, iorder)
      
      ! Integrates tables y(x)dx
      USE special_functions
      REAL, INTENT(IN) :: x(:)
      REAL, INTENT(IN) :: y(:)
      INTEGER, INTENT(IN) :: n1
      INTEGER, INTENT(IN) :: n2
      INTEGER, INTENT(IN) :: iorder
      REAL :: a, b, c, d, h
      REAL :: q1, q2, q3, qi, qf
      REAL :: x1, x2, x3, x4, y1, y2, y3, y4, xi, xf
      REAL :: sum
      INTEGER :: i, i1, i2, i3, i4, n

      n = size(x)
      IF (n /= size(y)) STOP 'INTEGRATE_TABLE_1D: Error, x and y should be the same size'
      IF (n1 < 1) STOP 'INTEGRATE_TABLE_1D: Error, n1 cannot be less than 1'
      IF (n2 > n) STOP 'INTEGRATE_TABLE_1D: Error, n2 cannot be greater than n'
      IF (n2 < n1) STOP 'INTEGRATE_TABLE_1D: Error, n2 cannot be less than n1'

      sum = 0.d0

      ! I think if n1=n2 then the result will just be zero anyway
      !IF(n2<=n1) STOP 'INTEGRATE_TABLE: Error n2 must be greater than n1'

      IF (n1 == n2) THEN

         integrate_table_1D = 0.

      ELSE IF(iorder==0) THEN

         ! Data must be evenly spaced for zeroth order to work
         ! x coordinates must represent bin centres
         ! Note from the range x(1)->x(2) there are only n-1 bins
         ! The 1st bin spills out by h/2 below x(1) and the nth by h/2 above x(n)
         ! This is only useful for summing histograms etc.
         h=(x(n)-x(1))/real(n-1)

         ! Each rectangle contributes y(i)*dx to the integral
         DO i = n1, n2
            sum=sum+y(i)
         END DO
         sum=sum*h

      ELSE IF (iorder == 1) THEN

         ! Sums over all Trapezia (a+b)*h/2
         DO i = n1, n2-1
            a = y(i+1)
            b = y(i)
            h = x(i+1)-x(i)
            sum = sum+(a+b)*h
         END DO
         sum=sum/2.

      ELSE IF (iorder == 2) THEN

         DO i = n1, n2-2

            x1 = x(i)
            x2 = x(i+1)
            x3 = x(i+2)

            y1 = y(i)
            y2 = y(i+1)
            y3 = y(i+2)

            CALL fix_polynomial(a, b, c, [x1, x2, x3], [y1, y2, y3])

            q1 = a*(x1**3.)/3.+b*(x1**2.)/2.+c*x1
            q2 = a*(x2**3.)/3.+b*(x2**2.)/2.+c*x2
            q3 = a*(x3**3.)/3.+b*(x3**2.)/2.+c*x3

            ! Takes value for first and last sections but averages over sections where you
            ! have two independent estimates of the area
            IF (n == 3) THEN
               sum = sum+q3-q1
            ELSE IF (i == 1) THEN
               sum = sum+(q2-q1)+(q3-q2)/2.d0
            ELSE IF (i == n-2) THEN
               sum = sum+(q2-q1)/2.d0+(q3-q2)
            ELSE
               sum = sum+(q3-q1)/2.
            END IF

         END DO

      ELSE IF (iorder == 3) THEN

         DO i = n1, n2-1

            ! First choose the integers used for defining cubics for each section
            ! First and last are different because the section does not lie in the *middle* of a cubic

            IF (i == 1) THEN

               i1 = 1
               i2 = 2
               i3 = 3
               i4 = 4

            ELSE IF (i == n-1) THEN

               i1 = n-3
               i2 = n-2
               i3 = n-1
               i4 = n

            ELSE

               i1 = i-1
               i2 = i
               i3 = i+1
               i4 = i+2

            END IF

            x1 = x(i1)
            x2 = x(i2)
            x3 = x(i3)
            x4 = x(i4)

            y1 = y(i1)
            y2 = y(i2)
            y3 = y(i3)
            y4 = y(i4)

            CALL fix_polynomial(a, b, c, d, [x1, x2, x3, x4], [y1, y2, y3, y4])

            ! These are the limits of the particular section of integral
            xi = x(i)
            xf = x(i+1)

            qi = a*(xi**4.)/4.+b*(xi**3.)/3.+c*(xi**2.)/2.+d*xi
            qf = a*(xf**4.)/4.+b*(xf**3.)/3.+c*(xf**2.)/2.+d*xf

            sum = sum+qf-qi

         END DO

      ELSE

         STOP 'INTEGRATE_TABLE_1D: Error, order not specified correctly'

      END IF

      integrate_table_1D = sum

   END FUNCTION integrate_table_1D

   REAL FUNCTION integrate_table_2D(x, y, F)

      ! A crude integration scheme for tabulated 2D functions
      REAL, INTENT(IN) :: x(:)
      REAL, INTENT(IN) :: y(:)
      REAL, INTENT(IN) :: F(:, :)
      INTEGER :: ix, iy, nx, ny
      REAL :: sum
      REAL :: dx, dy

      nx = size(x)
      ny = size(y)
      IF (nx /= size(F, 1)) STOP 'INTEGRATE_TABLE_2D: Size of x must be the same size as the first dimension of F'
      IF (ny /= size(F, 2)) STOP 'INTEGRATE_TABLE_2D: Size of y must be the same size as the second dimension of F'

      ! Set the sum variable to zero
      sum = 0.

      ! Loop over function, calculate dx, dy, sum to get integral
      DO iy = 1, ny-1

         dy = y(iy+1)-y(iy)

         DO ix = 1, nx-1

            dx = x(ix+1)-x(ix)

            sum = sum+dx*dy*(F(ix, iy)+F(ix+1, iy)+F(ix, iy+1)+F(ix+1, iy+1))/4.

         END DO

      END DO

      integrate_table_2D = real(sum)

   END FUNCTION integrate_table_2D

END MODULE calculus_table

MODULE root_finding

   ! TODO: Write a wrapper for solve routines
   USE basic_operations
   USE table_integer
   USE interpolate

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: solve_quadratic
   PUBLIC :: solve_gradient
   PUBLIC :: solve_find
   PUBLIC :: solve_bisect_tables
   PUBLIC :: solve_bisect_function

   INTEGER, PARAMETER :: iorder_bisect = 3
   INTEGER, PARAMETER :: ifind_bisect = ifind_split
   INTEGER, PARAMETER :: iinterp_bisect = iinterp_Lagrange

CONTAINS

   FUNCTION solve_quadratic(a, b, c)

      ! Get the two real solutions of a quadratic ax^2 + bx + c = 0
      ! TODO: Solve for imaginary solutions too
      REAL :: solve_quadratic(2)
      REAL, INTENT(IN) :: a
      REAL, INTENT(IN) :: b
      REAL, INTENT(IN) :: c
      REAL :: disc, root

      disc = b**2-4.*a*c
      IF(disc >= 0.) THEN
         root = sqrt(disc)
      ELSE
         STOP 'SOLVE_QUADRATIC: Error, your quadratic has imaginary solutions'
      END IF

      solve_quadratic(1) = (root-b)/(2.*a)
      solve_quadratic(2) = (-root-b)/(2.*a)

   END FUNCTION solve_quadratic

   REAL FUNCTION solve_gradient(x1in, x2in, f, acc_opt)

      ! Solves for x0 with f(x0) = 0; initial guesses x1 and x2
      ! e.g., f(x) = x^2-4 would find either x = -2 or x = 2 depending on the initial guess
      USE special_functions
      REAL, INTENT(IN) :: x1in, x2in
      REAL, EXTERNAL :: f
      REAL, OPTIONAL, INTENT(IN) :: acc_opt
      REAL :: x1, x2, f1, f2, a0, a1, xnew, acc
      REAL, PARAMETER :: acc_def = 1e-6
      INTERFACE
         FUNCTION f(x)
            REAL, INTENT(IN) :: x
         END FUNCTION f
      END INTERFACE

      acc = default_or_optional(acc_def, acc_opt)
      x1 = x1in; x2 = x2in
      f1 = f(x1); f2 = f(x2)
      DO
         IF ((min(abs(f1), abs(f2))) <= acc) EXIT
         CALL fix_polynomial(a1, a0, [x1, x2], [f1, f2])
         xnew = -a0/a1 ! x intercept
         IF (abs(f1) < abs(f2)) THEN
            x2 = xnew; f2 = f(x2) ! Guess 1 was better, so replace 2...
         ELSE
            x1 = xnew; f1 = f(x1) ! ...otherwise guess 2 was better, so replace 1
         END IF
      END DO

      IF (abs(f1) <= acc) THEN
         solve_gradient = x1
      ELSE
         solve_gradient = x2
      END IF

   END FUNCTION solve_gradient

   REAL FUNCTION solve_find(xtab, ytab)

      ! Solves y(x) = 0 for x
      ! Can also do x = exp(solve_find(log(xtab), ytab) if better
      ! e.g., consider y(x) = x-4; solve_find(x, y) will return 4 (i.e., value when y=0) when x, y tabulated
      ! e.g., consider y(x) = tan(x)-x; solve_find(x, y) will return 4.493 (or 0) iff this value is bracketed by tabulations
      REAL, INTENT(IN) :: xtab(:)
      REAL, INTENT(IN) :: ytab(:)
      INTEGER, PARAMETER :: iorder = 3
      INTEGER, PARAMETER :: ifind = 3
      INTEGER, PARAMETER :: imeth = 2
      REAL, PARAMETER :: a = 0. ! y(x)=a; a=0 here

      solve_find = find(a, ytab, xtab, size(xtab), iorder, ifind, imeth)

   END FUNCTION solve_find

   REAL FUNCTION solve_bisect_tables(xtab, ytab, acc)

      ! Solves y(x)=0 for x, f(x) should be monotonic and cross f=0 once only
      USE interpolate
      REAL, INTENT(IN) :: xtab(:)
      REAL, INTENT(IN) :: ytab(:)
      REAL, INTENT(IN) :: acc
      REAL :: x1, x2, y1, y2, x, y
      INTEGER :: i, n
      INTEGER, PARAMETER :: iorder = iorder_bisect
      INTEGER, PARAMETER :: ifind = ifind_bisect
      INTEGER, PARAMETER :: iinterp = iinterp_bisect

      ! Check array sizes
      n = size(xtab)
      IF (n /= size(ytab)) STOP 'BISECT_SOLVE: Error, x and y arrays must be the same size'

      ! Initial values taken from top and bottom of table
      x1 = xtab(1)
      x2 = xtab(n)
      y1 = ytab(1)
      y2 = ytab(n)

      ! Now iterate until desired accuracy is reached
      i = 0
      DO
         i = i+1
         x = 0.5*(x1+x2)
         y = find(x, xtab, ytab, n, iorder, ifind, iinterp)
         IF (abs(y) < acc) THEN
            EXIT
         ELSE IF (positive(y1) .AND. positive(y)) THEN
            x1 = x
            y1 = y
         ELSE
            x2 = x
            y2 = y
         END IF
      END DO

      solve_bisect_tables = x

   END FUNCTION solve_bisect_tables

   REAL FUNCTION solve_bisect_function(x1_ini, x2_ini, f, acc)

      ! Solve f(x0)=0 for x0 using a bisect method, f(x) should be monotonic and cross 0 only once
      REAL, INTENT(IN) :: x1_ini ! Lower limit for initial guess for range of root
      REAL, INTENT(IN) :: x2_ini ! Upper limit for initial guess for range of root
      REAL, EXTERNAL :: f        ! Function of which to find root
      REAL, INTENT(IN) :: acc    ! Accuracy in f(x) ~ 0
      REAL :: x1, x2, xm
      REAL :: f1, f2, fm

      INTERFACE
         FUNCTION f(x)
            REAL, INTENT(IN) :: x
         END FUNCTION f
      END INTERFACE

      ! Calcualte the values of the function at the initial guess points
      x1 = x1_ini; x2 = x2_ini
      f1 = f(x1); f2 = f(x2)
      IF (positive(f1) .AND. positive(f2)) STOP 'FIND_ROOT: Error, initial guesses must bracket the root'

      ! Loop until convergence achieved
      DO

         ! Calculate the mid-point between x1 and x2 and the value of the function here
         xm = (x1+x2)/2.
         fm = f(xm)

         ! Check for convergence, or update the range between which the root is to be found
         IF (abs(fm) < acc) THEN
            ! Convergence has been met
            EXIT
         ELSE IF (positive(fm) .AND. positive(f1)) THEN
            ! If f(x1) and f(xm) have the same sign then the root is between xm and x2, so update x1, f1 ...
            x1 = xm; f1 = fm
         ELSE
            ! ...otherwise update x2 and f2.
            x2 = xm; f2 = fm
         END IF

      END DO

      solve_bisect_function = xm

   END FUNCTION solve_bisect_function

END MODULE root_finding

MODULE orbits

   USE constants
   USE vectors

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: Kepler_period
   PUBLIC :: orbit_radius
   PUBLIC :: orbit_position
   PUBLIC :: orbit_velocity
   PUBLIC :: reduced_energy
   PUBLIC :: reduced_angular_momentum
   PUBLIC :: Laplace_Runge_Lenz
   PUBLIC :: semi_latus_rectum
   PUBLIC :: semi_major_axis
   PUBLIC :: semi_minor_axis
   PUBLIC :: polar_angle
   PUBLIC :: true_anomaly
   PUBLIC :: argument_of_periapsis
   PUBLIC :: eccentricity

   REAL, PARAMETER :: G_orbit = 1.              ! Gravitational constant for sensible units for orbits
   REAL, PARAMETER :: M_Jupiter = 9.54265748e-4 ! Jupiter mass [Msun]
   REAL, PARAMETER :: M_Earth = 3.003e-6        ! Earth mass [Msun]

CONTAINS

   REAL FUNCTION Kepler_period(a, M)

      ! Period of an orbit [yr]
      REAL, INTENT(IN) :: a ! Semi-major axis [au]
      REAL, INTENT(IN) :: M ! Central mass [Msun]

      Kepler_period = sqrt(a**3/(G_orbit*M))

   END FUNCTION kepler_period

!!$  REAL FUNCTION radius_theta(theta,e)
!!$
!!$    ! Calculate r(theta) for a Keplerian orbit [au]
!!$    ! BUG: Should this not be l/(1+e*cos(t))
!!$    IMPLICIT NONE
!!$    REAL, INTENT(IN) :: theta ! Plane-polar angle; true anomaly [rad]
!!$    REAL, INTENT(IN) :: e     ! Eccentricity
!!$
!!$    radius_theta=1./(1.+e*cos(theta))**2
!!$
!!$  END FUNCTION radius_theta

   REAL FUNCTION orbit_radius(a, e, n)

      ! Calculate orbit x,y,z [au]
      REAL, INTENT(IN) :: a ! Semi-major axis [au]
      REAL, INTENT(IN) :: e ! Eccentricity
      REAL, INTENT(IN) :: n ! True anomaly [rad]
      REAL :: l

      l = a*(1.-e**2) ! Semi-latus rectum

      orbit_radius = l/(1.+e*cos(n))

   END FUNCTION orbit_radius

   FUNCTION orbit_position(a, e, n, w)

      ! Orbit posititon x,y,z [au]
      REAL :: orbit_position(3)
      REAL, INTENT(IN) :: a ! Semi-major axis [au]
      REAL, INTENT(IN) :: e ! Eccentricity
      REAL, INTENT(IN) :: n ! True anomaly [rad]
      REAL, INTENT(IN) :: w ! Argument of periapsis [rad]
      REAL :: l, t

      IF (a < 0. .AND. e < 1.) STOP 'ORBIT_POSITION: Error, if a<0 then e>1 must be enforced'
      IF (e > 1. .AND. a > 0.) STOP 'ORBIT_POSITION: Error, if a<0 then e>1 must be enforced'

      t = n+w         ! Polar angle
      l = a*(1.-e**2) ! Semi-latus rectum

      orbit_position(1) = cos(t)*orbit_radius(a, e, n)
      orbit_position(2) = sin(t)*orbit_radius(a, e, n)
      orbit_position(3) = 0.

   END FUNCTION orbit_position

   FUNCTION orbit_velocity(a, e, n, w, M)

      ! Orbit velocity vx,vy,vz [2piau/yr]
      REAL :: orbit_velocity(3)
      REAL, INTENT(IN) :: a ! Semi-major axis [au]
      REAL, INTENT(IN) :: e ! Eccentricity
      REAL, INTENT(IN) :: n ! True anomaly [rad]
      REAL, INTENT(IN) :: w ! Argument of periapsis [rad]
      REAL, INTENT(IN) :: M ! Central mass [Msun]
      REAL :: t, l, h

      IF (a < 0. .AND. e < 1.) STOP 'ORBIT_VELOCITY: Error, if a<0 then e>1 must be enforced'
      IF (e > 1. .AND. a > 0.) STOP 'ORBIT_VELOCITY: Error, if a<0 then e>1 must be enforced'

      t = n+w               ! Polar angle
      l = a*(1.-e**2)       ! Semi-latus rectum
      h = sqrt(G_orbit*M*l) ! Reduced angular momentum

      orbit_velocity(1) = -sin(t)-e*(sin(t)*cos(n)-sin(n)*cos(t))
      orbit_velocity(2) = cos(t)+e*(cos(t)*cos(n)+sin(t)*sin(n))
      orbit_velocity(3) = 0.

      orbit_velocity = orbit_velocity*h/l

   END FUNCTION orbit_velocity

   REAL FUNCTION reduced_energy(x, v, M)

      ! Conserved reduced orbital energy
      ! This is negative for bound orbits and positive for unbound orbits
      REAL, INTENT(IN) :: x(3) ! Orbit position [au]
      REAL, INTENT(IN) :: v(3) ! Orbit velocity []
      REAL, INTENT(IN) :: M    ! Central mass [Msun]

      reduced_energy = 0.5*dot_product(v, v)-G_orbit*M/modulus(x)

   END FUNCTION reduced_energy

   REAL FUNCTION reduced_angular_momentum(x, v)

      ! Conserved reduced angular momentum vector
      REAL, INTENT(IN) :: x(3) ! Orbit position [au]
      REAL, INTENT(IN) :: v(3) ! Orbit velocity [au]
      REAL :: h(3)

      h = cross_product(x, v)
      reduced_angular_momentum = modulus(h)

   END FUNCTION reduced_angular_momentum

   FUNCTION Laplace_Runge_Lenz(x, v, M)

      ! Conserved Laplace-Runge-Lenz vector
      REAL :: Laplace_Runge_Lenz(3)
      REAL, INTENT(IN) :: x(3) ! Orbit position [au]
      REAL, INTENT(IN) :: v(3) ! Orbit velocity [2piau/yr]
      REAL, INTENT(IN) :: M    ! Central mass [Msun]
      REAL :: h(3)

      h = cross_product(x, v)
      Laplace_Runge_Lenz = cross_product(v, h)/(G_orbit*M)-x/modulus(x)

   END FUNCTION Laplace_Runge_Lenz

   REAL FUNCTION semi_latus_rectum(x, v, M)

      ! Calculate the semi-latus rectum [au]
      REAL, INTENT(IN) :: x(3) ! Orbit position [au]
      REAL, INTENT(IN) :: v(3) ! Orbit velocity []
      REAL, INTENT(IN) :: M    ! Central mass [Msun]
      REAL :: h

      h = reduced_angular_momentum(x, v)
      semi_latus_rectum = h**2/(G_orbit*M)

   END FUNCTION semi_latus_rectum

   REAL FUNCTION semi_major_axis(x, v, M)

      ! Semi-major axis [au]
      ! Negative for unbound orbits
      REAL, INTENT(IN) :: x(3) ! Orbit position [au]
      REAL, INTENT(IN) :: v(3) ! Orbit velocity []
      REAL, INTENT(IN) :: M    ! Central mass [Msun]

      !semi_major_axis=semi_latus_rectum(x,v,M)/(1.-eccentricity(x,v,M)**2)
      semi_major_axis = -G_orbit*M/(2.*reduced_energy(x, v, M))

   END FUNCTION semi_major_axis

   REAL FUNCTION semi_minor_axis(x, v, M)

      ! Semi-minor axis [au]
      ! Assumes that the orbit is bound. Will break for unbound orbits
      REAL, INTENT(IN) :: x(3) ! Orbit position [au]
      REAL, INTENT(IN) :: v(3) ! Orbit velocity []
      REAL, INTENT(IN) :: M    ! Central mass [Msun]

      semi_minor_axis = semi_latus_rectum(x, v, M)/sqrt(1.-eccentricity(x, v, M)**2)

   END FUNCTION semi_minor_axis

   REAL FUNCTION eccentricity(x, v, M)

      ! Orbit eccentricity
      ! If e<1 the orbit is bound, if e>1 the orbit is unbound
      REAL, INTENT(IN) :: x(3) ! Orbit position [au]
      REAL, INTENT(IN) :: v(3) ! Orbit velocity [2piau/yr]
      REAL, INTENT(IN) :: M    ! Central mass [Msun]
      REAL :: e(3)

      e = Laplace_Runge_Lenz(x, v, M)

      eccentricity = modulus(e)

   END FUNCTION eccentricity

   REAL FUNCTION polar_angle(x)

      ! Plane-polar orbit angle [rad]
      ! Assumes orbit is in the x-y plane
      ! Gives result from 0 to 2pi
      REAL, INTENT(IN) :: x(3) ! Orbit position [au]

      polar_angle = atan2(x(2), x(1))
      polar_angle = shift_angle_to_circle(polar_angle)

   END FUNCTION polar_angle

   REAL FUNCTION true_anomaly(x, v, M)

      ! Orbital true anomaly [rad]
      ! Assumes orbit is in the x-y plane
      ! Gives result from 0 to 2pi
      REAL, INTENT(IN) :: x(3) ! Orbit position [au]
      REAL, INTENT(IN) :: v(3) ! Orbit velocity [2piau/yr]
      REAL, INTENT(IN) :: M    ! Central mass [Msun]

      true_anomaly = polar_angle(x)-argument_of_periapsis(x, v, M)
      true_anomaly = shift_angle_to_circle(true_anomaly)

   END FUNCTION true_anomaly

   REAL FUNCTION argument_of_periapsis(x, v, M)

      ! Orbit argument of periapsis [rad]
      ! Assumes orbit is in the x-y plane
      ! Gives result from 0 to 2pi
      REAL, INTENT(IN) :: x(3) ! Orbit position [au]
      REAL, INTENT(IN) :: v(3) ! Orbit velocity [2piau/yr]
      REAL, INTENT(IN) :: M    ! Central mass [Msun]
      REAL :: e(3)

      e = Laplace_Runge_Lenz(x, v, M)

      argument_of_periapsis = atan2(e(2), e(1))
      argument_of_periapsis = shift_angle_to_circle(argument_of_periapsis)

   END FUNCTION argument_of_periapsis

END MODULE orbits

MODULE basic_operations

   IMPLICIT NONE
 
   PRIVATE

   PUBLIC :: progression
   PUBLIC :: fix_minimum
   PUBLIC :: fix_maximum
   PUBLIC :: read_command_argument
   PUBLIC :: positive
   PUBLIC :: negative
   PUBLIC :: even
   PUBLIC :: odd
   PUBLIC :: requal
   PUBLIC :: present_and_correct
   PUBLIC :: first_digit
   PUBLIC :: swap
   PUBLIC :: increment
   PUBLIC :: default_or_optional
   PUBLIC :: between
   PUBLIC :: equals_or

   INTERFACE swap
      MODULE PROCEDURE swap_real
      MODULE PROCEDURE swap_integer
   END INTERFACE swap

   INTERFACE read_command_argument
      MODULE PROCEDURE read_command_argument_real
      MODULE PROCEDURE read_command_argument_integer
      MODULE PROCEDURE read_command_argument_logical
      MODULE PROCEDURE read_command_argument_character
   END INTERFACE read_command_argument

   INTERFACE increment
      MODULE PROCEDURE increment_real
      MODULE PROCEDURE increment_integer
   END INTERFACE increment

   INTERFACE default_or_optional
      MODULE PROCEDURE default_or_optional_real
      MODULE PROCEDURE default_or_optional_integer
   END INTERFACE default_or_optional

   INTERFACE between
      MODULE PROCEDURE between_real
      MODULE PROCEDURE between_integer
   END INTERFACE between

CONTAINS

   LOGICAL FUNCTION equals_or(a, i)

      ! Returns true if a=i and b=j *or* a=j and b=i
      ! Useful for symmetric things
      INTEGER, INTENT(IN) :: a(:)
      INTEGER, INTENT(IN) :: i(:)

      equals_or = (a(1) == i(1) .AND. a(2) == i(2)) .OR. (a(1) == i(2) .AND. a(2) == i(1))

   END FUNCTION equals_or

   LOGICAL FUNCTION between_real(x, xmin, xmax)

      ! True if xmin <= x <= xmax
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xmin
      REAL, INTENT(IN) :: xmax

      between_real = (x >= xmin .AND. x <= xmax)

   END FUNCTION between_real

   LOGICAL FUNCTION between_integer(x, xmin, xmax)

      ! True if xmin <= x <= xmax
      INTEGER, INTENT(IN) :: x
      INTEGER, INTENT(IN) :: xmin
      INTEGER, INTENT(IN) :: xmax

      between_integer = (x >= xmin .AND. x <= xmax)

   END FUNCTION between_integer

   REAL FUNCTION default_or_optional_real(x_default, x_optional)

      REAL, INTENT(IN) :: x_default
      REAL, OPTIONAL, INTENT(IN) :: x_optional

      IF (present(x_optional)) THEN
         default_or_optional_real = x_optional
      ELSE
         default_or_optional_real = x_default
      END IF

   END FUNCTION default_or_optional_real

   INTEGER FUNCTION default_or_optional_integer(x_default, x_optional)

      INTEGER, INTENT(IN) :: x_default
      INTEGER, OPTIONAL, INTENT(IN) :: x_optional

      IF (present(x_optional)) THEN
         default_or_optional_integer = x_optional
      ELSE
         default_or_optional_integer = x_default
      END IF

   END FUNCTION default_or_optional_integer

   RECURSIVE REAL FUNCTION progression(xmin, xmax, i, n, ilog)

      ! Split the region xmin -> xmax into n linearly spaced increments (including both xmin and xmax)
      ! Returns the value at the i-th point
      REAL, INTENT(IN) :: xmin
      REAL, INTENT(IN) :: xmax
      INTEGER, INTENT(IN) :: i
      INTEGER, INTENT(IN) :: n
      LOGICAL, OPTIONAL, INTENT(IN) :: ilog

      IF (n == 1) THEN
         IF (xmin /= xmax) STOP 'PROGRESSION: Error, if n=1 then xmin and xmax must be identical'
         progression = xmin
      ELSE
         IF (present_and_correct(ilog)) THEN
            progression = exp(log(xmin)+log(xmax/xmin)*real(i-1)/real(n-1))
         ELSE
            progression = xmin+(xmax-xmin)*real(i-1)/real(n-1)
         END IF
      END IF

   END FUNCTION progression

   SUBROUTINE increment_real(x, y)

      ! Adds the value of y to x: x -> x+y
      REAL, INTENT(INOUT) :: x ! Value to be added to
      REAL, INTENT(IN) :: y    ! Value to add

      x = x+y

   END SUBROUTINE increment_real

   SUBROUTINE increment_integer(x, y)

      ! Adds the value of y to x: x -> x+y
      INTEGER, INTENT(INOUT) :: x ! Value to be added to
      INTEGER, INTENT(IN) :: y    ! Value to add

      x = x+y

   END SUBROUTINE increment_integer

   SUBROUTINE fix_minimum(x, xmin)

      ! If x is below xmin then set to xmin
      REAL, INTENT(INOUT) :: x ! Value to fix
      REAL, INTENT(IN) :: xmin ! Minimum value for x

      IF (x < xmin) x = xmin

   END SUBROUTINE fix_minimum

   SUBROUTINE fix_maximum(x, xmax)

      ! If x is above xmax then set to xmax
      REAL, INTENT(INOUT) :: x ! Value to fix
      REAL, INTENT(IN) :: xmax ! Maximum value for x

      IF (x > xmax) x = xmax

   END SUBROUTINE fix_maximum

   SUBROUTINE read_command_argument_real(i, x, desc, def)

      ! Read command-line argument i and use to to fill variable x
      INTEGER, INTENT(IN) :: i             ! Position of command-line argument
      REAL, INTENT(OUT) :: x               ! Real number to be assigned command-line argument
      CHARACTER(len=*), INTENT(IN) :: desc ! Description of command-line argument
      REAL, INTENT(IN), OPTIONAL :: def    ! Default value
      CHARACTER(len=256) :: word

      CALL get_command_argument(i, word)
      IF (word == '') THEN
         IF (present(def)) THEN
            x = def
         ELSE
            WRITE (*, *) 'READ_COMMAND_ARGUMENT_REAL: Missing command-line argument number:', i
            WRITE (*, *) 'READ_COMMAND_ARGUMENT_REAL: ', TRIM(desc)
            STOP
         END IF
      ELSE
         READ (word, *) x
      END IF

   END SUBROUTINE read_command_argument_real

   SUBROUTINE read_command_argument_integer(i, x, desc, def)

      ! Read command-line argument i and use to to fill variable x
      INTEGER, INTENT(IN) :: i             ! Position of command-line argument
      INTEGER, INTENT(OUT) :: x            ! Real number to be assigned command-line argument
      CHARACTER(len=*), INTENT(IN) :: desc ! Description of command-line argument
      INTEGER, INTENT(IN), OPTIONAL :: def ! Default value
      CHARACTER(len=256) :: word

      CALL get_command_argument(i, word)
      IF (word == '') THEN
         IF (present(def)) THEN
            x = def
         ELSE
            WRITE (*, *) 'READ_COMMAND_ARGUMENT_INTEGER: Missing command-line argument:', i
            WRITE (*, *) 'READ_COMMAND_ARGUMENT_INTEGER: ', TRIM(desc)
            STOP
         END IF
      ELSE
         READ (word, *) x
      END IF

   END SUBROUTINE read_command_argument_integer

   SUBROUTINE read_command_argument_logical(i, x, desc, def)

      ! Read command-line argument i and use to to fill variable x
      INTEGER, INTENT(IN) :: i             ! Position of command-line argument
      LOGICAL, INTENT(OUT) :: x            ! Real number to be assigned command-line argument
      CHARACTER(len=*), INTENT(IN) :: desc ! Description of command-line argument
      LOGICAL, INTENT(IN), OPTIONAL :: def ! Default value
      CHARACTER(len=256) :: word

      CALL get_command_argument(i, word)
      IF (word == '') THEN
         IF (present(def)) THEN
            x = def
         ELSE
            WRITE (*, *) 'READ_COMMAND_ARGUMENT_LOGICAL: Missing command-line argument:', i
            WRITE (*, *) 'READ_COMMAND_ARGUMENT_LOGICAL: ', TRIM(desc)
            STOP
         END IF
      ELSE
         IF (word == 'TRUE') THEN
            x = .TRUE.
         ELSE IF (word == 'FALSE') THEN
            x = .FALSE.
         ELSE
            STOP 'READ_COMMAND_ARGUMENT_LOGICAL: Error, should be either TRUE or FALSE'
         END IF
      END IF

   END SUBROUTINE read_command_argument_logical

   SUBROUTINE read_command_argument_character(i, x, desc, def)

      ! Read command-line argument i and use to to fill variable x
      INTEGER, INTENT(IN) :: i                      ! Position of command-line argument
      CHARACTER(len=*), INTENT(OUT) :: x            ! String to be assigned command-line argument
      CHARACTER(len=*), INTENT(IN) :: desc          ! Description of command-line argument
      CHARACTER(len=*), INTENT(IN), OPTIONAL :: def ! Default value
      CHARACTER(len=256) :: word

      CALL get_command_argument(i, word)
      IF (word == '') THEN
         IF (present(def)) THEN
            x = def
         ELSE
            WRITE (*, *) 'READ_COMMAND_ARGUMENT_CHARACTER: Missing command-line argument:', i
            WRITE (*, *) 'READ_COMMAND_ARGUMENT_CHARACTER: ', TRIM(desc)
            STOP
         END IF
      ELSE
         x = trim(word)
      END IF

   END SUBROUTINE read_command_argument_character

   LOGICAL FUNCTION positive(x)

      ! Returns .TRUE. if x>=0., if x=0. will return true
      REAL, INTENT(IN) :: x

      positive = (.NOT. negative(x))

   END FUNCTION positive

   LOGICAL FUNCTION negative(x)

      ! Returns true if argument is negative
      REAL, INTENT(IN) :: x

      negative = (x < 0.)

   END FUNCTION negative

   LOGICAL FUNCTION even(i)

      ! Tests for i being even, returns true if even
      INTEGER, INTENT(IN) :: i

      even = (mod(i, 2) == 0)

   END FUNCTION even

   LOGICAL FUNCTION odd(i)

      ! Tests for i being odd, returns true if odd
      INTEGER, INTENT(IN) :: i

      odd = (.NOT. even(i))

   END FUNCTION odd

   LOGICAL FUNCTION requal(x, y, eps)

      ! Tests if two real numbers are within some tolerance of each other
      ! If they are, then they should be considered equal
      ! Adapted from https://stackoverflow.com/questions/4915462/how-should-i-do-floating-point-comparison/4915891#4915891
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: y
      REAL, INTENT(IN) :: eps
      REAL :: absx, absy, diff

      absx = abs(x)
      absy = abs(y)
      diff = abs(x-y)
      IF (x == y) THEN
         requal = .TRUE.
      ELSE IF (x == 0. .OR. y == 0. .OR. diff < tiny(x)) THEN
         requal = (diff < eps*tiny(x))
      ELSE
         requal = (diff/(absx+absy) < 0.5*eps) ! June 2020: Added 0.5
      END IF

   END FUNCTION requal

   LOGICAL FUNCTION present_and_correct(x)

      ! Returns true if an optional argument is both present and true
      LOGICAL, OPTIONAL, INTENT(IN) :: x

      IF (present(x)) THEN
         present_and_correct = x
      ELSE
         present_and_correct = .FALSE.
      END IF

   END FUNCTION present_and_correct

   INTEGER FUNCTION first_digit(x)

      ! Returns the first non-zero digit of a real number
      REAL, INTENT(IN) :: x
      REAL :: y

      y = abs(x)
      DO
         IF (y == 1.) THEN
            first_digit = 1
            EXIT
         ELSE IF (y > 1. .AND. y < 10.) THEN
            first_digit = floor(y)
            EXIT
         ELSE IF (y >= 10.) THEN
            y = y/10.
         ELSE IF (y < 1.) THEN
            y = y*10.
         END IF
      END DO

   END FUNCTION first_digit

   SUBROUTINE swap_real(a, b)

      ! Swaps the values of variables a and b
      REAL, INTENT(INOUT) :: a
      REAL, INTENT(INOUT) :: b
      REAL :: c

      c = a
      a = b
      b = c

   END SUBROUTINE swap_real

   SUBROUTINE swap_integer(n, m)

      ! Swap integers n and m in the most memory-efficient way possible
      INTEGER, INTENT(INOUT) :: n
      INTEGER, INTENT(INOUT) :: m

      n = n+m ! n' = n+m
      m = n-m ! m' = n'-m = n+m-m = n
      n = n-m ! n'' = n'-m' = n+m-n = m

   END SUBROUTINE swap_integer

END MODULE basic_operations

MODULE table_integer

   IMPLICIT NONE

   PRIVATE

   ! Routines
   PUBLIC :: find_table_integer
   PUBLIC :: nearest_table_integer

   ! Constants
   PUBLIC :: ifind_linear
   PUBLIC :: ifind_crude
   PUBLIC :: ifind_split

   ! Constants
   INTEGER, PARAMETER :: ifind_linear = 1
   INTEGER, PARAMETER :: ifind_crude = 2
   INTEGER, PARAMETER :: ifind_split = 3

CONTAINS

   INTEGER FUNCTION nearest_table_integer(x, xtab, ifind)

      ! Finds the integer table position in xtab closest to x
      ! Assumes that xtab is sorted from low to high
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xtab(:)
      INTEGER, INTENT(IN) :: ifind
      INTEGER :: i, n

      n = size(xtab)
      i = find_table_integer(x, xtab, ifind)

      IF (i == 0) THEN
         nearest_table_integer = 1
      ELSE IF (i == n) THEN
         nearest_table_integer = n
      ELSE
         IF (x-xtab(i) < xtab(i+1)-x) THEN
            nearest_table_integer = i
         ELSE
            nearest_table_integer = i+1
         END IF
      END  IF

   END FUNCTION nearest_table_integer

   INTEGER FUNCTION find_table_integer(x, xtab, ifind)

      ! Chooses between ways to find the integer location *below* some value in an array
      ! Assumes that xtab is sorted from low to high
      ! If x is within the table then the value returned will be between 1 and n-1
      ! If x is below the lower value of the array then 0 is returned (IMPORTANT)
      ! If x is above the upper value of the array then n is returned (IMPORTANT)
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xtab(:)
      INTEGER, INTENT(IN) :: ifind
      INTEGER :: n

      ! Methods (ifind)
      ! 1 - Get integer assuming the array has linear spacing
      ! 2 - Search array from first entry to last entry (often a silly thing to do)
      ! 3 - Mid-point search method to find integer (efficient for 2^n)

      n = size(xtab)

      IF (x < xtab(1)) THEN
         find_table_integer = 0
      ELSE IF (x > xtab(n)) THEN
         find_table_integer = n
      ELSE IF (ifind == ifind_linear) THEN
         find_table_integer = linear_table_integer(x, xtab)
      ELSE IF (ifind == ifind_crude) THEN
         find_table_integer = search_int(x, xtab)
      ELSE IF (ifind == ifind_split) THEN
         find_table_integer = int_split(x, xtab)
      ELSE
         STOP 'TABLE INTEGER: Method specified incorrectly'
      END IF

   END FUNCTION find_table_integer

   INTEGER FUNCTION linear_table_integer(x, xtab)

      ! Assuming the table is exactly linear this gives you the integer position
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xtab(:)
      REAL :: x1, xn
      INTEGER :: n

      n = size(xtab)

      x1 = xtab(1)
      xn = xtab(n)
      linear_table_integer = 1+floor(real(n-1)*(x-x1)/(xn-x1))

   END FUNCTION linear_table_integer

   INTEGER FUNCTION search_int(x, xtab)

      ! Does a stupid search through the table from beginning to end to find integer
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xtab(:)
      INTEGER :: i, n

      n = size(xtab)

      IF (xtab(1) > xtab(n)) STOP 'SEARCH_INT: table in wrong order'

      DO i = 1, n
         IF (x >= xtab(i) .AND. x <= xtab(i+1)) EXIT
      END DO

      search_int = i

   END FUNCTION search_int

   INTEGER FUNCTION int_split(x, xtab)

      ! Finds the position of the value in the table by continually splitting it in half
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xtab(:)
      INTEGER :: i1, i2, imid, n

      n = size(xtab)

      IF (xtab(1) > xtab(n)) STOP 'INT_SPLIT: table in wrong order'

      i1 = 1
      i2 = n

      DO

         imid = nint((i1+i2)/2.)

         IF (x < xtab(imid)) THEN
            i2 = imid
         ELSE
            i1 = imid
         END IF

         IF (i2 == i1+1) EXIT

      END DO

      int_split = i1

   END FUNCTION int_split

END MODULE table_integer

MODULE physics

   USE constants

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: black_body_nu
   PUBLIC :: black_body_lambda
   PUBLIC :: wein_law_nu
   PUBLIC :: wein_law_lambda

CONTAINS

   REAL FUNCTION black_body_nu(nu, T)

      ! The radiance from a blackbody [Wm^-2 Hz^-1 Sr^-1]
      REAL, INTENT(IN) :: nu ! Frequency [Hz]
      REAL, INTENT(IN) :: T ! Black-body temperature [K]
      REAL :: a, x

      a = 2.*h_Planck*nu**3/c_light**2

      x = h_Planck*nu/(kB*T)

      black_body_nu = a/(exp(x)-1.)

   END FUNCTION black_body_nu

   REAL FUNCTION black_body_lambda(lambda, T)

      ! The radiance from a blackbody [Wm^-2 m^-1 Sr^-1]
      REAL, INTENT(IN) :: lambda ! Wavelength [m]
      REAL, INTENT(IN) :: T ! Black-body temperature [K]
      REAL :: nu

      nu = c_light/lambda

      black_body_lambda = black_body_nu(nu, T)*nu/lambda

   END FUNCTION black_body_lambda

   REAL FUNCTION wein_law_nu(T)

      ! The peak emission frequency from a blackbody [Hz]
      REAL, INTENT(IN) :: T ! Black-body temperature [K]
      REAL, PARAMETER :: a = 5.879e10 ! Wein constant [Hz/K]

      wein_law_nu = a*T

   END FUNCTION wein_law_nu

   REAL FUNCTION wein_law_lambda(T)

      ! The peak emission wavelength from a blackbody [m]
      REAL, INTENT(IN) :: T ! Black-body temperature [K]
      REAL, PARAMETER :: b = 2.8977729e-3 ! Wein constant [Km]

      wein_law_lambda = b/T

   END FUNCTION wein_law_lambda

END MODULE physics

MODULE sorting

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: index
   PUBLIC :: sort
   PUBLIC :: sorted
   PUBLIC :: sorted_index
   PUBLIC :: reindex
   PUBLIC :: isort_bubble
   PUBLIC :: isort_stupid
   PUBLIC :: isort_QsortC

   INTERFACE index
      MODULE PROCEDURE index_real
      MODULE PROCEDURE index_int
   END INTERFACE index

   INTERFACE bubble_index
      MODULE PROCEDURE bubble_index_real
      MODULE PROCEDURE bubble_index_int
   END INTERFACE bubble_index

   INTERFACE stupid_index
      MODULE PROCEDURE stupid_index_real
      MODULE PROCEDURE stupid_index_int
   END INTERFACE stupid_index

   INTEGER, PARAMETER :: isort_stupid = 1
   INTEGER, PARAMETER :: isort_bubble = 2
   INTEGER, PARAMETER :: isort_QsortC = 3

CONTAINS

   SUBROUTINE sort(a, isort)

      ! Sort arrays in order from lowest to highest values
      !INTEGER, INTENT(IN) :: n
      REAL, INTENT(INOUT) :: a(:)
      INTEGER, INTENT(IN) :: isort

      IF (isort == isort_stupid) THEN
         CALL stupid_sort(a)
      ELSE IF (isort == isort_bubble) THEN
         CALL bubble_sort(a)
      ELSE IF (isort == isort_QsortC) THEN
         CALL QsortC(a)
      ELSE
         STOP 'SORT: Error, isort not specified correctly'
      END IF

   END SUBROUTINE sort

   SUBROUTINE bubble_sort(a)

      ! Bubble sort array 'a' into lowest to highest value
      REAL, INTENT(INOUT) :: a(:)
      REAL :: hold
      INTEGER :: i, n
      LOGICAL :: is_sorted

      n = size(a)

      DO
         is_sorted = .TRUE.
         DO i = 1, n-1
            IF (a(i) > a(i+1)) THEN
               hold = a(i+1)
               a(i+1) = a(i)
               a(i) = hold
               is_sorted = .FALSE.
            END IF
         END DO
         IF (is_sorted) EXIT
      END DO

   END SUBROUTINE bubble_sort

   SUBROUTINE stupid_sort(a)

      ! I have no idea what this is
      REAL, INTENT(INOUT) :: a(:)
      REAL :: hold, min
      INTEGER :: i, j, minl, n

      n = size(a)

      DO i = 1, n-1
         min = a(i)
         minl = i
         DO j = i+1, n
            IF (a(j) < min) THEN
               min = a(j)
               minl = j
            END IF
         END DO
         hold = a(i)
         a(i) = min
         a(minl) = hold
      END DO

   END SUBROUTINE stupid_sort

   RECURSIVE SUBROUTINE QsortC(A)

      ! Stolen from http://www.fortran.com/qsort_c.f95
      REAL, INTENT(INOUT), DIMENSION(:) :: A
      INTEGER :: iq

      IF (size(A) > 1) THEN
         CALL Partition(A, iq)
         CALL QsortC(A(:iq-1))
         CALL QsortC(A(iq:))
      END IF

   END SUBROUTINE QsortC

   SUBROUTINE Partition(A, marker)

      ! Stolen from http://www.fortran.com/qsort_c.f95
      REAL, INTENT(INOUT), DIMENSION(:) :: A
      INTEGER, INTENT(OUT) :: marker
      INTEGER :: i, j
      REAL :: temp
      REAL :: x      ! pivot point

      x = A(1)
      i = 0
      j = size(A)+1

      do
         j = j-1
         do
            if (A(j) <= x) exit
            j = j-1
         end do
         i = i+1
         do
            if (A(i) >= x) exit
            i = i+1
         end do
         if (i < j) then
            ! exchange A(i) and A(j)
            temp = A(i)
            A(i) = A(j)
            A(j) = temp
         elseif (i == j) then
            marker = i+1
            return
         else
            marker = i
            return
         endif
      end do

   END SUBROUTINE Partition

   SUBROUTINE index_real(a, ind, isort)

      ! Index the array 'a' from lowest to highest value
      REAL, INTENT(IN) :: a(:)
      INTEGER, INTENT(OUT) :: ind(:)
      INTEGER, INTENT(IN) :: isort

      IF (isort == isort_stupid) THEN
         CALL stupid_index_real(a, ind)
      ELSE IF (isort == isort_bubble) THEN
         CALL bubble_index_real(a, ind)
      ELSE
         STOP 'INDEX_REAL: Error, isort specified incorrectly'
      END IF

   END SUBROUTINE index_real

   SUBROUTINE index_int(a, ind, isort)

      ! Index the array 'a' from lowest to highest value  
      INTEGER, INTENT(IN) :: a(:)
      INTEGER, INTENT(OUT) :: ind(:)
      INTEGER, INTENT(IN) :: isort
      
      IF (isort == isort_stupid) THEN
         CALL stupid_index_int(a, ind)
      ELSE IF (isort == isort_bubble) THEN
         CALL bubble_index_int(a, ind)
      ELSE
         STOP 'INDEX_REAL: Error, isort specified incorrectly'
      END IF

   END SUBROUTINE index_int

   SUBROUTINE bubble_index_real(a, ind)

      ! Create an index array for a(:) that indexes from smallest to largest value
      REAL, INTENT(IN) :: a(:)
      INTEGER, INTENT(OUT) :: ind(:)
      INTEGER :: i, isort, hold, n

      n = size(a)
      IF (n /= size(ind)) STOP 'BUBBLE_INDEX_REAL: Error, a and ind must have the same size'

      DO i = 1, n
         ind(i) = i
      END DO

      DO
         isort = 0
         DO i = 1, n-1
            IF (a(ind(i)) > a(ind(i+1))) THEN
               hold = ind(i+1)
               ind(i+1) = ind(i)
               ind(i) = hold
               isort = 1
            END IF
         END DO
         IF (isort == 0) EXIT
      END DO

   END SUBROUTINE bubble_index_real

   SUBROUTINE bubble_index_int(a, ind)!,verbose)

      ! Create an index array for integer a(:) that indexes from smallest to largest value
      INTEGER, INTENT(IN) :: a(:)
      INTEGER, INTENT(OUT) :: ind(:)
      INTEGER :: i, isort, hold, n

      n = size(a)
      IF (n /= size(ind)) STOP 'BUBBLE_INDEX_INT: Error, a and ind must have the same size'

      DO i = 1, n
         ind(i) = i
      END DO

      DO
         isort = 0
         DO i = 1, n-1
            IF (a(ind(i)) > a(ind(i+1))) THEN
               hold = ind(i+1)
               ind(i+1) = ind(i)
               ind(i) = hold
               isort = 1
            END IF
         END DO
         IF (isort == 0) EXIT
      END DO

   END SUBROUTINE bubble_index_int

   SUBROUTINE stupid_index_real(a, ind)
  
      REAL, INTENT(IN) :: a(:)
      INTEGER, INTENT(OUT) :: ind(:)
      INTEGER :: i, j, n
      REAL, ALLOCATABLE :: b(:)

      n = size(a)
      IF (n /= size(ind)) STOP 'STUPID_INDEX_REAL: Error, a and ind must have the same size'
      ALLOCATE(b(n))

      b = a

      ! This is probably stupid
      DO i = 1, n
         j = MINLOC(b, 1)
         ind(i) = j
         b(j) = HUGE(b)
      END DO

   END SUBROUTINE stupid_index_real

   SUBROUTINE stupid_index_int(a, ind)

      INTEGER, INTENT(IN) :: a(:)
      INTEGER, INTENT(OUT) :: ind(:)
      INTEGER :: i, j, n
      INTEGER, ALLOCATABLE :: b(:)

      n = size(a)
      IF (n /= size(ind)) STOP 'STUPID_INDEX_INT: Error, a and ind must have the same size'
      ALLOCATE(b(n))

      b = a

      ! This is probably stupid
      DO i = 1, n
         j = MINLOC(b, 1)
         ind(i) = j
         b(j) = HUGE(b)
      END DO

   END SUBROUTINE stupid_index_int

   LOGICAL FUNCTION sorted(a)

      ! Checks if array 'a' is sorted from highest to lowest
      REAL, INTENT(IN) :: a(:) ! Input array to check
      INTEGER :: i, n

      n = size(a)

      sorted = .TRUE.

      DO i = 1, n-1
         IF (a(i) > a(i+1)) THEN
            sorted = .FALSE.
            EXIT
         END IF
      END DO

   END FUNCTION sorted

   LOGICAL FUNCTION sorted_index(a, j)

      ! Checks if array indices for 'a' are sorted from highest to lowest
      REAL, INTENT(IN) :: a(:)    ! Input array to check
      INTEGER, INTENT(IN) :: j(:) ! Input array indices to check
      INTEGER :: i, n

      n = size(a)
      IF (n /= size(j)) STOP 'CHECK_SORTED_INDEX: Error a and j should be same size'

      sorted_index = .TRUE.

      DO i = 1, n-1
         IF (a(j(i)) > a(j(i+1))) THEN
            sorted_index = .FALSE.
            EXIT
         END IF
      END DO

   END FUNCTION sorted_index

   SUBROUTINE reindex(a, j)

      ! Reindex the array 'a' with the new indices 'j'
      REAL, INTENT(INOUT) :: a(:) ! Input array to check
      INTEGER, INTENT(IN) :: j(:) ! Input array indices to check
      REAL, ALLOCATABLE :: b(:)
      INTEGER :: i, n

      n = size(a)
      IF (n /= size(j)) STOP 'REINDEX: Error, a and j must have the same size'
      ALLOCATE(b(n))

      b = a ! Store the input array

      a = 0. ! Delete the input array

      ! Loop over values and reindex
      DO i = 1, n
         a(i) = b(j(i))
      END DO

   END SUBROUTINE reindex

END MODULE sorting

MODULE calculus

   ! TODO: Make jmin -> jmax parameters in header
   ! TODO: Number of steps is 2^(j-1) which may exceed integer range for large j

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: derivative
   PUBLIC :: integrate
   PUBLIC :: integrate_basic
   PUBLIC :: integrate_log
   PUBLIC :: integrate_cubic
   PUBLIC :: integrate_jac
   PUBLIC :: integrate_monte_carlo

   ! Differentiation
   INTEGER, PARAMETER :: min_deriv_iter = 5
   INTEGER, PARAMETER :: max_deriv_iter = 100

   ! Integration
   INTEGER, PARAMETER :: jmin_integrate = 5  ! 2^jmin minimum steps
   INTEGER, PARAMETER :: jmax_integrate = 20 ! 2^jmax maximum steps
   INTEGER, PARAMETER :: ninit_integrate = 5

   INTERFACE derivative
      MODULE PROCEDURE derivative_1D
      MODULE PROCEDURE derivative_2D
   END INTERFACE derivative

CONTAINS

   REAL FUNCTION derivative_1D(f, x, acc)

      ! Calculates the derivative of a function 'f' at the point x to accuracy acc!
      REAL, EXTERNAL :: f
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: acc
      REAL :: dnew, dold, dx
      INTEGER :: i
      INTEGER, PARAMETER :: imin = min_deriv_iter ! Minimum number of iterations
      INTEGER, PARAMETER :: n = max_deriv_iter ! Maximum number of iterations

      INTERFACE
         FUNCTION f(xin)
            REAL, INTENT(IN) :: xin
         END FUNCTION f
      END INTERFACE

      dold = 0.
      dx = 1. ! Is this a good choice?

      DO i = 1, n

         dnew = (f(x+dx/2.)-f(x-dx/2.))/dx ! New, using equal sided derivative

         IF (i >= imin .AND. abs(dnew/dold-1.) < acc) THEN
            EXIT
         ELSE IF (i == n) THEN
            STOP 'DERIVATIVE: Error, maximum number of iterations exceeded'
         ELSE
            dold = dnew
            dx = dx/2.
         END IF

      END DO

      derivative_1D = dnew

   END FUNCTION derivative_1D

   REAL FUNCTION derivative_2D(f, x, y, acc, dim)

      ! Calculates the derivative of a function 'f' at the point x, y along dimension dim to accuracy acc!
      REAL, EXTERNAL :: f
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: y
      REAL, INTENT(IN) :: acc
      INTEGER, INTENT(IN) :: dim
      REAL :: dnew, dold, dx, dy
      INTEGER :: i
      INTEGER, PARAMETER :: n = max_deriv_iter

      INTERFACE
         FUNCTION f(xin, yin)
            REAL, INTENT(IN) :: xin
            REAL, INTENT(IN) :: yin
         END FUNCTION f
      END INTERFACE

      dold = 0.
      dx = 4.
      dy = 4.

      DO i = 1, n

         IF (dim == 1) THEN

            dnew = (f(x+dx, y)-f(x, y))/dx

            IF (i > 1 .AND. abs(dnew/dold-1.) < acc) THEN
               EXIT
            ELSE IF (i == n) THEN
               STOP 'DERIVATIVE_X: Error, maximum number of iterations exceeded'
            ELSE
               dold = dnew
               dx = dx/2.
            END IF

         ELSE IF (dim == 2) THEN

            dnew = (f(x, y+dy)-f(x, y))/dy

            IF (i > 1 .AND. abs(dnew/dold-1.) < acc) THEN
               EXIT
            ELSE IF (i == n) THEN
               STOP 'DERIVATIVE_Y: Error, maximum number of iterations exceeded'
            ELSE
               dold = dnew
               dy = dy/2.
            END IF

         ELSE

            STOP 'DERIVATIVE_2D: Error, dim specified incorrectly'

         END IF

      END DO

      derivative_2D = dnew

   END FUNCTION derivative_2D

   REAL FUNCTION derivative_y(f, x, y, acc)

      ! Calculates the derivative of a function 'f' at the point x to accuracy acc!
      REAL, EXTERNAL :: f
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: y
      REAL, INTENT(IN) :: acc
      REAL :: dnew, dold, dy
      INTEGER :: i
      INTEGER, PARAMETER :: n = max_deriv_iter

      INTERFACE
         FUNCTION f(xin, yin)
            REAL, INTENT(IN) :: xin
            REAL, INTENT(IN) :: yin
         END FUNCTION f
      END INTERFACE

      dy = 4.
      dold = 0.

      DO i = 1, n

         dnew = (f(x, y+dy)-f(x, y))/dy

         IF (i > 1 .AND. abs(dnew/dold-1.) < acc) THEN
            !derivative_y=dnew
            EXIT
         ELSE IF (i == n) THEN
            STOP 'DERIVATIVE_Y: Error, maximum number of iterations exceeded'
         ELSE
            dold = dnew
            dy = dy/2.
         END IF

      END DO

      derivative_y = dnew

   END FUNCTION derivative_y

   REAL FUNCTION integrate_basic(a, b, f, n, iorder)

      ! Integrates between a and b with n points; not adaptive so no error control
      USE basic_operations
      REAL, INTENT(IN) :: a ! Integration limits
      REAL, INTENT(IN) :: b ! Integration limits
      REAL, EXTERNAL :: f
      INTEGER, INTENT(IN) :: n ! Number of points
      INTEGER, INTENT(IN) :: iorder ! Order for integration
      INTEGER :: i
      REAL :: x, dx, weight
      REAL :: sum

      INTERFACE
         FUNCTION f(xin)
            REAL, INTENT(IN) :: xin
         END FUNCTION f
      END INTERFACE

      IF (a == b) THEN

         integrate_basic = 0.

      ELSE

         ! Set the sum variable
         sum = 0.d0

         DO i = 1, n

            !x=a+(b-a)*real(i-1)/real(n-1)
            x = progression(a, b, i, n)

            IF (iorder == 1) THEN
               ! Composite trapezium weights
               IF (i == 1 .OR. i == n) THEN
                  weight = 0.5
               ELSE
                  weight = 1.
               END IF
            ELSE IF (iorder == 2) THEN
               ! Composite extended formula weights
               IF (i == 1 .OR. i == n) THEN
                  weight = 0.4166666666
               ELSE IF (i == 2 .OR. i == n-1) THEN
                  weight = 1.0833333333
               ELSE
                  weight = 1.
               END IF
            ELSE IF (iorder == 3) THEN
               ! Composite Simpson weights
               IF (i == 1 .OR. i == n) THEN
                  weight = 0.375
               ELSE IF (i == 2 .OR. i == n-1) THEN
                  weight = 1.1666666666
               ELSE IF (i == 3 .OR. i == n-2) THEN
                  weight = 0.9583333333
               ELSE
                  weight = 1.
               END IF
            ELSE
               STOP 'INTEGERATE_BASIC: Error, order specified incorrectly'
            END IF

            sum = sum+weight*f(x)

         END DO

         dx = (b-a)/real(n-1)
         integrate_basic = real(sum)*dx

         !WRITE(*,*) 'INTEGRATE_BASIC: Order:', iorder
         !WRITE(*,*) 'INTEGRATE_BASIC: Nint:', n

      END IF

   END FUNCTION integrate_basic

   REAL FUNCTION integrate(a, b, f, acc, iorder)

      ! Integrates between a and b until desired accuracy is reached
      ! Stores information to reduce function calls
      USE basic_operations
      REAL, INTENT(IN) :: a
      REAL, INTENT(IN) :: b
      REAL, EXTERNAL :: f
      REAL, INTENT(IN) :: acc
      INTEGER, INTENT(IN) :: iorder
      INTEGER :: i, j
      INTEGER :: n
      REAL :: x, dx
      REAL :: f1, f2, fx
      LOGICAL :: pass
      REAL :: sum_n, sum_2n, sum_new, sum_old
      INTEGER, PARAMETER :: jmin = jmin_integrate
      INTEGER, PARAMETER :: jmax = jmax_integrate

      INTERFACE
         FUNCTION f(xin)
            REAL, INTENT(IN) :: xin
         END FUNCTION f
      END INTERFACE

      IF (a == b) THEN

         ! Fix the answer to zero if the integration limits are identical
         integrate = 0.

      ELSE

         ! Set the sum variable for the integration
         sum_2n = 0.d0
         sum_n = 0.d0
         sum_old = 0.d0
         sum_new = 0.d0

         DO j = 1, jmax

            ! Note, you need this to be 1+2**n for some integer n
            ! j=1 n=2; j=2 n=3; j=3 n=5; j=4 n=9; ...'
            n = 1+2**(j-1)

            ! Calculate the dx interval for this value of 'n'
            dx = (b-a)/real(n-1)

            IF (j == 1) THEN

               ! The first go is just the trapezium of the end points
               f1 = f(a)
               f2 = f(b)
               sum_2n = 0.5*(f1+f2)*dx
               sum_new = sum_2n

            ELSE

               ! Loop over only new even points to add these to the integral
               DO i = 2, n, 2
                  x = progression(a, b, i, n)
                  fx = f(x)
                  sum_2n = sum_2n+fx
               END DO

               ! Now create the total using the old and new parts
               sum_2n = sum_n/2.+sum_2n*dx

               ! Now calculate the new sum depending on the integration order
               IF (iorder == 1) THEN
                  sum_new = sum_2n
               ELSE IF (iorder == 3) THEN
                  sum_new = (4.*sum_2n-sum_n)/3. ! This is Simpson's rule and cancels error
               ELSE
                  STOP 'INTEGRATE: Error, iorder specified incorrectly'
               END IF

            END IF

            IF (sum_old == 0.d0 .OR. j<jmin) THEN
               pass = .FALSE.
            ELSE IF(abs(-1.d0+sum_new/sum_old) < acc) THEN
               pass = .TRUE.
            ELSE IF (j == jmax) THEN
               pass = .FALSE.
               STOP 'INTEGRATE: Integration timed out'
            ELSE
               pass = .FALSE.
            END IF

            IF (pass) THEN
               EXIT
            ELSE
               ! Integral has not converged so store old sums and reset sum variables
               sum_old = sum_new
               sum_n = sum_2n
               sum_2n = 0.d0
            END IF

         END DO

         integrate = real(sum_new)

      END IF

   END FUNCTION integrate

   REAL FUNCTION integrate_log(a, b, f, acc, iorder, ilog)

      ! Integrates between a and b until desired accuracy is reached
      REAL, INTENT(IN) :: a
      REAL, INTENT(IN) :: b
      REAL, EXTERNAL :: f
      REAL, INTENT(IN) :: acc
      INTEGER, INTENT(IN) :: iorder
      INTEGER, INTENT(IN) :: ilog
      INTEGER :: i, j, n
      REAL :: x, weight, dx, lima, limb
      LOGICAL :: pass
      REAL :: sum_old, sum_new
      INTEGER, PARAMETER :: jmin = jmin_integrate
      INTEGER, PARAMETER :: jmax = jmax_integrate
      INTEGER, PARAMETER :: ninit = ninit_integrate

      INTERFACE
         FUNCTION f(xin)
            REAL, INTENT(IN) :: xin
         END FUNCTION f
      END INTERFACE

      IF (a == b) THEN

         integrate_log = 0.d0

      ELSE

         ! Set the sum variables
         sum_old = 0.d0
         sum_new = 0.d0

         IF (ilog == 1) THEN
            lima = log(a)
            limb = log(b)
         ELSE
            lima = a
            limb = b
         END IF

         DO j = 1, jmax

            n = ninit*(2**(j-1))

            DO i = 1, n

               x = lima+(limb-lima)*real(i-1)/real(n-1)

               IF (ilog == 1) THEN
                  x = exp(x)
               END IF

               IF (iorder == 1) THEN
                  ! Composite trapezium weights
                  IF (i == 1 .OR. i == n) THEN
                     weight = 0.5
                  ELSE
                     weight = 1.
                  END IF
               ELSE IF (iorder == 2) THEN
                  ! Composite extended formula weights
                  IF (i == 1 .OR. i == n) THEN
                     weight = 0.4166666666
                  ELSE IF (i == 2 .OR. i == n-1) THEN
                     weight = 1.0833333333
                  ELSE
                     weight = 1.
                  END IF
               ELSE IF (iorder == 3) THEN
                  ! Composite Simpson weights
                  IF (i == 1 .OR. i == n) THEN
                     weight = 0.375
                  ELSE IF (i == 2 .OR. i == n-1) THEN
                     weight = 1.1666666666
                  ELSE IF (i == 3 .OR. i == n-2) THEN
                     weight = 0.9583333333
                  ELSE
                     weight = 1.
                  END IF
               ELSE
                  STOP 'INTEGERATE_LOG: Error, order specified incorrectly'
               END IF

               IF (ilog == 0) THEN
                  sum_new = sum_new+weight*f(x)
               ELSE IF (ilog == 1) THEN
                  sum_new = sum_new+weight*f(x)*x
               ELSE
                  STOP 'INTEGRATE_LOG: Error, ilog specified incorrectly'
               END IF

            END DO

            dx = (limb-lima)/real(n-1)
            sum_new = sum_new*dx

            IF (sum_old == 0.d0 .OR. j<jmin) THEN
               pass = .FALSE.
            ELSE IF(abs(-1.d0+sum_new/sum_old) < acc) THEN
               pass = .TRUE.
            ELSE IF (j == jmax) THEN
               pass = .FALSE.
               STOP 'INTEGRATE_LOG: Integration timed out'       
            ELSE
               pass = .FALSE.
            END IF

            IF (pass) THEN
               EXIT
            ELSE
               ! Integral has not converged so store old sums and reset sum variables
               sum_old = sum_new
               sum_new = 0.
            END IF

         END DO
         
         integrate_log = real(sum_new)

      END IF

   END FUNCTION integrate_log

   REAL FUNCTION integrate_cubic(a, b, f, acc)

      ! Integrates between a and b until desired accuracy is reached!
      ! Fits a cubic between successive 4 points
      ! Only useful if points are not eqaully spaced, thus this routine is probably redundant
      USE special_functions
      REAL, INTENT(IN) :: a
      REAL, INTENT(IN) :: b
      REAL, EXTERNAL :: f
      REAL, INTENT(IN) :: acc
      INTEGER :: i, j, nint, nsec
      REAL :: a3, a2, a1, a0
      REAL :: x1, x2, x3, x4
      REAL :: y1, y2, y3, y4
      REAL :: sum_old, sum_new
      LOGICAL :: pass

      INTEGER, PARAMETER :: jmin = jmin_integrate
      INTEGER, PARAMETER :: jmax = jmax_integrate
      INTEGER, PARAMETER :: ni = ninit_integrate  ! CARE: This was previously set to 1

      INTERFACE
         FUNCTION f(x)
            REAL, INTENT(IN) :: x
         END FUNCTION f
      END INTERFACE

      IF (a == b) THEN

         integrate_cubic = 0.

      ELSE

         ! Set the sum variables
         sum_old = 0.d0
         sum_new = 0.d0

         DO j = 1, jmax

            ! This is the number of cubic sections (each of which has four function evaluations)
            nsec = ni*2**(j-1)

            ! Number of function evaluation points so as to be able to fit a cubic (4,7,10 ...)
            nint = 3*nsec+1

            DO i = 1, nsec

               IF (i == 1) THEN

                  x1 = a+(b-a)*float(3*(i-1)+1-1)/float(nint-1)
                  y1 = f(x1)

               ELSE

                  x1 = x4
                  y1 = y4

               END IF

               x2 = a+(b-a)*float(3*(i-1)+2-1)/float(nint-1)
               x3 = a+(b-a)*float(3*(i-1)+3-1)/float(nint-1)
               x4 = a+(b-a)*float(3*(i-1)+4-1)/float(nint-1)

               y2 = f(x2)
               y3 = f(x3)
               y4 = f(x4)

               CALL fix_polynomial(a3, a2, a1, a0, [x1, x2, x3, x4], [y1, y2, y3, y4])

               ! Add the (analytical) intergal of a cubic between points x1 and x4 to the total
               sum_new = sum_new+(a3/4.)*(x4**4.-x1**4.)+(a2/3.)*(x4**3.-x1**3.)+(a1/2.)*(x4**2.-x1**2.)+a0*(x4-x1)

            END DO

            IF (sum_old == 0.d0 .OR. j<jmin) THEN
               pass = .FALSE.
            ELSE IF(abs(-1.d0+sum_new/sum_old) < acc) THEN
               pass = .TRUE.
            ELSE IF (j == jmax) THEN
               pass = .FALSE.
               STOP 'INTEGRATE_CUBIC: Integration timed out'
            ELSE
               pass = .FALSE.
            END IF

            IF (pass) THEN
               EXIT
            ELSE
               ! Integral has not converged so store old sums and reset sum variables
               sum_old = sum_new
               sum_new = 0.
            END IF

         END DO

         integrate_cubic = real(sum_new)

      END IF

   END FUNCTION integrate_cubic

   REAL FUNCTION integrate_jac(a, b, f, acc, iorder, g, gi, dg)

      ! Integrates between a and b until desired accuracy is reached
      ! Uses a Jacobian to speed up the integration
      REAL, INTENT(IN) :: a
      REAL, INTENT(IN) :: b
      REAL, EXTERNAL :: f
      REAL, INTENT(IN) :: acc
      INTEGER, INTENT(IN) :: iorder
      REAL, EXTERNAL :: g
      REAL, EXTERNAL :: gi
      REAL, EXTERNAL :: dg
      INTEGER :: i, j, n
      REAL :: dy, alim, blim
      REAL :: x, y, weight
      REAL :: sum_old, sum_new
      LOGICAL :: pass     

      INTEGER, PARAMETER :: jmin = jmin_integrate
      INTEGER, PARAMETER :: jmax = jmax_integrate
      INTEGER, PARAMETER :: ninit = ninit_integrate

      INTERFACE
         FUNCTION f(xin)
            REAL, INTENT(IN) :: xin
         END FUNCTION f
         FUNCTION g(xin)
            REAL, INTENT(IN) :: xin
         END FUNCTION g
         FUNCTION gi(xin)
            REAL, INTENT(IN) :: xin
         END FUNCTION gi
         FUNCTION dg(xin)
            REAL, INTENT(IN) :: xin
         END FUNCTION dg
      END INTERFACE

      IF (a == b) THEN

         integrate_jac = 0.

      ELSE

         ! Set the sum variables
         sum_old = 0.d0
         sum_new = 0.d0

         alim = g(a)
         blim = g(b)

         DO j = 1, jmax

            n = ninit*(2**(j-1))

            DO i = 1, n

               y = alim+(blim-alim)*real(i-1)/real(n-1)

               IF (iorder == 1) THEN
                  ! Composite trapezium weights
                  IF (i == 1 .OR. i == n) THEN
                     weight = 0.5
                  ELSE
                     weight = 1.
                  END IF
               ELSE IF (iorder == 2) THEN
                  ! Composite extended formula weights
                  IF (i == 1 .OR. i == n) THEN
                     weight = 0.4166666666
                  ELSE IF (i == 2 .OR. i == n-1) THEN
                     weight = 1.0833333333
                  ELSE
                     weight = 1.
                  END IF
               ELSE IF (iorder == 3) THEN
                  ! Composite Simpson weights
                  IF (i == 1 .OR. i == n) THEN
                     weight = 0.375
                  ELSE IF (i == 2 .OR. i == n-1) THEN
                     weight = 1.1666666666
                  ELSE IF (i == 3 .OR. i == n-2) THEN
                     weight = 0.9583333333
                  ELSE
                     weight = 1.
                  END IF
               ELSE
                  STOP 'INTEGERATE_JAC: Error, order specified incorrectly'
               END IF

               x = gi(y)

               sum_new = sum_new+weight*f(x)/dg(x)

            END DO

            dy = (blim-alim)/real(n-1)
            sum_new = sum_new*dy

            IF (sum_old == 0.d0 .OR. j<jmin) THEN
               pass = .FALSE.
            ELSE IF(abs(-1.d0+sum_new/sum_old) < acc) THEN
               pass = .TRUE.
            ELSE IF (j == jmax) THEN
               pass = .FALSE.
               STOP 'INTEGRATE_JAC: Integration timed out'
            ELSE
               pass = .FALSE.
            END IF

            IF(pass) THEN
               EXIT
            ELSE
               ! Integral has not converged so store old sums and reset sum variables
               sum_old = sum_new
               sum_new = 0.
            END IF

         END DO
         
         integrate_jac = real(sum_new)

      END IF

   END FUNCTION integrate_jac

   REAL FUNCTION integrate_monte_carlo(a, b, f, n)

      ! Integrates between a and b with n points; not adaptive so no error control
      USE random_numbers
      REAL, INTENT(IN) :: a ! Integration limits
      REAL, INTENT(IN) :: b ! Integration limits
      REAL, EXTERNAL :: f
      INTEGER, INTENT(IN) :: n ! Number of points
      INTEGER :: i
      REAL :: x, dx
      REAL :: sum

      INTERFACE
         FUNCTION f(xin)
            REAL, INTENT(IN) :: xin
         END FUNCTION f
      END INTERFACE

      IF (a == b) THEN

         integrate_monte_carlo = 0.

      ELSE

         sum = 0.d0
         DO i = 1, n
            x = random_uniform(a, b)
            sum = sum+f(x)
         END DO

         dx = (b-a)/real(n)

         sum = sum*dx

         integrate_monte_carlo = real(sum)

      END IF

   END FUNCTION integrate_monte_carlo

END MODULE calculus

MODULE camb_stuff

   USE constants
   USE basic_operations
   USE file_info

   IMPLICIT NONE

   PRIVATE

   ! Routines
   PUBLIC :: read_CAMB_Pk
   PUBLIC :: write_CAMB_Pk
   PUBLIC :: read_CAMB_Tk

   ! File columns and additional info
   PUBLIC :: CAMB_column_Tk_CDM
   PUBLIC :: CAMB_column_Tk_baryon
   PUBLIC :: CAMB_column_Tk_photon
   PUBLIC :: CAMB_column_Tk_nu
   PUBLIC :: CAMB_column_Tk_massive_nu
   PUBLIC :: CAMB_column_Tk_total
   PUBLIC :: CAMB_Pk_comment_lines
   PUBLIC :: CAMB_Tk_comment_lines

   INTEGER, PARAMETER :: CAMB_Pk_comment_lines = 1
   INTEGER, PARAMETER :: CAMB_Tk_comment_lines = 1
   INTEGER, PARAMETER :: CAMB_number_Tk = 6
   INTEGER, PARAMETER :: CAMB_column_Tk_CDM = 1
   INTEGER, PARAMETER :: CAMB_column_Tk_baryon = 2
   INTEGER, PARAMETER :: CAMB_column_Tk_photon = 3
   INTEGER, PARAMETER :: CAMB_column_Tk_nu = 4
   INTEGER, PARAMETER :: CAMB_column_Tk_massive_nu = 5
   INTEGER, PARAMETER :: CAMB_column_Tk_total = 6

CONTAINS

   SUBROUTINE read_CAMB_Pk(k, Pk, nk, infile, verbose)

      ! Read in CAMB format P(k) file
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:)
      INTEGER, INTENT(OUT) :: nk
      CHARACTER(len=*), INTENT(IN) :: infile
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      INTEGER :: i
      INTEGER :: u

      nk = file_length(infile, verbose=.FALSE.)
      nk = nk-CAMB_Pk_comment_lines
      IF(present_and_correct(verbose)) THEN
         WRITE (*, *) 'READ_CAMB_PK: CAMB file: ', trim(infile)
         WRITE (*, *) 'READ_CAMB_PK: Number of points:', nk
      END IF

      ALLOCATE (k(nk), Pk(nk))

      OPEN (newunit=u, file=infile)
      DO i = 1-CAMB_Pk_comment_lines, nk
         IF (i <= 0) THEN
            READ (u, *)
         ELSE
            READ (u, *) k(i), Pk(i)
         END IF
      END DO
      CLOSE (u)

      ! Convert from P(k) [(Mpc/h)^3] to Delta^2(k)
      Pk = 4.*pi*Pk*(k**3)/twopi**3

      IF(present_and_correct(verbose)) THEN
         WRITE (*, *) 'READ_CAMB_PK: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE read_CAMB_Pk

   SUBROUTINE write_CAMB_Pk(k, Pk, outfile, header)

      REAL, INTENT(IN) :: k(:)
      REAL, INTENT(IN) :: Pk(:)
      CHARACTER(len=256), INTENT(IN) :: outfile
      LOGICAL, INTENT(IN) :: header
      INTEGER :: u
      INTEGER :: ik

      OPEN(newunit=u, file=outfile)
      IF (header) WRITE(u, *) '#           k/h    P'
      DO ik = 1, size(k)
         WRITE(u, *) k(ik), Pk(ik)/(4.*pi*(k(ik)/twopi)**3)
      END DO
      CLOSE(u)

   END SUBROUTINE write_CAMB_Pk

   SUBROUTINE read_CAMB_Tk(k, Tk, nk, nTk, infile, verbose)

      ! Read in CAMB format T(k) file
      ! Note that this assumes there is one comment line
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Tk(:,:)
      INTEGER, INTENT(OUT) :: nk
      INTEGER, INTENT(OUT) :: nTk
      CHARACTER(len=*), INTENT(IN) :: infile
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      INTEGER :: i, j

      nk = file_length(infile, verbose=.FALSE.)
      nk = nk-CAMB_Tk_comment_lines
      IF(present_and_correct(verbose)) THEN
         WRITE (*, *) 'READ_CAMB_Tcold: CAMB file: ', trim(infile)
         WRITE (*, *) 'READ_CAMB_Tcold: Number of points:', nk
         WRITE (*, *)
      END IF

      nTk = CAMB_number_Tk
      ALLOCATE (k(nk), Tk(nTk, nk))

      OPEN (7, file=infile)
      DO i = 1-CAMB_Tk_comment_lines, nk
         IF (i <= 0 ) THEN
            READ (7, *)
         ELSE
            READ (7, *) k(i), (Tk(j,i), j=1,nTk)
         END IF       
      END DO
      CLOSE (7)

      IF(present_and_correct(verbose)) THEN
         WRITE (*, *) 'READ_CAMB_Tcold: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE read_CAMB_Tk

END MODULE camb_stuff

MODULE fft

   ! TODO: Re-enable single and double precision versions of functions
   ! TODO: Remove unnecessary array-size arguments from functions
   ! TODO: Clean up

   !USE iso_c_binding ! This use statement seems not to be necessary any more, not sure why
   USE basic_operations
   USE precision

   IMPLICIT NONE

   !Include the FFTW libraray locations
   !INCLUDE '/usr/local/include/fftw3.f' !Mac
   !INCLUDE '/usr/include/fftw3.f' !Linux'
   INCLUDE 'fftw3.f'

   PRIVATE

   PUBLIC :: FFT1
   PUBLIC :: FFT2
   PUBLIC :: FFT3

   PUBLIC :: k_FFT

   PUBLIC :: fundamental_frequency
   PUBLIC :: Nyquist_frequency
   PUBLIC :: Nyquist_cell
   PUBLIC :: conjugate_mode_location

   INTERFACE FFT1
      MODULE PROCEDURE FFT1_complex_double
      MODULE PROCEDURE FFT1_complex_single
      MODULE PROCEDURE FFT1_real_double
      MODULE PROCEDURE FFT1_real_single
   END INTERFACE FFT1

   INTERFACE FFT2
      MODULE PROCEDURE FFT2_complex_double
      MODULE PROCEDURE FFT2_complex_single
      MODULE PROCEDURE FFT2_real_double
      MODULE PROCEDURE FFT2_real_single
   END INTERFACE FFT2

   INTERFACE FFT3
      MODULE PROCEDURE FFT3_complex_double
      MODULE PROCEDURE FFT3_complex_single
      MODULE PROCEDURE FFT3_real_double
      MODULE PROCEDURE FFT3_real_single
   END INTERFACE FFT3

! This works, but cannot be called FFT as this is the same name as fft.f90
!!$  INTERFACE FFTs
!!$     MODULE PROCEDURE FFT1_complex_double
!!$     MODULE PROCEDURE FFT1_complex_single
!!$     MODULE PROCEDURE FFT1_real_double
!!$     MODULE PROCEDURE FFT1_real_single
!!$     MODULE PROCEDURE FFT2_complex_double
!!$     MODULE PROCEDURE FFT2_complex_single
!!$     MODULE PROCEDURE FFT2_real_double
!!$     MODULE PROCEDURE FFT2_real_single
!!$     MODULE PROCEDURE FFT3_complex_double
!!$     MODULE PROCEDURE FFT3_complex_single
!!$     MODULE PROCEDURE FFT3_real_double
!!$     MODULE PROCEDURE FFT3_real_single
!!$  END INTERFACE FFTs

CONTAINS

   INTEGER FUNCTION Nyquist_cell(m)

      ! Location of Nyquist cell for Fourier transform array of size m
      INTEGER, INTENT(IN) :: m

      IF(odd(m)) STOP 'NYQUIST_CELL: Error, need to think about Nyquist for odd FFT'
      Nyquist_cell = 1+m/2

   END FUNCTION Nyquist_cell

   INTEGER FUNCTION conjugate_mode_location(i, m)

      ! Assumes that m is even
      INTEGER, INTENT(IN) :: i
      INTEGER, INTENT(IN) :: m

      IF (i == 1) THEN
         conjugate_mode_location = 1
      ELSE
         conjugate_mode_location = m+2-i
      END IF

   END FUNCTION conjugate_mode_location

   REAL FUNCTION fundamental_frequency(L)

      USE constants
      REAL, INTENT(IN) :: L

      fundamental_frequency =  twopi/L

   END FUNCTION fundamental_frequency

   REAL FUNCTION Nyquist_frequency(L, m)

      USE constants
      REAL, INTENT(IN) :: L
      INTEGER, INTENT(IN) :: m

      Nyquist_frequency =  pi*m/L

   END FUNCTION Nyquist_frequency

   SUBROUTINE k_FFT(ix, iy, iz, m, kx, ky, kz, kmod, L)

      ! Finds the wavevector associated with the FFT cell
      USE constants
      INTEGER, INTENT(IN) :: ix, iy, iz, m
      REAL, INTENT(IN) :: L
      REAL, INTENT(OUT) :: kx, ky, kz, kmod

      IF (odd(m)) STOP 'K_FFT: Fourier transform does not have an even mesh'

      kx = real(ix-1)
      ky = real(iy-1)
      kz = real(iz-1)

      IF (ix > m/2+1) kx = -real(m-ix+1)
      IF (iy > m/2+1) ky = -real(m-iy+1)
      IF (iz > m/2+1) kz = -real(m-iz+1)

      kx = kx*twopi/L
      ky = ky*twopi/L
      kz = kz*twopi/L

      kmod = sqrt(kx**2+ky**2+kz**2)

   END SUBROUTINE k_FFT

   SUBROUTINE FFT1_complex_double(in, out, n, ifb)

      ! Wrapper for the 1D FFTW
      INTEGER, INTENT(IN) :: n
      COMPLEX(dp), INTENT(IN) :: in(n) 
      COMPLEX(dp), INTENT(OUT) :: out(n)
      INTEGER, INTENT(IN) :: ifb
      INTEGER(int8) :: plan
      LOGICAL, PARAMETER :: verbose = .FALSE.

      IF (odd(n)) STOP 'FFT1_COMPLEX_DOUBLE Error, the array should be even'

      ! Create the plan for the FFT
      IF (verbose) WRITE (*, *) 'FFT1_COMPLEX_DOUBLE Starting FFT - creating plan'
      IF (ifb == -1) THEN
         CALL dfftw_plan_dft_1d(plan, n, in, out, FFTW_FORWARD, FFTW_ESTIMATE)
      ELSE IF (ifb == 1) THEN
         CALL dfftw_plan_dft_1d(plan, n, in, out, FFTW_BACKWARD, FFTW_ESTIMATE)
      ELSE
         STOP 'FFT1_COMPLEX_DOUBLE Error - need to specify forwards or backwards'
      END IF

      ! This computes the FFT...
      IF (verbose) WRITE (*, *) 'FFT1_COMPLEX_DOUBLE Executing FFTW'
      CALL dfftw_execute(plan)
      IF (verbose) WRITE (*, *) 'FFT1_COMPLEX_DOUBLE FFTW complete'

      ! ...and this destroys the plan
      CALL dfftw_destroy_plan(plan)
      IF (verbose) THEN
         WRITE (*, *) 'FFT1_COMPLEX_DOUBLE Plan destroyed'
         WRITE (*, *)
      END IF

   END SUBROUTINE FFT1_complex_double

   SUBROUTINE FFT1_complex_single(in, out, n, ifb)

      ! Wrapper for the 1D FFTW
      INTEGER, INTENT(IN) :: n
      COMPLEX(sp), INTENT(IN) :: in(n)
      COMPLEX(sp), INTENT(OUT) :: out(n)
      INTEGER, INTENT(IN) :: ifb
      INTEGER(int8) :: plan
      LOGICAL, PARAMETER :: verbose = .FALSE.

      IF (odd(n)) STOP 'FFT1_COMPELX_SINGLE: Error, the array should be even'

      ! Create the plan for the FFT
      IF (verbose) WRITE (*, *) 'FFT1_COMPELX_SINGLE: Starting FFT - creating plan'
      IF (ifb == -1) THEN
         CALL sfftw_plan_dft_1d(plan, n, in, out, FFTW_FORWARD, FFTW_ESTIMATE)
      ELSE IF (ifb == 1) THEN
         CALL sfftw_plan_dft_1d(plan, n, in, out, FFTW_BACKWARD, FFTW_ESTIMATE)
      ELSE
         STOP 'FFT1_COMPELX_SINGLE: Error - need to specify forwards or backwards'
      END IF

      ! This computes the FFT...
      IF (verbose) WRITE (*, *) 'FFT1_COMPELX_SINGLE: Executing FFTW'
      CALL sfftw_execute(plan)
      IF (verbose) WRITE (*, *) 'FFT1_COMPELX_SINGLE: FFTW complete'

      ! ...and this destroys the plan
      CALL sfftw_destroy_plan(plan)
      IF (verbose) THEN
         WRITE (*, *) 'FFT1_COMPELX_SINGLE: Plan destroyed'
         WRITE (*, *)
      END IF

   END SUBROUTINE FFT1_complex_single

   SUBROUTINE FFT1_real_double(rspace, fspace, n, ifb)

      ! Wrapper for the real 1D FFTW
      INTEGER, INTENT(IN) :: n
      REAL(dp), INTENT(INOUT) :: rspace(n)
      COMPLEX(dp), INTENT(INOUT) :: fspace(n/2+1)
      INTEGER, INTENT(IN) :: ifb
      INTEGER(int8) :: plan

      IF (odd(n)) STOP 'FFT1_REAL_DOUBLE: Error, the array should be even'

      IF (ifb == -1) THEN
         CALL dfftw_plan_dft_r2c_1d(plan, N, rspace, fspace, FFTW_ESTIMATE)
         CALL dfftw_execute_dft_r2c(plan, rspace, fspace)
      ELSE IF (ifb == 1) THEN
         CALL dfftw_plan_dft_c2r_1d(plan, N, fspace, rspace, FFTW_ESTIMATE)
         CALL dfftw_execute_dft_c2r(plan, fspace, rspace)
      ELSE
         STOP 'FFT1_REAL_DOUBLE: Error - need to specify forwards or backwards'
      END IF

      CALL dfftw_destroy_plan(plan)

   END SUBROUTINE FFT1_real_double

   SUBROUTINE FFT1_real_single(rspace, fspace, n, ifb)

      ! Wrapper for the real 1D FFTW
      INTEGER, INTENT(IN) :: n
      REAL(sp), INTENT(INOUT) :: rspace(n)   
      COMPLEX(sp), INTENT(INOUT) :: fspace(n/2+1)
      INTEGER, INTENT(IN) :: ifb
      INTEGER(int8) :: plan

      IF (odd(n)) STOP 'FFT1_REAL_SINGLE: Error, the array should be even'

      IF (ifb == -1) THEN
         CALL sfftw_plan_dft_r2c_1d(plan, N, rspace, fspace, FFTW_ESTIMATE)
         CALL sfftw_execute_dft_r2c(plan, rspace, fspace)
      ELSE IF (ifb == 1) THEN
         CALL sfftw_plan_dft_c2r_1d(plan, N, fspace, rspace, FFTW_ESTIMATE)
         CALL sfftw_execute_dft_c2r(plan, fspace, rspace)
      ELSE
         STOP 'FFT1_REAL_SINGLE: Error - need to specify forwards or backwards'
      END IF

      CALL sfftw_destroy_plan(plan)

   END SUBROUTINE FFT1_real_single

   SUBROUTINE FFT2_complex_double(in, out, nx, ny, ifb)

      ! Wrapper for the 2D FFTW
      INTEGER, INTENT(IN) :: nx, ny
      COMPLEX(dp), INTENT(IN) :: in(nx, ny)
      COMPLEX(dp), INTENT(OUT) :: out(nx, ny)
      INTEGER, INTENT(IN) :: ifb
      INTEGER(int8) :: plan
      LOGICAL, PARAMETER :: verbose = .FALSE.

      IF (odd(nx)) STOP 'FFT2_COMPLEX_DOUBLE: Error, the array should be even'
      IF (odd(ny)) STOP 'FFT2_COMPLEX_DOUBLE: Error, the array should be even'

      ! Create the plans for the FFT
      IF (verbose) WRITE (*, *) 'FFT2_COMPLEX_DOUBLE: Starting FFT - creating plan'
      IF (ifb == -1) THEN
         CALL dfftw_plan_dft_2d(plan, nx, ny, in, out, FFTW_FORWARD, FFTW_ESTIMATE)
      ELSE IF (ifb == 1) THEN
         CALL dfftw_plan_dft_2d(plan, nx, ny, in, out, FFTW_BACKWARD, FFTW_ESTIMATE)
      ELSE
         WRITE (*, *) 'FFT2_COMPLEX_DOUBLE: Error - need to specify forwards or backwards'
      END IF

      ! This computes the FFT...
      IF (verbose) WRITE (*, *) 'FFT2_COMPLEX_DOUBLE: Executing FFTW'
      CALL dfftw_execute(plan)
      IF (verbose) WRITE (*, *) 'FFT2_COMPLEX_DOUBLE: FFTW complete'

      ! ...and this destroys the plan!
      CALL dfftw_destroy_plan(plan)
      IF (verbose) THEN
         WRITE (*, *) 'FFT2_COMPLEX_DOUBLE: Plan destroyed'
         WRITE (*, *)
      END IF

   END SUBROUTINE FFT2_complex_double

   SUBROUTINE FFT2_complex_single(in, out, nx, ny, ifb)

      ! Wrapper for the 2D FFTW
      INTEGER, INTENT(IN) :: nx, ny
      COMPLEX(sp), INTENT(IN) :: in(nx, ny)
      COMPLEX(sp), INTENT(OUT) :: out(nx, ny)
      INTEGER, INTENT(IN) :: ifb
      INTEGER(int8) :: plan
      LOGICAL, PARAMETER :: verbose = .FALSE.

      IF (odd(nx)) STOP 'FFT2_COMPLEX_SINGLE: Error, the array should be even'
      IF (odd(ny)) STOP 'FFT2_COMPLEX_SINGLE: Error, the array should be even'

      ! Create the plans for the FFT
      IF (verbose) WRITE (*, *) 'FFT2_COMPLEX_SINGLE: Starting FFT - creating plan'
      IF (ifb == -1) THEN
         CALL sfftw_plan_dft_2d(plan, nx, ny, in, out, FFTW_FORWARD, FFTW_ESTIMATE)
      ELSE IF (ifb == 1) THEN
         CALL sfftw_plan_dft_2d(plan, nx, ny, in, out, FFTW_BACKWARD, FFTW_ESTIMATE)
      ELSE
         WRITE (*, *) 'FFT2_COMPLEX_SINGLE: Error - need to specify forwards or backwards'
      END IF

      ! This computes the FFT...
      IF (verbose) WRITE (*, *) 'FFT2_COMPLEX_SINGLE: Executing FFTW'
      CALL sfftw_execute(plan)
      IF (verbose) WRITE (*, *) 'FFT2_COMPLEX_SINGLE: FFTW complete'

      ! ...and this destroys the plan!
      CALL sfftw_destroy_plan(plan)
      IF (verbose) THEN
         WRITE (*, *) 'FFT2_COMPLEX_SINGLE: Plan destroyed'
         WRITE (*, *)
      END IF

   END SUBROUTINE FFT2_complex_single

   SUBROUTINE FFT2_real_double(rspace, fspace, nx, ny, ifb)

      ! Wrapper for the real 3D FFTW
      INTEGER, INTENT(IN) :: nx, ny
      REAL(dp), INTENT(INOUT)  :: rspace(nx, ny)
      COMPLEX(dp), INTENT(INOUT) :: fspace(nx/2+1, ny)
      INTEGER, INTENT(IN) :: ifb
      INTEGER(int8) :: plan
      LOGICAL, PARAMETER :: verbose = .FALSE.

      IF (odd(nx)) STOP 'FFT2_REAL_DOUBLE: Error, the array should be even'
      IF (odd(ny)) STOP 'FFT2_REAL_DOUBLE: Error, the array should be even'

      ! Create the plans for the FFT and execute
      IF (verbose) WRITE (*, *) 'FFT2_REAL_DOUBLE: Starting FFT - creating plan and executing simulatanesouly'
      IF (ifb == -1) THEN
         CALL dfftw_plan_dft_r2c_2d(plan, nx, ny, rspace, fspace, FFTW_ESTIMATE)
         CALL dfftw_execute_dft_r2c(plan, rspace, fspace)
      ELSE IF (ifb == 1) THEN
         CALL dfftw_plan_dft_c2r_2d(plan, nx, ny, fspace, rspace, FFTW_ESTIMATE)
         CALL dfftw_execute_dft_c2r(plan, fspace, rspace)
      ELSE
         WRITE (*, *) 'FFT2_REAL_DOUBLE: Error - need to specify forwards or backwards'
      END IF

      ! ..and this destroys the plan!
      CALL dfftw_destroy_plan(plan)
      IF (verbose) THEN
         WRITE (*, *) 'FFT2_REAL_DOUBLE: Plan destroyed'
         WRITE (*, *)
      END IF

   END SUBROUTINE FFT2_real_double

   SUBROUTINE FFT2_real_single(rspace, fspace, nx, ny, ifb)

      ! Wrapper for the real 3D FFTW
      INTEGER, INTENT(IN) :: nx, ny
      REAL(sp), INTENT(INOUT)  :: rspace(nx, ny)
      COMPLEX(sp), INTENT(INOUT) :: fspace(nx/2+1, ny)
      INTEGER, INTENT(IN) :: ifb
      INTEGER(int8) :: plan
      LOGICAL, PARAMETER :: verbose = .FALSE.

      IF (odd(nx)) STOP 'FFT2_REAL_SINGLE: Error, the array should be even'
      IF (odd(ny)) STOP 'FFT2_REAL_SINGLE: Error, the array should be even'

      ! Create the plans for the FFT and execute
      IF (verbose) WRITE (*, *) 'FFT2_REAL_SINGLE: Starting FFT - creating plan and executing simulatanesouly'
      IF (ifb == -1) THEN
         CALL sfftw_plan_dft_r2c_2d(plan, nx, ny, rspace, fspace, FFTW_ESTIMATE)
         CALL sfftw_execute_dft_r2c(plan, rspace, fspace)
      ELSE IF (ifb == 1) THEN
         CALL sfftw_plan_dft_c2r_2d(plan, nx, ny, fspace, rspace, FFTW_ESTIMATE)
         CALL sfftw_execute_dft_c2r(plan, fspace, rspace)
      ELSE
         WRITE (*, *) 'FFT2_REAL_SINGLE: Error - need to specify forwards or backwards'
      END IF

      ! ..and this destroys the plan!
      CALL sfftw_destroy_plan(plan)
      IF (verbose) THEN
         WRITE (*, *) 'FFT2_REAL_SINGLE: Plan destroyed'
         WRITE (*, *)
      END IF

   END SUBROUTINE FFT2_real_single

   SUBROUTINE FFT3_complex_double(in, out, nx, ny, nz, ifb)

      ! Wrapper for the 3D FFTW
      INTEGER, INTENT(IN) :: nx, ny, nz
      COMPLEX(dp), INTENT(IN)  :: in(nx, ny, nz)
      COMPLEX(dp), INTENT(OUT) :: out(nx, ny, nz)
      INTEGER, INTENT(IN) :: ifb
      INTEGER(int8) :: plan
      LOGICAL, PARAMETER :: verbose = .FALSE.

      IF (odd(nx)) STOP 'FFT3_COMPLEX_DOUBLE: Error, the array should be even'
      IF (odd(ny)) STOP 'FFT3_COMPLEX_DOUBLE: Error, the array should be even'
      IF (odd(nz)) STOP 'FFT3_COMPLEX_DOUBLE: Error, the array should be even'

      ! Create the plans for the FFT
      IF (verbose) WRITE (*, *) 'FFT3_COMPLEX_DOUBLE: Starting FFT - creating plan'
      IF (ifb == -1) THEN
         CALL dfftw_plan_dft_3d(plan, nx, ny, nz, in, out, FFTW_FORWARD, FFTW_ESTIMATE)
      ELSE IF (ifb == 1) THEN
         CALL dfftw_plan_dft_3d(plan, nx, ny, nz, in, out, FFTW_BACKWARD, FFTW_ESTIMATE)
      ELSE
         WRITE (*, *) 'FFT3_COMPLEX_DOUBLE: Error - need to specify forwards or backwards'
      END IF

      ! This computes the FFT...
      IF (verbose) WRITE (*, *) 'FFT3_COMPLEX_DOUBLE: Executing FFTW'
      CALL dfftw_execute(plan)
      IF (verbose) WRITE (*, *) 'FFT3_COMPLEX_DOUBLE: FFTW complete'

      ! ...and this destroys the plan!
      CALL dfftw_destroy_plan(plan)
      IF (verbose) THEN
         WRITE (*, *) 'FFT3_COMPLEX_DOUBLE: Plan destroyed'
         WRITE (*, *)
      END IF

   END SUBROUTINE FFT3_complex_double

   SUBROUTINE FFT3_complex_single(in, out, nx, ny, nz, ifb)

      ! Wrapper for the 3D FFTW
      INTEGER, INTENT(IN) :: nx, ny, nz
      COMPLEX(sp), INTENT(IN)  :: in(nx, ny, nz)
      COMPLEX(sp), INTENT(OUT) :: out(nx, ny, nz)
      INTEGER, INTENT(IN) :: ifb
      INTEGER(int8) :: plan
      LOGICAL, PARAMETER :: verbose = .FALSE.

      IF (odd(nx)) STOP 'FFT3_COMPLEX_SINGLE: Error, the array should be even'
      IF (odd(ny)) STOP 'FFT3_COMPLEX_SINGLE: Error, the array should be even'
      IF (odd(nz)) STOP 'FFT3_COMPLEX_SINGLE: Error, the array should be even'

      ! Create the plans for the FFT
      IF (verbose) WRITE (*, *) 'FFT3_COMPLEX_SINGLE: Starting FFT - creating plan'
      IF (ifb == -1) THEN
         CALL sfftw_plan_dft_3d(plan, nx, ny, nz, in, out, FFTW_FORWARD, FFTW_ESTIMATE)
      ELSE IF (ifb == 1) THEN
         CALL sfftw_plan_dft_3d(plan, nx, ny, nz, in, out, FFTW_BACKWARD, FFTW_ESTIMATE)
      ELSE
         WRITE (*, *) 'FFT3_COMPLEX_SINGLE: Error - need to specify forwards or backwards'
      END IF

      ! This computes the FFT...
      IF (verbose) WRITE (*, *) 'FFT3_COMPLEX_SINGLE: Executing FFTW'
      CALL sfftw_execute(plan)
      IF (verbose) WRITE (*, *) 'FFT3_COMPLEX_SINGLE: FFTW complete'

      ! ...and this destroys the plan!
      CALL sfftw_destroy_plan(plan)
      IF (verbose) THEN
         WRITE (*, *) 'FFT3_COMPLEX_SINGLE: Plan destroyed'
         WRITE (*, *)
      END IF

   END SUBROUTINE FFT3_complex_single

   SUBROUTINE FFT3_real_double(rspace, fspace, nx, ny, nz, ifb)

      ! Wrapper for the real 3D FFTW
      INTEGER, INTENT(IN) :: nx, ny, nz
      REAL(dp), INTENT(INOUT)  :: rspace(nx, ny, nz)
      COMPLEX(dp), INTENT(INOUT) :: fspace(nx/2+1, ny, nz)
      INTEGER, INTENT(IN) :: ifb
      INTEGER(int8) :: plan
      LOGICAL, PARAMETER :: verbose = .FALSE.

      IF (odd(nx)) STOP 'FFT3_REAL_DOUBLE: Error, the array should be even'
      IF (odd(ny)) STOP 'FFT3_REAL_DOUBLE: Error, the array should be even'
      IF (odd(nz)) STOP 'FFT3_REAL_DOUBLE: Error, the array should be even'

      ! Create the plans for the FFT and execute
      IF (verbose) WRITE (*, *) 'FFT3_REAL_DOUBLE: Starting FFT - creating plan and executing simultanesouly'
      IF (ifb == -1) THEN
         CALL dfftw_plan_dft_r2c_3d(plan, nx, ny, nz, rspace, fspace, FFTW_ESTIMATE)
         CALL dfftw_execute_dft_r2c(plan, rspace, fspace)
      ELSE IF (ifb == 1) THEN
         CALL dfftw_plan_dft_c2r_3d(plan, nx, ny, nz, fspace, rspace, FFTW_ESTIMATE)
         CALL dfftw_execute_dft_c2r(plan, fspace, rspace)
      ELSE
         WRITE (*, *) 'FFT3_REAL_DOUBLE: Error - need to specify forwards or backwards'
      END IF

      ! ..and this destroys the plan!
      CALL dfftw_destroy_plan(plan)
      IF (verbose) THEN
         WRITE (*, *) 'FFT3_REAL_DOUBLE: Plan destroyed'
         WRITE (*, *)
      END IF

   END SUBROUTINE FFT3_real_double

   SUBROUTINE FFT3_real_single(rspace, fspace, nx, ny, nz, ifb)

      ! Wrapper for the real 3D FFTW
      INTEGER, INTENT(IN) :: nx, ny, nz
      REAL(sp), INTENT(INOUT)  :: rspace(nx, ny, nz)
      COMPLEX(sp), INTENT(INOUT) :: fspace(nx/2+1, ny, nz)
      INTEGER, INTENT(IN) :: ifb
      INTEGER(int8) :: plan
      LOGICAL, PARAMETER :: verbose = .FALSE.

      IF (odd(nx)) STOP 'FFT3_REAL_SINGLE: Error, the array should be even'
      IF (odd(ny)) STOP 'FFT3_REAL_SINGLE: Error, the array should be even'
      IF (odd(nz)) STOP 'FFT3_REAL_SINGLE: Error, the array should be even'

      ! Create the plans for the FFT and execute
      IF (verbose) WRITE (*, *) 'FFT3_REAL_SINGLE: Starting FFT - creating plan and executing simulatanesouly'
      IF (ifb == -1) THEN
         CALL sfftw_plan_dft_r2c_3d(plan, nx, ny, nz, rspace, fspace, FFTW_ESTIMATE)
         CALL sfftw_execute_dft_r2c(plan, rspace, fspace)
      ELSE IF (ifb == 1) THEN
         CALL sfftw_plan_dft_c2r_3d(plan, nx, ny, nz, fspace, rspace, FFTW_ESTIMATE)
         CALL sfftw_execute_dft_c2r(plan, fspace, rspace)
      ELSE
         WRITE (*, *) 'FFT3_REAL_SINGLE: Error - need to specify forwards or backwards'
      END IF

      ! ..and this destroys the plan!
      CALL sfftw_destroy_plan(plan)
      IF (verbose) THEN
         WRITE (*, *) 'FFT3_REAL_SINGLE: Plan destroyed'
         WRITE (*, *)
      END IF

   END SUBROUTINE FFT3_real_single

END MODULE fft

MODULE gadget_stuff

   USE precision
   USE array_operations

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: write_gadget_simulation_format_Pk
   PUBLIC :: read_gadget
   PUBLIC :: write_gadget
   PUBLIC :: read_catalogue
   PUBLIC :: write_catalogue

   REAL, PARAMETER :: Lunit = 1e-3  ! Convert from Gadget2 kpc/h to Mpc/h
   REAL, PARAMETER :: Munit = 1e10  ! Convert from Gadget2 10^10 Msun/h to Msun/h

   ! Gadget file format precisions
   INTEGER, PARAMETER :: gadget_sp = 4
   INTEGER, PARAMETER :: gadget_dp = 8

CONTAINS

   SUBROUTINE write_gadget_simulation_format_Pk(k, Pk, outfile, verbose)

      ! Converts a CAMB P(k) file to a Gadget format P(k) file 
      REAL, INTENT(IN) :: k(:)  ! Input k [h/Mpc]
      REAL, INTENT(IN) :: Pk(:) ! Input dimensionless Delta^2(k)
      CHARACTER(len=*), INTENT(IN) :: outfile ! Output file
      LOGICAL, INTENT(IN) :: verbose ! Verbose or not
      INTEGER :: i, nk
      REAL, ALLOCATABLE :: Gadget_k(:), Gadget_Pk(:)

      nk = size(k)
      IF (nk /= size(Pk)) STOP 'WRITE_GADGET_SIMULATION_FORMAT: Error, k and Pk must be the same size'
      ALLOCATE(Gadget_k(nk), Gadget_Pk(nk))

      IF(verbose) WRITE(*, *) 'WRITE_GADGET_INPUT_POWER: Converting units to Gadget format'

      Gadget_k = log10(k)-3. ! Convert Mpc/h to kpc/h and take log10
      Gadget_Pk = log10(Pk)  ! Take log10

      IF(verbose) WRITE(*, *) 'WRITE_GADGET_INPUT_POWER: Output file: ', trim(outfile)
      OPEN(7, file=outfile)
      DO i = 1, nk
         WRITE(7,*) Gadget_k(i), Gadget_Pk(i)
      END DO
      CLOSE(7)
      IF(verbose) THEN
         WRITE(*, *) 'WRITE_GADGET_INPUT_POWER: Done'
         WRITE(*, *)
      END IF

   END SUBROUTINE write_gadget_simulation_format_Pk

   SUBROUTINE read_gadget(x, v, id, L, Om_m, Om_v, h, m, a, z, n, infile)

      ! Read in particle data from a Gadget formatted binary file
      USE precision
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:, :)
      REAL, ALLOCATABLE, INTENT(OUT) :: v(:, :)
      INTEGER, ALLOCATABLE, INTENT(OUT) :: id(:)
      REAL, INTENT(OUT) :: L
      REAL, INTENT(OUT) :: Om_m
      REAL, INTENT(OUT) :: Om_v
      REAL, INTENT(OUT) :: h
      REAL, INTENT(OUT) :: m
      REAL, INTENT(OUT) :: a
      REAL, INTENT(OUT) :: z
      INTEGER, INTENT(OUT) :: n
      CHARACTER(len=*), INTENT(IN) :: infile
      REAL(gadget_dp) :: mass_in(6), L_in, Om_m_in, Om_v_in, h_in, a_in, z_in
      REAL(gadget_sp), ALLOCATABLE :: x_in(:, :), v_in(:, :)
      INTEGER :: np(6), craps(6), crap
      LOGICAL :: lexist

      WRITE (*, *) 'READ_GADGET: Reading in Gadget-2 file: ', trim(infile)
      INQUIRE (file=infile, exist=lexist)
      IF (.NOT. lexist) STOP 'READ_GADGET: Error, input file does not exist'

      OPEN (7, file=infile, form='unformatted', status='old')
      READ (7) np, mass_in, a_in, z_in, crap, crap, craps, crap, crap, L_in, Om_m_in, Om_v_in, h_in
      CLOSE (7)

      ! Convert Gadget header numbers to my numbers
      ! TODO: Possible precision change
      m = mass_in(2)
      a = a_in
      z = z_in
      Om_m = Om_m_in
      Om_v = Om_v_in
      h = h_in
      L = L_in
      n = np(2)

      ! Convert units
      m = m*Munit
      L = L*Lunit

      WRITE (*, *) 'READ_GADGET: Particle number:', n
      WRITE (*, *) 'READ_GADGET: Which is:', nint(n**(1./3.)), 'cubed.'
      WRITE (*, *) 'READ_GADGET: Particle mass log10([M_sun/h]):', log10(m)
      WRITE (*, *) 'READ_GADGET: Box size [Mpc/h]:', L
      WRITE (*, *) 'READ_GADGET: a:', a
      WRITE (*, *) 'READ_GADGET: z:', z
      WRITE (*, *) 'READ_GADGET: Om_m:', Om_m
      WRITE (*, *) 'READ_GADGET: Om_v:', Om_v
      WRITE (*, *) 'READ_GADGET: h:', h

      ! Allocate arrays for position, velocity and particle ID number
      ALLOCATE (x_in(3, n), v_in(3, n), id(n))

      ! Read in the binary data, skip the header line
      OPEN (7, file=infile, form='unformatted', status='old')
      READ (7)
      READ (7) x_in
      READ (7) v_in
      READ (7) id
      CLOSE (7)

      ! Convert precision
      ALLOCATE(x(3, n))
      x = x_in
      DEALLOCATE(x_in)
      
      ! Convert precision
      ALLOCATE(v(3, n))
      v = v_in
      DEALLOCATE(v_in)

      ! Convert units
      x = x*Lunit
      v = v*sqrt(a)

      WRITE (*, *) 'READ_GADGET: Finished reading file'
      WRITE (*, *)

   END SUBROUTINE read_gadget

   SUBROUTINE write_gadget(x, v, id, L, Om_m, Om_v, h, m, a, z, outfile)

      ! Write particle data to a Gadget formatted particle file
      REAL, INTENT(IN) :: x(:, :)
      REAL, INTENT(IN) :: v(:, :)
      INTEGER, INTENT(IN) :: id(:)
      REAL, INTENT(IN) :: L
      REAL, INTENT(IN) :: Om_m
      REAL, INTENT(IN) :: Om_v
      REAL, INTENT(IN) :: h
      REAL, INTENT(IN) :: m
      REAL, INTENT(IN) :: a
      REAL, INTENT(IN) :: z
      CHARACTER(len=*), INTENT(IN) :: outfile
      REAL(dp) :: mass(6), crap(12), Om_m_out, Om_v_out, h_out, L_out, a_out, z_out
      INTEGER :: np(6), crapi, n

      IF(size(x, 1) /= 3 .OR. size(v, 1) /= 3 ) STOP 'WRITE_GADGET: Error, input x, v arrays should be 3D'
      n = size(x, 2)
      IF (n /= size(x, 2) .OR. n /= size(v, 2) .OR. n /= size(id)) THEN
         STOP 'WRITE_GADGET: Error, x, v, id do not have the same number of entries'
      END IF

      WRITE (*, *) 'WRITE_GADGET: Outputting particle data in Gadget2 format: ', trim(outfile)

      np = 0
      np(2) = n
      mass = 0.
      mass(2) = real(m/Munit, gadget_dp) ! Convert mass to Gadget units
      a_out = real(a, gadget_dp)
      z_out = real(z, gadget_dp)
      crapi = 0
      crap = 0.
      Om_m_out = real(Om_m, gadget_dp)
      Om_v_out = real(Om_v, gadget_dp)
      h_out = real(h, gadget_dp)
      L_out = real(L/Lunit, gadget_dp)

      WRITE (*, *) 'WRITE_GADGET: Particle number:', n
      WRITE (*, *) 'WRITE_GADGET: Which is:', nint(n**(1./3.)), 'cubed'
      WRITE (*, *) 'WRITE_GADGET: Box size [Mpc/h]:', L
      WRITE (*, *) 'WRITE_GADGET: a:', a
      WRITE (*, *) 'WRITE_GADGET: z:', z
      WRITE (*, *) 'WRITE_GADGET: Particle mass log10([Msun/h]):', log10(m)
      WRITE (*, *) 'WRITE_GADGET: Om_m:', Om_m
      WRITE (*, *) 'WRITE_GADGET: Om_v:', Om_v
      WRITE (*, *) 'WRITE_GADGET: h:', h

      OPEN (7, file=outfile, form='unformatted', status='replace')
      WRITE (7) np, mass, a_out, z_out, crapi, crapi, np, crapi, crapi, L_out, Om_m_out, Om_v_out, h_out, crap
      WRITE (7) real(x/Lunit, gadget_sp)
      WRITE (7) real(v/sqrt(a), gadget_sp)
      WRITE (7) id
      CLOSE (7)

      WRITE (*, *) 'WRITE_GADGET: Finished writing file'
      WRITE (*, *)

   END SUBROUTINE write_gadget

   SUBROUTINE read_catalogue(x, v, m, npart, disp, c, env, Dv, rmax, avg_r, rms_r, n, infile)

      USE file_info
      REAL(sp), ALLOCATABLE, INTENT(OUT) :: x(:, :)
      REAL(sp), ALLOCATABLE, INTENT(OUT) :: v(:, :)
      REAL(sp), ALLOCATABLE, INTENT(OUT) :: m(:)
      INTEGER, ALLOCATABLE, INTENT(OUT) :: npart(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: disp(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: c(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: env(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Dv(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: rmax(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: avg_r(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: rms_r(:) 
      INTEGER, INTENT(OUT) :: n
      CHARACTER(len=*), INTENT(IN) :: infile
      INTEGER :: i
      LOGICAL :: lexist

      STOP 'READ_CATALOGUE: need to change this for single/double precision'

      WRITE (*, *) 'READ_CATALOGUE: Reading in catalogue: ', trim(infile)
      INQUIRE (file=infile, exist=lexist)
      IF (.NOT. lexist) STOP 'READ_CATALOGUE: Error, input file does not exist'

      n = file_length(infile, verbose=.FALSE.)
      ALLOCATE (x(3, n), v(3, n), m(n), npart(n))
      ALLOCATE (disp(n), c(n), env(n), Dv(n), rmax(n), avg_r(n), rms_r(n))

      OPEN (7, file=infile)
      DO i = 1, n
         READ (7, *) x(1, i), x(2, i), x(3, i), v(1, i), v(2, i), v(3, i), &
            m(i), npart(i), disp(i), c(i), env(i), Dv(i), rmax(i), avg_r(i), rms_r(i)
      END DO
      CLOSE (7)

      WRITE (*, *) 'READ_CATALOGUE: Min x [Mpc/h]    :', minval(x)
      WRITE (*, *) 'READ_CATALOGUE: Max x [Mpc/h]    :', maxval(x)
      WRITE (*, *) 'READ_CATALOGUE: Min v [km/s]     :', minval(v)
      WRITE (*, *) 'READ_CATALOGUE: Max v [km/s]     :', maxval(v)
      WRITE (*, *) 'READ_CATALOGUE: Min mass [Msun/h]:', minval(m)
      WRITE (*, *) 'READ_CATALOGUE: Max mass [Msun/h]:', maxval(m)
      WRITE (*, *) 'READ_CATALOGUE: Finished reading catalogue file'
      WRITE (*, *)

   END SUBROUTINE read_catalogue

   SUBROUTINE write_catalogue(x, v, m, npart, disp, c, env, Dv, rmax, avg_r, rms_r, outfile)

      REAL, INTENT(IN) :: x(:, :)
      REAL, INTENT(IN) :: v(:, :)
      REAL, INTENT(IN) :: m(:)
      INTEGER, INTENT(IN) :: npart(:)
      REAL, INTENT(IN) :: disp(:)
      REAL, INTENT(IN) :: c(:)
      REAL, INTENT(IN) :: env(:)
      REAL, INTENT(IN) :: Dv(:)
      REAL, INTENT(IN) :: rmax(:)
      REAL, INTENT(IN) :: avg_r(:)
      REAL, INTENT(IN) :: rms_r(:)
      CHARACTER(len=*), INTENT(IN) :: outfile
      INTEGER :: i, n

      STOP 'WRITE_CATALOGUE: Need to change this for single/double precision'
      STOP 'WRITE_CATALOGUE: Add checks that sizes of catalogue entries are all the same size'

      IF(size(x,1) /= 3 .OR. size(v,1) /= 3 ) STOP 'WRITE_CATALOGUE: Error, input x, v arrays should be 3D'
      n = size(x,2)
      IF (n /= size(x,2) .OR. n /= size(v,2)) THEN
         STOP 'WRITE_CATALOGUE: Error, x, v, id do not have the same number of entries'
      END IF

      WRITE (*, *) 'WRITE_CATALOGUE: Outputting catalogue'

      OPEN (7, file=outfile)
      DO i = 1, n
         WRITE (7, *) x(1, i), x(2, i), x(3, i), v(1, i), v(2, i), v(3, i), &
            m(i), npart(i), disp(i), c(i), env(i), Dv(i), rmax(i), avg_r(i), rms_r(i)
      END DO
      CLOSE (7)

      WRITE (*, *) 'WRITE_CATALOGUE: Finished writing catalogue file'
      WRITE (*, *)

   END SUBROUTINE write_catalogue

END MODULE gadget_stuff

MODULE file_info

   USE basic_operations

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: file_length
   PUBLIC :: file_columns
   PUBLIC :: count_number_of_lines
   PUBLIC :: check_file_exists
   PUBLIC :: file_exists

CONTAINS

   INTEGER FUNCTION file_length(file_name, verbose)

      ! Get the number of lines in the file 
      ! TODO: Remove GOTO-ish thing   
      CHARACTER(len=*), INTENT(IN) :: file_name
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      INTEGER :: n, u
      LOGICAL :: lexist

      IF (present_and_correct(verbose)) WRITE (*, *) 'FILE_LENGTH: File: ', trim(file_name)
      INQUIRE (file=file_name, exist=lexist)
      IF (.NOT. lexist) THEN
         WRITE (*, *) 'FILE_LENGTH: File: ', trim(file_name)
         STOP 'FILE_LENGTH: Error, file does not exist'
      END IF
   
      n = 0
      OPEN (newunit=u, file=file_name, status='old')
      DO
         n = n+1
         READ (u, *, end=301) ! Horrid go to
      END DO    
301   CLOSE (u) ! 301 is just the label to jump to when the end of the file is reached
      file_length = n-1

      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'FILE_LENGTH: Length:', file_length
         WRITE (*, *)
      END IF

   END FUNCTION file_length

   INTEGER FUNCTION file_columns(infile, verbose)

      ! Count the number of columns in a file
      ! Based on: https://stackoverflow.com/questions/7314216/reading-data-file-in-fortran-with-known-number-of-lines-but-unknown-number-of-en
      CHARACTER(len=*) :: infile
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      INTEGER :: i, error, u
      !CHARACTER(len=16) :: crap
      CHARACTER(len=1024) :: line
      CHARACTER(len=16), ALLOCATABLE :: array(:)
      LOGICAL :: lexist
      !INTEGER :: file_rows
      INTEGER, PARAMETER :: max_columns = 1000 ! Maximum possible number of entries

      ! Check the file exists
      IF (present_and_correct(verbose)) WRITE (*, *) 'FILE_COLUMNS: File: ', trim(infile)
      INQUIRE (file=infile, exist=lexist)
      IF (.NOT. lexist) THEN
         WRITE (*, *) 'FILE_COLUMNS: File: ', trim(infile)
         STOP 'FILE_COLUMNS: Error, file does not exist'
      END IF
      
      ! Read in first line as string
      OPEN(newunit=u, file=infile, status='old')
      READ(u, '(A)') line
      CLOSE(u)

      ! Analyse string for how many bits it can be split in to
      ALLOCATE(array(max_columns))
      DO i = 1, max_columns       
         READ(line, *, iostat=error) array(1:i)
         IF (error .NE. 0) THEN
            file_columns = i-1
            EXIT
         END IF        
      END DO

      ! Write to screen
      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'FILE_COLUMNS: Columns:', file_columns
         WRITE (*, *)
      END IF

   END FUNCTION file_columns

   FUNCTION count_number_of_lines(filename) result(n)

      ! Tilman's version of file_length (nice because no GOTO)
      CHARACTER(len=*), INTENT(IN) :: filename
      INTEGER :: n
      INTEGER :: file_unit, iostat
      CHARACTER :: c

      OPEN (newunit=file_unit, file=filename, status='old', iostat=iostat)
      IF (iostat > 0) THEN
         PRINT *, "Failed to open file ", filename
         n = -1
         RETURN
      END IF

      n = 0
      DO
         READ (unit=file_unit, fmt=*, iostat=iostat) c
         IF (iostat == 0) THEN
            IF (c == '#') THEN
               print *, "Detected comment lines in file ", filename, ". Check your data file."
               CYCLE
            END IF

            n = n+1
         ELSE IF (iostat < 0) THEN
            !print *, "Reached end of file."
            EXIT
         ELSE
            PRINT *, "Error reading file ", filename
            n = -1
            RETURN
         END IF
      END DO

      CLOSE (file_unit)

   END FUNCTION count_number_of_lines

   SUBROUTINE check_file_exists(file)

      CHARACTER(len=*), INTENT(IN) :: file

      ! Check file exists
      IF (.NOT. file_exists(file)) THEN
         WRITE (*, *) 'CHECK_FILE_EXISTS: File: ', trim(file)
         STOP 'CHECK_FILE_EXISTS: File does not exist'
      END IF

   END SUBROUTINE check_file_exists

   LOGICAL FUNCTION file_exists(file)

      ! Returns true if a file exists, or false otherwise
      CHARACTER(len=*), INTENT(IN) :: file

      INQUIRE (file=file, exist=file_exists)

   END FUNCTION file_exists

END MODULE file_info

MODULE statistics

   USE basic_operations
   USE array_operations
   USE sorting

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: mean
   PUBLIC :: geometric_mean
   PUBLIC :: harmonic_mean
   PUBLIC :: polynomial_mean
   PUBLIC :: weighted_mean
   PUBLIC :: variance
   PUBLIC :: standard_deviation
   PUBLIC :: root_mean_square
   PUBLIC :: histogram
   PUBLIC :: advanced_histogram
   PUBLIC :: calculate_confidence
   PUBLIC :: parameter_probability
   PUBLIC :: percentile
   PUBLIC :: percentiles

   ! Parameters
   INTEGER, PARAMETER :: percentile_sort = isort_bubble

CONTAINS

   FUNCTION percentiles(x, f) 
  
      ! For input distribution or measuments x(n) calculates the x value above which a fraction 'f' of x(n) lie
      ! Can be used to calculate interquartile ranges and such things
      REAL, INTENT(IN) :: x(:)
      REAL, INTENT(IN) :: f(:)
      REAL :: percentiles(size(f))
      REAL, ALLOCATABLE :: y(:)
      INTEGER :: i1, i2, nx, j
      REAL :: in
      INTEGER, PARAMETER :: isort = percentile_sort

      y = x
      CALL sort(y, isort)
      nx = size(y)

      DO j = 1, size(f)
         IF (.NOT. between(f(j), 0., 1.)) THEN
            ERROR STOP 'PERCENTILE: Error, f must be between 0 and 1'
         ELSE IF (f(j) == 0.) THEN
            percentiles(j) = minval(x)
         ELSE IF (f(j) == 1.) THEN
            percentiles(j) = maxval(x)
         ELSE        
            in = 1.+f(j)*(nx-1)
            i1 = floor(in)
            i2 = ceiling(in)
            percentiles(j) = (y(i1)*(i2-in)+y(i2)*(in-i1)) ! Linear interpolation
         END IF
      END DO

   END FUNCTION percentiles

   REAL FUNCTION percentile(x, f)
  
      ! For input distribution or measuments x(n) calculates the x value above which a fraction 'f' of x(n) lie
      ! Can be used to calculate interquartile ranges and such things
      REAL, INTENT(IN) :: x(:)
      REAL, INTENT(IN) :: f
      REAL, ALLOCATABLE :: y(:)
      INTEGER :: i1, i2, n
      REAL :: in
      INTEGER, PARAMETER :: isort = percentile_sort

      IF (.NOT. between(f, 0., 1.)) THEN
         ERROR STOP 'PERCENTILE: Error, f must be between 0 and 1'
      ELSE IF (f == 0.) THEN
         percentile = minval(x)
      ELSE IF (f == 1.) THEN
         percentile = maxval(x)
      ELSE
         y = x
         CALL sort(y, isort)
         n = size(y)
         in = 1.+f*(n-1)
         i1 = floor(in)
         i2 = ceiling(in)
         percentile = (y(i1)*(i2-in)+y(i2)*(in-i1)) ! Linear interpolation
      END IF

   END FUNCTION percentile

   REAL FUNCTION mean(x)

      REAL, INTENT(IN) :: x(:)

      mean = sum(x)/size(x)

   END FUNCTION mean

   REAL FUNCTION geometric_mean(x)

      REAL, INTENT(IN) :: x(:)

      !geometric_mean = product(x)**(1./size(x)) ! Probably insane to do this
      geometric_mean = exp(mean(log(x)))

   END FUNCTION geometric_mean

   REAL FUNCTION harmonic_mean(x)

      REAL, INTENT(IN) :: x(:)

      !harmonic_mean = 1./mean(1./x)
      harmonic_mean = polynomial_mean(x, -1)

   END FUNCTION harmonic_mean

   REAL FUNCTION polynomial_mean(x, n)

      REAL, INTENT(IN) :: x(:)
      INTEGER, INTENT(IN) :: n

      polynomial_mean = mean(x**n)**n

   END FUNCTION polynomial_mean

   REAL FUNCTION weighted_mean(x, w)

      REAL, INTENT(IN) :: x(:)
      REAL, INTENT(IN) :: w(:)

      IF (size(x) .NE. size(w)) STOP 'WEIGHTED_MEAN: Error, data and weight arrays must be the same size'
      weighted_mean = sum(w*x)/sum(w)

   END FUNCTION weighted_mean

   REAL FUNCTION variance(x)

      ! Note that depending on the application one might want to use n-1 here
      ! Difference is between sample variance and population varaince
      ! See https://en.wikipedia.org/wiki/Bessel%27s_correction
      ! Sample is simply the variance of your sample 1/N
      ! However, if you are estimating the population variance then you need 1/(N-1)
      REAL, INTENT(IN) :: x(:)

      variance = mean((x-mean(x))**2)
      !variance = mean(x**2)-mean(x)**2 ! Could also use this

   END FUNCTION variance

   REAL FUNCTION standard_deviation(x)

      ! Square root of variance
      REAL, INTENT(IN) :: x(:)

      standard_deviation = sqrt(variance(x))

   END FUNCTION standard_deviation

   REAL FUNCTION root_mean_square(x)

      ! Same as the standard deviation if the mean is zero
      REAL, INTENT(IN) :: x(:)

      root_mean_square = sqrt(mean(x**2))

   END FUNCTION root_mean_square

   SUBROUTINE histogram(xmin, xmax, x, hist, n, data)

      USE table_integer
      REAL, INTENT(IN) :: xmin ! Minimum x value
      REAL, INTENT(IN) :: xmax ! Maximum x value
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:)       ! Output array of bin edges, size n+1
      INTEGER, ALLOCATABLE, INTENT(OUT) :: hist(:) ! Output integer array of bin counts, size n
      INTEGER, INTENT(IN) :: n    ! Number of bins
      REAL, INTENT(IN) :: data(:) ! Data to be binned
      INTEGER :: i, j, m

      m = size(data)

      WRITE (*, *) 'HISTOGRAM: Assiging arrays'

      ! Fill the table for the xrange and allocate the histogram array
      CALL fill_array(xmin, xmax, x, n+1)

      ! Set the histogram to zero
      IF (ALLOCATED(hist)) DEALLOCATE (hist)
      ALLOCATE (hist(n))
      hist = 0

      WRITE (*, *) 'HISTOGRAM: Constructing histogram'

      ! Make the histogram from the data
      DO i = 1, m
         IF (data(i) < xmin .OR. data(i) > xmax) THEN
            CYCLE
         ELSE
            ! TODO: Check ifind_linear is correct here
            j = find_table_integer(data(i), x, ifind_linear)
            hist(j) = hist(j)+1
         END IF
      END DO

      WRITE (*, *) 'HISTOGRAM: Fraction of data assigned to histogram:', real(sum(hist))/real(m)
      WRITE (*, *) 'HISTOGRAM: Done'
      WRITE (*, *)

   END SUBROUTINE histogram

   SUBROUTINE advanced_histogram(x_data, y_data, w_data, x_bins, y_bins, w_bins)

      USE table_integer
      REAL, INTENT(IN) :: x_data(:) ! x values for data (can be unordered)
      REAL, INTENT(IN) :: y_data(:) ! y values for data (can be unordered)
      REAL, INTENT(IN) :: w_data(:) ! weight for data
      REAL, INTENT(IN) :: x_bins(:) ! Ordered array of bin edges
      REAL, ALLOCATABLE, INTENT(OUT) :: y_bins(:) ! Output histogram heights
      REAL, ALLOCATABLE, INTENT(OUT) :: w_bins(:) ! Output sum of weights entering histogram
      INTEGER :: i_data, i_bins, n_data, n_bins
      INTEGER, PARAMETER :: ifind = ifind_split

      n_data = size(x_data)
      IF (n_data /= size(y_data)) STOP 'ADVANCED_HISTOGRAM: Error, x and y data should be the same size'
      IF (n_data /= size(w_data)) STOP 'ADVANCED_HISTOGRAM: Error, x and data weights should be the same size'

      n_bins = size(x_bins)-1
      ALLOCATE(y_bins(n_bins), w_bins(n_bins))
      y_bins = 0.
      w_bins = 0.

      DO i_data = 1, n_data
         i_bins = find_table_integer(x_data(i_data), x_bins, ifind)
         IF (i_bins > 0 .AND. i_bins <= n_bins) THEN
            y_bins(i_bins) = y_bins(i_bins)+y_data(i_data)*w_data(i_data)
            w_bins(i_bins) = w_bins(i_bins)+w_data(i_data)
         END IF
      END DO

   END SUBROUTINE advanced_histogram

   SUBROUTINE cumulative_distribution(x, p, c)

      USE calculus_table
      REAL, INTENT(IN) :: x(:)
      REAL, INTENT(IN) :: p(:)
      REAL, INTENT(OUT) :: c(:)
      REAL :: norm
      INTEGER :: i, n
      INTEGER, PARAMETER :: iorder=0 ! Zeroth-order (histogram) integration and plenty of points are best here

      n = size(x)
      IF (n /= size(p) .OR. n /= size(c)) STOP 'CUMULATIVE_DISTRIBUTION: Error, x, p and c should be same size'

      norm = integrate_table(x, p, 1, n, iorder)

      DO i = 1, n
         c(i) = integrate_table(x, p, 1, i, iorder)
      END DO

      c = c/norm

   END SUBROUTINE cumulative_distribution

   SUBROUTINE calculate_confidence(x, p, one_sigma, two_sigma)

      USE interpolate
      REAL, INTENT(IN) :: x(:)
      REAL, INTENT(IN) :: p(:)
      REAL, INTENT(OUT) :: one_sigma(2)
      REAL, INTENT(OUT) :: two_sigma(2)
      REAL :: ans, ci
      REAL, ALLOCATABLE :: c(:)
      INTEGER :: i, n
      INTEGER, PARAMETER :: iorder = 3
      INTEGER, PARAMETER :: ifind = 3
      INTEGER, PARAMETER :: imeth = 2

      n = size(x)
      IF (n /= size(p)) STOP 'CALCULATE_CONFIDENCE: Error, x and p should be same size'
      ALLOCATE(c(n))

      CALL cumulative_distribution(x, p, c)

      DO i = 1, 4

         IF (i == 1) THEN
            ci = 0.5*(1.-erf(2./sqrt(2.))) ! ~0.025
         ELSE IF (i == 2) THEN
            ci = 1.-ci ! ~0.975
         ELSE IF(i == 3) THEN
            ci = 0.5*(1.-erf(1./sqrt(2.))) ! ~0.16
         ELSE IF(i == 4) THEN
            ci = 1.-ci ! ~0.84
         ELSE
            STOP 'CALCULATE_CONFIDENCE: Error, something went wrong'
         END IF

         ans = find(ci, c, x, n, iorder, ifind, imeth)

         IF(i==1) THEN
            two_sigma(1) = ans
         ELSE IF(i==2) THEN
            two_sigma(2) = ans
         ELSE IF(i==3) THEN
            one_sigma(1) = ans
         ELSE IF(i==4) THEN
            one_sigma(2) = ans
         ELSE
            STOP 'CALCULATE_CONFIDENCE: Error, something went wrong'
         END IF

      END DO

   END SUBROUTINE calculate_confidence

   REAL FUNCTION parameter_probability(p, model, x_data, y_data, sigma_data)

      ! Calculate the probability of parameter p in model fitting the data assuming data uncorrelated
      REAL, INTENT(IN) :: p             ! Parameter value
      REAL, EXTERNAL :: model           ! Model function
      REAL, INTENT(IN) :: x_data(:)     ! x values for data
      REAL, INTENT(IN) :: y_data(:)     ! y values for data
      REAL, INTENT(IN) :: sigma_data(:) ! Error bar for data
      REAL :: y, chi2
      INTEGER :: i, n

      INTERFACE
         FUNCTION model(x, pin)
            REAL, INTENT(IN) :: x
            REAL, INTENT(IN) :: pin
         END FUNCTION model
      END INTERFACE

      n = size(x_data)
      IF (n /= size(y_data) .OR. n /= size(sigma_data)) THEN
         STOP 'PARAMETER_PROBABILITY: Error, x_data, y_data and sigma_data should all be the same size'
      END IF

      chi2=0.
      DO i=1,n
         y = model(x_data(i), p)
         chi2 = chi2+((y-y_data(i))/sigma_data(i))**2
      END DO

      parameter_probability=exp(-chi2/2.)

   END FUNCTION parameter_probability

END MODULE statistics

MODULE multidark_stuff

   USE array_operations
   USE string_operations
   USE file_info
   USE table_integer

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: read_multidark_halo_catalogue
   PUBLIC :: read_multidark_particles
   PUBLIC :: write_multidark_halo_catalogue
   PUBLIC :: multidark_snapshot
   PUBLIC :: multidark_scale_factor
   PUBLIC :: nearest_multidark_snapshot
   PUBLIC :: nearest_multidark_snapshot_sig8

   PUBLIC :: column_Mvir
   PUBLIC :: column_Mtot
   PUBLIC :: column_M200
   PUBLIC :: column_M200c
   PUBLIC :: column_M500c
   PUBLIC :: column_M2500c

   ! Available Multidark scale factors
   REAL, PARAMETER :: as(35) = [0.257, 0.287, 0.318, 0.348, 0.378, 0.409, 0.439, &
                                 0.470, 0.500, 0.530, 0.561, 0.591, 0.621, 0.652, &
                                 0.682, 0.713, 0.728, 0.743, 0.758, 0.773, 0.788, &
                                 0.804, 0.819, 0.834, 0.849, 0.864, 0.880, 0.895, &
                                 0.910, 0.925, 0.940, 0.956, 0.971, 0.986, 1.001]

   ! Snapshots corresponding to scale factors
   INTEGER, PARAMETER :: snaps(35) = [36, 38, 40, 42, 44, 46, 48, &
                                       50, 52, 54, 56, 58, 60, 62, &
                                       64, 66, 67, 68, 69, 70, 71, &
                                       72, 73, 74, 75, 76, 77, 78, &
                                       79, 80, 81, 82, 83, 84, 85]

   ! sigma8 values corresponding to scale factors
   REAL, PARAMETER :: sig8s(35) = [0.275, 0.306, 0.338, 0.368, 0.398, 0.428, 0.456, &
                                    0.484, 0.511, 0.536, 0.562, 0.586, 0.609, 0.631, &
                                    0.652, 0.673, 0.682, 0.692, 0.701, 0.710, 0.718, &
                                    0.727, 0.736, 0.744, 0.752, 0.759, 0.767, 0.774, &
                                    0.781, 0.788, 0.795, 0.802, 0.808, 0.814, 0.820]

   ! Halo catalogue files
   ! TODO: Note that Rockstar catalogues have 6 mass entries, while BDMV only have 2 mass entries
   ! NOTE: Only have BDMV catalogues for Bolshoi
   INTEGER, PARAMETER :: column_Mvir = 1
   INTEGER, PARAMETER :: column_Mtot = 2
   INTEGER, PARAMETER :: column_M200 = 3
   INTEGER, PARAMETER :: column_M200c = 4
   INTEGER, PARAMETER :: column_M500c = 5
   INTEGER, PARAMETER :: column_M2500c = 6 

   ! Snapshot finding
   INTEGER, PARAMETER :: ifind_snap = ifind_split
   REAL, PARAMETER :: eps_snap = 0.

CONTAINS

   ! SUBROUTINE read_multidark_haloes(infile, mmin, x, m, n)

   !    ! TODO: Remove, this is unnecessary if you use the SQL interface
   !    IMPLICIT NONE
   !    CHARACTER(len=*), INTENT(IN) :: infile      ! File to read in
   !    REAL, INTENT(IN) :: mmin                    ! Minimum halo virial mass [Msun/h]
   !    REAL, ALLOCATABLE, INTENT(OUT) :: x(:, :)    ! Position array [Mpc/h]
   !    REAL, ALLOCATABLE, INTENT(OUT) :: m(:, :)    ! Virial halo mass [Msun/h]
   !    INTEGER, INTENT(OUT) :: n                   ! Total number of haloes
   !    LOGICAL :: lexist
   !    INTEGER :: i, j
   !    INTEGER :: p, pid
   !    REAL :: mm!, c
   !    REAL, ALLOCATABLE :: data(:)

   !    INTEGER, PARAMETER :: hash_lines = 58 ! Number of lines beginning with # (Both Multidark and Bolshoi have 58)
   !    !REAL, PARAMETER :: mmin=1.74e12     ! Minimum halo mass [Msun/h] (corresponds to N>200 for MDR1; 1e12 would mean n~115)
   !    !INTEGER, PARAMETER :: columns=73       ! Total number of columns in file
   !    INTEGER, PARAMETER :: columns = 41       ! Total number of columns to read from file (weird errors if this is set to 73)
   !    INTEGER, PARAMETER :: column_pid = 6     ! Column for PID (-1 if unique halo)
   !    INTEGER, PARAMETER :: column_mv = 11     ! Column for virial mass (unbinding done) [Msun/h]
   !    INTEGER, PARAMETER :: column_x = 18      ! Column for x position [Mpc/h]
   !    INTEGER, PARAMETER :: column_y = 19      ! Column for y position [Mpc/h]
   !    INTEGER, PARAMETER :: column_z = 20      ! Column for z position [Mpc/h]
   !    INTEGER, PARAMETER :: column_vx = 21     ! Column for vx position [km/s]
   !    INTEGER, PARAMETER :: column_vy = 22     ! Column for vy position [km/s]
   !    INTEGER, PARAMETER :: column_vz = 23     ! Column for vz position [km/s]
   !    INTEGER, PARAMETER :: column_mvu = 37    ! Column for total virial mass (no unbinding) [Msun/h]
   !    INTEGER, PARAMETER :: column_m200 = 38   ! Column for M200 [Msun/h]
   !    INTEGER, PARAMETER :: column_m200c = 39  ! Column for M200 critical [Msun/h]
   !    INTEGER, PARAMETER :: column_m500c = 40  ! Column for M500 critical [Msun/h]
   !    INTEGER, PARAMETER :: column_m2500c = 41 ! Column for M2500 critical [Msun/h]

   !    ! Check file exists
   !    INQUIRE (file=infile, exist=lexist)
   !    IF (.NOT. lexist) THEN
   !       WRITE (*, *) 'READ_MULTIDARK_HALOES: Error, catalogue file does not exist: ', trim(infile)
   !       STOP
   !    END IF

   !    ! Welcome message
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Reading in halo catalogue: ', trim(infile)

   !    ! Find file length
   !    n = file_length(infile, verbose=.FALSE.)
   !    n = n-hash_lines

   !    ! Allocate the data array with the total number of columns so that you can read in a full line
   !    ALLOCATE (data(columns))

   !    ! Count unique haloes
   !    p = 0 ! Set sum variable to zero
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Total number of haloes:', n
   !    OPEN (7, file=infile)
   !    DO i = 1, hash_lines
   !       READ (7, *)
   !    END DO
   !    DO i = 1, n
   !       READ (7, *) (data(j), j=1, columns)
   !       mm = data(column_mv) ! Read virial mass
   !       pid = nint(data(column_pid))
   !       IF (mm > mmin .AND. pid == -1) p = p+1
   !    END DO
   !    CLOSE (7)
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Minimum allowed halo mass [Msun/h]:', mmin
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Total number of distinct haloes:', p
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Fraction of distinct haloes:', REAL(p)/REAL(n)

   !    ALLOCATE (x(3, p), m(6, p))
   !    x = 0.
   !    m = 0.

   !    ! Fill arrays with unique halo properties
   !    p = 0 ! Reset sum variable to zero
   !    OPEN (7, file=infile)
   !    DO i = 1, hash_lines
   !       READ (7, *)
   !    END DO
   !    DO i = 1, n
   !       ! Virial mass is column 11, x,y,z positions are columns 18,19,20
   !       ! Halo is unique iff pid=-1 (pid is column 6)
   !       READ (7, *) (data(j), j=1, columns)
   !       mm = data(column_mv)
   !       pid = nint(data(column_pid))
   !       IF (mm > mmin .AND. pid == -1) THEN
   !          p = p+1
   !          !WRITE(*,*) p
   !          x(1, p) = data(column_x)
   !          x(2, p) = data(column_y)
   !          x(3, p) = data(column_z)
   !          m(1, p) = data(column_mv)
   !          m(2, p) = data(column_mvu)
   !          m(3, p) = data(column_m200)
   !          m(4, p) = data(column_m200c)
   !          m(5, p) = data(column_m500c)
   !          m(6, p) = data(column_m2500c)
   !       END IF
   !    END DO
   !    CLOSE (7)

   !    ! Set the total output number
   !    n = p

   !    ! Write min/max values to screen
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Minimum x [Mpc/h]:', MINVAL(x(1, :))
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Maximum x [Mpc/h]:', MAXVAL(x(1, :))
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Minimum y [Mpc/h]:', MINVAL(x(2, :))
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Maximum y [Mpc/h]:', MAXVAL(x(2, :))
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Minimum z [Mpc/h]:', MINVAL(x(3, :))
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Maximum z [Mpc/h]:', MAXVAL(x(3, :))
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Minimum virial halo mass [Msun/h]:', MINVAL(m(1, :))
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Maximum virial halo mass [Msun/h]:', MAXVAL(m(1, :))
   !    WRITE (*, *) 'READ_MULTIDARK_HALOES: Done'
   !    WRITE (*, *)

   ! END SUBROUTINE read_multidark_haloes

   SUBROUTINE read_multidark_halo_catalogue(infile, x, m, n)

      ! New version for halo catalogues downloaded via https://www.cosmosim.org/query
      CHARACTER(len=*), INTENT(IN) :: infile
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:, :)
      REAL, ALLOCATABLE, INTENT(OUT) :: m(:, :)
      INTEGER, INTENT(OUT) :: n
      INTEGER :: i, j, crap, nmass

      IF (snippet_in_string('rockstar', infile)) THEN
         nmass = 6
      ELSE
         nmass = 2
      END IF

      n = file_length(infile, verbose=.FALSE.)
      n = n-1 ! Remove comment line
      ALLOCATE (x(3, n), m(nmass, n))

      WRITE (*, *) 'READ_MULTIDARK_HALO_CATALOGUE: ', trim(infile)
      WRITE (*, *) 'READ_MULTIDARK_HALO_CATALOGUE: Number of haloes:', n
      OPEN (7, file=infile, status='old')
      READ (7, *) ! Comment line
      DO i = 1, n
         READ (7, *) crap, (x(j, i), j=1,3), (m(j, i), j=1,nmass)
      END DO
      CLOSE (7)
      WRITE (*, *) 'READ_MULTIDARK_HALO_CATALOGUE: Done'
      WRITE (*, *)

   END SUBROUTINE read_multidark_halo_catalogue

   SUBROUTINE write_multidark_halo_catalogue(outfile, x, m, idx)

      CHARACTER(len=*), INTENT(IN) :: outfile
      REAL, INTENT(IN) :: x(:, :)
      REAL, INTENT(IN) :: m(:, :)
      INTEGER, INTENT(IN) :: idx(:)
      INTEGER :: i, j, k
      INTEGER :: nd, nm, n

      nd = size(x, 1)
      nm = size(m, 1)
      n = size(x, 2)

      ! Write out the little catalogue
      WRITE (*, *) 'WRITE_MULTIDARK_HALO_CATALOGUE: Writing outfile: ', trim(outfile)
      OPEN (7, file=outfile)
      DO i = 1, n
         j = idx(n+1-i)
         WRITE (7, *) (x(k, j), k=1, nd), (m(k, j), k=1,nm)
      END DO
      CLOSE (7)
      WRITE (*, *) 'WRITE_MULTIDARK_HALO_CATALOGUE: Done'
      WRITE (*, *)

   END SUBROUTINE write_multidark_halo_catalogue

   SUBROUTINE read_multidark_particles(infile, x, n)

      CHARACTER(len=*), INTENT(IN) :: infile
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:, :)
      INTEGER, INTENT(OUT) :: n
      INTEGER :: i
      REAL :: crap

      WRITE (*, *) 'READ_MULTIDARK_PARTICLES: ', trim(infile)

      n = file_length(infile, verbose=.FALSE.)
      n = n-1 ! First line is comment
      ALLOCATE (x(3, n))

      WRITE (*, *) 'READ_MULTIDARK_PARTICLES: Number of particles:', n
      OPEN (7, file=infile, status='old')
      READ (7, *) ! First line is comment
      DO i = 1, n
         READ (7, *) crap, x(1, i), x(2, i), x(3, i)
      END DO
      CLOSE (7)
      WRITE (*, *) 'READ_MULTIDARK_PARTICLES: Done'
      WRITE (*, *)

   END SUBROUTINE read_multidark_particles

   INTEGER FUNCTION multidark_snapshot(a)

      ! Exact multidark snapshot corresponding to a given scale factor
      REAL, INTENT(IN) :: a
      INTEGER :: i
      REAL, PARAMETER :: eps = eps_snap

      i = array_position(a, as, eps)
      IF (i == 0) THEN
         WRITE(*, *) 'MULTIDARK_SNAPSHOT: a:', a
         STOP 'MULTIDARK_SNAPSHOT: Error, no snapshot corresponding to the scale factor'
      ELSE
         multidark_snapshot = i
      END IF

   END FUNCTION multidark_snapshot

   REAL FUNCTION multidark_scale_factor(s)

      ! Multidark scale factor corresponding to a given snapshot
      ! Inverse function of multidark_snapshot
      INTEGER, INTENT(IN) :: s
      INTEGER ::  i

      IF (s == 416) THEN
         multidark_scale_factor = 1.000 ! This is actually Bolshoi, this is lazy
      ELSE
         i = array_position(s, snaps)
         IF (i == 0) THEN
            WRITE(*, *) 'MULTIDARK_SCALE_FACTOR: snapshot:', s
            STOP 'MULTIDARK_SNAPSHOT: Error, no scale factor corresponding to the snapshot'
         ELSE
            multidark_scale_factor = as(i)
         END IF
      ENDIF

   END FUNCTION multidark_scale_factor

   INTEGER FUNCTION nearest_multidark_snapshot(a)

      ! Nearest multidark snapshot to scale factor 'a' in terms of 'a' distance
      REAL, INTENT(IN) :: a
      INTEGER :: i
      INTEGER, PARAMETER :: ifind = ifind_snap

      i = nearest_table_integer(a, as, ifind)
      nearest_multidark_snapshot = snaps(i)

   END FUNCTION nearest_multidark_snapshot

   INTEGER FUNCTION nearest_multidark_snapshot_sig8(sig8)

      ! Nearest multidark snapshot to scale factor in terms of 'sigma_8' distance
      REAL, INTENT(IN) :: sig8
      INTEGER :: i
      INTEGER, PARAMETER :: ifind = ifind_snap

      i = nearest_table_integer(sig8, sig8s, ifind)
      nearest_multidark_snapshot_sig8 = snaps(i)

   END FUNCTION nearest_multidark_snapshot_sig8

END MODULE multidark_stuff

MODULE simulations

   ! This module should contain only routines that pertain to simualtion particles specifically
   ! Anything that involves only the fields should go in field_operations.f90
   ! Each routine should take particle properties (e.g., positions) as an argument

   USE constants
   USE basic_operations
   USE array_operations
   USE table_integer
   USE interpolate
   USE field_operations

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: particle_bin
   PUBLIC :: particle_bin_average
   PUBLIC :: correlation_function
   PUBLIC :: create_mass_function
   PUBLIC :: halo_mass_cut
   PUBLIC :: halo_mass_weights
   PUBLIC :: compute_and_write_power_spectrum
   PUBLIC :: write_power_spectrum
   PUBLIC :: write_density_slice_ascii
   PUBLIC :: Zeldovich_ICs
   PUBLIC :: replace
   PUBLIC :: sharp_Fourier_density_contrast
   PUBLIC :: power_spectrum_particles
   PUBLIC :: cross_spectrum_particles
   PUBLIC :: folded_power_spectrum_particles
   PUBLIC :: combine_folded_power
   PUBLIC :: fold_particles

   PUBLIC :: generate_randoms
   PUBLIC :: generate_poor_glass
   PUBLIC :: generate_grid

   PUBLIC :: sparse_sample

   PUBLIC :: random_translation
   PUBLIC :: random_inversion
   PUBLIC :: random_rotation

   PUBLIC :: shot_noise
   PUBLIC :: shot_noise_simple
   PUBLIC :: shot_noise_mass
   PUBLIC :: shot_noise_k

   PUBLIC :: SOD
   PUBLIC :: find_pairs
   PUBLIC :: zshift
   PUBLIC :: write_slice_ascii
   PUBLIC :: write_adaptive_field

   PUBLIC :: random_halo_particles
   PUBLIC :: make_HOD

   ! Random NFW profile generation
   INTEGER, PARAMETER :: nr_random_NFW = 65
   INTEGER, PARAMETER :: iorder_random_NFW = 3
   INTEGER, PARAMETER :: ifind_random_NFW = ifind_split
   INTEGER, PARAMETER :: iinterp_random_NFW = iinterp_Lagrange

   INTERFACE particle_bin
      MODULE PROCEDURE particle_bin_2D
      MODULE PROCEDURE particle_bin_3D
   END INTERFACE particle_bin

   INTERFACE particle_bin_average
      MODULE PROCEDURE particle_bin_average_3D
   END INTERFACE particle_bin_average

   INTERFACE NGP
      MODULE PROCEDURE NGP_2D
      MODULE PROCEDURE NGP_3D
   END INTERFACE NGP

   INTERFACE CIC
      MODULE PROCEDURE CIC_2D
      MODULE PROCEDURE CIC_3D
   END INTERFACE CIC

CONTAINS

   SUBROUTINE correlation_function(rmin, rmax, r, xi, n, nr, x1, x2, w1, w2, n1, n2, L)

      ! Calculate the correlation function for the sample with positions 'x' and weights 'w'
      ! CARE: Removed double-precision sums
      USE table_integer
      INTEGER, INTENT(IN) :: n1, n2            ! Total numbers of particles
      INTEGER, INTENT(IN) :: nr                ! Required number of log-spaced bins
      REAL, INTENT(IN) :: rmin, rmax           ! Maximum and maximum distances to calculate xi for [Mpc/h]
      REAL, INTENT(OUT) :: r(nr)               ! Output array of r [Mpc/h]
      REAL, INTENT(OUT) :: xi(nr)              ! Output array of xi
      INTEGER, INTENT(OUT) :: n(nr)            ! Output array of number of pairs in bin     
      REAL, INTENT(IN) :: x1(3, n1), x2(3, n2) ! Particle position arrays [Mpc/h]
      REAL, INTENT(IN) :: w1(n1), w2(n2)       ! Particle weight arrays     
      REAL, INTENT(IN) :: L                    ! Periodic box size [Mpc/h]
      INTEGER :: i, i1, i2
      REAL, ALLOCATABLE :: rbin(:)
      REAL :: rpair, V, nbar1, nbar2, sum1, sum2
      REAL :: r8(nr), xi8(nr) ! TODO: Remove this crap with the 8 suffix

      INTEGER, PARAMETER :: ifind = ifind_split

      ! Allocate arrays and fill the bin edges
      CALL fill_array(log(rmin), log(rmax), rbin, nr+1)
      rbin = exp(rbin)

      ! Set these to zero as they will be used for sums
      r8 = 0.
      xi8 = 0.
      n = 0

      WRITE (*, *) 'CORRELATION_FUNCTION: Calculating correlation function'
      WRITE (*, *) 'CORRELATION_FUNCTION: Summing directly over pairs (slow)'

      ! Loop over first particle
      DO i1 = 1, n1

         ! Do not waste time with zero weights
         IF (w1(i1) == 0.) CYCLE

         ! Loop over second particle
         DO i2 = 1, n2

            ! Do not waste time with zero weights
            IF (w2(i2) == 0.) CYCLE

            ! Calculate the distance between the particle pair
            rpair = periodic_distance(x1(:, i1), x2(:, i2), L)

            ! Bin depending on the distance
            IF (rpair < rmin .OR. rpair > rmax) THEN
               CYCLE
            ELSE
               i = find_table_integer(rpair, rbin, ifind)
               r8(i) = r8(i)+rpair
               xi8(i) = xi8(i)+w1(i1)*w2(i2)
               n(i) = n(i)+1
            END IF

         END DO
      END DO

      WRITE (*, *) 'CORRELATION_FUNCTION: Done sum'

      sum1 = sum(w1)
      sum2 = sum(w2)
      nbar1 = sum1/L**3
      nbar2 = sum2/L**3

      WRITE (*, *) 'CORRELATION_FUNCTION: sum 1:', sum1
      WRITE (*, *) 'CORRELATION_FUNCTION: sum 2:', sum2
      WRITE (*, *) 'CORRELATION_FUNCTION: nbar 1:', nbar1
      WRITE (*, *) 'CORRELATION_FUNCTION: nbar 2:', nbar2
      WRITE (*, *) 'CORRELATION_FUNCTION: Doing final bit (not sure if this is correct)'

      ! Calculate the actual correlation functions from the sums above
      DO i = 1, nr
         IF (n(i) == 0) THEN
            r(i) = sqrt(rbin(i+1)*rbin(i))
            xi(i) = -1.
         ELSE
            r(i) = real(r8(i))/real(n(i))
            V = 4.*pi*(rbin(i+1)-rbin(i))*r(i)**2
            xi(i) = -1.+real(xi8(i))/(sum1*sum2*V/L**3)
         END IF
      END DO

      WRITE (*, *) 'CORRELATION_FUNCTION: Done'
      WRITE (*, *)

   END SUBROUTINE correlation_function

   SUBROUTINE create_mass_function(mmin, mmax, halo_masses, n_haloes, mass_bins, mass_function, n_bins, L)

      USE statistics

      INTEGER, INTENT(IN) :: n_haloes                    ! Total number of haloes
      REAL, INTENT(IN) :: mmin                           ! Minimum halo mass for the mass function [Msun/h]
      REAL, INTENT(IN) :: mmax                           ! Maximum halo mass for the mass function [Msun/h]
      REAL, INTENT(IN) :: halo_masses(n_haloes)          ! Array of halo masses [Msun/h] 
      REAL, ALLOCATABLE, INTENT(OUT) :: mass_bins(:)     ! Mass function bin values [Msun/h]
      REAL, ALLOCATABLE, INTENT(OUT) :: mass_function(:) ! Mass function
      INTEGER, INTENT(IN) :: n_bins                      ! Number of bins in mass function
      REAL, INTENT(IN) :: L                              ! Simulation volume [Mpc/h]
      INTEGER :: i
      REAL, ALLOCATABLE :: mass_bin_edges(:)
      INTEGER, ALLOCATABLE :: counts(:)

      CALL histogram(log(mmin), log(mmax), mass_bin_edges, counts, n_bins, log(halo_masses))
      mass_bin_edges = exp(mass_bin_edges)

      ALLOCATE (mass_bins(n_bins))
      ALlOCATE (mass_function(n_bins))

      DO i = 1, n_bins
         mass_bins(i) = sqrt(mass_bin_edges(i)*mass_bin_edges(i+1))
         mass_function(i) = real(counts(i))/((mass_bin_edges(i+1)-mass_bin_edges(i))*L**3)
      END DO

   END SUBROUTINE create_mass_function

   SUBROUTINE halo_mass_cut(mmin, mmax, x, m, n)

      REAL, INTENT(IN) :: mmin
      REAL, INTENT(IN) :: mmax
      REAL, ALLOCATABLE, INTENT(INOUT) :: x(:, :)
      REAL, ALLOCATABLE, INTENT(INOUT) :: m(:)
      INTEGER, INTENT(INOUT) :: n
      REAL :: x_store(3, n), m_store(n)
      INTEGER :: i, j, n_store

      WRITE (*, *) 'HALO_MASS_CUT: Number of haloes before cut:', n
      IF (minval(m) == 0.) THEN
         WRITE (*, *) 'HALO_MASS_CUT: Minimum halo mass before cut [Msun/h]:', minval(m)
      ELSE
         WRITE (*, *) 'HALO_MASS_CUT: Minimum halo mass before cut log10([Msun/h]):', log10(minval(m))
      END IF    
      WRITE (*, *) 'HALO_MASS_CUT: Maximum halo mass before cut log10([Msun/h]):', log10(maxval(m))
      WRITE (*, *) 'HALO_MASS_CUT: Minimum mass for cut log10([Msun/h]):', log10(mmin)
      WRITE (*, *) 'HALO_MASS_CUT: Maximum mass for cut log10([Msun/h]):', log10(mmax)

      ! Initially store the initial values of the inputs
      x_store = x
      m_store = m
      n_store = n

      ! Find how many haloes satisfy this cut
      n = 0
      DO i = 1, n_store
         IF (m_store(i) > mmin .AND. m_store(i) < mmax) THEN
            n = n+1
         END IF
      END DO

      WRITE (*, *) 'HALO_MASS_CUT: Number of haloes after cut:', n

      ! Deallocate and reallocate input arrays
      DEALLOCATE (x, m)
      ALLOCATE (x(3, n), m(n))

      ! Now fill up arrays for output
      j = 0
      DO i = 1, n_store
         IF (m_store(i) > mmin .AND. m_store(i) < mmax) THEN
            j = j+1
            x(:, j) = x_store(:, i)
            m(j) = m_store(i)
         END IF
      END DO

      WRITE (*, *) 'HALO_MASS_CUT: Minimum halo mass after cut log10([Msun/h]):', log10(minval(m))
      WRITE (*, *) 'HALO_MASS_CUT: Maximum halo mass after cut log10([Msun/h]):', log10(maxval(m))
      WRITE (*, *) 'HALO_MASS_CUT: Done'
      WRITE (*, *)

   END SUBROUTINE halo_mass_cut

   SUBROUTINE halo_mass_weights(mmin, mmax, m, w)

      ! Set the weight, w(i), to one if the halo is in the mass range, zero otherwise
      REAL, INTENT(IN) :: mmin
      REAL, INTENT(IN) :: mmax
      REAL, INTENT(IN) :: m(:)
      REAL, INTENT(OUT) :: w(:)
      INTEGER :: i, n

      n = size(m)
      IF (n .NE. size(w)) STOP 'HALO_MASS_WEIGHTS: Error, m and w must be the same size'

      w = 0.
      DO i = 1, n
         IF (m(i) >= mmin .AND. m(i) < mmax) w(i) = 1.
      END DO

   END SUBROUTINE halo_mass_weights

   SUBROUTINE compute_and_write_power_spectrum(x, L, m, nk, outfile)

      ! Compute and write the power spectrum out in some standard format
      REAL, INTENT(IN) :: x(:, :)    
      REAL, INTENT(IN) :: L
      INTEGER, INTENT(IN) :: m
      INTEGER, INTENT(IN) :: nk
      CHARACTER(len=*), INTENT(IN) :: outfile
      REAL, ALLOCATABLE :: k(:), Pk(:), sig(:), shotk(:)
      INTEGER, ALLOCATABLE :: nbin(:)
      REAL :: shot
      INTEGER :: n

      IF (size(x, 1) .NE. 3) STOP 'COMPUTE_AND_WRITE_POWER_SPECTRUM: Error, needs to be 3D'
      n = size(x, 2)

      ! Compute the power spectrum from the particle positions
      ! This is only correct if all particles have the same mass
      CALL power_spectrum_particles(x, L, m, nk, k, Pk, nbin, sig)

      ! Compute the shot noise assuming all particles have equal mass
      shot = shot_noise_simple(L, n)
      shotk = shot_noise_k(k, shot)

      CALL write_power_spectrum(k, Pk, shotk, nbin, sig, outfile)

   END SUBROUTINE compute_and_write_power_spectrum

   SUBROUTINE write_power_spectrum(k, Pk, shot, nbin, sig, outfile)

      REAL, INTENT(IN) :: k(:)
      REAL, INTENT(IN) :: Pk(:)
      REAL, INTENT(IN) :: shot(:)
      INTEGER, INTENT(IN) :: nbin(:)
      REAL, INTENT(IN) :: sig(:)
      CHARACTER(len=*), INTENT(IN) :: outfile
      INTEGER :: nk
      INTEGER :: u
      INTEGER :: ik

      ! Number of k elements
      nk = size(k)

      ! Write to screen
      WRITE (*, *) 'WRITE_POWER_SPECTRUM: Outfile: ', trim(outfile)
      WRITE (*, *) 'WRITE_POWER_SPECTRUM: Number of k points:', nk

      ! Write to file in standard format
      OPEN (newunit=u, file=outfile)
      DO ik = 1, nk
         IF (nbin(ik) == 0) CYCLE
         WRITE (u, *) k(ik), Pk(ik), shot(ik), nbin(ik), sig(ik)
      END DO
      CLOSE (u)

      ! Write to screen
      WRITE (*, *) 'WRITE_POWER_SPECTRUM: Done'
      WRITE (*, *)

   END SUBROUTINE write_power_spectrum

   SUBROUTINE power_spectrum_particles(x, L, m, nk, k, Pk, nbin, sig, kmin_opt, kmax_opt, linear_k)

      REAL, INTENT(IN) :: x(:, :)
      REAL, INTENT(IN) :: L
      INTEGER, INTENT(IN) :: m
      INTEGER, INTENT(IN) :: nk
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:)
      INTEGER, ALLOCATABLE, INTENT(OUT) :: nbin(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: sig(:)
      REAL, OPTIONAL, INTENT(IN) :: kmin_opt
      REAL, OPTIONAL, INTENT(IN) :: kmax_opt
      LOGICAL, OPTIONAL, INTENT(IN) :: linear_k
      COMPLEX :: dk(m, m, m)
      REAL :: kmin, kmax, kmin_def, kmax_def
      INTEGER :: n

      ! Default minimum and maximum wavenumbers
      kmin_def = twopi/L
      kmax_def = pi*m/L
      kmin = default_or_optional(kmin_def, kmin_opt)
      kmax = default_or_optional(kmax_def, kmax_opt)

      IF (size(x, 1) .NE. 3) STOP 'POWER_SPECTRUM_PARTICLES: Error, particles must be in 3D'
      n = size(x, 2)

      ! Convert the particle positions into a density field
      ! This assumes all particles have the same mass
      CALL sharp_Fourier_density_contrast(x, n, L, dk, m)

      ! Compute the power spectrum from the density field  
      CALL compute_power_spectrum(dk, dk, m, L, kmin, kmax, nk, k, Pk, nbin, sig, linear_k)

   END SUBROUTINE power_spectrum_particles

   SUBROUTINE folded_power_spectrum_particles(x, L, m, nk, k, Pk, nbin, sig, nfold_opt)

      ! TODO: Can it be ensured that k overlap between folds somehow?
      ! TODO: Combine measurements from different folds to get a reasonable total
      REAL, INTENT(IN) :: x(:, :)
      REAL, INTENT(IN) :: L
      INTEGER, INTENT(IN) :: m
      INTEGER, INTENT(IN) :: nk
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:, :)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:, :)
      INTEGER, ALLOCATABLE, INTENT(OUT) :: nbin(:, :)
      REAL, ALLOCATABLE, INTENT(OUT) :: sig(:, :)
      INTEGER, OPTIONAL, INTENT(IN) :: nfold_opt
      REAL, ALLOCATABLE :: xfold(:, :)
      REAL, ALLOCATABLE :: kfold(:), Pkfold(:), sigfold(:)
      REAL :: Lfold
      INTEGER, ALLOCATABLE :: nbinfold(:)
      INTEGER :: ifold
      INTEGER :: nfold
      INTEGER, PARAMETER :: nfold_def = 0
      LOGICAL, PARAMETER :: linear_k = .TRUE.

      ! Number of foldings
      nfold = default_or_optional(nfold_def, nfold_opt)
      IF (nfold < 0) STOP 'FOLDED_POWER_SPECTRUM_PARTICLES: Error, number of foldings must be zero or positive'

      ! Make a copy of the particle array to fold
      ! TODO: Expensive in memory
      xfold = x
      Lfold = L

      ! Allocate arrays
      ALLOCATE(k(nk, nfold+1), Pk(nk, nfold+1), nbin(nk, nfold+1), sig(nk, nfold+1))

      ! Loop over the folds
      DO ifold = 0, nfold

         ! Make a fold
         IF (ifold > 0) THEN
            CALL fold_particles(xfold, Lfold)
         END IF

         ! Compute power at this level of fold and correct for folding
         CALL power_spectrum_particles(xfold, Lfold, m, nk, kfold, Pkfold, nbinfold, sigfold)
         Pkfold = Pkfold*(L/Lfold)**3
         sigfold = sigfold*(L/Lfold)**3

         ! Fill arrays
         k(:, ifold+1) = kfold
         Pk(:, ifold+1) = Pkfold
         nbin(:, ifold+1) = nbinfold
         sig(:, ifold+1) = sigfold

      END DO

   END SUBROUTINE folded_power_spectrum_particles

   SUBROUTINE cross_spectrum_particles(x1, x2, L, m, nk, k, Pk, nbin, sig, kmin_opt, kmax_opt)

      USE FFT
      REAL, INTENT(IN) :: x1(:, :)
      REAL, INTENT(IN) :: x2(:, :)
      REAL, INTENT(IN) :: L
      INTEGER, INTENT(IN) :: m
      INTEGER, INTENT(IN) :: nk
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:)
      INTEGER, ALLOCATABLE, INTENT(OUT) :: nbin(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: sig(:)
      REAL, OPTIONAL, INTENT(IN) :: kmin_opt
      REAL, OPTIONAL, INTENT(IN) :: kmax_opt
      COMPLEX :: dk1(m, m, m), dk2(m, m, m)
      REAL :: kmin, kmax, kmin_def, kmax_def
      INTEGER :: n1, n2
      
      ! Default minimum and maximum wavenumbers
      kmin_def = twopi/L
      kmax_def = pi*m/L

      ! Check that array sizes make sense
      IF ((size(x1, 1) .NE. 3) .OR. (size(x2, 1) .NE. 3)) STOP 'CROSS_SPECTRUM_PARTICLES: Error, must be 3D'
      n1 = size(x1, 2)
      n2 = size(x2, 2)

      ! Convert the particle positions into a density field
      ! This assumes all particles have the same weight
      CALL sharp_Fourier_density_contrast(x1, n1, L, dk1, m)
      CALL sharp_Fourier_density_contrast(x2, n2, L, dk2, m)

      ! Compute the power spectrum from the density field     
      kmin = default_or_optional(kmin_def, kmin_opt)
      kmax = default_or_optional(kmax_def, kmax_opt)
      CALL compute_power_spectrum(dk1, dk2, m, L, kmin, kmax, nk, k, Pk, nbin, sig)

   END SUBROUTINE cross_spectrum_particles

   SUBROUTINE sharp_Fourier_density_contrast(x, n, L, dk, m)

      ! Bin particles and create the Fourier modes with appropriate sharpening for the binning strategy
      ! TODO: Upgrade to support both m and mn, m arrays
      USE FFT
      INTEGER, INTENT(IN) :: n, m
      REAL, INTENT(IN) :: x(3, n), L
      COMPLEX, INTENT(OUT) :: dk(m, m, m)
      REAL :: w(n), dbar
      REAL :: d(m, m, m)
      COMPLEX :: dk_out(m, m, m)
      INTEGER, PARAMETER :: ibin = 2 ! 2 - CIC binning

      ! Bin the particles with equal weight to create the particle-number field in cells [dimensionless]
      w = 1.
      CALL particle_bin(x, n, L, w, d, m, ibin, all=.TRUE., periodic=.TRUE., verbose=.TRUE.)

      ! Now compute the mean particle number density in a cell [dimensionless]
      dbar = real(n)/real(m)**3

      ! Convert the particle-number field to the density-contrast field [dimensionless]
      d = d/dbar

      ! Do the Fourier Transform, no normalisation
      dk = d
      CALL fft3(dk, dk_out, m, m, m, -1)
      dk = dk_out

      ! Sharpen the Fourier Transform for the binning
      CALL sharpen_k(dk, ibin)

   END SUBROUTINE sharp_Fourier_density_contrast

   SUBROUTINE write_density_slice_ascii(x, n, z1, z2, L, m, outfile)

      ! Write out a slice of density field
      INTEGER, INTENT(IN) :: n   ! Number of particles
      REAL, INTENT(IN) :: x(3, n) ! Particle positions  
      REAL, INTENT(IN) :: z1     ! Starting point for slab
      REAL, INTENT(IN) :: z2     ! Starting point for slab
      REAL, INTENT(IN) :: L      ! Simulation box size
      INTEGER, INTENT(IN) :: m   ! Mesh size for output
      CHARACTER(len=*), INTENT(IN) :: outfile ! Output file name
      REAL :: d(m, m)
      REAL :: xp, yp, smoothing
      INTEGER :: i, j

      ! Make the projected 2D density
      CALL make_projected_density(x, n, z1, z2, L, d, m)

      ! Smooth the density field
      smoothing = L/real(m) !Set the smoothing scale to be the mesh size
      CALL smooth(d, m, smoothing, L)

      ! Write out to file
      WRITE (*, *) 'WRITE_DENSITY_SLICE_ASCII: Writing density map'
      WRITE (*, *) 'WRITE_DENSITY_SLICE_ASCII: File: ', trim(outfile)
      OPEN (9, file=outfile)
      DO i = 1, m
         DO j = 1, m
            xp = cell_position(i, L, m)
            yp = cell_position(j, L, m)
            WRITE (9, *) xp, yp, d(i, j)
         END DO
      END DO
      CLOSE (9)

      WRITE (*, *) 'WRITE_DENSITY_SLICE_ASCII: Done'
      WRITE (*, *)

   END SUBROUTINE write_density_slice_ascii

   SUBROUTINE make_projected_density(x, n, z1, z2, L, d, m)

      ! Write out a slice of density field
      INTEGER, INTENT(IN) :: m ! Mesh
      INTEGER, INTENT(IN) :: n ! Number of particles
      REAL, INTENT(IN) :: x(3, n) ! Particle positions   
      REAL, INTENT(IN) :: z1 ! Starting z for slab
      REAL, INTENT(IN) :: z2 ! Finishing z for slab
      REAL, INTENT(IN) :: L  ! Length of simulation
      REAL, INTENT(OUT) :: d(m, m) ! Projected density field   
      REAL :: vfac, dbar
      REAL, ALLOCATABLE :: x2D(:, :), w2D(:)
      INTEGER :: i, i2D, n2D
      INTEGER, PARAMETER :: ibin = 2 ! 2 - CIC binning

      ! Count the number of particles falling into the slice
      n2D = 0
      DO i = 1, n
         IF (x(3, i) >= z1 .AND. x(3, i) <= z2) n2D = n2D+1
      END DO
      ALLOCATE (x2D(2, n2D))

      ! Make the 2D position array
      i2D = 0
      DO i = 1, n
         IF (x(3, i) >= z1 .AND. x(3, i) <= z2) THEN
            i2D = i2D+1
            x2D(1, i2D) = x(1, i)
            x2D(2, i2D) = x(2, i)
         END IF
      END DO

      ! Bin for the 2D density field and convert to relative density
      ALLOCATE (w2D(n2D))
      w2D = 1.
      CALL particle_bin(x2D, n2D, L, w2D, d, m, ibin, all=.TRUE., periodic=.TRUE., verbose=.TRUE.)
      DEALLOCATE (x2D)
      vfac = (z2-z1)/L
      dbar = (real(n)*vfac)/real(m**2)
      d = d/dbar

      ! Write useful things to screen
      WRITE (*, *) 'MAKE_PROJECTED_DENSITY: Thickness in z [Mpc/h]:', z2-z1
      WRITE (*, *) 'MAKE_PROJECTED_DENSITY: Volume factor:', vfac
      WRITE (*, *) 'MAKE_PROJECTED_DENSITY: Mean cell particle density:', dbar
      WRITE (*, *) 'MAKE_PROJECTED_DENSITY: Done'
      WRITE (*, *)

   END SUBROUTINE make_projected_density

   SUBROUTINE Zeldovich_ICs(x, v, L, k_tab, Pk_tab, vfac, m)

      ! Generate Zeldovich displacement fields and move particles
      REAL, INTENT(INOUT) :: x(:, :)
      REAL, ALLOCATABLE, INTENT(OUT) :: v(:, :)
      REAL, INTENT(IN) :: L
      REAL, INTENT(IN) :: k_tab(:)
      REAL, INTENT(IN) :: Pk_tab(:)
      REAL, INTENT(IN) :: vfac
      INTEGER, INTENT(IN) :: m 
      REAL :: ips, maxf
      INTEGER :: n
      REAL, ALLOCATABLE :: f(:, :, :, :)
      INTEGER, PARAMETER :: dim = 3

      ! Check array dimensions
      IF ((size(x, 1) .NE. dim)) STOP 'ZELDOVICH_ICS: Error, x must be three dimensional'

      ! Make the displacement field
      CALL generate_displacement_fields(f, m, L, k_tab, Pk_tab)

      ! Calculate some useful things
      n = size(x, 2)
      ips = L/real(n**(1./3.)) ! Mean ID inter-particle spacing
      maxf = maxval(f)         ! Maximum value of 1D displacement

      ! Calculate the particle velocities first
      ALLOCATE(v(3, n))
      CALL Zeldovich_velocity(x, v, vfac*f, L)

      ! Then do the particle positions
      CALL Zeldovich_displacement(x, f, L)

      ! Write some useful things to the screen
      WRITE (*, *) 'ZELDOVICH_ICS: Max 1D displacement [Mpc/h]:', maxf
      WRITE (*, *) 'ZELDOVICH_ICS: Inter-particle spacing [Mpc/h]:', ips
      WRITE (*, *) 'ZELDOVICH_ICS: Max 1D displacement in units of the IPS:', maxf/ips
      WRITE (*, *) 'ZELDOVICH_ICS: Done'
      WRITE (*, *)

   END SUBROUTINE Zeldovich_ICs

   SUBROUTINE Zeldovich_displacement(x, s, L)

      ! Displace particles using the Zeldovich approximation given a displacement field
      ! TODO: Could do CIC reverse interpolation here
      REAL, INTENT(INOUT) :: x(:, :)    ! Initial and final particle positions [Mpc/h]
      REAL, INTENT(IN) :: s(:, :, :, :) ! Dispalcement field [Mpc/h]
      REAL, INTENT(IN) :: L             ! Box size [Mpc/h]
      INTEGER :: i, j, ix(3)
      INTEGER :: n, m
      INTEGER, PARAMETER :: dim = 3

      ! Check fields are 3D
      IF (size(x, 1) .NE. dim) STOP 'ZELDOVICH_DISPLACEMENTS: Error, only works in three dimensions'
      IF (size(s, 1) .NE. dim) STOP 'ZELDOVICH_DISPLACEMENTS: Error, only works in three dimensions'

      ! Total number of particles
      n = size(x, 2)
      m = size(s, 2)
      IF ((m .NE. size(s, 3)) .OR. (m .NE. size(s, 4))) STOP 'ZELDOVICH_DISPLACEMENTS: Error, displacement field must be square'

      WRITE (*, *) 'ZELDOVICH_DISPLACEMENT: Displacing particles'

      ! Loop over all particles
      DO i = 1, n
         DO j = 1, 3
            ix(j) = NGP_cell(x(j, i), L, m) ! Find the integer-coordinates for which cell you are in
         END DO
         x(:, i) = x(:, i)+s(:, ix(1), ix(2), ix(3)) ! Do the displacement
      END DO

      WRITE (*, *) 'ZELDOVICH_DISPLACEMENT: Done'
      WRITE (*, *)

      ! Replace particles that may have strayed
      CALL replace(x, L)

   END SUBROUTINE Zeldovich_displacement

   SUBROUTINE Zeldovich_velocity(x, v, s, L)

      ! Give particles velocities from a velocity field
      ! TODO: Could do CIC reverse interpolation here
      REAL, INTENT(IN) :: x(:, :)               ! Particle position array [Mpc/h]
      REAL, ALLOCATABLE, INTENT(OUT) :: v(:, :) ! Particle velocity array [km/s]
      REAL, INTENT(IN) :: s(:, :, :, :)         ! Velocity field [km/s]
      REAL, INTENT(IN) :: L                     ! Box size [Mpc/h]
      INTEGER :: i, j, ix(3)
      INTEGER :: n, m
      INTEGER, PARAMETER :: dim = 3

      ! Check array dimensions
      IF ((dim .NE. size(x, 1)) .OR. (dim .NE. size(s, 1))) STOP 'ZELDOVICH_VELOCITY: This only works in three dimensions'
      IF ((size(s, 2) .NE. size(s, 3)) .OR. (size(s, 2) .NE. size(s, 4))) STOP 'ZELDOVICH_DISPLACEMENTS: Error, displacement field must be square'

      ! Array sizes
      n = size(x, 2)
      m = size(s, 2)

      ! Write to screen
      WRITE (*, *) 'ZELDOVICH_VELOCITY: Assigining particle velocties'
      WRITE (*, *) 'ZELDOVICH_VELOCITY: Number of particles:', n
      WRITE (*, *) 'ZELDOVICH_VELOCITY: Mesh size:', m
      WRITE (*, *) 'ZELDOVICH_VELOCITY: Box size [Mpc/h]:', L

      ! Allocate array for particle velocities
      ALLOCATE(v(dim, n))

      ! Loop over all particles
      DO i = 1, n
         DO j = 1, 3
            ix(j) = NGP_cell(x(j, i), L, m) ! Find the integer-coordinates for the cell
         END DO
         v(:, i) = s(:, ix(1), ix(2), ix(3)) ! Assign the velocity to the particles from the field
      END DO

      WRITE (*, *) 'ZELDOVICH_VELOCITY: Done'
      WRITE (*, *)

   END SUBROUTINE Zeldovich_velocity

   SUBROUTINE generate_randoms(x, L)

      ! Generate random x, y, z positions in a cube of size L^3
      USE random_numbers
      REAL, INTENT(OUT) :: x(:, :)
      REAL, INTENT(IN) :: L   
      INTEGER :: i, j
      INTEGER :: n, d
      REAL :: dx
      REAL, PARAMETER :: eps = 1e-6

      ! To prevent the particle being exactly at L
      dx = eps*L

      ! Write to screen
      n = size(x, 2)
      d = size(x, 1)
      WRITE (*, *) 'GENERATE_RANDOMS: Generating a uniform-random particle distribution'
      WRITE (*, *) 'GENERATE_RANDOMS: Number of particles:', n
      WRITE (*, *) 'GENERATE_RANDOMS: Number of dimensions:', d

      ! Loop over all particles and coordinates and assign randomly
      DO i = 1, n
         DO j = 1, d
            x(j, i) = random_uniform(0., L-dx)
         END DO
      END DO

      ! Write to screen
      WRITE (*, *) 'GENERATE_RANDOMS: Done'
      WRITE (*, *)

   END SUBROUTINE generate_randoms

   SUBROUTINE generate_grid(x, L)

      ! Generate a grid of positions in a cube of size L^3
      ! These positions will be the locations of cube centres that tessalate the volume
      REAL, INTENT(OUT) :: x(:, :)
      REAL, INTENT(IN) :: L    
      INTEGER :: ix, iy, iz, i, m, n
      INTEGER, PARAMETER :: dim = 3

      IF (size(x, 1) .NE. dim) STOP 'GENERATE_GRID: Error, this only works for a three-dimensional grid'

      ! Check that the particle number is cubic
      n = size(x, 2)
      m = nint(n**(1./3.))
      IF (m**3 .NE. n) STOP 'GENERATE_GRID: Error, you need a cubic number of particles for a grid'

      WRITE (*, *) 'GENERATE_GRID: Generating a grid particle distribution'
      WRITE (*, *) 'GENERATE_GRID: Number of particles (should be a cube number):', n
      WRITE (*, *) 'GENERATE_GRID: Mesh size:', m
      WRITE (*, *) 'GENERATE_GRID: Mesh size cubed (should eqaul number of particles):', m**3
      WRITE (*, *) 'GENERATE_GRID: Box size [Mpc/h]:', L

      ! Loop over all particles
      i = 0 ! Set the particle counting variable to zero
      DO iz = 1, m
         DO iy = 1, m
            DO ix = 1, m
               i = i+1 !Increment the particle counter
               x(1, i) = cell_position(ix, L, m)
               x(2, i) = cell_position(iy, L, m)
               x(3, i) = cell_position(iz, L, m)
            END DO
         END DO
      END DO

      ! Replace in case any end up on boundary
      CALL replace(x, L)

      WRITE (*, *) 'GENERATE_GRID: Done'
      WRITE (*, *)

   END SUBROUTINE generate_grid

   SUBROUTINE generate_poor_glass(x, L)

      ! Generate a poor man's glass in a cube of size L^3
      USE random_numbers
      REAL, INTENT(OUT) :: x(:, :) 
      REAL, INTENT(IN) :: L
      INTEGER :: i, j, m, n
      REAL :: dx
      INTEGER, PARAMETER :: dim = 3

      IF (size(x, 1) .NE. dim) STOP 'GENERATE_POOR_GLASS: Error, this only works in three dimensions'

      ! First genrate a grid
      CALL generate_grid(x, L)

      ! The cube-root of the number of particles
      n = size(x, 2)
      m = nint(n**(1./3.))

      ! How far can the particles be shifted in x, y, z
      ! They need to stay in their initial cube region
      dx = L/real(m)
      dx = dx/2.

      ! Write to screen
      WRITE (*, *) 'GENERATE_POOR_GLASS: Generating a poor man glass from the grid'
      WRITE (*, *) 'GENERATE_POOR_GLASS: Number of particles:', n
      WRITE (*, *) 'GENERATE_POOR_GLASS: Cube root of number of particles:', m
      WRITE (*, *) 'GENERATE_POOR_GLASS: Box size [Mpc/h]:', L
      WRITE (*, *) 'GENERATE_POOR_GLASS: Cell size [Mpc/h]', 2.*dx
      WRITE (*, *) 'GENERATE_POOR_GLASS: Maximum displacement [Mpc/h]', dx

      ! Loop over the particles and do the displacement
      DO i = 1, n
         DO j = 1, dim
            x(j, i) = x(j, i)+random_uniform(-dx, dx)
         END DO
      END DO

      ! Write to screen
      WRITE (*, *) 'GENERATE_POOR_GLASS: Done'
      WRITE (*, *)

   END SUBROUTINE generate_poor_glass

   SUBROUTINE sparse_sample(x, v, n, f)

      USE random_numbers
      REAL, ALLOCATABLE, INTENT(INOUT) :: x(:, :)
      REAL, ALLOCATABLE, INTENT(INOUT) :: v(:, :)
      REAL, INTENT(IN) :: f
      INTEGER, INTENT(INOUT) :: n
      REAL :: x_old(3, n), v_old(3, n)
      INTEGER :: keep(n), n_old, j, i

      n_old = n

      keep = 0
      n = 0

      STOP 'SPARSE_SAMPLE: Test this'

      WRITE (*, *) 'SPARSE_SAMPLE: Sparse sampling'

      DO i = 1, n_old

         IF (random_unit() < f) THEN
            n = n+1
            keep(i) = 1
         END IF

      END DO

      x_old = x
      v_old = v

      DEALLOCATE (x, v)
      ALLOCATE (x(3, n), v(3, n))

      j = 0

      DO i = 1, n_old

         IF (keep(i) == 1) THEN
            j = j+1
            x(1, j) = x_old(1, i)
            x(2, j) = x_old(2, i)
            x(3, j) = x_old(3, i)
            v(1, j) = v_old(1, i)
            v(2, j) = v_old(2, i)
            v(3, j) = v_old(3, i)
         END IF

      END DO

      WRITE (*, *) 'SPARSE_SAMPLE: Complete'
      WRITE (*, *) 'SPARSE_SAMPLE: Before:', n_old
      WRITE (*, *) 'SPARSE_SAMPLE: After:', n
      WRITE (*, *) 'SPARSE_SAMPLE: Ratio:', real(n)/real(n_old)
      WRITE (*, *)

   END SUBROUTINE sparse_sample

   SUBROUTINE replace(x, L, verbose)

      ! Ensures/enforces periodicity by cycling particles round that may have strayed
      ! This forces all particles to be 0<=x<L, so they cannot be exactly at x=L
      REAL, INTENT(INOUT) :: x(:, :)    
      REAL, INTENT(IN) :: L
      LOGICAL, OPTIONAL :: verbose
      INTEGER :: i, j
      INTEGER :: m

      IF (present_and_correct(verbose)) WRITE (*, *) 'REPLACE: Replacing particles that may have strayed'

      ! Loop over all particles and coordinates
      DO i = 1, size(x, 2)
         DO j = 1, size(x, 1)
            m = FLOOR(x(j, i)/L)
            x(j, i) = x(j, i)-m*L
            IF (x(j, i) == -0.) x(j, i) = 0.
         END DO
      END DO

      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'REPLACE: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE replace

   SUBROUTINE random_translation(x, n, L, verbose)

      USE random_numbers

      INTEGER, INTENT(IN) :: n
      REAL, INTENT(INOUT) :: x(3, n)    
      REAL, INTENT(IN) :: L
      LOGICAL, OPTIONAL :: verbose
      INTEGER :: i
      REAL :: T(3)

      IF (present_and_correct(verbose)) WRITE (*, *) 'RANDOM_TRANSLATION: Applying random translation'

      ! Calculate and apply the translations
      DO i = 1, 3
         T(i) = random_uniform(0., L)
         IF (present_and_correct(verbose)) THEN
            WRITE (*, *) 'RANDOM_TRANSLATION: Direction', i
            WRITE (*, *) 'RANDOM_TRANSLATION: Translation [Mpc/h]:', T(i)
         END IF
         x(i, :) = x(i, :)+T(i)
      END DO

      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'RANDOM_TRANSLATION: Done'
         WRITE (*, *)
      END IF

      ! Replace particles within the cube
      CALL replace(x, L, verbose)

   END SUBROUTINE random_translation

   SUBROUTINE random_inversion(x, n, L, verbose)

      USE random_numbers

      INTEGER, INTENT(IN) :: n
      REAL, INTENT(INOUT) :: x(3, n)
      REAL, INTENT(IN) :: L
      LOGICAL, OPTIONAL :: verbose
      INTEGER :: i
      INTEGER :: pm(3)

      IF (present_and_correct(verbose)) WRITE (*, *) 'RANDOM_INVERSION: Applying random inversion'

      ! Calculate and apply the translations
      DO i = 1, 3
         pm(i) = random_sign()
         IF (present_and_correct(verbose)) WRITE (*, *) 'RANDOM_INVERSION: Direction', i, 'Sign:', pm(i)
         x(i, :) = x(i, :)*pm(i)
      END DO

      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'RANDOM_INVERSION: Done'
         WRITE (*, *)
      END IF

      ! Replace particles within the cube
      CALL replace(x, L, verbose)

   END SUBROUTINE random_inversion

   SUBROUTINE random_rotation(x, n, verbose)

      ! Do a random rotation of the box by 90 degrees, I think this also captures inversions
      ! This way is memory efficient
      ! TODO: This raises an 'array temporary' warning because non-contiguous sections of x are passed to swap_arrays
      USE random_numbers

      INTEGER, INTENT(IN) :: n
      REAL, INTENT(INOUT) :: x(3, n)  
      LOGICAL, OPTIONAL :: verbose
      INTEGER :: type

      IF (present_and_correct(verbose)) WRITE (*, *) 'RANDOM_ROTATION: Applying random rotation'

      ! Choose random rotation
      type = random_integer(1, 6)

      ! Apply random rotation
      IF (type == 1) THEN
         IF (present_and_correct(verbose)) WRITE (*, *) 'RANDOM_ROTATION: Doing 123'
         ! Do nothing here
      ELSE IF (type == 2) THEN
         IF (present_and_correct(verbose)) WRITE (*, *) 'RANDOM_ROTATION: Doing 132'
         CALL swap_arrays(x(2, :), x(3, :)) ! Swap 2<->3 (123 -> 132)
      ELSE IF (type == 3) THEN
         IF (present_and_correct(verbose)) WRITE (*, *) 'RANDOM_ROTATION: Doing 213'
         CALL swap_arrays(x(1, :), x(2, :)) ! Swap 1<->2 (123 -> 213)
      ELSE IF (type == 4) THEN
         IF (present_and_correct(verbose)) WRITE (*, *) 'RANDOM_ROTATION: Doing 231'
         CALL swap_arrays(x(1, :), x(2, :)) ! Swap 1<->2 (123 -> 213)
         CALL swap_arrays(x(2, :), x(3, :)) ! Swap 2<->3 (213 -> 231)
      ELSE IF (type == 5) THEN
         IF (present_and_correct(verbose)) WRITE (*, *) 'RANDOM_ROTATION: Doing 312'
         CALL swap_arrays(x(2, :), x(3, :)) ! Swap 1<->2 (123 -> 132)
         CALL swap_arrays(x(1, :), x(2, :)) ! Swap 2<->3 (132 -> 312)
      ELSE IF (type == 6) THEN
         IF (present_and_correct(verbose)) WRITE (*, *) 'RANDOM_ROTATION: Doing 321'
         CALL swap_arrays(x(1, :), x(3, :)) ! Swap 1<->3 (123 -> 321)
      ELSE
         STOP 'RANDOM_ROTATION: Error, something went very wrong'
      END IF

      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'RANDOM_ROTATION: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE random_rotation

   SUBROUTINE particle_bin_2D(x, n, L, w, d, m, ibin, all, periodic, verbose)

      ! Bin particle properties onto a mesh, summing as you go
      ! TODO: Adapt for different lengths and different meshes in x,y
      INTEGER, INTENT(IN) :: n         ! Total number of particles
      INTEGER, INTENT(IN) :: m         ! Mesh size for density field
      REAL, INTENT(IN) :: x(2, n)       ! 2D particle positions    
      REAL, INTENT(IN) :: L            ! Area side length
      REAL, INTENT(IN) :: w(n)         ! Weight array for each particle
      REAL, INTENT(OUT) :: d(m, m)      ! Output of eventual 2D density field
      INTEGER, INTENT(IN) :: ibin      ! Binning strategy
      LOGICAL, INTENT(IN) :: all       ! Should all particles be contributing to the binning?
      LOGICAL, INTENT(IN) :: periodic  ! Is the volume periodic?
      LOGICAL, INTENT(IN) :: verbose   ! Verbose?

      IF (periodic .AND. (.NOT. all)) STOP 'PARTICLE_BIN_2D: Very strange to have periodic and not all particles contribute'

      IF (ibin == 1) THEN
         CALL NGP_2D(x, n, L, w, d, m, all, verbose)
      ELSE IF (ibin == 2) THEN
         CALL CIC_2D(x, n, L, w, d, m, all, periodic, verbose)
      ELSE
         STOP 'PARTICLE_BIN_2D: Error, ibin not specified correctly'
      END IF

   END SUBROUTINE particle_bin_2D

   SUBROUTINE particle_bin_3D(x, n, L, w, d, m, ibin, all, periodic, verbose)

      ! Bin particle properties onto a mesh, summing as you go
      INTEGER, INTENT(IN) :: n        ! Total number of particles
      INTEGER, INTENT(IN) :: m        ! Mesh size for density field
      REAL, INTENT(IN) :: x(3, n)      ! 3D particle positions  
      REAL, INTENT(IN) :: L           ! Volume side length
      REAL, INTENT(IN) :: w(n)        ! Weight array for each particle
      REAL, INTENT(INOUT) :: d(m, m, m) ! Output of eventual 3D density field
      INTEGER, INTENT(IN) :: ibin     ! Binning strategy
      LOGICAL, INTENT(IN) :: all      ! Should all particles be contributing to the binning?
      LOGICAL, INTENT(IN) :: periodic ! Is the volume periodic?
      LOGICAL, INTENT(IN) :: verbose  ! Verbose?

      IF (periodic .AND. (.NOT. all)) STOP 'PARTICLE_BIN_3D: Very strange to have periodic and not all particles contribute'

      IF (ibin == 1) THEN
         CALL NGP_3D(x, n, L, w, d, m, all, verbose)
      ELSE IF (ibin == 2) THEN
         CALL CIC_3D(x, n, L, w, d, m, all, periodic, verbose)
      ELSE
         STOP 'PARTICLE_BIN_3D: Error, ibin not specified correctly'
      END IF

   END SUBROUTINE particle_bin_3D

   SUBROUTINE particle_bin_average_3D(x, n, L, w, d, m, ibin, all, periodic)

      ! Bin particle properties onto a mesh, averaging properties over cells
      ! TODO: This should probably not be used if there are any empty cells
      INTEGER, INTENT(IN) :: n, m
      REAL, INTENT(IN) :: x(3, n)    
      REAL, INTENT(IN) :: L
      REAL, INTENT(IN) :: w(n)
      REAL, INTENT(OUT) :: d(m, m, m)  
      INTEGER, INTENT(IN) :: ibin
      LOGICAL, INTENT(IN) :: all
      LOGICAL, INTENT(IN) :: periodic
      REAL :: number(m, m, m), ones(n)
      INTEGER :: i, j, k, sum

      IF (periodic .AND. (.NOT. all)) STOP 'PARTICLE_BIN_3D: Very strange to have periodic and not all particles contribute'

      ! Need an array of ones
      ! TODO: wasteful for memory, could use pointer maybe?
      ones = 1.

      !Call the binning twice, first to bin particle property and second to count
      IF (ibin == 1) THEN
         CALL NGP_3D(x, n, L, w, d, m, all, verbose=.TRUE.)
         CALL NGP_3D(x, n, L, ones, number, m, all, verbose=.TRUE.)
      ELSE IF (ibin == 2) THEN
         CALL CIC_3D(x, n, L, w, d, m, all, periodic, verbose=.TRUE.)
         CALL CIC_3D(x, n, L, ones, number, m, all, periodic, verbose=.TRUE.)
      ELSE
         STOP 'PARTICLE_BIN_AVERAGE: Error, ibin not specified correctly'
      END IF

      ! Now want to average over all elements in each cell, but need to be wary of cells with zero particles
      ! Loop over all elements of the field and average over the number of contributions
      ! Not sure how this will work for CIC binning if cell only gets a small contribution from one particle
      sum = 0
      WRITE (*, *) 'PARTICLE_BIN_AVERAGE: Averaging over particles in cells'
      DO k = 1, m
         DO j = 1, m
            DO i = 1, m
               IF (number(i, j, k) == 0.) THEN
                  sum = sum+1
               ELSE
                  d(i, j, k) = d(i, j, k)/number(i, j, k)
               END IF
            END DO
         END DO
      END DO
      WRITE (*, *) 'PARTICLE_BIN_AVERAGE: Numer of empty cells:', n
      WRITE (*, *) 'PARTICLE_BIN_AVERAGE: Fraction of empty cells', real(sum)/real(m**3)
      WRITE (*, *) 'PARTICLE_BIN_AVERAGE: Done'
      WRITE (*, *)

   END SUBROUTINE particle_bin_average_3D

   SUBROUTINE NGP_2D(x, n, L, w, d, m, all, verbose)

      ! Nearest-grid-point binning routine
      INTEGER, INTENT(IN) :: n       ! Total number of particles in area
      INTEGER, INTENT(IN) :: m       ! Mesh size for density field
      REAL, INTENT(IN) :: x(2, n)    ! particle positions     
      REAL, INTENT(IN) :: L          ! Area side length
      REAL, INTENT(IN) :: w(n)       ! Weight array
      REAL, INTENT(OUT) :: d(m, m)   ! Output of eventual 2D density field  
      LOGICAL, INTENT(IN) :: all     ! Should all particles be contributing to the binning?
      LOGICAL, INTENT(IN) :: verbose ! Verbose
      INTEGER :: i, j, ix(2)
      LOGICAL :: outside
      INTEGER, PARAMETER :: dim = 2

      IF (verbose) THEN
         WRITE (*, *) 'NGP_2D: Binning particles and creating field'
         WRITE (*, *) 'NGP_2D: Binning region size:', L
         WRITE (*, *) 'NGP_2D: Cells:', m
      END IF

      ! Fix to zero
      d = 0.

      DO i = 1, n

         ! Get the integer coordinates of the cell
         DO j = 1, dim
            ix(j) = NGP_cell(x(j, i), L, m)
         END DO

         ! Check if particles are outside the mesh region
         outside = .FALSE.
         DO j = 1, dim
            IF (ix(j) < 1 .OR. ix(j) > m) outside = .TRUE.
         END DO

         ! If the particle is outside the mesh region then either make an error or cycle
         IF (outside) THEN
            IF (all) THEN
               DO j = 1, dim
                  WRITE (*, *) 'NGP_2D: Coordinate:', j
                  WRITE (*, *) 'NGP_2D: position:', x(j, i)
                  WRITE (*, *) 'NGP_2D: cell: ', ix(j)
               END DO
               STOP 'NGP_2D: Error, particle outside boundary'
            ELSE
               CYCLE
            END IF
         END IF

         ! Do the binning
         d(ix(1), ix(2)) = d(ix(1), ix(2))+w(i)

      END DO

      IF (verbose) THEN
         WRITE (*, *) 'NGP_2D: Binning complete'
         WRITE (*, *)
      END IF

   END SUBROUTINE NGP_2D

   SUBROUTINE NGP_3D(x, n, L, w, d, m, all, verbose)

      ! Nearest-grid-point binning routine
      INTEGER, INTENT(IN) :: n, m     ! Total number of particles in area
      REAL, INTENT(IN) :: x(3, n)     ! particle positions    
      REAL, INTENT(IN) :: L           ! Area side length
      REAL, INTENT(IN) :: w(n)        ! Weight array
      REAL, INTENT(OUT) :: d(m, m, m) ! Output of eventual 3D density field    
      LOGICAL, INTENT(IN) :: all      ! Should all particles be contributing to the binning?
      LOGICAL, INTENT(IN) :: verbose  ! Verbose
      INTEGER :: i, j, ix(3)
      LOGICAL :: outside
      INTEGER, PARAMETER :: dim = 3

      IF (verbose) THEN
         WRITE (*, *) 'NGP_3D: Binning particles and creating field'
         WRITE (*, *) 'NGP_3D: Binning region size:', L
         WRITE (*, *) 'NGP_3D: Cells:', m
      END IF

      ! Fix to zero
      d = 0.

      DO i = 1, n

         ! Get the integer coordinates of the cell
         DO j = 1, dim
            ix(j) = NGP_cell(x(j, i), L, m)
         END DO

         ! Check if particles are outside the mesh region
         outside = .FALSE.
         DO j = 1, dim
            IF (ix(j) < 1 .OR. ix(j) > m) outside = .TRUE.
         END DO

         ! If the particle is outside the mesh region then either make an error or cycle
         IF (outside) THEN
            IF (all) THEN
               DO j = 1, dim
                  WRITE (*, *) 'NGP_3D: Coordinate:', j
                  WRITE (*, *) 'NGP_3D: position:', x(j, i)
                  WRITE (*, *) 'NGP_3D: cell: ', ix(j)
               END DO
               STOP 'NGP_3D: Error, particle outside boundary'
            ELSE
               CYCLE
            END IF
         END IF

         ! Do the binning
         d(ix(1), ix(2), ix(3)) = d(ix(1), ix(2), ix(3))+w(i)

      END DO

      IF (verbose) THEN
         WRITE (*, *) 'NGP_3D: Binning complete'
         WRITE (*, *)
      END IF

   END SUBROUTINE NGP_3D

   SUBROUTINE CIC_2D(x, n, L, w, d, m, all, periodic, verbose)

      ! Cloud-in-cell binning routine
      INTEGER, INTENT(IN) :: n, m     ! Total number of particles in area
      REAL, INTENT(IN) :: x(2, n)     ! 2D particle positions     
      REAL, INTENT(IN) :: L           ! Area side length
      REAL, INTENT(IN) :: w(n)        ! Weight array
      REAL, INTENT(OUT) :: d(m, m)    ! Output of eventual 2D density field
      LOGICAL, INTENT(IN) :: all      ! Should all particles be contributing to the binning?
      LOGICAL, INTENT(IN) :: periodic ! Is the volume periodic?
      LOGICAL, INTENT(IN) :: verbose  ! Verbose
      INTEGER :: i, j, k
      INTEGER :: ix(2), iy(2), ic(2)
      REAL :: dx(2), eps
      LOGICAL :: outside
      INTEGER, PARAMETER :: dim = 2

      IF (verbose) THEN
         WRITE (*, *) 'CIC_2D: Binning particles and creating density field'
         WRITE (*, *) 'CIC_2D: Binning region size:', L
         WRITE (*, *) 'CIC_2D: Cells:', m
      END IF

      ! Needs to be set to zero
      eps = 0.
      d = 0.

      DO i = 1, n

         ! Get the cell interger coordinates
         DO j = 1, dim
            ix(j) = NGP_cell(x(j, i), L, m)
         END DO

         ! Check to make sure particles are all within the binning region
         IF (all) THEN

            ! See if particles are outside region
            outside = .FALSE.
            DO j = 1, dim
               IF (ix(j) < 1 .OR. ix(j) > m) outside = .TRUE.
            END DO

            ! Write to screen if they are
            IF (outside) THEN
               DO j = 1, dim
                  WRITE (*, *) 'CIC_2D: Coordinate', j
                  WRITE (*, *) 'CIC_2D: Position:', x(j, i)
                  WRITE (*, *) 'CIC_2D: Cell: ', ix(j)
               END DO
               STOP 'CIC_2D: Error, particle outside boundary'
            END IF

         END IF

         ! dx, dy in cell units, away from cell centre
         DO j = 1, dim
            dx(j) = (x(j, i)/L)*real(m)-(real(ix(j))-0.5)
         END DO

         ! Find which other cell needs a contribution
         DO j = 1, dim
            IF (dx(j) >= 0.) THEN
               iy(j) = ix(j)+1
            ELSE
               iy(j) = ix(j)-1
               dx(j) = -dx(j) ! So that dx is always positive
            END IF
         END DO

         ! Deal with periodicity
         IF (periodic) THEN
            DO j = 1, dim
               IF (iy(j) == m+1) THEN
                  iy(j) = 1
               ELSE IF (iy(j) == 0) THEN
                  iy(j) = m
               END IF
            END DO
         END IF

         ! Carry out CIC binning
         DO k = 1, 4
            IF (k == 1) THEN
               ! Main cell
               eps = (1.-dx(1))*(1.-dx(2))
               ic(1) = ix(1)
               ic(2) = ix(2)
            ELSE IF (k == 2) THEN
               ! Offset in x
               eps = dx(1)*(1.-dx(2))
               ic(1) = iy(1)
               ic(2) = ix(2)
            ELSE IF (k == 3) THEN
               ! Offset in y
               eps = (1.-dx(1))*dx(2)
               ic(1) = ix(1)
               ic(2) = iy(2)
            ELSE IF (k == 4) THEN
               ! Offset in xy
               eps = dx(1)*dx(2)
               ic(1) = iy(1)
               ic(2) = iy(2)
            ELSE
               STOP 'CIC_2D: Error, something went terribly wrong'
            END IF
            CALL add_to_array(d, eps*w(i), ic)
         END DO

      END DO

      IF (verbose) THEN
         WRITE (*, *) 'CIC_2D: Binning complete'
         WRITE (*, *)
      END IF

   END SUBROUTINE CIC_2D

   SUBROUTINE CIC_3D(x, n, L, w, d, m, all, periodic, verbose)

      ! Cloud-in-cell binning routine
      INTEGER, INTENT(IN) :: n, m     ! Total number of particles in area
      REAL, INTENT(IN) :: x(3, n)     ! 3D particle positions    
      REAL, INTENT(IN) :: L           ! Area side length
      REAL, INTENT(IN) :: w(n)        ! Weight array
      REAL, INTENT(OUT) :: d(m, m, m) ! Output of eventual 2D density field
      LOGICAL, INTENT(IN) :: all      ! Should all particles be contributing to the binning?
      LOGICAL, INTENT(IN) :: periodic ! Is the volume periodic?
      LOGICAL, INTENT(IN) :: verbose  ! Verbose
      INTEGER :: i, j, k
      INTEGER :: ix(3), iy(3), ic(3)
      REAL :: dx(3), eps
      LOGICAL :: outside
      INTEGER, PARAMETER :: dim = 3

      IF (verbose) THEN
         WRITE (*, *) 'CIC_3D: Binning particles and creating density field'
         WRITE (*, *) 'CIC_3D: Number of particles:', n
         WRITE (*, *) 'CIC_3D: Binning region size:', L
         WRITE (*, *) 'CIC_3D: Cells:', m
      END IF

      ! Needs to be set to zero
      eps = 0.
      d = 0.

      DO i = 1, n

         ! Get the cell interger coordinates
         DO j = 1, dim
            ix(j) = NGP_cell(x(j, i), L, m)
         END DO

         ! Check to make sure particles are all within the binning region
         IF (all) THEN

            ! See if particles are outside region
            outside = .FALSE.
            DO j = 1, dim
               IF (ix(j) < 1 .OR. ix(j) > m) outside = .TRUE.
            END DO

            ! Write to screen if they are
            IF (outside) THEN
               DO j = 1, dim
                  WRITE (*, *) 'CIC_3D: Coordinate', j
                  WRITE (*, *) 'CIC_3D: Position:', x(j, i)
                  WRITE (*, *) 'CIC_3D: Cell: ', ix(j)
               END DO
               STOP 'CIC_3D: Error, particle outside boundary'
            END IF

         END IF

         ! dx, dy in cell units, away from cell centre
         DO j = 1, dim
            dx(j) = (x(j, i)/L)*real(m)-(real(ix(j))-0.5)
         END DO

         ! Find which other cell needs a contribution
         DO j = 1, dim
            IF (dx(j) >= 0.) THEN
               iy(j) = ix(j)+1
            ELSE
               iy(j) = ix(j)-1
               dx(j) = -dx(j) ! So that dx is always positive
            END IF
         END DO

         ! Deal with periodicity
         IF (periodic) THEN
            DO j = 1, dim
               IF (iy(j) == m+1) THEN
                  iy(j) = 1
               ELSE IF (iy(j) == 0) THEN
                  iy(j) = m
               END IF
            END DO
         END IF

         ! Carry out CIC binning
         DO k = 1, 8
            IF (k == 1) THEN
               ! Main cell
               eps = (1.-dx(1))*(1.-dx(2))*(1-dx(3))
               ic(1) = ix(1)
               ic(2) = ix(2)
               ic(3) = ix(3)
            ELSE IF (k == 2) THEN
               ! Offset in x
               eps = dx(1)*(1.-dx(2))*(1-dx(3))
               ic(1) = iy(1)
               ic(2) = ix(2)
               ic(3) = ix(3)
            ELSE IF (k == 3) THEN
               ! Offset in y
               eps = (1.-dx(1))*dx(2)*(1-dx(3))
               ic(1) = ix(1)
               ic(2) = iy(2)
               ic(3) = ix(3)
            ELSE IF (k == 4) THEN
               ! Offset in z
               eps = (1.-dx(1))*(1.-dx(2))*dx(3)
               ic(1) = ix(1)
               ic(2) = ix(2)
               ic(3) = iy(3)
            ELSE IF (k == 5) THEN
               ! Offset in xy
               eps = dx(1)*dx(2)*(1-dx(3))
               ic(1) = iy(1)
               ic(2) = iy(2)
               ic(3) = ix(3)
            ELSE IF (k == 6) THEN
               ! Offset in yz
               eps = (1.-dx(1))*dx(2)*dx(3)
               ic(1) = ix(1)
               ic(2) = iy(2)
               ic(3) = iy(3)
            ELSE IF (k == 7) THEN
               ! Offset in xz
               eps = dx(1)*(1.-dx(2))*dx(3)
               ic(1) = iy(1)
               ic(2) = ix(2)
               ic(3) = iy(3)
            ELSE IF (k == 8) THEN
               ! Offset in xyz
               eps = dx(1)*dx(2)*dx(3)
               ic(1) = iy(1)
               ic(2) = iy(2)
               ic(3) = iy(3)
            ELSE
               STOP 'CIC_3D: Error, something went terribly wrong'
            END IF
            CALL add_to_array(d, eps*w(i), ic)
         END DO

      END DO

      IF (verbose) THEN
         WRITE (*, *) 'CIC_3D: Binning complete'
         WRITE (*, *)
      END IF

   END SUBROUTINE CIC_3D

   SUBROUTINE SOD(x, n, L, w, d, m, Rs)

      ! Spherical density routine
      INTEGER, INTENT(IN) :: n, m
      REAL, INTENT(IN) :: x(3, n)   
      REAL, INTENT(IN) :: L
      REAL, INTENT(IN) :: w(n)
      REAL, INTENT(OUT) :: d(m, m, m)
      REAL, INTENT(IN) :: Rs
      !LOGICAL, INTENT(IN) :: all
      !LOGICAL, INTENT(IN) :: periodic
      REAL :: xc(3, m, m, m)
      REAL :: r, dx, dy, dz
      INTEGER :: i, j, k, ix, iy, iz, jx, jy, jz, kx, ky, kz

      WRITE (*, *) 'SOD: Binning particles and creating density field'
      WRITE (*, *) 'SOD: Cells:', m

      d = 0.

      ! Fill array with sphere centre positions
      DO k = 1, m
         DO j = 1, m
            DO i = 1, m
               xc(1, i, j, k) = cell_position(i, L, m)
               xc(2, i, j, k) = cell_position(j, L, m)
               xc(3, i, j, k) = cell_position(k, L, m)
            END DO
         END DO
      END DO

      ! Loop over all particles and assign to spheres
      DO i = 1, n

         ! Coordinate of nearest mesh cell
         ix = NGP_cell(x(1, i), L, m)
         iy = NGP_cell(x(2, i), L, m)
         iz = NGP_cell(x(3, i), L, m)

         ! See if particle is within spheres of over 27 neighbouring spheres
         DO jx = -1, 1
            DO jy = -1, 1
               DO jz = -1, 1

                  ! Find the x integer for the sphere
                  kx = ix+jx
                  IF (kx < 1) THEN
                     kx = kx+m
                  ELSE IF (kx > m) THEN
                     kx = kx-m
                  END IF

                  ! Find the y integer for the sphere
                  ky = iy+jy
                  IF (ky < 1) THEN
                     ky = ky+m
                  ELSE IF (ky > m) THEN
                     ky = ky-m
                  END IF

                  ! Find the z integer for the sphere
                  kz = iz+jz
                  IF (kz < 1) THEN
                     kz = kz+m
                  ELSE IF (kz > m) THEN
                     kz = kz-m
                  END IF

                  !WRITE(*,*) 'Mesh:', jx, jy, jz, kx, ky, kz

                  ! Calculate the displacement between the particle and the sphere centre
                  dx = x(1, i)-xc(1, kx, ky, kz)
                  dy = x(2, i)-xc(2, kx, ky, kz)
                  dz = x(3, i)-xc(3, kx, ky, kz)
                  !!

                  !WRITE(*,*) 'Displacements:', dx, dy, dz

                  !!
                  !Correct if particle is on the other side of the box - x
                  IF (dx > L/2.) THEN
                     dx = dx-L
                  ELSE IF (dx < -L/2.) THEN
                     dx = dx+L
                  END IF

                  !Correct if particle is on the other side of the box - y
                  IF (dy > L/2.) THEN
                     dy = dy-L
                  ELSE IF (dy < -L/2.) THEN
                     dy = dy+L
                  END IF

                  !Correct if particle is on the other side of the box - z
                  IF (dz > L/2.) THEN
                     dz = dz-L
                  ELSE IF (dz < -L/2.) THEN
                     dz = dz+L
                  END IF
                  !!

                  !WRITE(*,*) 'Displacements:', dx, dy, dz

                  !!
                  !Calculate the radial distance between the sphere centre and the particle
                  r = sqrt(dx**2.+dy**2.+dz**2.)

                  !Add to density if within sphere radius
                  IF (r < Rs) THEN
                     d(kx, ky, kz) = d(kx, ky, kz)+w(i)
                     !WRITE(*,*) 'Added:', kx, ky, kz
                  END IF
                  !!

               END DO
            END DO
         END DO
         !STOP

      END DO

      WRITE (*, *) 'SOD: Binning complete'
      WRITE (*, *)

   END SUBROUTINE SOD

   SUBROUTINE find_pairs(x, okay, n, rmin, rmax, L, outfile)

      INTEGER, INTENT(IN) :: n
      REAL, INTENT(IN) :: x(3, n)
      LOGICAL, INTENT(IN) :: okay(n)
      REAL, INTENT(IN) :: rmin, rmax, L
      CHARACTER(len=*), INTENT(IN) :: outfile
      INTEGER :: i, j, np
      REAL :: r

      WRITE (*, *) 'FIND_PAIRS: Minimum separation [Mpc/h]:', rmin
      WRITE (*, *) 'FIND_PAIRS: Maximum separation [Mpc/h]:', rmax
      WRITE (*, *) 'FIND_PAIRS: Doing finding'

      !Fix the number counter to be zero
      np = 0

      OPEN (7, file=outfile)
      DO i = 1, n
         DO j = i+1, n
            IF (okay(i) .AND. okay(j)) THEN
               r = periodic_distance(x(:, i), x(:, j), L)
               IF (r >= rmin .AND. r <= rmax) THEN
                  !CALL add_to_array(x(:,i),x(:,j),pairs,np)
                  np = np+1
                  WRITE (7, *) x(1, i), x(2, i), x(3, i), x(1, j), x(2, j), x(3, j)
               END IF
            END IF
         END DO
      END DO
      CLOSE (7)

      WRITE (*, *) 'FIND_PAIRS: Number of pairs:', np
      WRITE (*, *) 'FIND_PAIRS: Done'
      WRITE (*, *)

   END SUBROUTINE find_pairs

   SUBROUTINE zshift(x, v, n, Om_m, Om_v, z, iz)

      ! Shift particles to redshift space
      INTEGER, INTENT(IN) :: n       ! Total number of particles
      REAL, INTENT(INOUT) :: x(3, n) ! Particle positions [Mpc/h]
      REAL, INTENT(IN) :: v(3, n)    ! Particle velocities [km/s] 
      REAL, INTENT(IN) :: Om_m, Om_v ! Cosmological parameters
      REAL, INTENT(IN) :: z          ! Redshift
      INTEGER, INTENT(IN) :: iz      ! Dimension along which to shift (1,2,3 for x,y,z)
      INTEGER :: i
      REAL :: H, a

      WRITE (*, *) 'ZSHIFT: Shifting particles into redshift space'

      H = 100.*sqrt(Hubble2_simple(z, Om_m, Om_v))

      a = 1./(1.+z)

      DO i = 1, n
         x(iz, i) = x(iz, i)+v(iz, i)/(a*H)
      END DO

      WRITE (*, *) 'ZSHIFT: Done'
      WRITE (*, *)

   END SUBROUTINE zshift

   SUBROUTINE fold_particles(x, L)

      ! Fold (really translate) particles by half in each dimension
      REAL, INTENT(INOUT) :: x(:, :) ! Particles
      REAL, INTENT(INOUT) :: L       ! Length of periodic box
      INTEGER :: n, dim
      INTEGER :: i, d

      ! Pre-calculations
      n = size(x, 2)   ! Number of particles
      dim = size(x, 1) ! Number of dimensions
      L = L/2.         ! Half box size
      
      ! Loop and do 'folding'
      DO i = 1, n
         DO d = 1, dim
            IF (x(d, i) >= L) x(d, i) = x(d, i)-L
         END DO
      END DO

   END SUBROUTINE fold_particles

   REAL FUNCTION Hubble2_simple(z, Om_m, Om_v)

      ! This calculates the dimensionless squared hubble parameter squared at redshift z!
      ! It ignores contributions from radiation (not accurate at very high z)!
      ! It also ignores anything other than vacuum and matter
      ! TODO: Include dark energy?
      ! TODO: Remove in favour of cosmology module?
      REAL, INTENT(IN) :: z ! Redshift
      REAL, INTENT(IN) :: Om_m, Om_v ! Cosmological parameters

      Hubble2_simple = Om_m*(1.+z)**3+Om_v+(1.-Om_m-Om_v)*(1.+z)**2

   END FUNCTION Hubble2_simple

   ! This subroutine was previously called slice
   SUBROUTINE write_slice_ascii(x, n, x1, x2, y1, y2, z1, z2, outfile)

      INTEGER, INTENT(IN) :: n                   ! Total number of particles
      REAL, INTENT(IN) :: x(3, n)                ! Particle positions [Mpc/h]
      REAL, INTENT(IN) :: x1, x2, y1, y2, z1, z2 ! Limits of the slice [Mpc/h]
      CHARACTER(len=*), INTENT(IN) :: outfile    ! Output file
      INTEGER :: i

      WRITE (*, *) 'WRITE_SLICE_ASCII: Writing slice'
      OPEN (10, file=outfile)
      WRITE (*, *) 'WRITE_SLICE_ASCII: Thickness in z [Mpc/h]:', (z2-z1)
      DO i = 1, n
         IF (x1 < x(1, i) .AND. x(1, i) <= x2 .AND. y1 < x(2, i) .AND. x(2, i) <= y2 .AND. z1 < x(3, i) .AND. x(3, i) <= z2) THEN
            WRITE (10, *) x(1, i), x(2, i), x(3, i)
         END IF
      END DO
      CLOSE (10)
      WRITE (*, *) 'WRITE_SLICE_ASCII: Slice written: ', trim(outfile)
      WRITE (*, *)

   END SUBROUTINE write_slice_ascii

   REAL FUNCTION shot_noise_simple(L, n)

      ! Calculate simulation shot noise for equal mass matter particlers [(Mpc/h)^3]
      USE precision
      REAL, INTENT(IN) :: L ! Box size [Mpc/h]
      !INTEGER*8, INTENT(IN) :: n ! Total number of particles
      INTEGER(int8), INTENT(IN) :: n ! Total number of particles

      ! Calculate number density
      shot_noise_simple = L**3/real(n)

   END FUNCTION shot_noise_simple

   REAL FUNCTION shot_noise(u, v, n, L)

      ! Calculates shot noise in P_uv(k) [(Mpc/h)^3]
      ! See appendix in HMx paper
      ! Note if this is for mass then u = v = particle_mass/total_mass
      ! CARE: Removed double-precision sums
      INTEGER, INTENT(IN) :: n ! Number of particles
      REAL, INTENT(IN) :: u(n) ! Contributions to the total field u and v per particle
      REAL, INTENT(IN) :: v(n) ! Contributions to the total field u and v per particle
      REAL, INTENT(IN) :: L    ! Box size [Mpc/h]

      ! Do the sum of the two fields, making sure to use doubles
      shot_noise = sum(u*v)

      ! Multiply through by factors of volume and mesh
      shot_noise = (L**3)*shot_noise

   END FUNCTION shot_noise

   REAL FUNCTION shot_noise_mass(L, m, n)

      ! Calculate simulation shot noise constant P(k) for different-mass tracers [(Mpc/h)^3]
      ! CARE: Removed double-precision sums
      INTEGER, INTENT(IN) :: n ! Number of particles
      REAL, INTENT(IN) :: L    ! Box size [Mpc/h]
      REAL, INTENT(IN) :: m(n) ! Array of particle masses
      REAL :: Nbar

      ! Calculate the effective mean number of tracers
      Nbar = sum(m)**2/sum(m**2)

      ! Calculate number density, this makes units of P(k) [(Mpc/h)^3]
      shot_noise_mass = L**3/Nbar

   END FUNCTION shot_noise_mass

   ELEMENTAL REAL FUNCTION shot_noise_k(k, shot)

      ! Calculates shot noise as Delta^2(k) from a constant-P(k) thing with units [(Mpc/h)^3]
      ! This shot noise is then dimensionless, exactly like Delta^2(k)
      USE cosmology_functions
      REAL, INTENT(IN) :: k    ! Wave vector [h/Mpc]
      REAL, INTENT(IN) :: shot ! The constant shot-noise term: P(k) [(Mpc/h)^3]

      shot_noise_k = Delta_Pk(shot, k)

   END FUNCTION shot_noise_k

   !SUBROUTINE adaptive_density(xc,yc,Lsub,z1,z2,m,r,x,w,n,L,nbar,outfile)
   SUBROUTINE write_adaptive_field(xc, yc, Lsub, z1, z2, m, r, x, w, n, L, outfile)

      ! Makes a pretty picture of a density field but uses adaptive meshes to make it nice
      USE string_operations
      REAL, INTENT(IN) :: xc, yc ! Coordinates of image centre [Mpc/h]
      REAL, INTENT(IN) :: Lsub ! Size of image [Mpc/h]
      REAL, INTENT(IN) :: z1, z2 ! Front and back of image [Mpc/h]
      INTEGER, INTENT(IN) :: m ! Image size in pixels (e.g., 2048)
      INTEGER, INTENT(IN) :: r ! Integer number of levels of refinement
      INTEGER, INTENT(IN) :: n ! Number of particles
      REAL, INTENT(IN) :: x(3, n) ! Particle position array [Mpc/h]
      REAL, INTENT(IN) :: w(n) ! Weight array (e.g., mass, or just an array of ones)
      REAL, INTENT(IN) :: L ! Box size [Mpc/h]
      CHARACTER(len=*), INTENT(IN) :: outfile ! Output file

      REAL :: x1, x2, y1, y2, Lx, Ly, Lz, delta, npexp
      INTEGER :: np
      INTEGER :: m1, m2, m3, m4, m5
      INTEGER :: i, j
      REAL, ALLOCATABLE :: y(:, :), d(:, :), u(:), ones(:)
      REAL, ALLOCATABLE :: count1(:, :), count2(:, :), count3(:, :), count4(:, :), count5(:, :)
      REAL, ALLOCATABLE :: field1(:, :), field2(:, :), field3(:, :), field4(:, :), field5(:, :)
      CHARACTER(len=256) :: base, ext, output
      LOGICAL :: all, periodic

      REAL, PARAMETER :: dc = 4. ! Refinement conditions (particles-per-cell)
      REAL, PARAMETER :: fcell = 1. ! Smoothing factor over cell sizes (maybe should be set to 1; 0.75 looks okay)
      LOGICAL, PARAMETER :: test = .FALSE. ! Activate test mode
      INTEGER, PARAMETER :: ibin = 2 ! 2- CIC binnings

      IF (r > 4) STOP 'WRITE_ADAPTIVE_FIELD: Error, too many refinement leves requested. Maximum is 4'

      ! Write information to screen
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Adaptive density field generator'
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Refinement conditions (particles-per-cell):', dc
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Smoothing factor in cell size:', fcell
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Number of refinements:', r
      WRITE (*, *)

      ! Set the region boundaries in Mpc/h
      x1 = xc-Lsub/2.
      x2 = xc+Lsub/2.
      y1 = yc-Lsub/2.
      y2 = yc+Lsub/2.

      ! Set the region thicknesses
      Lx = x2-x1
      Ly = y2-y1
      Lz = z2-z1

      ! Write information to screen
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Subvolume:'
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: x1:', x1
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: x2:', x2
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Lx:', Lx
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: y1:', y1
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: y2:', y2
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Ly:', Ly
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: z1:', z1
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: z2:', z2
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Lz:', Lz
      WRITE (*, *)

      ! First pass to count the number of particles in the region
      np = 0
      DO i = 1, n
         IF (x(1, i) > x1 .AND. x(1, i) < x2 .AND. x(2, i) > y1 .AND. x(2, i) < y2 .AND. x(3, i) > z1 .AND. x(3, i) < z2) THEN
            np = np+1
         END IF
      END DO

      ! Calculate particle-density statistics
      npexp = real(n)*(Lx*Ly*Lz/L**3.)
      delta = -1.+real(np)/real(npexp)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Particle-density statistics'
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Particles in subvolume:', np
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Expected number of partilces in subvolume:', npexp
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Particle over-density in subvolume:', delta
      WRITE (*, *)

      ! Allocate arrays for 2D position and 2D weight
      ALLOCATE (y(2, np), u(np), ones(np))
      ones = 1. ! Need an array of ones for particle binning

      ! Second pass to add particles in the region to 2D array y
      j = 0
      DO i = 1, n
         IF (x(1, i) > x1 .AND. x(1, i) < x2 .AND. x(2, i) > y1 .AND. x(2, i) < y2 .AND. x(3, i) > z1 .AND. x(3, i) < z2) THEN
            j = j+1
            y(1, j) = x(1, i)-xc+Lsub/2. ! 2D position array
            y(2, j) = x(2, i)-yc+Lsub/2. ! 2D position array
            u(j) = w(i) ! u is the 2D weight array
         END IF
      END DO

      ! Boost the weight array to account for the smaller volume
      ! Note that this is a bit complicated
      ! The weight array for overdensity is m_i/M, where M is the total box mass
      ! i.e., the weight is the contribution of each particle to total box mass
      ! For pressure it is the pressure contribution to the total box pressure
      ! Need to account for the fact that we are actually working in a subvolume now
      u = u*(L**3/(Lx*Ly*Lz))

      ! Set the sizes of all of the adaptive meshes, which all differ by a factor of 2
      ! m1=m, m2=m/2, m3=m/4, m4=m/8, m5=m/16
      m1 = m
      m2 = m1/2
      m3 = m2/2
      m4 = m3/2
      m5 = m4/2

      ! Write out sizes to screen
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Mesh size 1:', m1
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Mesh size 2:', m2
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Mesh size 3:', m3
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Mesh size 4:', m4
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Mesh size 5:', m5
      WRITE (*, *)

      ! Allocate arrays for particle counts and fields
      ! This is ugly, but I do not think it can be avoided with e.g., field(5,m,m) because m are all different
      ALLOCATE (field1(m1, m1), count1(m1, m1))
      ALLOCATE (field2(m2, m2), count2(m2, m2))
      ALLOCATE (field3(m3, m3), count3(m3, m3))
      ALLOCATE (field4(m4, m4), count4(m4, m4))
      ALLOCATE (field5(m5, m5), count5(m5, m5))

      all = .TRUE. ! All particles in array y contribute to the binning
      IF (Lsub == L) THEN
         periodic = .TRUE. ! Only possibly periodic if the subvolume size is the same as the actual size
      ELSE
         periodic = .FALSE.
      END IF

      ! Do binning of particles on each mesh resolution
      CALL particle_bin(y, np, Lsub, ones, count1, m1, ibin, all, periodic, verbose=.TRUE.)
      CALL particle_bin(y, np, Lsub, ones, count2, m2, ibin, all, periodic, verbose=.TRUE.)
      CALL particle_bin(y, np, Lsub, ones, count3, m3, ibin, all, periodic, verbose=.TRUE.)
      CALL particle_bin(y, np, Lsub, ones, count4, m4, ibin, all, periodic, verbose=.TRUE.)
      CALL particle_bin(y, np, Lsub, ones, count5, m5, ibin, all, periodic, verbose=.TRUE.)

      ! Now bin field values, rather than particle numbers
      ! Need to multiply the weights through by factors of mesh to give the contribution to the mesh cell
      ! For example, for overdensity u is m_i/M, where M is now the subvolume mass
      ! This changes it to be the contribution to the density per mesh cell
      ! Same for pressure contributions
      CALL particle_bin(y, np, Lsub, u*m1**2, field1, m1, ibin, all, periodic, verbose=.TRUE.)
      CALL particle_bin(y, np, Lsub, u*m2**2, field2, m2, ibin, all, periodic, verbose=.TRUE.)
      CALL particle_bin(y, np, Lsub, u*m3**2, field3, m3, ibin, all, periodic, verbose=.TRUE.)
      CALL particle_bin(y, np, Lsub, u*m4**2, field4, m4, ibin, all, periodic, verbose=.TRUE.)
      CALL particle_bin(y, np, Lsub, u*m5**2, field5, m5, ibin, all, periodic, verbose=.TRUE.)

      ! Smooth fields
      CALL smooth(field1, m1, fcell*Lsub/real(m1), Lsub)
      CALL smooth(field2, m2, fcell*Lsub/real(m2), Lsub)
      CALL smooth(field3, m3, fcell*Lsub/real(m3), Lsub)
      CALL smooth(field4, m4, fcell*Lsub/real(m4), Lsub)
      CALL smooth(field5, m5, fcell*Lsub/real(m5), Lsub)

      ! Write out density statistics on each mesh
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Mesh:', m1
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Max count:', maxval(count1)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Min count:', minval(count1)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Max overdensity:', maxval(field1)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Min overdensity:', minval(field1)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Mesh:', m2
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Max count:', maxval(count2)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Min count:', minval(count2)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Max overdensity:', maxval(field2)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Min overdensity:', minval(field2)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Mesh:', m3
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Max count:', maxval(count3)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Min count:', minval(count3)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Max overdensity:', maxval(field3)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Min overdensity:', minval(field3)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Mesh:', m4
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Max count:', maxval(count4)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Min count:', minval(count4)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Max overdensity:', maxval(field4)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Min overdensity:', minval(field4)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Mesh:', m5
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Max count:', maxval(count5)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Min count:', minval(count5)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Max overdensity:', maxval(field5)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Min overdensity:', minval(field5)
      WRITE (*, *)

      ! Write out each mesh if testing
      IF (test) THEN

         base = 'density_'
         ext = '.dat'

         output = number_file_zeroes(base, m1, 4, ext)
         WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Writing: ', trim(output)
         CALL write_field_ascii(field1, m1, Lsub, output)

         output = number_file_zeroes(base, m2, 4, ext)
         WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Writing: ', trim(output)
         CALL write_field_ascii(field2, m2, Lsub, output)

         output = number_file_zeroes(base, m3, 4, ext)
         WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Writing: ', trim(output)
         CALL write_field_ascii(field3, m3, Lsub, output)

         output = number_file_zeroes(base, m4, 4, ext)
         WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Writing: ', trim(output)
         CALL write_field_ascii(field4, m4, Lsub, output)

         output = number_file_zeroes(base, m5, 4, ext)
         WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Writing: ', trim(output)
         CALL write_field_ascii(field5, m5, Lsub, output)

      END IF

      ! No refinement required
      IF (r == 0) THEN

         ALLOCATE (d(m, m))
         d = field1

         ! Start the refinements
      ELSE

         ! First refinement
         IF (r >= 4) THEN

            ! Allocate d with the size of the second-corsest image
            ALLOCATE (d(m4, m4))
            DO i = 1, m5
               DO j = 1, m5
                  IF (count5(i, j) < dc) THEN
                     ! Use coarser density
                     d(2*i-1, 2*j-1) = field5(i, j)
                     d(2*i, 2*j-1) = field5(i, j)
                     d(2*i-1, 2*j) = field5(i, j)
                     d(2*i, 2*j) = field5(i, j)
                  ELSE
                     ! Use finer density
                     d(2*i-1, 2*j-1) = field4(2*i-1, 2*j)
                     d(2*i, 2*j-1) = field4(2*i, 2*j-1)
                     d(2*i-1, 2*j) = field4(2*i-1, 2*j)
                     d(2*i, 2*j) = field4(2*i, 2*j)
                  END IF
               END DO
            END DO

         END IF

         ! Second refinement
         IF (r >= 3) THEN

            IF (ALLOCATED(d)) THEN
               field4 = d
               DEALLOCATE (d)
            END IF
            ALLOCATE (d(m3, m3))
            DO i = 1, m4
               DO j = 1, m4
                  IF (count4(i, j) < dc) THEN
                     ! Use coarser density
                     d(2*i-1, 2*j-1) = field4(i, j)
                     d(2*i, 2*j-1) = field4(i, j)
                     d(2*i-1, 2*j) = field4(i, j)
                     d(2*i, 2*j) = field4(i, j)
                  ELSE
                     ! Use finer density
                     d(2*i-1, 2*j-1) = field3(2*i-1, 2*j)
                     d(2*i, 2*j-1) = field3(2*i, 2*j-1)
                     d(2*i-1, 2*j) = field3(2*i-1, 2*j)
                     d(2*i, 2*j) = field3(2*i, 2*j)
                  END IF
               END DO
            END DO

         END IF

         ! Third refinement
         IF (r >= 2) THEN

            IF (ALLOCATED(d)) THEN
               field3 = d
               DEALLOCATE (d)
            END IF
            ALLOCATE (d(m2, m2))
            DO i = 1, m3
               DO j = 1, m3
                  IF (count3(i, j) < dc) THEN
                     ! Use coarser density
                     d(2*i-1, 2*j-1) = field3(i, j)
                     d(2*i, 2*j-1) = field3(i, j)
                     d(2*i-1, 2*j) = field3(i, j)
                     d(2*i, 2*j) = field3(i, j)
                  ELSE
                     ! Use finer density
                     d(2*i-1, 2*j-1) = field2(2*i-1, 2*j)
                     d(2*i, 2*j-1) = field2(2*i, 2*j-1)
                     d(2*i-1, 2*j) = field2(2*i-1, 2*j)
                     d(2*i, 2*j) = field2(2*i, 2*j)
                  END IF
               END DO
            END DO

         END IF

         ! Fourth refinement
         IF (r >= 1) THEN

            IF (ALLOCATED(d)) THEN
               field2 = d
               DEALLOCATE (d)
            END IF
            ALLOCATE (d(m1, m1))
            DO i = 1, m2
               DO j = 1, m2
                  IF (count2(i, j) < dc) THEN
                     ! Use coarser density
                     d(2*i-1, 2*j-1) = field2(i, j)
                     d(2*i, 2*j-1) = field2(i, j)
                     d(2*i-1, 2*j) = field2(i, j)
                     d(2*i, 2*j) = field2(i, j)
                  ELSE
                     ! Use finer density
                     d(2*i-1, 2*j-1) = field1(2*i-1, 2*j)
                     d(2*i, 2*j-1) = field1(2*i, 2*j-1)
                     d(2*i-1, 2*j) = field1(2*i-1, 2*j)
                     d(2*i, 2*j) = field1(2*i, 2*j)
                  END IF
               END DO
            END DO

         END IF

      END IF

      ! Deallocate arrays
      DEALLOCATE (field1, field2, field3, field4, field5)
      DEALLOCATE (count1, count2, count3, count4, count5)

      ! Write info to screen
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Adaptive density field'
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Max density:', maxval(d)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Min density:', minval(d)
      WRITE (*, *)

      ! Ensure all cells are positive (note this is to make pretty pictures, not for science)
      DO i = 1, m1
         DO j = 1, m1
            IF (d(i, j) < 0.) d(i, j) = 0.
         END DO
      END DO

      ! Write field statistics
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Smoothed adaptive density field'
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Max density:', maxval(d)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Min density:', minval(d)
      WRITE (*, *)

      ! Finally write out an ascii file for plotting
      CALL write_field_ascii(d, m1, Lsub, outfile)
      WRITE (*, *) 'WRITE_ADAPTIVE_FIELD: Done'
      WRITE (*, *)

   END SUBROUTINE write_adaptive_field

   SUBROUTINE make_HOD(xh, nph, rv, rs, irho, L, x, np)

      ! Make an HOD realisation
      ! TODO: Could speed up for NFW by not regenerating the iversion/interpolation halo unless rv, rs change
      REAL, ALLOCATABLE, INTENT(IN) :: xh(:, :) ! Halo position array [Mpc/h]
      INTEGER, INTENT(IN) :: nph(:)             ! Number of particles in each halo
      REAL, INTENT(IN) :: rv(:)                 ! Halo virial radii [Mpc/h]
      REAL, INTENT(IN) :: rs(:)                 ! Halo scale radii [Mpc/h]
      INTEGER, INTENT(IN) :: irho               ! Halo profile specifier
      REAL, INTENT(IN) :: L                     ! Simulation box size [Mpc/h]
      REAL, ALLOCATABLE, INTENT(OUT) :: x(:, :) ! HOD particle position array [Mpc/h]
      INTEGER, INTENT(OUT) :: np                ! Total number of HOD particles generated  
      INTEGER :: i, j, k
      INTEGER :: nh
      REAL, ALLOCATABLE :: xi(:, :)

      nh = size(xh, 2)
      IF((nh .NE. size(nph)) .OR. (nh .NE. size(rv))) THEN
         STOP 'MAKE_HOD: Error, halo-position array, number of particles and virial radii must all be the same size'
      END IF

      ! Calculate total number of particles to generate
      np = SUM(nph)
      ALLOCATE (x(3, np))

      ! Generate the particles
      k = 0
      DO i = 1, nh
         IF (nph(i) > 0) THEN
            ALLOCATE(xi(3, nph(i)))
            CALL random_halo_particles(xi, rv(i), rs(i), irho)
            DO j = 1, nph(i)
               k = k + 1
               x(:, k) = xh(:, i)+xi(:, j)
            END DO
            DEALLOCATE(xi)
         END IF
      END DO

      ! Replace particles that may have strayed outside the volume
      CALL replace(x, L)

   END SUBROUTINE make_HOD

   SUBROUTINE random_halo_particles(rr, rv, rs, irho)

      ! Get a set of x,y,z coordiantes for a random point in an artificial spherical halo
      ! The halo centre is fixed to be the coordinate zero point
      USE random_numbers
      USE HMx
      REAL, INTENT(OUT) :: rr(:, :) ! Halo coordinates (should be shape 3,n) [Mpc/h]
      REAL, INTENT(IN) :: rv        ! Halo virial radius [Mpc/h]
      REAL, INTENT(IN) :: rs        ! Halo scale radius [Mpc/h]
      INTEGER, INTENT(IN) :: irho   ! Switch for halo profile (from HMx)
      REAL, ALLOCATABLE :: r(:)
      REAL :: theta, phi
      INTEGER :: i, n

      IF (size(rr, 1) /= 3) STOP 'RANDOM_HALO_PARTICLES: Error, output array must be shape (3, n)'
      n = size(rr, 2)
      ALLOCATE(r(n))

      IF (irho == irho_NFW) THEN
         CALL random_rs_NFW(r, rv, rs)
      ELSE
         DO i = 1, n
            ! Get radial coordinate
            IF (irho == irho_tophat) THEN
               r(i) = random_r_constant(rv)
            ELSE IF (irho == irho_iso) THEN
               r(i) = random_r_isothermal(rv)
            ELSE IF (irho == irho_shell) THEN
               r(i) = rv
            ELSE IF (irho == irho_delta) THEN
               r(i) = 0.
            ELSE
               STOP 'RANDOM_SPHERE: Error, irho specified incorrectly or not supported'
            END IF
         END DO
      END IF

      ! Generate the full 3D coordinates assuming a spherical profile (isotropic angles)
      DO i = 1, n
         theta = random_spherical_theta()    ! Angle from z: Between 0 and pi
         phi = random_uniform(0., twopi)     ! x-y plane angle
         rr(1, i) = r(i)*sin(theta)*cos(phi) ! x
         rr(2, i) = r(i)*sin(theta)*sin(phi) ! y
         rr(3, i) = r(i)*cos(theta)          ! z
      END DO

   END SUBROUTINE random_halo_particles

   REAL FUNCTION random_r_constant(rv)

      ! The radial random weighting for a constant-density halo profile
      USE random_numbers
      REAL, INTENT(IN) :: rv ! halo virial radius [Mpc/h]

      random_r_constant = rv*random_polynomial(2.)

   END FUNCTION random_r_constant

   REAL FUNCTION random_r_isothermal(rv)

      ! The radial random weighting for an isothermal halo profile
      USE random_numbers
      REAL, INTENT(IN) :: rv ! halo virial radius [Mpc/h]

      random_r_isothermal = random_uniform(0., rv)

   END FUNCTION random_r_isothermal

   SUBROUTINE random_rs_NFW(rr, rv, rs)

      ! Get a set of random radii drawn from an NFW distribution
      ! Has to perform a numerical inversion/interpolation
      ! If F(x) = ln(1+x) - x/(1+x) then f = F(r/rs) / F(c) with f in [0->1] must be inverted for r
      USE random_numbers
      USE interpolate
      USE HMx
      REAL, INTENT(OUT) :: rr(:)
      REAL, INTENT(IN) :: rv
      REAL, INTENT(IN) :: rs
      REAL, ALLOCATABLE :: r(:), f(:)
      REAL :: u
      INTEGER :: i
      INTEGER, PARAMETER :: nr = nr_random_NFW
      INTEGER, PARAMETER :: iorder = iorder_random_NFW
      INTEGER, PARAMETER :: ifind = ifind_random_NFW
      INTEGER, PARAMETER :: iinterp = iinterp_random_NFW

      ! Fill array of r vs. f(r) for interpolation/inversion
      CALL fill_array(0., rv, r, nr)
      ALLOCATE(f(nr))
      DO i = 1, nr
         f(i) = NFW_factor(r(i)/rs)/NFW_factor(rv/rs)
      END DO

      ! Get n different values of the radius using numerical inversion
      DO i = 1, size(rr)
         u = random_unit()
         rr(i) = find(u, f, r, nr, iorder, ifind, iinterp)
      END DO

   END SUBROUTINE random_rs_NFW
   
   SUBROUTINE combine_folded_power(k, Pk, sig, k_bin, k_tot, Pk_tot, sig_tot)

      ! TODO: Should weight enter the calculation of mean k? Or should this just be an array of ones?
      ! TODO: Remove power above half-Nyquist at each fold
      USE statistics
      REAL, INTENT(IN) :: k(:, :)
      REAL, INTENT(IN) :: Pk(:, :)
      REAL, INTENT(IN) :: sig(:, :)
      REAL, INTENT(IN) :: k_bin(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: k_tot(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk_tot(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: sig_tot(:)
      REAL, ALLOCATABLE :: weight(:, :), ones(:)
      REAL, ALLOCATABLE :: w_k(:), w_Pk(:), w_sig(:)
      INTEGER :: nk, nf
      INTEGER :: ifold, ik

      ! Check k dimension
      nk = size(k, 1)
      IF (size(Pk, 1) /= nk) STOP 'COMBINE_FOLDED_POWER_DATA: Error Pk_fold should have the same first dimension as k_fold'
      IF (size(sig, 1) /= nk) STOP 'COMBINE_FOLDED_POWER_DATA: Error sig_fold should have the same first dimension as k_fold'

      ! Check fold dimension
      nf = size(k, 2)
      IF (size(Pk, 2) /= nf) STOP 'COMBINE_FOLDED_POWER_DATA: Error Pk_fold should have the same second dimension as k_fold'
      IF (size(sig, 2) /= nf) STOP 'COMBINE_FOLDED_POWER_DATA: Error sig_fold should have the same second dimension as k_fold'
      nf = nf-1

      ! Create weight array from errors
      ALLOCATE(weight(nk, nf+1))
      DO ifold = 1, nf+1
         DO ik = 1, nk
            IF (sig(ik, ifold) == 0.) THEN
               weight(ik, ifold) = 0.
            ELSE
               weight(ik, ifold) = 1./sig(ik, ifold)
            END IF
         END DO
      END DO
      ALLOCATE(ones(nk*(nf+1)))
      ones = 1.

      ! Histogram k, P(k) and sig(k) 
      CALL advanced_histogram(reshape(k, [nk*(nf+1)]), reshape(k, [nk*(nf+1)]), ones, k_bin, k_tot, w_k)
      CALL advanced_histogram(reshape(k, [nk*(nf+1)]), reshape(Pk, [nk*(nf+1)]), reshape(weight, [nk*(nf+1)]), k_bin, Pk_tot, w_Pk)
      CALL advanced_histogram(reshape(k, [nk*(nf+1)]), reshape(weight**2, [nk*(nf+1)]), ones, k_bin, sig_tot, w_sig)

      ! Normalise results
      DO ik = 1, size(k_tot)
         k_tot(ik) = k_tot(ik)/w_k(ik)
         IF (w_Pk(ik) == 0.) THEN
            Pk_tot(ik) = 0.
            sig_tot(ik) = 0.
         ELSE         
            Pk_tot(ik) = Pk_tot(ik)/w_Pk(ik)
            sig_tot(ik) = sqrt(1./sig_tot(ik))
         END IF
      END DO

   END SUBROUTINE combine_folded_power

END MODULE simulations

MODULE owls_extras

   USE owls_stuff

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: BAHAMAS_read_power
   PUBLIC :: BAHAMAS_get_ks
   PUBLIC :: VD20_get_power
   PUBLIC :: VD20_get_response
   PUBLIC :: VD20_get_more_power
   PUBLIC :: VD20_get_cosmology

   INTEGER, PARAMETER :: computer_mac = 1
   INTEGER, PARAMETER :: computer_linux = 2

   ! Set computer
   INTEGER, PARAMETER :: computer = computer_mac

CONTAINS

   SUBROUTINE BAHAMAS_get_ks(mesh, k, nk)

      USE file_info
      INTEGER, INTENT(IN) :: mesh
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      INTEGER, INTENT(OUT) :: nk
      INTEGER :: i
      CHARACTER(len=256) :: dir, infile
      CHARACTER(len=256), PARAMETER :: kfile = 'DMONLY_nu0_L400N1024_WMAP9_snap32_all_all_power.dat'

      dir = BAHAMAS_dir(mesh)
      infile = trim(dir)//'/'//trim(kfile)
      nk = file_length(infile, verbose=.FALSE.)
      
      ALLOCATE(k(nk))
      OPEN(7, file=infile)
      DO i = 1, nk
         READ(7, *) k(i)
      END DO
      CLOSE(7)

   END SUBROUTINE BAHAMAS_get_ks

   CHARACTER(len=64) FUNCTION BAHAMAS_dir(m)

      USE string_operations
      INTEGER, INTENT(IN) :: m
      CHARACTER(len=8) :: mesh
      CHARACTER(len=64) :: dir

      ! Directory containing everything
      IF (computer == computer_mac)   dir = '/Users/Mead/Physics/BAHAMAS/power/'
      IF (computer == computer_linux) dir = '/home/amead/BAHAMAS/power/'

      ! Convert the mesh size to a string and append to directory
      mesh = integer_to_string(m)
      BAHAMAS_dir = TRIM(dir)//'M'//trim(mesh)

   END FUNCTION BAHAMAS_dir

   CHARACTER(len=32) FUNCTION BAHAMAS_field_name(i)

      USE HMx
      INTEGER, INTENT(IN) :: i

      IF (i == field_matter) THEN
         BAHAMAS_field_name = 'all'
      ELSE IF (i == field_cdm) THEN
         BAHAMAS_field_name = 'dm'
      ELSE IF (i == field_gas) THEN
         BAHAMAS_field_name = 'gas'
      ELSE IF (i == field_stars) THEN
         BAHAMAS_field_name = 'stars'
      ELSE IF (i == field_electron_pressure) THEN
         BAHAMAS_field_name = 'epressure'
      ELSE
         WRITE (*, *) 'BAHAMAS_FIELD_NAME: Field integer:', i
         STOP 'BAHAMAS_FIELD_NAME: Error, field integer specified incorrectly'
      END IF

   END FUNCTION BAHAMAS_field_name

   CHARACTER(len=256) FUNCTION BAHAMAS_power_file_name(model, m, z, ip)

      CHARACTER(len=*), INTENT(IN) :: model
      INTEGER, INTENT(IN) :: m
      REAL, INTENT(IN) :: z
      INTEGER, INTENT(IN) :: ip(2)
      CHARACTER(len=64) :: dir
      CHARACTER(len=32) :: snap, field(2), f1, f2
      LOGICAL :: lexist
      INTEGER :: j

      dir = BAHAMAS_dir(m)
      snap = BAHAMAS_snapshot(z)
      DO j = 1, 2
         field(j) = BAHAMAS_field_name(ip(j))
      END DO

      DO j = 1, 2

         IF (j == 1) THEN
            f1 = field(1)
            f2 = field(2)
         ELSE IF (j == 2) THEN
            f1 = field(2)
            f2 = field(1)
         ELSE
            STOP 'BAHAMAS_POWER_FILE_NAME: Error, something went wrong'
         END IF

         ! File name
         BAHAMAS_power_file_name = &
            trim(dir)//'/'//trim(model)//'_L400N1024_WMAP9_'//trim(snap)//'_'//trim(f1)//'_'//trim(f2)//'_power.dat'

         ! Check it exists
         INQUIRE (file=BAHAMAS_power_file_name, exist=lexist)

         IF (lexist) THEN
            EXIT
         ELSE IF (j == 2) THEN
            WRITE (*, *) 'BAHAMAS_POWER_FILE_NAME: ', trim(BAHAMAS_power_file_name)
            STOP 'BAHAMAS_POWER_FILE_NAME: Error, file does not exist'
         END IF

      END DO

   END FUNCTION BAHAMAS_power_file_name

   CHARACTER(len=256) FUNCTION BAHAMAS_error_file_name(m, z, ip)

      INTEGER, INTENT(IN) :: m
      REAL, INTENT(IN) :: z
      INTEGER, INTENT(IN) :: ip(2)
      CHARACTER(len=64) :: dir
      CHARACTER(len=32) :: snap, field(2), f1, f2
      LOGICAL :: lexist
      INTEGER :: j

      dir = BAHAMAS_dir(m)
      snap = BAHAMAS_snapshot(z)
      DO j = 1, 2
         field(j) = BAHAMAS_field_name(ip(j))
      END DO

      DO j = 1, 2

         IF (j == 1) THEN
            f1 = field(1)
            f2 = field(2)
         ELSE IF (j == 2) THEN
            f1 = field(2)
            f2 = field(1)
         ELSE
            STOP 'BAHAMAS_ERROR_FILE_NAME: Error, something went wrong'
         END IF

         ! File name
         BAHAMAS_error_file_name = &
            trim(dir)//'/L400N1024_WMAP9_'//trim(snap)//'_'//trim(f1)//'_'//trim(f2)//'_error.dat'

         ! Check it exists
         INQUIRE (file=BAHAMAS_error_file_name, exist=lexist)

         IF (lexist) THEN
            EXIT
         ELSE IF (j == 2) THEN
            WRITE (*, *) 'BAHAMAS_ERROR_FILE_NAME: ', trim(BAHAMAS_error_file_name)
            STOP 'BAHAMAS_ERROR_FILE_NAME: Error, file does not exist'
         END IF

      END DO

   END FUNCTION BAHAMAS_error_file_name

   SUBROUTINE BAHAMAS_read_power(k, Pk, Er, nk, z, name, mesh, field, cosm, response, kmin, kmax, &
      cut_nyquist, subtract_shot, realisation_errors, verbose)

      USE basic_operations
      USE cosmology_functions
      USE HMx
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Er(:)
      INTEGER, INTENT(OUT) :: nk
      REAL, INTENT(IN) :: z
      CHARACTER(len=*), INTENT(IN) :: name
      INTEGER, INTENT(IN) :: mesh
      INTEGER, INTENT(IN) :: field(2)
      TYPE(cosmology), INTENT(INOUT) :: cosm
      INTEGER, OPTIONAL, INTENT(IN) :: response
      REAL, OPTIONAL, INTENT(IN) :: kmin, kmax
      LOGICAL, OPTIONAL, INTENT(IN) :: cut_nyquist
      LOGICAL, OPTIONAL, INTENT(IN) :: subtract_shot
      LOGICAL, OPTIONAL, INTENT(IN) :: realisation_errors
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      REAL, ALLOCATABLE :: Pk_DM(:), crap(:), Pk_HMcode(:,:)
      REAL :: a(1)  
      CHARACTER(len=256) :: infile, dmonly
      INTEGER, PARAMETER :: na = 1
      INTEGER, PARAMETER :: field_all_matter(2) = field_matter
      CHARACTER(len=256), PARAMETER :: response_infile = 'DMONLY_2fluid_nu0'
      !INTEGER, PARAMETER :: HMcode_version = HMcode2016 ! For response
      
      infile = BAHAMAS_power_file_name(name, mesh, z, field)
      CALL read_simulation_power_spectrum(k, Pk, Er, nk, infile, kmin, kmax, cut_nyquist, subtract_shot, verbose)
      IF(present_and_correct(realisation_errors)) THEN
         infile = BAHAMAS_error_file_name(mesh, z, field)
         CALL read_simulation_power_spectrum(k, crap, Er, nk, infile, kmin, kmax, cut_nyquist, subtract_shot, verbose)
      END IF

      IF (present(response)) THEN
         IF (response .NE. 0) THEN
            dmonly = BAHAMAS_power_file_name(response_infile, mesh, z, field_all_matter)
            CALL read_simulation_power_spectrum(k, Pk_DM, crap, nk, dmonly, kmin, kmax, cut_nyquist, subtract_shot, verbose)
            Pk = Pk/Pk_DM
            a = scale_factor_z(z)
            ALLOCATE (Pk_HMcode(nk, na))
            CALL calculate_HMcode(k, a, Pk_HMcode, nk, na, cosm, response)
            Pk = Pk*Pk_HMcode(:,1)
         END IF
      END IF

   END SUBROUTINE BAHAMAS_read_power

   SUBROUTINE read_simulation_power_spectrum(k, Pk, Er, nk, infile, kmin, kmax, cut_nyquist, subtract_shot, verbose)

      ! TODO: Move this to simulations.f90
      USE file_info
      USE basic_operations  
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)  ! Output simulation k and power
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:) ! Output simulation k and power
      REAL, ALLOCATABLE, INTENT(OUT) :: Er(:) ! Output simulation k and power
      INTEGER, INTENT(OUT) :: nk              ! Number of output k values
      CHARACTER(len=*), INTENT(IN) :: infile ! Input file location
      REAL, OPTIONAL, INTENT(IN) :: kmin, kmax ! Minimum and maximum k values to cut at
      LOGICAL, OPTIONAL, INTENT(IN) :: cut_nyquist ! Logical to cut Nyquist or not
      LOGICAL, OPTIONAL, INTENT(IN) :: subtract_shot ! Logical to subtract shot noise or not
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose ! Logical verbose
      INTEGER :: i
      REAL :: shot, crap

      ! Deallocate arrays if they are already allocated
      IF (ALLOCATED(k))  DEALLOCATE (k)
      IF (ALLOCATED(Pk)) DEALLOCATE (Pk)
      IF (ALLOCATED(Er)) DEALLOCATE (Er)

      CALL check_file_exists(infile)

      ! Get file length and allocate arrays for output
      nk = file_length(infile, verbose=.FALSE.)
      ALLOCATE (k(nk), Pk(nk), Er(nk))

      ! Write to screen
      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'READ_SIMULATION_POWER_SPECTRUM: Reading in data'
         WRITE (*, *) 'READ_SIMULATION_POWER_SPECTRUM: File: ', trim(infile)
         WRITE (*, *) 'READ_SIMULATION_POWER_SPECTRUM: Initial nk:', nk
      END IF

      ! Read in data from file
      OPEN (9, file=infile, status='old')
      DO i = 1, nk
         READ (9, *) k(i), Pk(i), shot, crap, Er(i)
         IF (present_and_correct(subtract_shot)) Pk(i) = Pk(i)-shot
      END DO
      CLOSE (9)

      ! Write to screen
      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'READ_SIMULATION_POWER_SPECTRUM: kmin [h/Mpc]:', k(1)
         WRITE (*, *) 'READ_SIMULATION_POWER_SPECTRUM: kmax [h/Mpc]:', k(nk)
      END IF

      IF (present_and_correct(cut_nyquist)) CALL cut_Nyquist_frequency(k, Pk, Er, nk, verbose)
      IF (PRESENT(kmin)) CALL cut_kmin(kmin, k, Pk, Er, nk, verbose)
      IF (PRESENT(kmax)) CALL cut_kmax(kmax, k, Pk, Er, nk, verbose)

      ! Write to screen
      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'READ_SIMULATION_POWER_SPECTRUM: Final nk:', nk
         WRITE (*, *) 'READ_SIMULATION_POWER_SPECTRUM: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE read_simulation_power_spectrum

   SUBROUTINE cut_Nyquist_frequency(k, Pk, Er, nk, verbose)

      USE basic_operations
      USE array_operations
      REAL, ALLOCATABLE, INTENT(INOUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(INOUT) :: Pk(:)
      REAL, ALLOCATABLE, INTENT(INOUT) :: Er(:)
      INTEGER, INTENT(INOUT) :: nk
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      INTEGER :: i
      REAL :: kbig

      ! Find position in array of half-Nyquist
      kbig = k(nk)
      DO i = 1, nk
         IF (k(i) > kbig/2.) EXIT
      END DO

      ! Cut arrays down to half-Nyquist
      CALL amputate_array(k, 1, i)
      CALL amputate_array(Pk, 1, i)
      CALL amputate_array(Er, 1, i)
      nk = i

      ! Write to screen
      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'READ_SIMULATION_POWER_SPECTRUM: Trimmed to Nyquist frequency'
         WRITE (*, *) 'READ_SIMULATION_POWER_SPECTRUM: New kmax [h/Mpc]:', k(nk)
      END IF

   END SUBROUTINE cut_Nyquist_frequency

   SUBROUTINE cut_kmin(kmin, k, Pk, Er, nk, verbose)

      USE basic_operations
      USE array_operations
      REAL, INTENT(IN) :: kmin
      REAL, ALLOCATABLE, INTENT(INOUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(INOUT) :: Pk(:)
      REAL, ALLOCATABLE, INTENT(INOUT) :: Er(:)
      INTEGER, INTENT(INOUT) :: nk
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      INTEGER :: i, j

      j = 0
      DO i = 1, nk-1
         IF (k(i) < kmin .AND. k(i+1) > kmin) THEN
            j = i
         END IF
      END DO
      IF (j .NE. 0) THEN
         CALL amputate_array(k, j, nk)
         CALL amputate_array(Pk, j, nk)
         CALL amputate_array(Er, j, nk)
         nk = nk-j+1
      END IF
      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'CUT_KMIN: Trimmed to new kmin'
         WRITE (*, *) 'CUT_KMIN: New kmin [h/Mpc]:', k(1)
         WRITE (*, *)
      END IF

   END SUBROUTINE cut_kmin

   SUBROUTINE cut_kmax(kmax, k, Pk, Er, nk, verbose)

      USE basic_operations
      USE array_operations
      REAL, INTENT(IN) :: kmax
      REAL, ALLOCATABLE, INTENT(INOUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(INOUT) :: Pk(:)
      REAL, ALLOCATABLE, INTENT(INOUT) :: Er(:)
      INTEGER, INTENT(INOUT) :: nk
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      INTEGER :: i, j
      
      j = nk
      DO i = 1, nk-1
         IF (k(i) < kmax .AND. k(i+1) > kmax) THEN
            j = i
         END IF
      END DO
      IF (j .NE. nk) THEN
         CALL amputate_array(k, 1, j)
         CALL amputate_array(Pk, 1, j)
         CALL amputate_array(Er, 1, j)
         nk = j
      END IF
      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'CUT_KMAX: Trimmed to new kmax'
         WRITE (*, *) 'CUT_KMAX: New kmax [h/Mpc]:', k(nk)
      END IF  

   END SUBROUTINE cut_kmax

   SUBROUTINE VD20_get_more_power(k, Pk, Ek, nk, z, name, cosm, response, kmin, kmax, rebin)

      USE basic_operations
      USE array_operations
      USE interpolate
      USE cosmology_functions
      USE HMx
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Ek(:)
      INTEGER, INTENT(OUT) :: nk
      REAL, INTENT(IN) :: z
      CHARACTER(len=*), INTENT(IN) :: name
      TYPE(cosmology), INTENT(INOUT) :: cosm
      INTEGER, OPTIONAL, INTENT(IN) :: response
      REAL, OPTIONAL, INTENT(IN) :: kmin
      REAL, OPTIONAL, INTENT(IN) :: kmax
      LOGICAL, OPTIONAL, INTENT(IN) :: rebin
      REAL, ALLOCATABLE :: Pk_HMcode(:, :), a(:)!, k2(:), Pk2(:)
      INTEGER :: response_here

      INTEGER, PARAMETER :: na = 1
      LOGICAL, PARAMETER :: verbose = .FALSE.
      INTEGER, PARAMETER :: nk_rebin = 129
      INTEGER, PARAMETER :: iorder_rebin = 3
      INTEGER, PARAMETER :: ifind_rebin = 3
      INTEGER, PARAMETER :: iinterp_rebin = 2
      !INTEGER, PARAMETER :: HMcode_version = HMcode2020 ! For response

      IF (present(response)) THEN
         response_here = response
      ELSE
         response_here = 0
      END IF

      IF (response_here == 0) THEN
         
         CALL VD20_get_power(k, Pk, nk, z, name)

      ELSE

         CALL VD20_get_response(k, Pk, nk, z, name)

         ALLOCATE (Pk_HMcode(nk, na))
         ALLOCATE (a(na))
         a(1) = scale_factor_z(z)

         CALL calculate_HMcode(k, a, Pk_HMcode, nk, na, cosm, response)
         Pk = Pk*Pk_HMcode(:, 1)

      END IF

      ALLOCATE(Ek(nk))
      Ek = 0.

      CALL cut_kmin(kmin, k, Pk, Ek, nk, verbose)
      CALL cut_kmax(kmax, k, Pk, Ek, nk, verbose)

      ! Rebin on a log-linear axis
      IF (present_and_correct(rebin)) THEN
         IF(.NOT. present(kmin) .OR. .NOT. present(kmax)) THEN
            STOP 'VD20_GET_MORE_POWER: Something went wroxng'
         END IF
         nk = nk_rebin
         CALL rebin_array(kmin, kmax, nk, k, Pk, &
            iorder_rebin, &
            ifind_rebin, &
            iinterp_rebin, &
            logx=.TRUE., &
            logf=.TRUE.&
            )
         DEALLOCATE(Ek)
         Ek = Pk
         Ek = 0.
      END IF

   END SUBROUTINE VD20_get_more_power

   SUBROUTINE VD20_get_power(k, Pk, nk, z, name)

      USE io
      USE array_operations
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:)
      INTEGER, INTENT(OUT) :: nk
      REAL, INTENT(IN) :: z
      CHARACTER(len=*), INTENT(IN) :: name
      REAL, ALLOCATABLE :: zs(:), Pks(:, :)
      INTEGER :: iz, nz
      REAL, PARAMETER :: eps = 1e-4

      CALL VD20_read_power(k, zs, Pks, nk, nz, name)

      iz = array_position(z, zs, eps)
      ALLOCATE(Pk(nk))
      Pk = Pks(:, iz)

   END SUBROUTINE VD20_get_power

   SUBROUTINE VD20_get_response(k, Rk, nk, z, name)

      USE io
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Rk(:)
      INTEGER, INTENT(OUT) :: nk
      REAL, INTENT(IN) :: z
      CHARACTER(len=*), INTENT(IN) :: name
      REAL, ALLOCATABLE :: Pk(:), Pk_dmonly(:)
      CHARACTER(len=256) :: name_dmonly

      name_dmonly = VD20_dmonly_counterpart(name)

      CALL VD20_get_power(k, Pk, nk, z, name)
      CALL VD20_get_power(k, Pk_dmonly, nk, z, name_dmonly)

      ALLOCATE(Rk(nk))

      Rk = Pk/Pk_dmonly

   END SUBROUTINE VD20_get_response

   CHARACTER(len=256) FUNCTION VD20_dmonly_counterpart(name)

      CHARACTER(len=*), INTENT(IN) :: name

      IF (trim(name) == 'BAHAMAS_Theat7.6_nu0_WMAP9') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0_WMAP9_L400N1024'
      ELSE IF (trim(name) == 'BAHAMAS_Theat8.0_nu0_WMAP9') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0_WMAP9_L400N1024'
      ELSE IF (trim(name) == 'BAHAMAS_nu0.06_Planck2015') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0.06_Planck2015_L400N1024'
      ELSE IF (trim(name) == 'BAHAMAS_nu0.06_WMAP9') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0.06_WMAP9_L400N1024'
      ELSE IF (trim(name) == 'BAHAMAS_nu0.12_Planck2015') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0.12_Planck2015_L400N1024'
      ELSE IF (trim(name) == 'BAHAMAS_nu0.12_WMAP9') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0.12_WMAP9_L400N1024'
      ELSE IF (trim(name) == 'BAHAMAS_nu0.24_Planck2015') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0.24_Planck2015_L400N1024'
      ELSE IF (trim(name) == 'BAHAMAS_nu0.24_WMAP9') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0.24_WMAP9_L400N1024'
      ELSE IF (trim(name) == 'BAHAMAS_nu0.48_Planck2015') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0.48_Planck2015_L400N1024'
      ELSE IF (trim(name) == 'BAHAMAS_nu0.48_WMAP9') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0.48_WMAP9_L400N1024'
      ELSE IF (trim(name) == 'BAHAMAS_nu0_BAO_L200N512') THEN
         VD20_dmonly_counterpart = 'DMONLY_nu0_BAO_L200N512'
      ELSE IF (trim(name) == 'BAHAMAS_nu0_Planck2013') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0_Planck2013_L400N1024'
      ELSE IF (trim(name) == 'BAHAMAS_nu0_WMAP9') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0_WMAP9_L400N1024'
      ELSE IF (trim(name) == 'BAHAMAS_nu0_WMAP9_L100N512') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0_WMAP9_L100N512'
      ELSE IF (trim(name) == 'BAHAMAS_nu0_WMAP9_v2') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0_v2_WMAP9_L400N1024'
      ELSE IF (trim(name) == 'BAHAMAS_nu0_WMAP9_v3') THEN
         VD20_dmonly_counterpart = 'DMONLY_2fluid_nu0_v3_WMAP9_L400N1024'
      ELSE IF (trim(name) == 'C-OWLS_AGN_Planck2013') THEN
         VD20_dmonly_counterpart = 'DMONLY_Planck2013_L400N1024'
      ELSE IF (trim(name) == 'C-OWLS_AGN_Theat8.5_Planck2013') THEN
         VD20_dmonly_counterpart = 'DMONLY_Planck2013_L400N1024'
      ELSE IF (trim(name) == 'C-OWLS_AGN_Theat8.5_WMAP7') THEN
         VD20_dmonly_counterpart = 'DMONLY_WMAP7_L400N1024'
      ELSE IF (trim(name) == 'C-OWLS_AGN_Theat8.7_Planck2013') THEN
         VD20_dmonly_counterpart = 'DMONLY_Planck2013_L400N1024'
      ELSE IF (trim(name) == 'C-OWLS_AGN_Theat8.7_WMAP7') THEN
         VD20_dmonly_counterpart = 'DMONLY_WMAP7_L400N1024'
      ELSE IF (trim(name) == 'C-OWLS_AGN_WMAP7') THEN
         VD20_dmonly_counterpart = 'DMONLY_WMAP7_L400N1024'
      ELSE IF (trim(name) == 'C-OWLS_NOCOOL_UVB_Planck2013') THEN
         VD20_dmonly_counterpart = 'DMONLY_Planck2013_L400N1024'
      ELSE IF (trim(name) == 'C-OWLS_NOCOOL_UVB_WMAP7') THEN
         VD20_dmonly_counterpart = 'DMONLY_WMAP7_L400N1024'
      ELSE IF (trim(name) == 'C-OWLS_REF_Planck2013') THEN
         VD20_dmonly_counterpart = 'DMONLY_Planck2013_L400N1024'
      ELSE IF (trim(name) == 'C-OWLS_REF_WMAP7') THEN
         VD20_dmonly_counterpart = 'DMONLY_WMAP7_L400N1024'
      ELSE
         WRITE (*, *) 'VD20_DMONLY_COUNTERPART: Simulation: ', trim(name)
         STOP 'VD20_DMONLY_COUNTERPART: Error, no counterpart found'
      END IF

   END FUNCTION VD20_dmonly_counterpart

   INTEGER FUNCTION VD20_get_cosmology(sim)

      USE string_operations
      CHARACTER(len=*), INTENT(IN) :: sim

      IF (snippet_in_string('Planck2013', sim)) THEN
         VD20_get_cosmology = 3
      ELSE IF (snippet_in_string('nu0_WMAP9', sim) .OR. &
               snippet_in_string('nu0_v2_WMAP9', sim) .OR. &
               snippet_in_string('nu0_v3_WMAP9', sim)) THEN
         VD20_get_cosmology = 96
      ELSE IF (snippet_in_string('nu0.06_WMAP9', sim)) THEN
         VD20_get_cosmology = 75
      ELSE IF (snippet_in_string('nu0.12_WMAP9', sim)) THEN
         VD20_get_cosmology = 76
      ELSE IF (snippet_in_string('nu0.24_WMAP9', sim)) THEN
         VD20_get_cosmology = 77
      ELSE IF (snippet_in_string('nu0.48_WMAP9', sim)) THEN
         VD20_get_cosmology = 78
      ELSE IF (snippet_in_string('nu0.06_Planck2015', sim)) THEN
         VD20_get_cosmology = 63
      ELSE IF (snippet_in_string('nu0.12_Planck2015', sim)) THEN
         VD20_get_cosmology = 93
      ELSE IF (snippet_in_string('nu0.24_Planck2015', sim)) THEN
         VD20_get_cosmology = 94
      ELSE IF (snippet_in_string('nu0.48_Planck2015', sim)) THEN
         VD20_get_cosmology = 95
      ELSE
         WRITE(*, *) 'VD20_GET_COSMOLOGY: Simulation name: ', trim(sim)
         STOP 'VD20_GET_COSMOLOGY: Error, VD20 simulation name not recognised'
      END IF

   END FUNCTION VD20_get_cosmology

END MODULE owls_extras

MODULE Limber

   USE constants
   USE basic_operations
   USE array_operations
   USE interpolate
   USE cosmology_functions

   IMPLICIT NONE

   PRIVATE

   ! Types
   PUBLIC :: projection

   ! Functions
   PUBLIC :: maxdist
   PUBLIC :: calculate_Cl
   PUBLIC :: xcorr_type
   PUBLIC :: Cl_contribution_ell
   PUBLIC :: Cl_contribution
   PUBLIC :: fill_projection_kernels
   PUBLIC :: read_nz
   PUBLIC :: write_projection_kernel
   PUBLIC :: write_angular_xi
   PUBLIC :: write_nz
   PUBLIC :: write_efficiency
   PUBLIC :: calculate_angular_xi
   PUBLIC :: write_Cl
   PUBLIC :: k_ell
   PUBLIC :: xpow_pka
   PUBLIC :: xpow_halomod
   PUBLIC :: set_field_for_xpow

   ! Tracers
   PUBLIC :: n_tracers
   PUBLIC :: tracer_RCSLenS
   PUBLIC :: tracer_Compton_y
   PUBLIC :: tracer_CMB_lensing
   PUBLIC :: tracer_CFHTLenS_vanWaerbeke2013
   PUBLIC :: tracer_KiDS
   PUBLIC :: tracer_KiDS_bin1
   PUBLIC :: tracer_KiDS_bin2
   PUBLIC :: tracer_KiDS_bin3
   PUBLIC :: tracer_KiDS_bin4
   PUBLIC :: tracer_gravity_wave
   PUBLIC :: tracer_KiDS_450
   PUBLIC :: tracer_KiDS_450_fat_bin1
   PUBLIC :: tracer_KiDS_450_fat_bin2
   PUBLIC :: tracer_KiDS_450_highz
   PUBLIC :: tracer_CIB_353
   PUBLIC :: tracer_CIB_545
   PUBLIC :: tracer_CIB_857
   PUBLIC :: tracer_galaxies
   PUBLIC :: tracer_lensing_z1p00
   PUBLIC :: tracer_lensing_z0p75
   PUBLIC :: tracer_lensing_z0p50
   PUBLIC :: tracer_lensing_z0p25
   PUBLIC :: tracer_KiDS_450_bin1
   PUBLIC :: tracer_KiDS_450_bin2
   PUBLIC :: tracer_KiDS_450_bin3
   PUBLIC :: tracer_KiDS_450_bin4
   PUBLIC :: tracer_CFHTLenS_Kilbinger2013

   ! Projection quantities that need to be calculated only once; these relate to the Limber integrals
   TYPE projection
      REAL, ALLOCATABLE :: X(:), r_X(:)
      REAL, ALLOCATABLE :: q(:), r_q(:)
      REAL, ALLOCATABLE :: nz(:), z_nz(:)
      INTEGER :: nX, nq, nnz, order_nz
   END TYPE projection

   ! P(k,a) look-up table parameters
   REAL, PARAMETER :: kmin_pka = 1e-4   ! k' value for P(k,a) table; P(k<k',a)=0
   REAL, PARAMETER :: kmax_pka = 1e2    ! k' value for P(k,a) table; P(k>k',a)=0
   REAL, PARAMETER :: amin_pka = 1e-3   ! a' value for P(k,a) table; P(k,a<a')=0
   REAL, PARAMETER :: amax_pka = 1.     ! a' value for P(k,a) table; P(k,a>a')=0

   ! Maximum k that corresponding to a given ell (prevents infinities for low z)
   REAL, PARAMETER :: k_ell_max = 1e3

   ! xcorr - C(l) calculation
   LOGICAL, PARAMETER :: verbose_Limber = .FALSE. ! Verbosity

   ! Maxdist
   REAL, PARAMETER :: dr_max = 0.01 ! Small subtraction from maxdist to prevent numerical issues

   ! Limber integration parameters
   INTEGER, PARAMETER  :: n_cont = 1025 ! Number of samples to take in r for Cl ell contribution calculation
   REAL, PARAMETER :: lcorr = 0.5       ! 1/2 in LoVerde (2008) Limber correction k(r)=(l+1/2)/f_k(r)
   REAL, PARAMETER :: acc_Limber = 1e-4 ! Accuracy parameter for Limber integration

   ! n(z)
   REAL, PARAMETER :: zmin_nz = 0.  ! Minimum redshift for the analytic n(z) tables
   REAL, PARAMETER :: zmax_nz = 2.5 ! Maximum redshift for the analytic n(z) tables
   INTEGER, PARAMETER :: n_nz = 129 ! Number of entries in the analytic n(z) tables
   LOGICAL, PARAMETER :: norm_nz = .TRUE. ! Explicitly normalise the input n(z)

   ! Projection kernel options
   REAL, PARAMETER :: rmin_kernel = 0.         ! Minimum r for table
   INTEGER, PARAMETER :: nx_kernel = 129       ! Number of entires in look-up table
   REAL, PARAMETER :: rmin_lensing = 0.        ! Minimum distance in integral
   INTEGER, PARAMETER :: nX_lensing = 129      ! Number of entries in X(r) table
   INTEGER, PARAMETER :: nq_efficiency = 129   ! Number of entries in q(r) table
   !INTEGER, PARAMETER :: iorder_efficiency = 1 ! Order for lensing-efficiency integration over n(z)

   ! Gravitational waves
   REAL, PARAMETER :: A_gwave = 1.
   REAL, PARAMETER :: rmin_gwave = 10.

   ! Method for angular correlation function
   ! 1 - Summation with accuracy parameter (converges very slowly, accuracy condition seems to not work)
   ! 2 - Standard integration (does not converge well, crap)
   ! 3 - Standard summation
   ! 4 - Summation assuming C(l) precomputed (fastest)
   INTEGER, PARAMETER :: method_angular_xi = 4

   ! Angular xi verbosity
   LOGICAL, PARAMETER :: verbose_xi = .FALSE. ! Verbosity

   ! Tracer types
   INTEGER, PARAMETER :: tracer_RCSLenS = 1
   INTEGER, PARAMETER :: tracer_Compton_y = 2
   INTEGER, PARAMETER :: tracer_CMB_lensing = 3
   INTEGER, PARAMETER :: tracer_CFHTLenS_vanWaerbeke2013 = 4
   INTEGER, PARAMETER :: tracer_KiDS = 5
   INTEGER, PARAMETER :: tracer_KiDS_bin1 = 6
   INTEGER, PARAMETER :: tracer_KiDS_bin2 = 7
   INTEGER, PARAMETER :: tracer_KiDS_bin3 = 8
   INTEGER, PARAMETER :: tracer_KiDS_bin4 = 9
   INTEGER, PARAMETER :: tracer_gravity_wave = 10
   INTEGER, PARAMETER :: tracer_KiDS_450 = 11
   INTEGER, PARAMETER :: tracer_KiDS_450_fat_bin1 = 12
   INTEGER, PARAMETER :: tracer_KiDS_450_fat_bin2 = 13
   INTEGER, PARAMETER :: tracer_KiDS_450_highz = 14
   INTEGER, PARAMETER :: tracer_CIB_353 = 15
   INTEGER, PARAMETER :: tracer_CIB_545 = 16
   INTEGER, PARAMETER :: tracer_CIB_857 = 17
   INTEGER, PARAMETER :: tracer_galaxies = 18
   INTEGER, PARAMETER :: tracer_lensing_z1p00 = 19
   INTEGER, PARAMETER :: tracer_lensing_z0p75 = 20
   INTEGER, PARAMETER :: tracer_lensing_z0p50 = 21
   INTEGER, PARAMETER :: tracer_lensing_z0p25 = 22
   INTEGER, PARAMETER :: tracer_KiDS_450_bin1 = 23
   INTEGER, PARAMETER :: tracer_KiDS_450_bin2 = 24
   INTEGER, PARAMETER :: tracer_KiDS_450_bin3 = 25
   INTEGER, PARAMETER :: tracer_KiDS_450_bin4 = 26
   INTEGER, PARAMETER :: tracer_CFHTLenS_Kilbinger2013 = 27
   INTEGER, PARAMETER :: n_tracers = 27

CONTAINS

   CHARACTER(len=256) FUNCTION xcorr_type(ix)

      ! Names for cross-correlation field types
      INTEGER, INTENT(IN) :: ix

      xcorr_type = ''
      IF (ix == tracer_RCSLenS) xcorr_type = 'RCSLenS lensing'
      IF (ix == tracer_Compton_y) xcorr_type = 'Compton y'
      IF (ix == tracer_CMB_lensing) xcorr_type = 'CMB lensing'
      IF (ix == tracer_CFHTLenS_vanWaerbeke2013) xcorr_type = 'CFHTLenS lensing (van Waerbeke 2013)'
      IF (ix == tracer_KiDS) xcorr_type = 'KiDS lensing (z = 0.1 -> 0.9)'
      IF (ix == tracer_KiDS_bin1) xcorr_type = 'KiDS lensing (z = 0.1 -> 0.3)'
      IF (ix == tracer_KiDS_bin2) xcorr_type = 'KiDS lensing (z = 0.3 -> 0.5)'
      IF (ix == tracer_KiDS_bin3) xcorr_type = 'KiDS lensing (z = 0.5 -> 0.7)'
      IF (ix == tracer_KiDS_bin4) xcorr_type = 'KiDS lensing (z = 0.7 -> 0.9)'
      IF (ix == tracer_gravity_wave) xcorr_type = 'Gravitational waves'
      IF (ix == tracer_KiDS_450) xcorr_type = 'KiDS 450 (z = 0.1 -> 0.9)'
      IF (ix == tracer_KiDS_450_fat_bin1) xcorr_type = 'KiDS 450 (z = 0.1 -> 0.5)'
      IF (ix == tracer_KiDS_450_fat_bin2) xcorr_type = 'KiDS 450 (z = 0.5 -> 0.9)'
      IF (ix == tracer_KiDS_450_highz) xcorr_type = 'KiDS 450 (z = 0.9 -> 3.5)'
      IF (ix == tracer_CIB_353) xcorr_type = 'CIB 353 GHz'
      IF (ix == tracer_CIB_545) xcorr_type = 'CIB 545 GHz'
      IF (ix == tracer_CIB_857) xcorr_type = 'CIB 857 GHz'
      IF (ix == tracer_galaxies) xcorr_type = 'Galaxies'
      IF (ix == tracer_lensing_z1p00) xcorr_type = 'Lensing with fixed z=1.00 source plane'
      IF (ix == tracer_lensing_z0p75) xcorr_type = 'Lensing with fixed z=0.75 source plane'
      IF (ix == tracer_lensing_z0p50) xcorr_type = 'Lensing with fixed z=0.50 source plane'
      IF (ix == tracer_lensing_z0p25) xcorr_type = 'Lensing with fixed z=0.25 source plane'
      IF (ix == tracer_KiDS_450_bin1) xcorr_type = 'KiDS 450 (z = 0.1 -> 0.3)'
      IF (ix == tracer_KiDS_450_bin2) xcorr_type = 'KiDS 450 (z = 0.3 -> 0.5)'
      IF (ix == tracer_KiDS_450_bin3) xcorr_type = 'KiDS 450 (z = 0.5 -> 0.7)'
      IF (ix == tracer_KiDS_450_bin4) xcorr_type = 'KiDS 450 (z = 0.7 -> 0.9)'
      IF (ix == tracer_CFHTLenS_Kilbinger2013) xcorr_type = 'CFHTLenS lensing (Kilbinger 2013)'
      IF (xcorr_type == '') STOP 'XCORR_TYPE: Error, ix not specified correctly'

   END FUNCTION xcorr_type

   REAL FUNCTION k_ell(ell, a, cosm)

      ! Finds the k that corresponds to ell at the given a
      REAL, INTENT(IN) :: ell ! angular wave number
      REAL, INTENT(IN) :: a   ! scale factor
      TYPE(cosmology), INTENT(INOUT) :: cosm ! cosmology
      REAL :: r

      IF (a == 1.) THEN
         ! This should really be infinite, but this stops a division by infinity
         k_ell = k_ell_max
      ELSE
         r = comoving_distance(a, cosm)
         k_ell = (ell+lcorr)/f_k(r, cosm)
      END IF

   END FUNCTION k_ell

   SUBROUTINE write_nz(proj, output)

      ! Write out the n(z) to a file
      TYPE(projection), INTENT(IN) :: proj
      CHARACTER(len=*), INTENT(IN) :: output
      INTEGER :: i

      OPEN (7, file=output)
      DO i = 1, proj%nnz
         WRITE (7, *) proj%z_nz(i), proj%nz(i)
      END DO
      CLOSE (7)

   END SUBROUTINE write_nz

   SUBROUTINE fill_projection_kernels(ix, proj, cosm)

      ! Fill look-up tables for the two projection kerels X_ij
      ! TODO: Change to take ix(n)?
      INTEGER, INTENT(IN) :: ix(2) ! Label for the type of projection kernel needed
      TYPE(projection), INTENT(OUT) :: proj(2) ! Output the projection kernel
      TYPE(cosmology), INTENT(INOUT) :: cosm ! Cosmological model
      INTEGER :: nk, i

      IF (ix(1) == ix(2)) THEN
         nk = 1
      ELSE
         nk = 2
      END IF

      ! Loop over the two kernels
      DO i = 1, nk
         CALL fill_projection_kernel(ix(i), proj(i), cosm)
      END DO

      ! In case the autospectrum is being considered
      IF (nk == 1) THEN
         proj(2) = proj(1)
      END IF

   END SUBROUTINE fill_projection_kernels

   SUBROUTINE fill_projection_kernel(ix, proj, cosm)

      ! Fill look-up table for a projection kernel X_i
      INTEGER, INTENT(IN) :: ix
      TYPE(projection), INTENT(OUT) :: proj
      TYPE(cosmology), INTENT(INOUT) :: cosm
      !TYPE(lensing) :: lens

      IF (ix == tracer_Compton_y .OR. &
          ix == tracer_gravity_wave .OR. &
          ix == tracer_CIB_353 .OR. &
          ix == tracer_CIB_545 .OR. &
          ix == tracer_CIB_857 .OR. &
          ix == tracer_galaxies) THEN
         CALL fill_kernel(ix, proj, cosm)
      ELSE IF (ix == tracer_RCSLenS .OR. &
               ix == tracer_CFHTLenS_vanWaerbeke2013 .OR. &
               ix == tracer_CMB_lensing .OR. &
               ix == tracer_KiDS .OR. &
               ix == tracer_KiDS_bin1 .OR. &
               ix == tracer_KiDS_bin2 .OR. &
               ix == tracer_KiDS_bin3 .OR. &
               ix == tracer_KiDS_bin4 .OR. &
               ix == tracer_KiDS_450 .OR. &
               ix == tracer_KiDS_450_fat_bin1 .OR. &
               ix == tracer_KiDS_450_fat_bin2 .OR. &
               ix == tracer_KiDS_450_highz .OR. &
               ix == tracer_lensing_z1p00 .OR. &
               ix == tracer_lensing_z0p75 .OR. &
               ix == tracer_lensing_z0p50 .OR. &
               ix == tracer_lensing_z0p25 .OR. &
               ix == tracer_KiDS_450_bin1 .OR. &
               ix == tracer_KiDS_450_bin2 .OR. &
               ix == tracer_KiDS_450_bin3 .OR. &
               ix == tracer_KiDS_450_bin4 .OR. &
               ix == tracer_CFHTLenS_Kilbinger2013) THEN
         CALL fill_lensing_kernel(ix, proj, cosm)
      ELSE
         STOP 'FILL_PROJECTION_KERNEL: Error, tracer type specified incorrectly'
      END IF

   END SUBROUTINE fill_projection_kernel

   SUBROUTINE calculate_Cl(r1, r2, ell, Cell, nl, k, a, pow, nk, na, proj, cosm)

      ! Calculates C(l) using the Limber approximation
      ! Note that using Limber and flat-sky for sensible results limits lmin to ell~10
      INTEGER, INTENT(IN) :: nl, nk, na ! Number of ell values
      REAL, INTENT(IN) :: r1, r2 ! Maximum and minimum comoving distances for integration
      REAL, INTENT(IN) :: ell(nl) ! Input array of desired ell values for C(ell)
      REAL, INTENT(OUT) :: Cell(nl) ! Output array for C(ell) values  
      REAL, INTENT(IN) :: k(nk), a(na), pow(nk, na) ! Input k, a and P(k,a) arrays    
      TYPE(projection), INTENT(IN) :: proj(2) ! Projection kernels for the Limber integration
      TYPE(cosmology), INTENT(INOUT) :: cosm ! Cosmology
      REAL :: logk(nk), loga(na), logpow(nk, na)
      INTEGER :: i, j

      ! Create log tables to speed up 2D find routine in find_pkz
      logk = log(k)
      loga = log(a)
      DO j = 1, na
         logpow(:, j) = log((2.*pi**2)*pow(:, j)/k**3)
      END DO

      ! Write some useful things to the screen
      IF (verbose_Limber) THEN
         WRITE (*, *) 'CALCULATE_CL: ell min:', real(ell(1))
         WRITE (*, *) 'CALCULATE_CL: ell max:', real(ell(nl))
         WRITE (*, *) 'CALCULATE_CL: number of ell:', nl
         WRITE (*, *) 'CALCULATE_CL: kmin [h/Mpc]:', k(1)
         WRITE (*, *) 'CALCULATE_CL: kmax [h/Mpc]:', k(nk)
         WRITE (*, *) 'CALCULATE_CL: number of k:', nk
         WRITE (*, *) 'CALCULATE_CL: amin [h/Mpc]:', a(1)
         WRITE (*, *) 'CALCULATE_CL: amax [h/Mpc]:', a(na)
         WRITE (*, *) 'CALCULATE_CL: number of a:', na
         WRITE (*, *) 'CALCULATE_CL: Minimum distance [Mpc/h]:', real(r1)
         WRITE (*, *) 'CALCULATE_CL: Maximum distance [Mpc/h]:', real(r2)
      END IF

      ! Finally do the integration
      IF (verbose_Limber) WRITE (*, *) 'CALCULATE_CL: Doing calculation'
      DO i = 1, nl
         Cell(i) = integrate_Limber(ell(i), r1, r2, logk, loga, logpow, nk, na, acc_Limber, 3, proj, cosm)
      END DO
      IF (verbose_Limber) THEN
         WRITE (*, *) 'CALCULATE_CL: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE calculate_Cl

   SUBROUTINE Cl_contribution_ell(r1, r2, k, a, pow, nk, na, proj, cosm, fbase, fext)

      USE string_operations

      ! Calculates the contribution to each ell of C(l) as a function of z, k, r
      ! Note that using Limber and flat-sky for sensible results limits lmin to ~10
      INTEGER, INTENT(IN) :: nk, na ! Number of entries in k and a
      REAL, INTENT(IN) :: r1, r2 ! Integration range
      REAL, INTENT(IN) :: k(nk), a(na), pow(nk, na) ! Input arrays of k, a and P(k,a) 
      TYPE(projection), INTENT(IN) :: proj(2) ! Projection kernels
      TYPE(cosmology), INTENT(INOUT) :: cosm ! Cosmology
      CHARACTER(len=*), INTENT(IN) :: fbase
      CHARACTER(len=*), INTENT(IN) :: fext
      REAL :: logk(nk), loga(na), logpow(nk, na)
      REAL, ALLOCATABLE :: ell(:)
      INTEGER :: i, j
      CHARACTER(len=256) :: outfile

      REAL, PARAMETER :: lmin = 1e1
      REAL, PARAMETER :: lmax = 1e4
      INTEGER, PARAMETER :: nl = 17 ! Number of ell values to take, from l=1 to l=2**(n-1); 2^15 ~ 32,000

      ! Create log tables to speed up 2D find routine in find_pka
      logk = log(k)
      loga = log(a)
      DO j = 1, na
         logpow(:, j) = log((2.*pi**2)*pow(:, j)/k**3)
      END DO

      CALL fill_array(log(lmin), log(lmax), ell, nl)
      ell = exp(ell)

      ! Now call the contribution subroutine
      !fbase='data/Cl_contribution_ell_'
      !fext='.dat'
      DO i = 1, nl
         outfile = number_file(fbase, i, fext)
         CALL Limber_contribution(ell(i), r1, r2, logk, loga, logpow, nk, na, proj, cosm, outfile)
      END DO

   END SUBROUTINE Cl_contribution_ell

   SUBROUTINE write_Cl(l, Cl, nl, outfile, verbose)

      ! Write C(l) to a file; writes l, C(l), l(l+1)C(l)/2pi
      INTEGER, INTENT(IN) :: nl
      REAL, INTENT(IN) :: l(nl)
      REAL, INTENT(IN) :: Cl(nl)
      CHARACTER(len=256) :: outfile
      LOGICAL, INTENT(IN) :: verbose
      INTEGER :: i

      IF (verbose) WRITE (*, *) 'WRITE_CL: Writing data to: ', TRIM(outfile)
      OPEN (7, file=outfile)
      DO i = 1, nl
         WRITE (7, *) l(i), Cl(i), l(i)*(l(i)+1.)*Cl(i)/twopi
      END DO
      CLOSE (7)
      IF (verbose) THEN
         WRITE (*, *) 'WRITE_CL: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE write_Cl

   SUBROUTINE calculate_angular_xi(ibessel, m, th_tab, xi_tab, n, l_tab, cl_tab, nl, lmax)

      ! Calcuate the two-dimensional correlation functions given a C(ell) array
      ! This uses the direct sum over discrete ell do the transformation
      ! TODO: Can I bunch together ell in the sum when ell is high?
      INTEGER, INTENT(IN) :: m, n, nl   ! Number of Bessel function transforms
      INTEGER, INTENT(IN) :: ibessel(m) ! Bessel functions to use   
      REAL, INTENT(IN) :: th_tab(n)     ! Angles for correlation function [degrees]
      REAL, INTENT(OUT) :: xi_tab(m, n) ! Correlation function    
      REAL, INTENT(IN) :: l_tab(nl)     ! Array of ell
      REAL, INTENT(IN) :: cl_tab(nl)    ! Array of C(ell)
      INTEGER, INTENT(IN) :: lmax       ! Maximum ell to go to in summation
      INTEGER :: i, j, l
      INTEGER :: ifind
      REAL :: logl(nl), logCl(nl), Cl(lmax)
      REAL :: theta, xi(m)
      INTEGER, PARAMETER :: iorder=3
      INTEGER, PARAMETER :: imeth=2

      ! Method
      ! 1 - Summation with accuracy parameter (converges very slowly, accuracy condition seems to not work)
      ! 2 - Standard integration (does not converge well, crap)
      ! 3 - Standard summation
      ! 4 - Summation assuming C(l) precomputed (fastest)
      INTEGER, PARAMETER :: method = method_angular_xi

      ! Speed up find routine by doing logarithms in advance
      logl = log(l_tab)
      logCl = log(cl_tab)

      IF (method == 4) THEN
         ! Need to precompute C(l) at each integer l for this method
         IF (regular_spacing(logl)) THEN
            ifind = 1 ! Array is linearly spaced
         ELSE
            ifind = 3 ! Mid-point method
         END IF
         DO l = 1, lmax
            Cl(l) = exp(find(log(real(l)), logl, logCl, nl, iorder, ifind, imeth))
         END DO
      END IF

      IF (verbose_xi) WRITE (*, *) 'CALCULATE_ANGULAR_XI: Computing correlation functions'

      DO i = 1, n

         ! Get theta value and convert from degrees to radians
         theta = th_tab(i)/rad2deg

         ! Calculate the correlation function
         DO j = 1, m

            IF (method == 1) THEN
               xi(j) = angular_xi_summation_adaptive(theta, ibessel(j), logl, logCl, nl, lmax, acc=acc_Limber)
            ELSE IF (method == 2) THEN
               xi(j) = integrate_angular_xi(theta, ibessel(j), logl, logCl, nl, acc_Limber)
            ELSE IF (method == 3) THEN
               IF (j == 2) EXIT
               xi = angular_xi_summation(theta, ibessel(j), m, logl, logCl, nl, lmax)
            ELSE IF (method == 4) THEN
               IF (j == 2) EXIT
               xi = angular_xi_summation_precompute(theta, ibessel, m, Cl, lmax)
            ELSE
               STOP 'CALCULATE_ANGULAR_XI: Error, method specified incorrectly'
            END IF

         END DO

         ! Populate tables
         xi_tab(:, i) = xi

      END DO

      IF (verbose_xi) THEN
         WRITE (*, *) 'CALCULATE_ANGULAR_XI: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE calculate_angular_xi

   REAL FUNCTION angular_xi_summation_adaptive(theta, nbessel, logl, logCl, nl, lmax, acc)

      USE special_functions

      ! This routine converges very slowly. The adaptive part seems to be terrible
      ! TODO: Probably remove this, although I am not sure why it is so bad
      INTEGER, INTENT(IN) :: nl       ! Number of entries in l-Cl arrays
      REAL, INTENT(IN) :: theta       ! Angle [rad]
      INTEGER, INTENT(IN) :: nbessel  ! Order form Bessel functions to use
      REAL, INTENT(IN) :: logl(nl)    ! Array of log l
      REAL, INTENT(IN) :: logCl(nl)   ! Array of log Cl  
      INTEGER, INTENT(IN) :: lmax     ! Maximum number of l to sum
      REAL, INTENT(IN) :: acc         ! Accuracy
      INTEGER :: l
      REAL :: Cl, xi
      REAL :: sum
      INTEGER, PARAMETER :: iorder = 3    ! Order for interpolation to find C(l) (3 - cubic)
      INTEGER, PARAMETER :: ifind = 3     ! Finding scheme for interpolation of C(l) (3 - mid-point)
      INTEGER, PARAMETER :: imeth = 2     ! Interpolation polynomial (2 - Lagrange polynomial)
      INTEGER, PARAMETER :: lmin = 100    ! Minimum number of l to sum

      ! Set values to zero before summing
      sum = 0.

      ! Do the conversion from Cl to xi as a summation over integer l
      DO l = 1, lmax

         ! Get the C(l) value associated with integer l
         Cl = exp(find(log(real(l)), logl, logCl, nl, iorder, ifind, imeth))

         ! Add to the running todays for the correlation functions
         xi = (2.*real(l)+1.)*Cl*Bessel(nbessel, real(l)*theta)
         sum = sum+xi

         ! Exit loop if sufficiently accurate
         IF (l > lmin .AND. ABS(xi/sum) < acc) THEN
            EXIT
         END IF

      END DO

      ! Divide by correct pre-factor
      angular_xi_summation_adaptive = real(sum)/(4.*pi)

   END FUNCTION angular_xi_summation_adaptive

   FUNCTION angular_xi_summation(theta, ibessel, n, logl, logCl, nl, lmax)

      USE special_functions

      INTEGER, INTENT(IN) :: n, nl          ! Number of Bessel functions to use
      REAL :: angular_xi_summation(n)
      REAL, INTENT(IN) :: theta         ! Angle [rad]
      INTEGER, INTENT(IN) :: ibessel(n) ! Order form Bessel functions to use    
      REAL, INTENT(IN) :: logl(nl)      ! Array of log l
      REAL, INTENT(IN) :: logCl(nl)     ! Array of log Cl  
      INTEGER, INTENT(IN) :: lmax       ! Maximum number of l to sum
      INTEGER :: l, i
      REAL :: Cl, xi(n)
      INTEGER :: ifind
      REAL :: sum(n)
      INTEGER, PARAMETER :: iorder = 3  ! Order for interpolation to find C(l) (3 - cubic)
      INTEGER, PARAMETER :: imeth = 2   ! Interpolation polynomial (2 - Lagrange polynomial)

      IF (regular_spacing(logl)) THEN
         ifind = 1 ! Array is linearly spaced
      ELSE
         ifind = 3 ! Mid-point method
      END IF

      ! Set values to zero before summing
      sum = 0.

      ! Do the conversion from Cl to xi as a summation over integer l
      DO l = 1, lmax

         ! Get the C(l) value associated with integer l
         Cl = exp(find(log(real(l)), logl, logCl, nl, iorder, ifind, imeth))

         ! Add to the running totals for the correlation functions
         DO i = 1, n
            xi(i) = (2.*real(l)+1.)*Cl*Bessel(ibessel(i), real(l)*theta)
            sum(i) = sum(i)+xi(i)
         END DO

      END DO

      ! Divide by correct pre-factor
      angular_xi_summation = real(sum)/(4.*pi)

   END FUNCTION angular_xi_summation

   FUNCTION angular_xi_summation_precompute(theta, ibessel, n, Cl, nl)

      USE special_functions

      INTEGER, INTENT(IN) :: n, nl          ! Number of Bessel functions to use
      REAL :: angular_xi_summation_precompute(n)
      REAL, INTENT(IN) :: theta         ! Angle [rad]
      INTEGER, INTENT(IN) :: ibessel(n) ! Order form Bessel functions to use 
      REAL, INTENT(IN) :: Cl(nl)     ! Array of log Cl 
      INTEGER :: l, i
      REAL :: xi(n)
      REAL :: sum(n)

      ! Set values to zero before summing
      sum = 0.

      ! Do the conversion from Cl to xi as a summation over integer l
      DO l = 1, nl

         ! Add to the running totals for the correlation functions
         DO i = 1, n
            xi(i) = (2.*real(l)+1.)*Cl(l)*Bessel(ibessel(i), real(l)*theta)
            sum(i) = sum(i)+xi(i)
         END DO

      END DO

      ! Divide by correct pre-factor
      angular_xi_summation_precompute = real(sum)/(4.*pi)

   END FUNCTION angular_xi_summation_precompute

   REAL FUNCTION integrate_angular_xi(theta, nbessel, logl, logCl, nl, acc)

      ! Integrates between a and b until desired accuracy is reached
      ! Stores information to reduce function calls
      INTEGER, INTENT(IN) :: nl
      REAL, INTENT(IN) :: theta
      INTEGER, INTENT(IN) :: nbessel
      REAL, INTENT(IN) :: logl(nl)
      REAL, INTENT(IN) :: logCl(nl)
      REAL, INTENT(IN) :: acc
      INTEGER :: i, j
      INTEGER :: n
      REAL :: x, dx
      REAL :: f1, f2, fx
      REAL :: sum_n, sum_2n, sum_new, sum_old
      LOGICAL :: pass
      REAL, PARAMETER :: a = 0.
      REAL, PARAMETER :: b = 1.
      INTEGER, PARAMETER :: jmin = 5   ! Standard integration parameters
      INTEGER, PARAMETER :: jmax = 30  ! Standard integration parameters
      INTEGER, PARAMETER :: iorder = 3 ! Order for integration

      IF (a == b) THEN

         ! Fix the answer to zero if the integration limits are identical
         integrate_angular_xi = 0.

      ELSE

         ! Set the sum variable for the integration
         sum_2n = 0.
         sum_n = 0.
         sum_old = 0.
         sum_new = 0.

         DO j = 1, jmax

            ! Note, you need this to be 1+2**n for some integer n
            ! j=1 n=2; j=2 n=3; j=3 n=5; j=4 n=9; ...'
            n = 1+2**(j-1)

            ! Calculate the dx interval for this value of 'n'
            dx = (b-a)/real(n-1)

            IF (j == 1) THEN

               ! The first go is just the trapezium of the end points
               f1 = angular_xi_integrand(a, theta, nbessel, logl, logCl, nl)
               f2 = angular_xi_integrand(b, theta, nbessel, logl, logCl, nl)
               sum_2n = 0.5*(f1+f2)*dx
               sum_new = sum_2n

            ELSE

               ! Loop over only new even points to add these to the integral
               DO i = 2, n, 2
                  x = progression(a, b, i, n)
                  fx = angular_xi_integrand(x, theta, nbessel, logl, logCl, nl)
                  sum_2n = sum_2n+fx
               END DO

               ! Now create the total using the old and new parts
               sum_2n = sum_n/2.+sum_2n*dx

               ! Now calculate the new sum depending on the integration order
               IF (iorder == 1) THEN
                  sum_new = sum_2n
               ELSE IF (iorder == 3) THEN
                  sum_new = (4.*sum_2n-sum_n)/3. ! This is Simpson's rule and cancels error
               ELSE
                  STOP 'INTEGRATE_ANGULAR_XI: Error, iorder specified incorrectly'
               END IF

            END IF

            IF (sum_old == 0.d0 .OR. j<jmin) THEN
               pass = .FALSE.
            ELSE IF (j == jmax) THEN
               STOP 'INTEGRATE_COSM_1: Integration timed out'
            ELSE IF (abs(-1.d0+sum_new/sum_old) < acc) THEN
               pass = .TRUE.
            ELSE
               pass = .FALSE.
            END IF

            IF (pass) THEN
               EXIT
            ELSE
               ! Integral has not converged so store old sums and reset sum variables
               sum_old = sum_new
               sum_n = sum_2n
               sum_2n = 0.d0
            END IF

         END DO

         integrate_angular_xi = sum_new

      END IF

   END FUNCTION integrate_angular_xi

   REAL FUNCTION angular_xi_integrand(t, theta, nbessel, logl, logCl, nl)

      USE special_functions

      ! TODO: Write integration routine for this
      INTEGER, INTENT(IN) :: nl       ! Number of entries in l-Cl arrays
      REAL, INTENT(IN) :: t           ! Integration variable: 1+l = 1/t
      REAL, INTENT(IN) :: theta       ! Angle [rad]
      INTEGER, INTENT(IN) :: nbessel  ! Order of Bessel functions to use
      REAL, INTENT(IN) :: logl(nl)    ! Array of log l
      REAL, INTENT(IN) :: logCl(nl)   ! Array of log Cl  
      REAL :: l, Cl
      INTEGER, PARAMETER :: iorder = 3 ! Order for interpolation to find C(l) (3 - cubic)
      INTEGER, PARAMETER :: ifind = 3  ! Finding scheme for interpolation of C(l) (3 - mid-point)
      INTEGER, PARAMETER :: imeth = 2  ! Interpolation polynomial (2 - Lagrange polynomial)

      IF (t == 0.) THEN
         ! Corresponds to l=infinity, where Cl is zero (hopefully)
         angular_xi_integrand = 0.
      ELSE IF (t == 1.) THEN
         ! Corresponds to l=0, where Cl is zero (hopefully)
         angular_xi_integrand = 0.
      ELSE IF (t < 0. .OR. t > 1.) THEN
         STOP 'ANGULAR_XI_INTEGRAND: Error, t is out of bounds'
      ELSE
         l = -1.+1./t
         Cl = exp(find(log(l), logl, logCl, nl, iorder, ifind, imeth))
         angular_xi_integrand = l*Cl*Bessel(nbessel, l*theta)/t**2
      END IF

   END FUNCTION

   SUBROUTINE write_angular_xi(th_tab, xi_tab, nb, nth, outfile)

      ! Write angular correlation functions to disk
      ! TODO: Is this a bit absurd?
      INTEGER, INTENT(IN) :: nb, nth          ! Number of theta values
      REAL, INTENT(IN) :: th_tab(nth)     ! Array of theta values [probably degress]
      REAL, INTENT(IN) :: xi_tab(nb, nth) ! Correlation functions
      CHARACTER(len=256), INTENT(IN) :: outfile ! Output file
      INTEGER :: i, j

      OPEN (7, file=outfile)
      DO i = 1, nth
         WRITE (7, *) th_tab(i), (xi_tab(j, i), j=1, nb)
      END DO
      CLOSE (7)

   END SUBROUTINE write_angular_xi

   FUNCTION maxdist(proj)

      ! Calculates the maximum distance necessary for the lensing integration
      REAL :: maxdist
      TYPE(projection), INTENT(IN) :: proj(2)
      REAL :: rmax1, rmax2

      !Fix the maximum redshift and distance (which may fixed at source plane)
      rmax1 = maxval(proj(1)%r_x)
      rmax2 = maxval(proj(2)%r_x)

      !Subtract a small distance here because of rounding errors in recalculating zmax
      maxdist = min(rmax1, rmax2)-dr_max

   END FUNCTION maxdist

   SUBROUTINE write_projection_kernel(proj, cosm, outfile)

      TYPE(projection), INTENT(IN) :: proj
      TYPE(cosmology), INTENT(INOUT) :: cosm
      CHARACTER(len=256), INTENT(IN) :: outfile
      INTEGER :: i
      REAL :: r, z

      ! Kernel
      IF (verbose_Limber) WRITE (*, *) 'WRITE_PROJECTION_KERNEL: Writing out kernel: ', trim(outfile)
      OPEN (7, file=outfile)
      DO i = 1, proj%nX
         r = proj%r_X(i)
         z = redshift_r(r, cosm)
         WRITE (7, *) r, z, proj%X(i)
      END DO
      CLOSE (7)
      IF (verbose_Limber) THEN
         WRITE (*, *) 'WRITE_PROJECTION_KERNEL: Writing done'
         WRITE (*, *)
      END IF

   END SUBROUTINE write_projection_kernel

   SUBROUTINE fill_lensing_kernel(ix, proj, cosm)

      ! Fill the lensing projection kernel
      INTEGER, INTENT(IN) :: ix
      !TYPE(lensing) :: lens
      TYPE(cosmology), INTENT(INOUT) :: cosm
      TYPE(projection), INTENT(OUT) :: proj
      REAL :: zmin, zmax, rmax, amax, r, dz
      INTEGER :: i, nX

      ! Choose either n(z) or fixed z_s
      IF (ix == tracer_CMB_lensing .OR. &
          ix == tracer_lensing_z1p00 .OR. &
          ix == tracer_lensing_z0p75 .OR. &
          ix == tracer_lensing_z0p50 .OR. &
          ix == tracer_lensing_z0p25) THEN
         zmin = 0.
         IF (ix == tracer_CMB_lensing) THEN
            zmax = cosm%z_cmb
         ELSE IF (ix == tracer_lensing_z1p00) THEN
            zmax = 1.00
         ELSE IF (ix == tracer_lensing_z0p75) THEN
            zmax = 0.75
         ELSE IF (ix == tracer_lensing_z0p50) THEN
            zmax = 0.50
         ELSE IF (ix == tracer_lensing_z0p25) THEN
            zmax = 0.25
         ELSE
            STOP 'FILL_LENSING_KERNEL: Error, tracer is specified incorrectly'
         END IF
         IF (verbose_Limber) WRITE (*, *) 'FILL_LENSING_KERNEL: Source plane redshift:', real(zmax)
      ELSE IF (ix == tracer_RCSLenS .OR. &
               ix == tracer_CFHTLenS_vanWaerbeke2013 .OR. &
               ix == tracer_KiDS .OR. &
               ix == tracer_KiDS_bin1 .OR. &
               ix == tracer_KiDS_bin2 .OR. &
               ix == tracer_KiDS_bin3 .OR. &
               ix == tracer_KiDS_bin4 .OR. &
               ix == tracer_KiDS_450 .OR. &
               ix == tracer_KiDS_450_fat_bin1 .OR. &
               ix == tracer_KiDS_450_fat_bin2 .OR. &
               ix == tracer_KiDS_450_highz .OR. &
               ix == tracer_KiDS_450_bin1 .OR. &
               ix == tracer_KiDS_450_bin2 .OR. &
               ix == tracer_KiDS_450_bin3 .OR. &
               ix == tracer_KiDS_450_bin4 .OR. &
               ix == tracer_CFHTLenS_Kilbinger2013) THEN
         CALL read_nz(ix, proj)
         IF (proj%order_nz == 0) THEN
            dz = proj%z_nz(2)-proj%z_nz(1)
            zmin = proj%z_nz(1)-dz/2.
            zmax = proj%z_nz(proj%nnz)+dz/2.
         ELSE
            zmin = proj%z_nz(1)
            zmax = proj%z_nz(proj%nnz)
         END IF
      ELSE
         STOP 'FILL_LENSING_KERNEL: Error, tracer is specified incorrectly'
      END IF

      ! Get the distance range for the lensing kernel
      amax = scale_factor_z(zmax)
      rmax = comoving_distance(amax, cosm)
      IF (verbose_Limber) THEN
         WRITE (*, *) 'FILL_LENSING_KERNEL: minimum r [Mpc/h]:', real(rmin_lensing)
         WRITE (*, *) 'FILL_LENSING_KERNEL: maximum r [Mpc/h]:', real(rmax)
         WRITE (*, *) 'FILL_LENSING_KERNEL: minimum z:', real(zmin)
         WRITE (*, *) 'FILL_LENSING_KERNEL: maximum z:', real(zmax)
         WRITE (*, *)
      END IF

      ! Fill the q(r) table
      CALL fill_efficiency(ix, rmin_lensing, rmax, zmax, proj, cosm)

      ! Assign arrays for the projection function
      nX = nX_lensing
      proj%nx = nx
      CALL fill_array(rmin_lensing, rmax, proj%r_x, nx)
      IF (verbose_Limber) WRITE (*, *) 'FILL_LENSING_KERNEL: number of points:', nx
      IF (ALLOCATED(proj%x)) DEALLOCATE (proj%x)
      ALLOCATE (proj%x(proj%nx))

      DO i = 1, nx
         ! Get r and fill X(r)
         r = proj%r_x(i)
         proj%x(i) = lensing_kernel(r, proj, cosm)
         ! Enforce that the kernel must not be negative (is this necessary?)
         IF (proj%x(i) < 0.) proj%x(i) = 0.
      END DO
      IF (verbose_Limber) THEN
         WRITE (*, *) 'FILL_LENSING_KERNEL: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE fill_lensing_kernel

   SUBROUTINE fill_efficiency(ix, rmin, rmax, zmax, proj, cosm)

      ! Fill the table for lensing efficiency
      INTEGER, INTENT(IN) :: ix
      REAL, INTENT(IN) :: rmin, rmax, zmax
      TYPE(projection), INTENT(INOUT) :: proj
      TYPE(cosmology), INTENT(INOUT) :: cosm
      REAL :: r, z
      INTEGER :: i
      INTEGER, PARAMETER :: iorder=3

      ! Fill the r vs. q(r) tables
      proj%nq = nq_efficiency
      IF (verbose_Limber) WRITE (*, *) 'FILL_EFFICIENCY: number of points:', proj%nq
      CALL fill_array(rmin, rmax, proj%r_q, proj%nq)
      IF (ALLOCATED(proj%q)) DEALLOCATE (proj%q)
      ALLOCATE (proj%q(proj%nq))

      DO i = 1, proj%nq
         r = proj%r_q(i)
         z = redshift_r(r, cosm)
         !WRITE(*,*) i, z, zmax
         IF (r == 0.) THEN
            ! To avoid division by zero
            proj%q(i) = 1.
         ELSE IF (i == proj%nq) THEN
            proj%q(i) = 0.
         ELSE
            IF (ix == tracer_CMB_lensing .OR. &
                ix == tracer_lensing_z1p00 .OR. &
                ix == tracer_lensing_z0p75 .OR. &
                ix == tracer_lensing_z0p50 .OR. &
                ix == tracer_lensing_z0p25) THEN
               ! q(r) for a fixed source plane
               proj%q(i) = f_k(rmax-r, cosm)/f_k(rmax, cosm)
            ELSE IF (ix == tracer_RCSLenS .OR. &
                     ix == tracer_CFHTLenS_vanWaerbeke2013 .OR. &
                     ix == tracer_KiDS .OR. &
                     ix == tracer_KiDS_bin1 .OR. &
                     ix == tracer_KiDS_bin2 .OR. &
                     ix == tracer_KiDS_bin3 .OR. &
                     ix == tracer_KiDS_bin4 .OR. &
                     ix == tracer_KiDS_450 .OR. &
                     ix == tracer_KiDS_450_fat_bin1 .OR. &
                     ix == tracer_KiDS_450_fat_bin2 .OR. &
                     ix == tracer_KiDS_450_highz .OR. &
                     ix == tracer_KiDS_450_bin1 .OR. &
                     ix == tracer_KiDS_450_bin2 .OR. &
                     ix == tracer_KiDS_450_bin3 .OR. &
                     ix == tracer_KiDS_450_bin4 .OR. &
                     ix == tracer_CFHTLenS_Kilbinger2013) THEN
               ! q(r) for a n(z) distribution
               proj%q(i) = integrate_q(r, z, zmax, acc_Limber, iorder, proj, cosm)
            ELSE
               STOP 'FILL_EFFICIENCY: Error, tracer specified incorrectly'
            END IF
         END IF
      END DO

      IF (verbose_Limber) THEN
         WRITE (*, *) 'FILL_EFFICIENCY: Done writing'
         WRITE (*, *)
      END IF

   END SUBROUTINE fill_efficiency

   FUNCTION q_r(r, proj)

      ! Interpolation function for q(r)
      REAL :: q_r
      REAL, INTENT(IN) :: r
      TYPE(projection), INTENT(IN) :: proj

      q_r = find(r, proj%r_q, proj%q, proj%nq, 3, 3, 2)

   END FUNCTION q_r

   SUBROUTINE write_efficiency(proj, cosm, outfile)

      ! Write lensing efficiency q(r) function to a file
      TYPE(projection), INTENT(INOUT) :: proj
      TYPE(cosmology), INTENT(INOUT) :: cosm
      CHARACTER(len=256), INTENT(IN) :: outfile
      REAL :: r, z, q
      INTEGER :: i

      WRITE (*, *) 'WRITE_EFFICIENCY: Writing q(r): ', trim(outfile)
      OPEN (7, file=outfile)
      DO i = 1, proj%nq
         r = proj%r_q(i)
         z = redshift_r(r, cosm)
         q = proj%q(i)
         WRITE (7, *) r, z, q
      END DO
      CLOSE (7)
      WRITE (*, *) 'WRITE_EFFICIENCY: Done'
      WRITE (*, *)

   END SUBROUTINE write_efficiency

   FUNCTION lensing_kernel(r, proj, cosm)

      ! The lensing projection kernel
      REAL :: lensing_kernel
      REAL, INTENT(IN) :: r
      TYPE(projection) :: proj
      TYPE(cosmology), INTENT(INOUT) :: cosm
      REAL :: z, q

      ! Get z(r)
      z = redshift_r(r, cosm)

      ! Get the lensing efficiency
      q = q_r(r, proj)

      ! This is then the projection kernel (X_kappa)
      lensing_kernel = (1.+z)*f_k(r, cosm)*q
      lensing_kernel = lensing_kernel*1.5*cosm%om_m/(Hdist**2)

   END FUNCTION lensing_kernel

   SUBROUTINE fill_kernel(ix, proj, cosm)

      ! Fill a table of kernel values
      INTEGER, INTENT(IN) :: ix
      TYPE(projection), INTENT(OUT) :: proj
      TYPE(cosmology), INTENT(INOUT) :: cosm
      INTEGER :: i, nX
      REAL :: rmax, r

      nX = nx_kernel
      proj%nx = nx

      ! Get the distance range for the projection function
      ! Use the same as that for the distance calculation
      ! Assign arrays for the kernel function
      !rmax=comoving_distance(0.,cosm) ! Cheat to ensure that init_distance has been run
      !rmax=maxval(cosm%r)
      rmax = comoving_distance(scale_factor_z(cosm%z_CMB), cosm) ! TODO: Worry
      CALL fill_array(rmin_kernel, rmax, proj%r_X, proj%nX)
      IF (verbose_Limber) THEN
         WRITE (*, *) 'FILL_KERNEL: minimum r [Mpc/h]:', real(rmin_kernel)
         WRITE (*, *) 'FILL_KERNEL: maximum r [Mpc/h]:', real(rmax)
         WRITE (*, *) 'FILL_KERNEL: number of points:', nX
      END IF

      IF (ALLOCATED(proj%X)) DEALLOCATE (proj%X)
      ALLOCATE (proj%X(nX))

      ! Now fill the kernels
      DO i = 1, nX
         r = proj%r_x(i)
         IF (ix == tracer_Compton_y) THEN
            proj%x(i) = y_kernel(r, cosm)
         ELSE IF (ix == tracer_gravity_wave) THEN
            proj%x(i) = gwave_kernel(r, cosm)
         ELSE IF (ix == tracer_CIB_353 .OR. ix == tracer_CIB_545 .OR. ix == tracer_CIB_857) THEN
            proj%x(i) = CIB_kernel(r, cosm)
         ELSE IF (ix == tracer_galaxies) THEN
            proj%x(i) = galaxy_kernel(r, cosm)
         ELSE
            STOP 'FILL_KERNEL: Error, tracer specified incorrectly'
         END IF
      END DO

      IF (verbose_Limber) THEN
         WRITE (*, *) 'FILL_KERNEL: Done:'
         WRITE (*, *)
      END IF

   END SUBROUTINE fill_kernel

   FUNCTION y_kernel(r, cosm)

      ! The Compton-y projection kernel
      ! TODO: (re)check the power of 'a'
      REAL :: y_kernel
      REAL, INTENT(IN) :: r
      TYPE(cosmology), INTENT(INOUT) :: cosm
      REAL :: z, a

      ! Get the scale factor
      z = redshift_r(r, cosm)
      a = scale_factor_z(z)

      ! Make the kernel and do some unit conversions
      y_kernel = yfac                     ! yfac = sigma_T / m_e c^2 [kg^-1 s^2]
      y_kernel = y_kernel*Mpc/cosm%h      ! Add Mpc/h units from the dr in the integral (h is new)
      y_kernel = y_kernel/a**2            ! These come from 'a^-3' for pressure multiplied by 'a' for comoving distance
      y_kernel = y_kernel*eV*(0.01)**(-3) ! Convert units of pressure spectrum from [eV/cm^3] to [J/m^3]

   END FUNCTION y_kernel

   REAL FUNCTION gwave_kernel(r, cosm)

      ! Projection kernel for gravitational waves (~ 1/r)
      REAL, INTENT(IN) :: r
      TYPE(cosmology), INTENT(INOUT) :: cosm
      REAL :: crap

      ! To stop compile-time warnings
      crap = cosm%Om_m

      IF (r < rmin_gwave) THEN
         gwave_kernel = A_gwave/rmin_gwave
      ELSE
         gwave_kernel = A_gwave/r
      END IF

   END FUNCTION gwave_kernel

   REAL FUNCTION CIB_kernel(r, cosm)

      ! Projection kernel CIB emission
      REAL, INTENT(IN) :: r
      TYPE(cosmology), INTENT(INOUT) :: cosm
      REAL :: z, a
      REAL :: rmin = 1. ! Minimum radius [Mpc/h]

      IF (r < rmin) THEN
         CIB_kernel = 0.
      ELSE
         z = redshift_r(r, cosm)
         a = scale_factor_z(z)
         CIB_kernel = 1./((1.+z)*luminosity_distance(a, cosm)**2)
      END IF

   END FUNCTION CIB_kernel

   REAL FUNCTION galaxy_kernel(r, cosm)

      USE special_functions

      REAL, INTENT(IN) :: r
      TYPE(cosmology), INTENT(INOUT) :: cosm
      REAL :: z, a
      REAL, PARAMETER :: sig = 0.5

      z = redshift_r(r, cosm)
      a = scale_factor_z(z)

      !nz=Rayleigh(z,sig) ! No, because this is included in the window function for galaxiex

      galaxy_kernel = sqrt(Hubble2(a, cosm))/Hdist

   END FUNCTION galaxy_kernel

   SUBROUTINE read_nz(ix, proj)
    
      USE calculus_table

      ! The the n(z) function for lensing
      INTEGER, INTENT(IN) :: ix
      TYPE(projection), INTENT(INOUT) :: proj
      REAL :: norm
      LOGICAL, PARAMETER :: normalise = norm_nz

      IF (ix == tracer_RCSLenS .OR. ix == tracer_CFHTLenS_vanWaerbeke2013) THEN
         CALL fill_analytic_nz_table(ix, proj)
      ELSE IF (ix == tracer_KiDS .OR. &
               ix == tracer_KiDS_bin1 .OR. &
               ix == tracer_KiDS_bin2 .OR. &
               ix == tracer_KiDS_bin3 .OR. &
               ix == tracer_KiDS_bin4 .OR. &
               ix == tracer_KiDS_450 .OR. &
               ix == tracer_KiDS_450_fat_bin1 .OR. &
               ix == tracer_KiDS_450_fat_bin2 .OR. &
               ix == tracer_KiDS_450_highz .OR. &
               ix == tracer_KiDS_450_bin1 .OR. &
               ix == tracer_KiDS_450_bin2 .OR. &
               ix == tracer_KiDS_450_bin3 .OR. &
               ix == tracer_KiDS_450_bin4 .OR. &
               ix == tracer_CFHTLenS_Kilbinger2013) THEN
         CALL fill_nz_table(ix, proj)
      ELSE
         STOP 'READ_NZ: Error, tracer specified incorrectly'
      END IF

      IF (ix == tracer_RCSLenS .OR. ix == tracer_CFHTLenS_vanWaerbeke2013) THEN
         proj%order_nz = 3 ! Continuous functions - treat as cubics
      ELSE IF (ix == tracer_KiDS .OR. &
               ix == tracer_KiDS_bin1 .OR. &
               ix == tracer_KiDS_bin2 .OR. &
               ix == tracer_KiDS_bin3 .OR. &
               ix == tracer_KiDS_bin4) THEN
         proj%order_nz = 3 ! These seem to integrate more accurately to unity this way
      ELSE IF (ix == tracer_KiDS_450 .OR. &
               ix == tracer_KiDS_450_fat_bin1 .OR. &
               ix == tracer_KiDS_450_fat_bin2 .OR. &
               ix == tracer_KiDS_450_highz .OR. &
               ix == tracer_KiDS_450_bin1 .OR. &
               ix == tracer_KiDS_450_bin2 .OR. &
               ix == tracer_KiDS_450_bin3 .OR. &
               ix == tracer_KiDS_450_bin4 .OR. &
               ix == tracer_CFHTLenS_Kilbinger2013) THEN
         proj%order_nz = 0 ! These are supposed to be histograms
      ELSE
         STOP 'READ_NZ: Error, order for integration not specified correctly'
      END IF

      IF (normalise) CALL normalise_nz(proj)

      IF (verbose_Limber) THEN
         norm = integrate_nz(proj)
         WRITE (*, *) 'READ_NZ: Normalisation (should be unity):', norm
         WRITE (*, *) 'READ_NZ: Order for integration:', proj%order_nz
         WRITE (*, *) 'READ_NZ: zmin:', proj%z_nz(1)
         WRITE (*, *) 'READ_NZ: zmax:', proj%z_nz(proj%nnz)
         WRITE (*, *) 'READ_NZ: nz:', proj%nnz
         WRITE (*, *)
      END IF

   END SUBROUTINE read_nz

   SUBROUTINE normalise_nz(proj)

      ! Explicitly normalise the input n(z)
      TYPE(projection), INTENT(INOUT) :: proj
      REAL :: norm

      ! Explicitly normalise
      norm = integrate_nz(proj)
      proj%nz = proj%nz/norm

   END SUBROUTINE normalise_nz

   REAL FUNCTION integrate_nz(proj)

      USE calculus_table

      ! Integrate the n(z) function over z (which should give unity)
      TYPE(projection), INTENT(INOUT) :: proj

      integrate_nz = integrate_table(proj%z_nz, proj%nz, 1, proj%nnz, proj%order_nz)

   END FUNCTION integrate_nz

   SUBROUTINE fill_analytic_nz_table(ix, proj)

      INTEGER, INTENT(IN) :: ix
      TYPE(projection), INTENT(INOUT) :: proj
      INTEGER :: i

      ! From analytical function
      proj%nnz = n_nz
      IF (ALLOCATED(proj%z_nz)) DEALLOCATE (proj%z_nz)
      IF (ALLOCATED(proj%nz)) DEALLOCATE (proj%nz)
      ALLOCATE (proj%z_nz(proj%nnz), proj%nz(proj%nnz))

      ! Fill the look-up tables
      CALL fill_array(zmin_nz, zmax_nz, proj%z_nz, proj%nnz)
      DO i = 1, n_nz
         proj%nz(i) = nz_distribution(proj%z_nz(i), ix)
      END DO

   END SUBROUTINE fill_analytic_nz_table

   SUBROUTINE fill_nz_table(ix, proj)

      USE file_info

      INTEGER, INTENT(IN) :: ix
      TYPE(projection), INTENT(INOUT) :: proj
      INTEGER :: i
      REAL :: spam
      CHARACTER(len=256) :: input

      ! Get file name
      IF (ix == tracer_KiDS) THEN
         input = '/Users/Mead/Physics/data/KiDS/nz/KiDS_z0.1-0.9.txt'
      ELSE IF (ix == tracer_KiDS_bin1) THEN
         input = '/Users/Mead/Physics/data/KiDS/nz/KiDS_z0.1-0.3.txt'
      ELSE IF (ix == tracer_KiDS_bin2) THEN
         input = '/Users/Mead/Physics/data/KiDS/nz/KiDS_z0.3-0.5.txt'
      ELSE IF (ix == tracer_KiDS_bin3) THEN
         input = '/Users/Mead/Physics/data/KiDS/nz/KiDS_z0.5-0.7.txt'
      ELSE IF (ix == tracer_KiDS_bin4) THEN
         input = '/Users/Mead/Physics/data/KiDS/nz/KiDS_z0.7-0.9.txt'
      ELSE IF (ix == tracer_KiDS_450 .OR. &
               ix == tracer_KiDS_450_fat_bin1 .OR. &
               ix == tracer_KiDS_450_fat_bin2 .OR. &
               ix == tracer_KiDS_450_highz) THEN
         input = '/Users/Mead/Physics/data/KiDS/nz/KiDS-450_fat_bin_nofz.txt'
      ELSE IF (ix == tracer_KiDS_450_bin1) THEN
         input = '/Users/Mead/Physics/data/KiDS/nz/Nz_DIR_z0.1t0.3.asc'
      ELSE IF (ix == tracer_KiDS_450_bin2) THEN
         input = '/Users/Mead/Physics/data/KiDS/nz/Nz_DIR_z0.3t0.5.asc'
      ELSE IF (ix == tracer_KiDS_450_bin3) THEN
         input = '/Users/Mead/Physics/data/KiDS/nz/Nz_DIR_z0.5t0.7.asc'
      ELSE IF (ix == tracer_KiDS_450_bin4) THEN
         input = '/Users/Mead/Physics/data/KiDS/nz/Nz_DIR_z0.7t0.9.asc'
      ELSE IF (ix == tracer_CFHTLenS_Kilbinger2013) THEN
         input = '/Users/Mead/Physics/data/CFHTLenS/nz.txt'
      ELSE
         STOP 'FILL_NZ_TABLE: tracer not specified correctly'
      END IF
      IF (verbose_Limber) WRITE (*, *) 'FILL_NZ_TABLE: Input file: ', trim(input)

      ! Allocate arrays
      proj%nnz = count_number_of_lines(input)
      IF (ALLOCATED(proj%z_nz)) DEALLOCATE (proj%z_nz)
      IF (ALLOCATED(proj%nz))   DEALLOCATE (proj%nz)
      ALLOCATE (proj%z_nz(proj%nnz), proj%nz(proj%nnz))

      ! Read in n(z) table
      OPEN (7, file=input)
      DO i = 1, proj%nnz
         IF (ix == tracer_KiDS .OR. &
             ix == tracer_KiDS_bin1 .OR. &
             ix == tracer_KiDS_bin2 .OR. &
             ix == tracer_KiDS_bin3 .OR. &
             ix == tracer_KiDS_bin4 .OR. &
             ix == tracer_KiDS_bin4 .OR. &
             ix == tracer_KiDS_450_bin1 .OR. &
             ix == tracer_KiDS_450_bin2 .OR. &
             ix == tracer_KiDS_450_bin3 .OR. &
             ix == tracer_KiDS_450_bin4 .OR. &
             ix == tracer_CFHTLenS_Kilbinger2013) THEN
            READ (7, *) proj%z_nz(i), proj%nz(i) ! Second column
         ELSE IF (ix == tracer_KiDS_450) THEN
            READ (7, *) proj%z_nz(i), proj%nz(i) ! Second column (z = 0.1 -> 0.9)
         ELSE IF (ix == tracer_KiDS_450_fat_bin1) THEN
            READ (7, *) proj%z_nz(i), spam, proj%nz(i) ! Third column (z = 0.1 -> 0.5)
         ELSE IF (ix == tracer_KiDS_450_fat_bin2) THEN
            READ (7, *) proj%z_nz(i), spam, spam, proj%nz(i) ! Fourth column (z = 0.5 -> 0.9)
         ELSE IF (ix == tracer_KiDS_450_highz) THEN
            READ (7, *) proj%z_nz(i), spam, spam, spam, proj%nz(i) ! Fifth column (z = 0.9 -> 3.5)
         ELSE
            STOP 'FILL_NZ_TABLE: tracer not specified correctly'
         END IF
      END DO
      CLOSE (7)

      ! Do this because the KiDS-450 files contain the lower left edge of histograms
      ! The bin sizes are 0.05 in z, so need to add 0.05/2 = 0.025
      ! This is also true for the CFHTLenS Kilbinger (2013) data
      IF (ix == tracer_KiDS_450 .OR. &
          ix == tracer_KiDS_450_fat_bin1 .OR. &
          ix == tracer_KiDS_450_fat_bin2 .OR. &
          ix == tracer_KiDS_450_highz .OR. &
          ix == tracer_KiDS_450_bin1 .OR. &
          ix == tracer_KiDS_450_bin2 .OR. &
          ix == tracer_KiDS_450_bin3 .OR. &
          ix == tracer_KiDS_450_bin4 .OR. &
          ix == tracer_CFHTLenS_Kilbinger2013) THEN
         proj%z_nz = proj%z_nz+0.025
      END IF

      IF (verbose_Limber) THEN
         WRITE (*, *) 'FILL_NZ_TABLE: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE fill_nz_table

   REAL FUNCTION nz_distribution(z, ix)

      ! Analytical n(z) for different surveys
      REAL, INTENT(IN) :: z
      INTEGER, INTENT(IN) :: ix
      REAL :: a, b, c, d, e, f, g, h, i
      REAL :: norm
      REAL :: n1, n2, n3
      REAL :: z1, z2

      IF (ix == tracer_RCSLenS) THEN
         ! RCSLenS
         a = 2.94
         b = -0.44
         c = 1.03
         d = 1.58
         e = 0.40
         f = 0.25
         g = 0.38
         h = 0.81
         i = 0.12
         n1 = a*z*exp(-(z-b)**2/c**2)
         n2 = d*z*exp(-(z-e)**2/f**2)
         n3 = g*z*exp(-(z-h)**2/i**2)
         nz_distribution = n1+n2+n3
      ELSE IF (ix == tracer_CFHTLenS_vanWaerbeke2013) THEN
         ! CFHTLenS
         z1 = 0.7 ! Not a free parameter in Van Waerbeke et al. fit (2013)
         z2 = 1.2 ! Not a free parameter in Van Waerbeke et al. fit (2013)
         a = 1.50
         b = 0.32
         c = 0.20
         d = 0.46
         norm = 1.0129840620118542 ! This is to ensure normalisation; without this integrates to ~1.013 according to python
         nz_distribution = (a*exp(-((z-z1)/b)**2)+c*exp(-((z-z2)/d)**2))/norm
      ELSE
         STOP 'NZ_DISTRIBUTION: Error, tracer specified incorrectly'
      END IF

   END FUNCTION nz_distribution

   REAL FUNCTION integrate_q(r, a, b, acc, iorder, proj, cosm)

      ! Integrates between a and b until desired accuracy is reached
      ! Stores information to reduce function calls
      ! TODO: This could be changed to a general integrate_proj_cosm routine
      REAL, INTENT(IN) :: r
      REAL, INTENT(IN) :: a
      REAL, INTENT(IN) :: b
      REAL, INTENT(IN) :: acc
      INTEGER, INTENT(IN) :: iorder
      TYPE(cosmology), INTENT(INOUT) :: cosm
      TYPE(projection), INTENT(IN) :: proj
      INTEGER :: i, j, n
      REAL :: x, dx
      REAL :: f1, f2, fx
      REAL :: sum_n, sum_2n, sum_new, sum_old
      LOGICAL :: pass

      INTEGER, PARAMETER :: jmin = 5  ! Standard integration parameters
      INTEGER, PARAMETER :: jmax = 30 ! Standard integration parameters

      IF (a == b) THEN

         ! Fix the answer to zero if the integration limits are identical
         integrate_q = 0.

      ELSE

         ! Set the sum variable for the integration
         sum_2n = 0.
         sum_n = 0.
         sum_old = 0.
         sum_new = 0.

         DO j = 1, jmax

            ! Note, you need this to be 1+2**n for some integer n
            ! j=1 n=2; j=2 n=3; j=3 n=5; j=4 n=9; ...'
            n = 1+2**(j-1)

            ! Calculate the dx interval for this value of 'n'
            dx = (b-a)/real(n-1)

            IF (j == 1) THEN

               ! The first go is just the trapezium of the end points
               f1 = q_integrand(a, r, proj, cosm)
               f2 = q_integrand(b, r, proj, cosm)
               sum_2n = 0.5*(f1+f2)*dx
               sum_new = sum_2n

            ELSE

               ! Loop over only new even points to add these to the integral
               DO i = 2, n, 2
                  x = progression(a, b, i, n)
                  fx = q_integrand(x, r, proj, cosm)
                  sum_2n = sum_2n+fx
               END DO

               ! Now create the total using the old and new parts
               sum_2n = sum_n/2.+sum_2n*dx

               ! Now calculate the new sum depending on the integration order
               IF (iorder == 1) THEN
                  sum_new = sum_2n
               ELSE IF (iorder == 3) THEN
                  sum_new = (4.*sum_2n-sum_n)/3. ! This is Simpson's rule and cancels error
               ELSE
                  STOP 'INTEGRATE_Q: Error, iorder specified incorrectly'
               END IF

            END IF

            IF (sum_old == 0.d0 .OR. j<jmin) THEN
               pass = .FALSE.
            ELSE IF (j == jmax) THEN
               STOP 'INTEGRATE_COSM_1: Integration timed out'
            ELSE IF (abs(-1.d0+sum_new/sum_old) < acc) THEN
               pass = .TRUE.
            ELSE
               pass = .FALSE.
            END IF

            IF (pass) THEN
               EXIT
            ELSE
               ! Integral has not converged so store old sums and reset sum variables
               sum_old = sum_new
               sum_n = sum_2n
               sum_2n = 0.d0
            END IF

         END DO

         integrate_q = sum_new

      END IF

   END FUNCTION integrate_q

   FUNCTION q_integrand(z, r, proj, cosm)

      ! The lensing efficiency integrand, which is a function of z
      ! z is integrated over while r is just a parameter
      ! This is only called for n(z)
      REAL :: q_integrand
      REAL, INTENT(IN) :: r, z
      TYPE(cosmology), INTENT(INOUT) :: cosm
      TYPE(projection), INTENT(IN) :: proj
      REAL :: rdash, nzz, a
      INTEGER, PARAMETER :: ifind = 3
      INTEGER, PARAMETER :: imeth = 2

      a = scale_factor_z(z)

      IF (z == 0.) THEN
         q_integrand = 0.
      ELSE
         ! Find the r'(z) variable that is integrated over
         rdash = comoving_distance(a, cosm)
         ! Find the n(z)
         nzz = find(z, proj%z_nz, proj%nz, proj%nnz, proj%order_nz, ifind, imeth)
         ! This is then the integrand
         q_integrand = nzz*f_k(rdash-r, cosm)/f_k(rdash, cosm)
      END IF

   END FUNCTION q_integrand

   REAL FUNCTION integrate_Limber(l, a, b, logktab, logatab, logptab, nk, na, acc, iorder, proj, cosm)

      ! Integrates between a and b until desired accuracy is reached
      INTEGER, INTENT(IN) :: nk, na
      REAL, INTENT(IN) :: a, b, acc
      INTEGER, INTENT(IN) :: iorder
      REAL, INTENT(IN) :: l
      REAL, INTENT(IN) :: logktab(nk), logatab(na), logptab(nk, na)  
      TYPE(projection), INTENT(IN) :: proj(2)
      TYPE(cosmology), INTENT(INOUT) :: cosm
      INTEGER :: i, j
      INTEGER :: n
      REAL :: x, dx
      REAL :: f1, f2, fx
      REAL :: sum_n, sum_2n, sum_new, sum_old
      LOGICAL :: pass

      INTEGER, PARAMETER :: jmin = 5  ! Standard integration parameters
      INTEGER, PARAMETER :: jmax = 25 ! Standard integration parameters

      IF (a == b) THEN

         ! Fix the answer to zero if the integration limits are identical
         integrate_Limber = 0.

      ELSE

         ! Set the sum variable for the integration
         sum_2n = 0.
         sum_n = 0.
         sum_old = 0.
         sum_new = 0.

         DO j = 1, jmax

            ! Note, you need this to be 1+2**n for some integer n
            ! j=1 n=2; j=2 n=3; j=3 n=5; j=4 n=9; ...'
            n = 1+2**(j-1)

            ! Calculate the dx interval for this value of 'n'
            dx = (b-a)/real(n-1)

            IF (j == 1) THEN

               ! The first go is just the trapezium of the end points
               f1 = Limber_integrand(a, l, logktab, logatab, logptab, nk, na, proj, cosm)
               f2 = Limber_integrand(b, l, logktab, logatab, logptab, nk, na, proj, cosm)
               sum_2n = 0.5*(f1+f2)*dx
               sum_new = sum_2n

            ELSE

               ! Loop over only new even points to add these to the integral
               DO i = 2, n, 2
                  x = progression(a, b, i, n)
                  fx = Limber_integrand(x, l, logktab, logatab, logptab, nk, na, proj, cosm)
                  sum_2n = sum_2n+fx
               END DO

               ! Now create the total using the old and new parts
               sum_2n = sum_n/2.+sum_2n*dx

               ! Now calculate the new sum depending on the integration order
               IF (iorder == 1) THEN
                  sum_new = sum_2n
               ELSE IF (iorder == 3) THEN
                  sum_new = (4.*sum_2n-sum_n)/3. ! This is Simpson's rule and cancels error
               ELSE
                  STOP 'INTEGRATE_LIMBER: Error, iorder specified incorrectly'
               END IF

            END IF

            IF (sum_old == 0.d0 .OR. j<jmin) THEN
               pass = .FALSE.
            ELSE IF (j == jmax) THEN
               STOP 'INTEGRATE_COSM_1: Integration timed out'
            ELSE IF (abs(-1.d0+sum_new/sum_old) < acc) THEN
               pass = .TRUE.
            ELSE
               pass = .FALSE.
            END IF

            IF (pass) THEN
               EXIT
            ELSE
               ! Integral has not converged so store old sums and reset sum variables
               sum_old = sum_new
               sum_n = sum_2n
               sum_2n = 0.d0
            END IF

         END DO

         integrate_Limber = sum_new

      END IF

   END FUNCTION integrate_Limber

   REAL FUNCTION Limber_integrand(r, l, logktab, logatab, logptab, nk, na, proj, cosm)

      ! The integrand for the Limber integral
      INTEGER, INTENT(IN) :: nk, na
      REAL, INTENT(IN) :: r, l
      REAL, INTENT(IN) :: logktab(nk), logatab(na), logptab(nk, na)
      
      TYPE(cosmology), INTENT(INOUT) :: cosm
      TYPE(projection), INTENT(IN) :: proj(2)
      REAL :: z, a, k, X(2)
      INTEGER :: i

      IF (r == 0.) THEN

         ! Must be set to zero here to prevent division by zero
         Limber_integrand = 0.

      ELSE

         ! Get the two kernels
         DO i = 1, 2
            X(i) = find(r, proj(i)%r_X, proj(i)%X, proj(i)%nX, 3, 3, 2)
            !X(i)=exp(find(log(r),log(proj(i)%r_X),log(proj(i)%X),proj(i)%nX,3,3,2)) ! Barfed with this
         END DO

         ! Get variables r, z(r) and k(r) for P(k,z)
         z = redshift_r(r, cosm)
         a = scale_factor_z(z)
         k = (l+lcorr)/f_k(r, cosm) ! LoVerde et al. (2008) Limber correction
         !k=k_ell(l,a,cosm) ! Does not make sense since this does an internal a->r conversion

         ! Construct the integrand
         Limber_integrand = X(1)*X(2)*find_pka(k, a, logktab, logatab, logptab, nk, na)/f_k(r, cosm)**2

      END IF

   END FUNCTION Limber_integrand

   SUBROUTINE Limber_contribution(l, r1, r2, logktab, logatab, logptab, nk, na, proj, cosm, outfile)

      INTEGER, INTENT(IN) :: nk, na
      REAL, INTENT(IN) :: l, r1, r2
      REAL, INTENT(IN) :: logktab(nk), logatab(na), logptab(nk, na)
      TYPE(cosmology), INTENT(INOUT) :: cosm
      TYPE(projection), INTENT(IN) :: proj(2)
      CHARACTER(len=256), INTENT(IN) :: outfile
      REAL :: k, r, z, total, int, a
      INTEGER :: i

      ! Calculate the integral for this value of ell
      total = integrate_Limber(l, r1, r2, logktab, logatab, logptab, nk, na, acc_Limber, 3, proj, cosm)

      ! Now split up the contributions
      ! You need the Jacobian and to remember that the contribution is split in ln(k), ln(z) and ln(R)
      ! This means factors of:
      ! k - f_k(r)/f'_k(r) (=r if flat)
      ! z - z/H(z)
      ! r - r
      OPEN (7, file=trim(outfile))
      DO i = 1, n_cont
         r = progression(r1, r2, i, n_cont)
         IF (r == 0.) THEN
            ! Avoid trouble for r = 0 exactly
            ! Maybe should do some sort of awful Taylor expansion here
            CYCLE
         ELSE
            k = (l+lcorr)/f_k(r, cosm)
            !k=k_ell(l,a,cosm) ! Does not make sense since this does an internal a->r conversion
            z = redshift_r(r, cosm)
            a = scale_factor_z(z)
            int = Limber_integrand(r, l, logktab, logatab, logptab, nk, na, proj, cosm)
            WRITE (7, *) k, int*f_k(r, cosm)/(fdash_k(r, cosm)*total), z, int*z/(sqrt(Hubble2(a, cosm))*total), r, int*r/total
         END IF
      END DO
      CLOSE (7)

   END SUBROUTINE Limber_contribution

   REAL FUNCTION find_pka(k, a, logktab, logatab, logptab, nk, na)

      ! Looks up the power as a 2D function of k and a
      ! Note that it cuts P(k,a) off above and below certain wavenumbers defined in the header (kmin_pka, kmax_pka)
      ! It will interpolate in log(a) outside range
      ! It will interpolate in log(k) outside range of ktab until kmin_pka/kmax_pka
      REAL, INTENT(IN) :: k, a ! Input desired values of k and a
      INTEGER, INTENT(IN) :: nk, na ! Number of entries of k and a in arrays
      REAL, INTENT(IN) :: logktab(nk), logatab(na), logptab(nk, na) ! Arrays of log(k), log(a) and log(P(k,a))
      REAL :: logk, loga
      INTEGER, PARAMETER :: iorder = 3 ! 3 - Cubic interpolation
      INTEGER, PARAMETER :: ifind = 3  ! 3 - Midpoint finding scheme
      INTEGER, PARAMETER :: imeth = 1  ! 1 - Polynomial method

      logk = log(k)
      loga = log(a)

      ! Get the power
      IF ((logk < logktab(1) .OR. logk > logktab(nk)) .AND. (loga < logatab(1) .OR. loga > logatab(na))) THEN
         find_pka = 0.
      ELSE IF (k < kmin_pka .OR. k > kmax_pka) THEN
         find_pka = 0.
      ELSE IF (a < amin_pka .OR. a > amax_pka) THEN
         find_pka = 0.
      ELSE
         find_pka = exp(find(logk, logktab, loga, logatab, logptab, nk, na, iorder, ifind, ifind, imeth))
      END IF

   END FUNCTION find_pka

   SUBROUTINE xpow_pka(ix, ell, Cl, nl, k, a, pow, nk, na, cosm)

      ! Calculates the C(l) for the cross correlation of fields ix(1) and ix(2) given P(k,a)
      ! TODO: Change to take in ix(n)?
      INTEGER, INTENT(IN) :: nk, na, nl
      INTEGER, INTENT(INOUT) :: ix(2)
      REAL, INTENT(IN) :: ell(nl)
      REAL, INTENT(OUT) :: Cl(nl)    
      REAL, INTENT(IN) :: k(nk)
      REAL, INTENT(IN) :: a(na)
      REAL, INTENT(IN) :: pow(nk, na)
      TYPE(cosmology), INTENT(INOUT) :: cosm
      TYPE(projection) :: proj(2)
      REAL :: r1, r2

      ! Fill out the projection kernel
      CALL fill_projection_kernels(ix, proj, cosm)

      ! Set the range in comoving distance for the Limber integral [Mpc]
      r1 = 0.
      r2 = maxdist(proj)

      ! Actually calculate the C(ell), but only for the full halo model part
      ! TODO: Array temporary
      CALL calculate_Cl(r1, r2, ell, Cl, nl, k, a, pow, nk, na, proj, cosm)

   END SUBROUTINE xpow_pka

   SUBROUTINE Cl_contribution(ix, k, a, pow, nk, na, cosm, fbase, fext)

      ! Calculates the C(l) for the cross correlation of fields ix(1) and ix(2) given P(k,a)
      ! TODO: Change to take in ix(n)?
      INTEGER, INTENT(IN) :: nk, na
      INTEGER, INTENT(INOUT) :: ix(2)
      REAL, INTENT(IN) :: k(nk)
      REAL, INTENT(IN) :: a(na)
      REAL, INTENT(IN) :: pow(nk, na)
      TYPE(cosmology), INTENT(INOUT) :: cosm
      CHARACTER(len=*), INTENT(IN) :: fbase
      CHARACTER(len=*), INTENT(IN) :: fext
      TYPE(projection) :: proj(2)
      REAL :: r1, r2

      ! Fill out the projection kernel
      CALL fill_projection_kernels(ix, proj, cosm)

      ! Set the range in comoving distance for the Limber integral [Mpc]
      r1 = 0.
      r2 = maxdist(proj)

      CALL Cl_contribution_ell(r1, r2, k, a, pow, nk, na, proj, cosm, fbase, fext)

   END SUBROUTINE Cl_contribution

   SUBROUTINE xpow_halomod(ix, nx, ell, Cl, nl, cosm, ihm, verbose)

      USE HMx

      ! Calculates the C(l) for the cross correlation of fields ix(1) and ix(2)
      ! TODO: Speed up if there are repeated fields in ix(n) (should this ever happen?)
      ! TODO: Add bin theory option
      ! TODO: Move this because it requires HMx?
      INTEGER, INTENT(IN) :: nx, nl
      INTEGER, INTENT(INOUT) :: ix(nx)
      REAL, INTENT(IN) :: ell(nl)
      REAL, INTENT(OUT) :: Cl(nl, nx, nx)
      !TYPE(halomod), INTENT(INOUT) :: hmod
      TYPE(cosmology), INTENT(INOUT) :: cosm
      INTEGER, INTENT(INOUT) :: ihm
      LOGICAL, INTENT(IN) :: verbose
      REAL, ALLOCATABLE :: a(:), k(:), pow_li(:, :), pow_2h(:, :, :, :), pow_1h(:, :, :, :), pow_hm(:, :, :, :)
      REAL :: lmin, lmax
      INTEGER :: ixx(2), ip(nx), nk, na, i, j, ii, jj, nnx, match(nx)
      INTEGER, ALLOCATABLE :: iix(:)
      REAL, ALLOCATABLE :: uCl(:, :, :)

      REAL, PARAMETER :: kmin_xpow = 1e-3 ! Minimum k to calculate P(k); it will be extrapolated below this by Limber
      REAL, PARAMETER :: kmax_xpow = 1e2  ! Maximum k to calculate P(k); it will be extrapolated above this by Limber
      INTEGER, PARAMETER :: nk_xpow = 257 ! Number of log-spaced k values (used to be 32)
      REAL, PARAMETER :: amin_xpow = 0.1  ! Minimum scale factor (problems with one-halo term if amin is less than 0.1)
      REAL, PARAMETER :: amax_xpow = 1.0  ! Maximum scale factor
      INTEGER, PARAMETER :: na_xpow = 17  ! Number of linearly-spaced scale factores

      !IF(repeated_entries(ix,n)) STOP 'XPOW: Error, repeated tracers'
      CALL unique_index(ix, nx, iix, nnx, match)
      ALLOCATE (uCl(nl, nnx, nnx))

      ! Set the k range
      nk = nk_xpow
      CALL fill_array(log(kmin_xpow), log(kmax_xpow), k, nk)
      k = exp(k)

      ! Set the a range
      na = na_xpow
      CALL fill_array(amin_xpow, amax_xpow, a, na)

      ! Set the ell range
      lmin = ell(1)
      lmax = ell(nl)

      ! Write to screen
      IF (verbose) THEN
         WRITE (*, *) 'XPOW: Cross-correlation information'
         WRITE (*, *) 'XPOW: Number of tracers:', nx
         WRITE (*, *) 'XPOW: P(k) minimum k [h/Mpc]:', REAL(kmin_xpow)
         WRITE (*, *) 'XPOW: P(k) maximum k [h/Mpc]:', REAL(kmax_xpow)
         WRITE (*, *) 'XPOW: Number of k:', nk
         WRITE (*, *) 'XPOW: minimum a:', REAL(amin_xpow)
         WRITE (*, *) 'XPOW: maximum a:', REAL(amax_xpow)
         WRITE (*, *) 'XPOW: number of a:', na
         WRITE (*, *) 'XPOW: minimum ell:', REAL(lmin)
         WRITE (*, *) 'XPOW: maximum ell:', REAL(lmax)
         WRITE (*, *) 'XPOW: number of ell:', nl
         WRITE (*, *)
      END IF

      ! Use the xpowlation type to set the necessary halo profiles
      DO i = 1, nnx
         CALL set_field_for_xpow(ix(i), ip(i))
      END DO

      ! Do the halo model power spectrum calculation
      !CALL calculate_HMx(ip, nnx, k, nk, a, na, pow_li, pow_2h, pow_1h, pow_hm, hmod, cosm, verbose)
      CALL calculate_HMx_full(ip, k, a, pow_li, pow_2h, pow_1h, pow_hm, nnx, nk, na, cosm, ihm)

      ! Set the Cl to zero initially
      uCl = 0.

      ! Loop over triangle combinations
      DO i = 1, nnx
         ixx(1) = ix(i)
         DO j = i, nnx
            ixx(2) = ix(j)
            CALL xpow_pka(ixx, ell, uCl(:, i, j), nl, k, a, pow_hm(i, j, :, :), nk, na, cosm)
         END DO
      END DO

      ! Fill the symmetric cross terms
      DO i = 1, nnx
         DO j = i+1, nnx
            uCl(:, j, i) = uCl(:, i, j)
         END DO
      END DO

      ! Now fill the full arrays from the unique arrays
      DO i = 1, nx
         DO j = 1, nx
            ii = match(i)
            jj = match(j)
            Cl(:, i, j) = uCl(:, ii, jj)
         END DO
      END DO

      ! Write to screen
      IF (verbose) THEN
         WRITE (*, *) 'XPOW: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE xpow_halomod

   SUBROUTINE set_field_for_xpow(ix, ip)

      USE HMx

      ! Set the cross-correlation type
      ! TODO: Move this because it requires HMx?
      INTEGER, INTENT(INOUT) :: ix ! Tracer for cross correlation
      INTEGER, INTENT(OUT) :: ip   ! Corresponding field for power spectrum
      INTEGER :: j

      IF (ix == -1) THEN
         WRITE (*, *) 'SET_FIELDS_FOR_XPOW: Choose field'
         WRITE (*, *) '================================='
         DO j = 1, n_tracers
            WRITE (*, fmt='(I3,A3,A30)') j, '- ', TRIM(xcorr_type(j))
         END DO
         READ (*, *) ix
         WRITE (*, *) '==================================='
         WRITE (*, *)
      END IF

      IF (ix == tracer_Compton_y) THEN
         ! Compton y
         ip = field_electron_pressure
      ELSE IF (ix == tracer_gravity_wave) THEN
         ! Gravitational waves
         ip = field_dmonly
      ELSE IF (ix == tracer_RCSLenS .OR. &
               ix == tracer_CFHTLenS_vanWaerbeke2013 .OR. &
               ix == tracer_CMB_lensing .OR. &
               ix == tracer_KiDS .OR. &
               ix == tracer_KiDS_bin1 .OR. &
               ix == tracer_KiDS_bin2 .OR. &
               ix == tracer_KiDS_bin3 .OR. &
               ix == tracer_KiDS_bin4 .OR. &
               ix == tracer_KiDS_450 .OR. &
               ix == tracer_KiDS_450_fat_bin1 .OR. &
               ix == tracer_KiDS_450_fat_bin2 .OR. &
               ix == tracer_KiDS_450_highz .OR. &
               ix == tracer_lensing_z1p00 .OR. &
               ix == tracer_lensing_z0p75 .OR. &
               ix == tracer_lensing_z0p50 .OR. &
               ix == tracer_lensing_z0p25 .OR. &
               ix == tracer_KiDS_450_bin1 .OR. &
               ix == tracer_KiDS_450_bin2 .OR. &
               ix == tracer_KiDS_450_bin3 .OR. &
               ix == tracer_KiDS_450_bin4 .OR. &
               ix == tracer_CFHTLenS_Kilbinger2013) THEN
         ! Lensing
         ip = field_matter
      ELSE IF (ix == tracer_CIB_353) THEN
         ip = field_CIB_353
      ELSE IF (ix == tracer_CIB_545) THEN
         ip = field_CIB_545
      ELSE IF (ix == tracer_CIB_857) THEN
         ip = field_CIB_857
      ELSE IF (ix == tracer_galaxies) THEN
         ip = field_galaxies
      ELSE
         STOP 'SET_FIELD_FOR_XPOW: Error, tracer specified incorrectly'
      END IF

   END SUBROUTINE set_field_for_xpow

END MODULE Limber

MODULE minimization

   USE sorting
   USE statistics

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: Nelder_Mead
   PUBLIC :: Nelder_Mead_multiple
   PUBLIC :: Nelder_Mead_centroid
   PUBLIC :: Nelder_Mead_sort
   PUBLIC :: Nelder_Mead_termination
   PUBLIC :: adaptive_minimization_1D
   PUBLIC :: adaptive_minimization_3D
   PUBLIC :: grid_minimization_1D
   PUBLIC :: gradient_minimization_1D
   PUBLIC :: gradient_minimization_2D
   PUBLIC :: quadratic_extremum_1D
   PUBLIC :: find_array_maximum

   INTEGER, PARAMETER :: isort_Nelder_Mead = isort_bubble
   REAL, PARAMETER :: alpha_Nelder_Mead = 1.  ! Reflection coefficient (alpha > 0; standard alpha = 1)
   REAL, PARAMETER :: gamma_Nelder_Mead = 2.  ! Expansion coefficient (gamma > 1; standard gamma = 2)
   REAL, PARAMETER :: rho_Nelder_Mead = 0.5   ! Contraction coefficient (0 < rho < 0.5; standard rho = 0.5)
   REAL, PARAMETER :: sigma_Nelder_Mead = 0.5 ! Shrink coefficient (standard sigma = 0.5)

   CONTAINS

   SUBROUTINE Nelder_Mead_multiple(x, xmin, xmax, dx, fom, m, f, tol, verbose)

      USE random_numbers
      REAL, INTENT(OUT) :: x(:)
      REAL, INTENT(IN) :: xmin(:)
      REAL, INTENT(IN) :: xmax(:)
      REAL, INTENT(IN) :: dx(:)
      REAL, INTENT(OUT) :: fom
      INTEGER, INTENT(IN) :: m
      REAL, EXTERNAL :: f
      REAL, INTENT(IN) :: tol
      LOGICAL, INTENT(IN) :: verbose
      REAL :: fy
      REAL, ALLOCATABLE :: y(:)
      INTEGER :: i, j, n

      INTERFACE
         FUNCTION f(xin)
            REAL, INTENT(IN) :: xin(:)           
         END FUNCTION f
      END INTERFACE

      n = size(x)
      IF (n /= size(xmin) .OR. n /= size(xmax) .OR. n /= size(dx)) THEN
         STOP 'NELDER_MEAD_MULTIPLE: Error; x, xmin, xmax, dx should all be the same size'
      END IF
      ALLOCATE(y(n))

      fom = huge(fom)
      DO i = 1, m

         DO j = 1, n
            y(j) = random_uniform(xmin(j), xmax(j))
         END DO

         CALL Nelder_Mead(y, dx, fy, f, tol, verbose)

         IF (fy < fom) THEN
            x = y
            fom = fy
         END IF

      END DO

      WRITE (*, *) 'NELDER_MEAD_MULTIPLE: Best fit:', fom, (x(j), j = 1, n)
      WRITE (*, *)


   END SUBROUTINE Nelder_Mead_multiple

   SUBROUTINE Nelder_Mead(x, dx, fom, f, tol, verbose)

      ! Nelder-Mead simplex for fiding minima of a function
      ! Coded up using https://en.wikipedia.org/wiki/Nelder%E2%80%93Mead_method
      ! x should be x(n)
      ! dx should be dx(n)
      REAL, INTENT(INOUT) :: x(:)
      REAL, INTENT(IN) :: dx(:)
      REAL, INTENT(OUT) :: fom
      REAL, EXTERNAL :: f
      REAL, INTENT(IN) :: tol
      LOGICAL, INTENT(IN) :: verbose
      REAL, ALLOCATABLE :: xx(:, :), ff(:)
      REAL, ALLOCATABLE :: xo(:), xr(:), xe(:), xc(:)
      REAL :: fr, fe, fc
      INTEGER :: i, j, ii, n
      CHARACTER(len=256) :: operation, nstring
      REAL, PARAMETER :: alpha = alpha_Nelder_Mead  ! Reflection coefficient (alpha > 0; standard alpha = 1)
      REAL, PARAMETER :: gamma = gamma_Nelder_Mead  ! Expansion coefficient (gamma > 1; standard gamma = 2)
      REAL, PARAMETER :: rho = rho_Nelder_Mead      ! Contraction coefficient (0 < rho < 0.5; standard rho = 0.5)
      REAL, PARAMETER :: sigma = sigma_Nelder_Mead  ! Shrink coefficient (standard sigma = 0.5)

      INTERFACE
         FUNCTION f(xin)
            REAL, INTENT(IN) :: xin(:)           
         END FUNCTION f
      END INTERFACE

      ! Check array sizes
      n = size(x)
      IF (n /= size(dx)) STOP 'NELDER_MEAD: Error, x and dx must be the same size'
      ALLOCATE(xx(n+1, n), ff(n+1))
      ALLOCATE(xo(n), xr(n), xe(n), xc(n))

      ! Set initial test points
      DO i = 1, n+1
         DO j = 1, n
            xx(i, j) = x(j)
            IF(i == j+1) xx(i, j) = xx(i, j)+dx(j)
         END DO
      END DO

      ! Evaluate function at initial points
      DO i = 1, n+1
         ff(i) = f(xx(i, :))
      END DO

      ! Start the minimization
      ii = 0
      operation = 'Starting'
      WRITE(nstring, *) n+1
      DO

         ii = ii+1

         ! Sort the points from best to worst
         CALL Nelder_Mead_sort(xx, ff)
         
         IF (verbose) WRITE(*, '(A16,I10,'//trim(nstring)//'F15.7)') TRIM(operation), ii, ff(1), (xx(1, i), i = 1, n)

         ! Decide on convergence
         IF (Nelder_Mead_termination(ff, tol)) THEN
            DO i = 1, n
               x(i) = xx(1, i)
            END DO
            EXIT
         END IF

         ! Calculate centroid of 1...n (not n+1; the worst point) through which to reflect the worst point
         xo = Nelder_Mead_centroid(xx)

         ! Calculate the reflected point of n+1 about the centroid
         xr = xo+alpha*(xo-xx(n+1, :))
         fr = f(xr)

         IF (fr < ff(1)) THEN
            ! if the reflected point is the best so far then calculate the expanded point 
            xe = xo+gamma*(xr-xo)
            fe = f(xe)
            IF(fe < fr) THEN
               ! Keep the expansed point if it is better than the reflected ...
               operation = 'Expanding'
               xx(n+1, :) = xe
               ff(n+1) = fe
            ELSE
               ! ... otherwise keep the reflected.
               operation = 'Reflecting'
               xx(n+1, :) = xr
               ff(n+1) = fr
            END IF
            CYCLE
         ELSE IF (ff(1) <= fr .AND. fr < ff(n)) THEN
            ! If the reflected point is not the best, but better than the second worst then keep the reflected point
            operation = 'Reflecting'
            xx(n+1, :) = xr
            ff(n+1) = fr
            CYCLE
         ELSE
            ! Here it is certain that the reflected point is at least as worse than the second worst point
            ! Calculate the contracted point
            xc = xo+rho*(xx(n+1, :)-xo)
            fc = f(xc)
            IF(fc < ff(n+1)) THEN
               ! Keep the contracted point if it is better than the worst point
               operation = 'Contracting'
               xx(n+1, :) = xc
               ff(n+1) = fc
               CYCLE
            ELSE
               ! The contracted point is the worst, and we must shrink
               ! Calculate the shrinkage for all except the best point
               operation = 'Shrinking'
               DO i = 2, n+1
                  xx(i, :) = xx(1, :)+sigma*(xx(i, :)-xx(1, :))
                  ff(i) = f(xx(i, :))
               END DO
            END IF
         END IF

      END DO

      ! Report the minimization point
      x = xx(1, :)
      fom = ff(1)

      IF (verbose) THEN
         !WRITE(*, '(A16,I10,'//trim(nstring)//'F15.7)') 'Best', ii, fom, (x(1, i), i = 1, n)
         WRITE(*, *) 'NELDER_MEAD: Done'
         WRITE(*, *)
      END IF

   END SUBROUTINE Nelder_Mead

   FUNCTION Nelder_Mead_centroid(x) result(centroid)

      ! Calculate the centroid of all points except the worst point, which is n+1
      ! x Should be x(n+1, n)
      ! Output should be centroid(n)
      REAL, INTENT(IN) :: x(:, :)
      REAL :: centroid(size(x, 2))
      REAL, ALLOCATABLE :: xx(:, :)
      INTEGER :: i, n

      ! Check array sizes
      n = size(x, 2)
      IF(n+1 /= size(x, 1)) STOP 'NELDER_MEAD_CENTROID: Error array x is wrong'

      ! This ugly stuff is needed because the final element is not counted in the mean
      ALLOCATE(xx(n, n))
      DO i = 1, n
         xx(i, :) = x(i, :)
      END DO

      ! Calculate the mean
      DO i = 1, n
         centroid(i) = mean(xx(:, i))
      END DO

   END FUNCTION Nelder_Mead_centroid

   SUBROUTINE Nelder_Mead_sort(x, f)

      ! Sort the points into order from best to worst
      ! x should be x(n+1, n), f should be f(n+1)
      REAL, INTENT(INOUT) :: x(:, :)
      REAL, INTENT(INOUT) :: f(:)
      INTEGER :: i, n
      INTEGER, ALLOCATABLE :: j(:)
      INTEGER, PARAMETER :: isort = isort_Nelder_Mead

      ! Check array sizes
      n = size(x, 2)
      IF (n+1 /= size(x, 1) .OR. n+1 /= size(f)) THEN
         STOP 'NELDER_MEAD_SORT: Error, arrays are the wrong size'
      END IF
      ALLOCATE(j(n+1))

      ! Carry out the reindexing
      CALL index(f, j, isort)
      CALL reindex(f, j)
      DO i = 1, n
         CALL reindex(x(:,i), j)
      END DO

   END SUBROUTINE Nelder_Mead_sort

   LOGICAL FUNCTION Nelder_Mead_termination(f, tol)

      ! Determine if the minimization has converged
      ! f should be f(n+1)
      REAL, INTENT(IN) :: f(:)
      REAL, INTENT(IN) :: tol
      REAL :: sigma

      ! Calculate the standard deviation of all n+1 points
      sigma = standard_deviation(f)

      ! Decide on termination
      IF(sigma <= tol) THEN
         Nelder_Mead_termination = .TRUE.
      ELSE
         Nelder_Mead_termination = .FALSE.
      END IF

   END FUNCTION Nelder_Mead_termination

   SUBROUTINE adaptive_minimization_1D(xmin, func, min, max, ref, ngrid, nref)

      USE basic_operations
      REAL, INTENT(OUT) :: xmin
      REAL, EXTERNAL :: func
      REAL, INTENT(IN) :: min
      REAL, INTENT(IN) :: max
      REAL, INTENT(IN) :: ref
      INTEGER, INTENT(IN) :: ngrid
      INTEGER, INTENT(IN) :: nref
      REAL :: fom, fommin, range, x
      REAL :: x1, x2
      INTEGER :: i, j, imin

      INTERFACE
         FUNCTION func(xin)
            REAL, INTENT(IN) :: xin
         END FUNCTION func
      END INTERFACE

      !xmin is output
      !min/max give you the initial bounds for the search
      !ref is the refinement level for each separate grid search
      !n is the number of points per grid search
      !m is the number of refinement levels

      !Needs to be set to prevent warning
      imin = 1

      !Needs to be set to prevent warnings
      fommin = 0.

      x1 = min
      x2 = max

      DO j = 1, nref

         DO i = 1, ngrid

            x = progression(x1, x2, i, ngrid)
            fom = func(x)

            IF (i == 1 .OR. fom < fommin) THEN
               fommin = fom
               xmin = x
               imin = i
            END IF

         END DO

         IF (imin == 1 .OR. imin == ngrid) STOP 'Error: best fit at edge of range'

         IF (j .NE. nref) THEN
            range = x2-x1
            x1 = xmin-range/ref
            x2 = xmin+range/ref
         END IF

      END DO

   END SUBROUTINE adaptive_minimization_1D

   SUBROUTINE adaptive_minimization_3D(xmin, func, min, max, ref, ngrid, nref)

      USE basic_operations
      REAL, INTENT(OUT) :: xmin(3)
      REAL, INTENT(IN) :: min(3), max(3), ref(3)
      INTEGER, INTENT(IN) :: ngrid(3), nref
      REAL, EXTERNAL :: func
      REAL :: fom, fommin, range(3), x(3)
      REAL :: x1(3), x2(3)
      INTEGER :: i, j, k, l, imin, jmin, kmin

      !xmin is output
      !min/max give you the initial bounds for the search
      !ref is the refinement level for each separate grid search
      !n is the number of points per grid search
      !m is the number of refinement levels

      !Need to be set to prevent warnings
      imin = 1
      jmin = 1
      kmin = 1

      !Needs to be set to prevent warnings
      fommin = 0.

      x1 = min
      x2 = max

      DO l = 1, nref

         DO i = 1, ngrid(1)

            !x(1)=x1(1)+(x2(1)-x1(1))*float(i-1)/float(ngrid(1)-1)
            x(1) = progression(x1(1), x2(1), i, ngrid(1))

            DO j = 1, ngrid(2)

               !x(2)=x1(2)+(x2(2)-x1(2))*float(j-1)/float(ngrid(2)-1)
               x(2) = progression(x1(2), x2(2), j, ngrid(2))

               DO k = 1, ngrid(3)

                  !x(3)=x1(3)+(x2(3)-x1(3))*float(k-1)/float(ngrid(3)-1)
                  x(3) = progression(x1(3), x2(3), k, ngrid(3))

                  fom = func(x)

                  IF ((i == 1 .AND. j == 1 .AND. k == 1) .OR. fom < fommin) THEN
                     fommin = fom
                     xmin = x
                     imin = i
                     jmin = j
                     kmin = k
                  END IF

               END DO

            END DO

         END DO

         IF (imin == 1 .OR. imin == ngrid(1)) STOP 'Error: best fit x(1) at edge of range'
         IF (jmin == 1 .OR. jmin == ngrid(2)) STOP 'Error: best fit x(2) at edge of range'
         IF (kmin == 1 .OR. kmin == ngrid(3)) STOP 'Error: best fit x(3) at edge of range'

         IF (l .NE. nref) THEN
            range = x2-x1
            x1 = xmin-range/ref
            x2 = xmin+range/ref
         END IF

      END DO

   END SUBROUTINE adaptive_minimization_3D

   SUBROUTINE grid_minimization_1D(Amin, Amax, Asteps, x, y)

      !This fits a one parameter model
      USE basic_operations
      REAL, INTENT(IN) :: Amin, Amax
      REAL, INTENT(IN) :: x(:), y(:)
      INTEGER, INTENT(IN) :: Asteps
      REAL :: ymod, fom, fombest, A, Abest
      INTEGER :: i, j

      fombest = 10000000.

      DO j = 1, Asteps

         !A=Amin+(Amax-Amin)*(float(j-1)/(Asteps-1))
         A = progression(Amin, Amax, j, Asteps)

         fom = 0.

         DO i = 1, size(x)

            !This is the model that you wish to fit
            ymod = x(i)**A

            fom = fom+(ymod-y(i))**2.

         END DO

         IF (fom < fombest) THEN
            fombest = fom
            Abest = A
         END IF

      END DO

      WRITE (*, *) 'Best fit is:', Abest

   END SUBROUTINE grid_minimization_1D

!!$  SUBROUTINE grid_fit_2(Amin,Amax,Asteps,Bmin,Bmax,Bsteps,x,y)
!!$
!!$    IMPLICIT NONE
!!$
!!$    REAL, INTENT(IN) :: Amin, Amax, Bmin, Bmax
!!$    REAL, INTENT(IN) :: x(:), y(:)
!!$    INTEGER, INTENT(IN) :: Asteps, Bsteps
!!$    REAL :: fom, fombest, A, Abest, B, Bbest, ymod
!!$    INTEGER :: i, j, k
!!$
!!$    !This fits a two parameter model
!!$
!!$    fombest=10000000.
!!$
!!$    DO j=1,Asteps
!!$
!!$       A=Amin+(Amax-Amin)*(float(j-1)/(float(Asteps-1)))
!!$
!!$       DO k=1,Bsteps
!!$
!!$          B=Bmin+(Bmax-Bmin)*(float(k-1)/(float(Bsteps-1)))
!!$
!!$          fom=0.
!!$          DO i=1,size(x)
!!$
!!$             !This is the model that you wish to fit
!!$             ymod=model(A,B,x(i))
!!$
!!$             !This looks at the raw difference between models!
!!$             fom=fom+(-1.+ymod/y(i))**2.
!!$
!!$             !         WRITE(*,*) y(i), A, B, ymod, fom
!!$
!!$          END DO
!!$
!!$          IF(fom<fombest) THEN
!!$             fombest=fom
!!$             Abest=A
!!$             Bbest=B
!!$          END IF
!!$
!!$       END DO
!!$    END DO
!!$
!!$    WRITE(*,*) 'Best fit A is:', Abest
!!$    WRITE(*,*) 'Best fit B is:', Bbest
!!$
!!$    OPEN(8,file='results.dat')
!!$    DO i=1,size(x)
!!$       WRITE(8,*) x(i), y(i), model(Abest,Bbest,x(i))
!!$    END DO
!!$    CLOSE(8)
!!$
!!$  END SUBROUTINE grid_fit_2

!!$  SUBROUTINE grid_fit_3(Amin,Amax,Asteps,Bmin,Bmax,Bsteps,Cmin,Cmax,Csteps,x,y)
!!$
!!$    IMPLICIT NONE
!!$
!!$    REAL, INTENT(IN) :: Amin, Amax, Bmin, Bmax, Cmin, Cmax
!!$    REAL, INTENT(IN) :: x(:), y(:)
!!$    INTEGER, INTENT(IN) :: Asteps, Bsteps, Csteps
!!$    REAL :: fom, fombest, A, Abest, B, Bbest, C, Cbest, ymod
!!$    INTEGER :: i, j, k, l
!!$
!!$    !This fits a two parameter model
!!$
!!$    fombest=10000000.
!!$
!!$    DO j=1,Asteps
!!$
!!$       IF(Asteps==1) THEN
!!$          A=Amin
!!$       ELSE
!!$          A=Amin+(Amax-Amin)*(float(j-1)/(Asteps-1))
!!$       END IF
!!$
!!$       DO k=1,Bsteps
!!$
!!$          IF(Bsteps==1) THEN
!!$             B=Bmin
!!$          ELSE
!!$             B=Bmin+(Bmax-Bmin)*(float(k-1)/(Bsteps-1))
!!$          END IF
!!$
!!$          DO l=1,Csteps
!!$
!!$             IF(Csteps==1) THEN
!!$                C=Cmin
!!$             ELSE
!!$                C=Cmin+(Cmax-Cmin)*(float(l-1)/(Csteps-1))
!!$             END IF
!!$
!!$             fom=0.
!!$             DO i=1,size(x)
!!$
!!$                !This is the model that you wish to fit
!!$                ymod=model(A,B,C,x(i))
!!$
!!$                !This looks at the raw difference between models!
!!$                fom=fom+(-1.+ymod/y(i))**2.
!!$
!!$                !         WRITE(*,*) y(i), A, B, ymod, fom
!!$
!!$             END DO
!!$
!!$             !         WRITE(10,*) A, B, C, fom
!!$
!!$             IF(fom<fombest) THEN
!!$                fombest=fom
!!$                Abest=A
!!$                Bbest=B
!!$                Cbest=C
!!$             END IF
!!$
!!$          END DO
!!$       END DO
!!$    END DO
!!$
!!$    WRITE(*,*) 'Best fit A is:', Abest
!!$    WRITE(*,*) 'Best fit B is:', Bbest
!!$    WRITE(*,*) 'Best fit C is:', Cbest
!!$
!!$    OPEN(8,file='results.dat')
!!$    DO i=1,size(x)
!!$       WRITE(8,*) x(i), y(i), model(Abest,Bbest,Cbest,x(i))
!!$    END DO
!!$    CLOSE(8)
!!$
!!$  END SUBROUTINE grid_fit_3

   REAL FUNCTION gradient_minimization_1D(f, x, acc)

      ! Finds the minimum of the function 'f' starting at value x0 with accuracy acc!
      USE calculus
      REAL, EXTERNAL :: f
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: acc
      REAL :: xold, xnew, df
      INTEGER :: i

      INTEGER, PARAMETER :: n = 1000
      REAL, PARAMETER :: fac = 1e3

      INTERFACE
         FUNCTION f(xin)
            REAL, INTENT(IN) :: xin
         END FUNCTION f
      END INTERFACE

      STOP 'GRADIENT_FIT_1: This does not work!'

      xold = x

      DO i = 1, n

         !       df=derivative(f,xold,acc/100.)
         !       xnew=xold-df*acc*100.

         WRITE (*, *) i, xold, xnew

         df = derivative(f, xold, acc/fac)
         xnew = xold-df*acc*fac

         WRITE (*, *) i, xold, xnew

         IF (i > 1 .AND. abs(xnew/xold-1.) < acc) THEN
            gradient_minimization_1D = xnew
            EXIT
         ELSE
            xold = xnew
         END IF

      END DO

   END FUNCTION gradient_minimization_1D

   FUNCTION gradient_minimization_2D(f, x, y, acc)

      ! Finds the minimum of the function 'f' starting at value x0 with accuracy acc
      USE calculus
      REAL :: gradient_minimization_2D(2)
      REAL, EXTERNAL :: f
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: y
      REAL, INTENT(IN) :: acc
      REAL :: xold, xnew, yold, ynew, dfx, dfy
      INTEGER :: i

      INTERFACE
         FUNCTION f(xin, yin)
            REAL, INTENT(IN) :: xin
            REAL, INTENT(IN) :: yin
         END FUNCTION f
      END INTERFACE

      STOP 'GRADIENT_FIT_2: This does not work!'

      xold = x
      yold = y

      DO i = 1, 1000

         dfx = derivative(f, xold, yold, acc/100., dim=1)
         dfy = derivative(f, xold, yold, acc/100., dim=2)

         xnew = xold-dfx*acc*100.
         ynew = yold-dfy*acc*100.

         IF (i > 1 .AND. abs(xnew/xold-1.) < acc .AND. abs(ynew/yold-1.) < acc) THEN
            gradient_minimization_2D(1) = xnew
            gradient_minimization_2D(2) = ynew
            EXIT
         ELSE
            xold = xnew
            yold = ynew
         END IF

      END DO

   END FUNCTION gradient_minimization_2D

   REAL FUNCTION quadratic_extremum_1D(x1, y1, x2, y2, x3, y3)

      ! This calculates the extrema of a function under the assumption that it is quadratic
      ! Takes 3 points to form a quadratic and then read off minimum
      USE special_functions
      REAL, INTENT(IN) :: x1, x2, x3, y1, y2, y3
      REAL :: a2, a1, a0

      CALL fix_polynomial(a2, a1, a0, [x1, x2, x3], [y1, y2, y3])
      quadratic_extremum_1D = -a1/(2.*a2)

   END FUNCTION quadratic_extremum_1D

   REAL FUNCTION find_array_maximum(x, y)

      ! From an array y(x) finds the x location of the maximum treating y(x) as a continuous function
      USE special_functions
      REAL, INTENT(IN) :: x(:)
      REAL, INTENT(IN) :: y(:)
      REAL :: x1, x2, x3, y1, y2, y3
      INTEGER :: imax(1), i, n

      n = size(x)
      IF(n /= size(y)) STOP 'MAXIMUM: Error, x and y must be the same size'

      ! Need this to stop a compile-time warning
      find_array_maximum = 0.

      ! Integer maximum location
      imax = maxloc(y)
      i = imax(1)

      IF (i == 1 .OR. i == n) THEN

         STOP 'MAXIMUM: Error, maximum array value is at one end of the array'

      ELSE

         ! Get the x positions
         x1 = x(i-1)
         x2 = x(i)
         x3 = x(i+1)

         ! Get the y values
         y1 = y(i-1)
         y2 = y(i)
         y3 = y(i+1)

         find_array_maximum = quadratic_extremum_1D(x1, y1, x2, y2, x3, y3)

      END IF

   END FUNCTION find_array_maximum

END MODULE minimization

MODULE fitting

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: fit_constant

CONTAINS

   REAL FUNCTION fit_constant(data, weight)

      REAL, INTENT(IN) :: data(:)
      REAL, INTENT(IN) :: weight(:)
      INTEGER :: n
      REAL :: total_weight

      n = size(data)
      IF (n /= size(weight)) STOP 'FIT_CONSTANT: Error, data and weight must be the same size'

      total_weight = sum(weight)
      IF (total_weight == 0.) THEN
         STOP 'FIT_CONSTANT: Error, weights sum to zero'
      ELSE
         fit_constant = sum(data*weight)/total_weight
      END IF

   END FUNCTION fit_constant

END MODULE fitting

MODULE random_numbers

   USE basic_operations

   IMPLICIT NONE

   PRIVATE

   ! Setting routine
   PUBLIC :: random_generator_seed

   ! Integer distributions
   PUBLIC :: random_integer
   PUBLIC :: random_sign
   PUBLIC :: dice
   PUBLIC :: random_Bernoulli
   PUBLIC :: random_twopoint
   PUBLIC :: random_binomial
   PUBLIC :: random_Poisson

   ! Real number distributions
   PUBLIC :: random_unit
   PUBLIC :: random_uniform
   PUBLIC :: random_Rayleigh
   PUBLIC :: random_Lorentzian
   PUBLIC :: random_Gaussian
   PUBLIC :: random_Gaussian_pair
   PUBLIC :: random_lognormal
   PUBLIC :: random_exponential
   PUBLIC :: random_polynomial
   PUBLIC :: random_spherical_theta

   ! Complex number disitrubutions
   PUBLIC :: random_complex_unit

   ! Draw from any real-number distribution
   PUBLIC :: accept_reject

   INTERFACE random_twopoint
      MODULE PROCEDURE random_twopoint_real
      MODULE PROCEDURE random_twopoint_integer
   END INTERFACE random_twopoint

CONTAINS

   ! SUBROUTINE RNG_set(seed, verbose)

   !    ! Seeds the RNG
   !    ! TODO: Retire rand, replace with random_number
   !    IMPLICIT NONE
   !    INTEGER, INTENT(IN) :: seed
   !    LOGICAL, OPTIONAL, INTENT(IN) :: verbose
   !    INTEGER :: int, timearray(3)
   !    REAL(kind=4) :: rand ! Necessary to define for ifort, also the *4 is necessary

   !    IF (present_and_correct(verbose)) THEN
   !       WRITE (*, *) 'RNG_SET: Initialising random number generator'
   !       WRITE (*, *) 'RNG_SET: Seed:', seed
   !    END IF

   !    IF (seed == 0) THEN

   !       ! This fills the time array using the system clock!
   !       ! If called within the same second the numbers will be identical!
   !       CALL itime(timeArray)

   !       ! This then initialises the generator!
   !       int = floor(rand(timeArray(1)+timeArray(2)+timeArray(3)))

   !    ELSE

   !       ! In this case you can keep track of the seed
   !       int = floor(rand(seed))

   !    END IF

   !    IF (present_and_correct(verbose)) THEN
   !       WRITE (*, *) 'RNG_SET: Done'
   !       WRITE (*, *)
   !    END IF

   ! END SUBROUTINE RNG_set

   SUBROUTINE random_generator_seed(seed, verbose)

      ! TODO: Understand seeding properly
      INTEGER, INTENT(IN) :: seed
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      INTEGER :: n
      INTEGER, ALLOCATABLE :: seedy(:)

      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'RANDOM_GENERATOR_SEED: Initialising random number generator'
         IF(seed .NE. 0) WRITE (*, *) 'RANDOM_GENERATOR_SEED: Seed:', seed
      END IF

      IF (seed == 0) THEN
         CALL random_seed()
      ELSE
         CALL random_seed(size=n)
         ALLOCATE(seedy(n))
         seedy = seed
         CALL random_seed(put=seedy)
      END IF

      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'RANDOM_GENERATOR_SEED: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE random_generator_seed

   INTEGER FUNCTION random_integer(i1, i2)

      ! Picks an integer with uniform random probability between i1 and i2 spaced with 1
      INTEGER, INTENT(IN) :: i1 ! Lower bound
      INTEGER, INTENT(IN) :: i2 ! Upper bound
      INTEGER, PARAMETER :: seed = 0

      random_integer = i1-1+ceiling(random_unit()*real(1+i2-i1))
      IF (random_integer == i1-1) random_integer = i1

   END FUNCTION random_integer

   INTEGER FUNCTION dice(ndice, dmin_opt, dmax_opt)

      ! Get a total for rolling ndice
      INTEGER, INTENT(IN) :: ndice               ! Number of dice to roll   
      INTEGER, OPTIONAL, INTENT(IN) :: dmin_opt  ! Minimum value on di
      INTEGER, OPTIONAL, INTENT(IN) :: dmax_opt  ! Maximum value on di (assumes all integers on di between dmin and dmax)    
      INTEGER :: i
      INTEGER :: dmin, dmax
      INTEGER, PARAMETER :: dmin_def = 1
      INTEGER, PARAMETER :: dmax_def = 6

      ! Check number of dice
      IF (ndice < 0) STOP 'DICE: Error, number of rolls must be positive'

      ! Default or optional values for the minimum and maximum on the di
      ! Note that all contiguous integers are taken between dmin and dmax
      dmin = default_or_optional(dmin_def, dmin_opt)
      dmax = default_or_optional(dmax_def, dmax_opt)

      ! Roll the dice and sum the score
      dice = 0
      DO i = 1, ndice
         dice = dice+random_integer(dmin, dmax)
      END DO

   END FUNCTION dice

   REAL FUNCTION random_twopoint_real(a, b, p)

      ! Pick 'a' with probability 'p' and 'b' with probability '1-p'
      REAL, INTENT(IN) :: a, b
      REAL, INTENT(IN) :: p
      REAL :: r

      r = random_unit()
      IF (r <= p) THEN
         random_twopoint_real = a
      ELSE
         random_twopoint_real = b
      END IF

   END FUNCTION random_twopoint_real

   INTEGER FUNCTION random_twopoint_integer(a, b, p)

      ! Pick 'a' with probability '1-p' and 'b' with probability 'p'
      INTEGER, INTENT(IN) :: a, b
      REAL, INTENT(IN) :: p
      REAL :: r

      r = random_unit()
      IF (r <= p) THEN
         random_twopoint_integer = a
      ELSE
         random_twopoint_integer = b
      END IF

   END FUNCTION random_twopoint_integer

   INTEGER FUNCTION random_Bernoulli(p)

      ! Unity with probability p, otherwise zero
      ! PDF: P_k = p^k (1-p)^(1-k) with k = 0, 1
      REAL, INTENT(IN) :: p ! Should be between 0 and 1

      random_Bernoulli=random_twopoint(1, 0, p)

   END FUNCTION random_Bernoulli

   INTEGER FUNCTION random_sign()

      ! Returns either +1 or -1 with equal probability
      random_sign = random_twopoint(-1, 1, 0.5)

   END FUNCTION random_sign

   INTEGER FUNCTION random_binomial(n, p)

      ! Generates a random number from a Binomial distribution with n trials, each with probability of success p
      ! Note that random_Binomial will always be between [0, n]; closer to n with higher p
      INTEGER, INTENT(IN) :: n ! Number of trials
      REAL, INTENT(IN) :: p    ! Probability of success of each trial
      INTEGER :: sum, i

      sum = 0
      DO i = 1, n
         sum = sum+random_Bernoulli(p)
      END DO
      random_binomial = sum

   END FUNCTION random_binomial

   INTEGER FUNCTION random_Poisson(mean)

      ! Generate a random number from a Poisson distribution 
      REAL, INTENT(IN) :: mean
      INTEGER :: k
      REAL :: L, p

      L = exp(-mean)

      k = 0
      p = 1.
      DO
         p = p*random_unit()
         IF (p < L) THEN
            EXIT
         ELSE
            k = k+1
         END IF
      END DO

      random_Poisson = k

   END FUNCTION random_Poisson

   REAL FUNCTION random_unit()

      ! Produces a uniform-random number between 0 and 1

      CALL random_number(random_unit)

   END FUNCTION random_unit

   REAL FUNCTION random_uniform(x1, x2)

      ! Produces a uniform random number between x1 and x2
      REAL, INTENT(IN) :: x1 ! Lower bound
      REAL, INTENT(IN) :: x2 ! Upper bound

      random_uniform = x1+(x2-x1)*random_unit()

   END FUNCTION random_uniform

   REAL FUNCTION random_Rayleigh(sigma)

      ! Produces a Rayleigh-distributed random number
      USE constants
      REAL, INTENT(IN) :: sigma        ! Sigma parameter (*not* standard deviation of the distribution)
      REAL, PARAMETER :: small = 1e-10 ! To avoid ever getting a log(0) call

      ! Problems if small=0. because log(0.) gets called sometimes
      random_Rayleigh = sigma*sqrt(-2.*log(random_uniform(small, one)))

   END FUNCTION random_Rayleigh

   REAL FUNCTION random_Lorentzian()

      ! Produces a Lorentzian-distributed random number
      USE constants

      random_Lorentzian = tan(random_uniform(zero, pi/2.))

   END FUNCTION random_Lorentzian

   FUNCTION random_Gaussian_pair(mean, sigma)

      ! Gets a pair of independent Gaussian random numbers
      ! This uses the Box-Muller method (https://en.wikipedia.org/wiki/Box-Muller_transform)
      USE constants
      REAL :: random_Gaussian_pair(2)
      REAL, INTENT(IN) :: mean  ! Mean of the distribution
      REAL, INTENT(IN) :: sigma ! Root-variance of the distribution
      REAL :: r, theta

      r = random_Rayleigh(sigma)
      theta = random_uniform(zero, twopi)

      ! Both of these numbers are independently Gaussian
      random_Gaussian_pair(1) = r*sin(theta)+mean
      random_Gaussian_pair(2) = r*cos(theta)+mean

   END FUNCTION random_Gaussian_pair

   REAL FUNCTION random_Gaussian(mean, sigma)

      ! Gets a single Gaussian random number
      ! This is wasteful as there is a second, independent Gaussian random number that is thrown away
      REAL, INTENT(IN) :: mean  ! Mean of the distribution
      REAL, INTENT(IN) :: sigma ! Root-variance of the distribution
      REAL :: G(2)

      G = random_Gaussian_pair(mean, sigma)
      random_Gaussian = G(1)

   END FUNCTION random_Gaussian

   REAL FUNCTION random_lognormal(mean, sd)

      ! Gets a single log-normal random number
      ! TODO: Could do random_lognormal_pair
      REAL, INTENT(IN) :: mean ! Mean of the distribution
      REAL, INTENT(IN) :: sd   ! Standard deviation of the distribution
      REAL :: mu, sigma

      mu = log(mean/sqrt(1.+(sd/mean)**2))
      sigma = sqrt(log(1.+(sd/mean)**2))
      random_lognormal = exp(random_Gaussian(mu, sigma))

   END FUNCTION random_lognormal

   REAL FUNCTION random_exponential(mean)

      ! Produces a exponentially-distributed random number
      REAL, INTENT(IN) :: mean         ! Mean of the distribution
      REAL, PARAMETER :: small = 1e-10 ! Needed because problems here if log(0) is ever called

      random_exponential = -mean*log(random_uniform(small, 1.))

   END FUNCTION random_exponential

   REAL FUNCTION random_polynomial(n)

      ! Generate a polynomailly distributed number [x:0->1]
      REAL, INTENT(IN) :: n ! Order for the polynomial [-1:inf]

      !IF (n <= -1) STOP 'RANDOM_POLYNOMIAL: Error, n is less than or equal to -1'
      random_polynomial = random_unit()**(1./(n+1))

   END FUNCTION random_polynomial

   REAL FUNCTION random_spherical_theta()

      ! A random spherical-polar angle such that the solid-angle is uniformally populated
      random_spherical_theta = acos(random_uniform(-1., 1.))

   END FUNCTION random_spherical_theta

   COMPLEX FUNCTION random_complex_unit()

      ! Get a complex phase with theta between 0 and 2pi
      ! Generates a unit amplitude complex number with random phase
      ! TODO: Is 0 actually counted twice because 0 and 2pi are identical?
      USE constants
      REAL :: theta

      theta = random_uniform(0., twopi)
      random_complex_unit = cmplx(cos(theta), sin(theta))

   END FUNCTION random_complex_unit

   REAL FUNCTION accept_reject(func, x1, x2, fmax)

      ! Simple one-dimensional accept-reject algorithm for drawing random numbers from func(x) between x1 and x2
      ! TODO: Increase to n-dimensions
      ! TODO: Include more complicated bounding structure (at the moment it is just a box)
      REAL, EXTERNAL :: func   ! Function to sample from
      REAL, INTENT(IN) :: x1   ! Lower bound for function
      REAL, INTENT(IN) :: x2   ! Upper bound for function
      REAL, INTENT(IN) :: fmax ! Maximum value of the function in the interval x1 to x2
      REAL :: x, y, f

      INTERFACE
         FUNCTION func(xin)
            REAL, INTENT(IN) :: xin
         END FUNCTION func
      END INTERFACE

      ! Try until a value is accepted
      DO

         ! Draw uniform-random x value and function height
         x = random_uniform(x1, x2)
         y = random_uniform(0., fmax)

         ! Evaulate the function at the random x value
         f = func(x)

         ! Decide whether or not to accept
         IF (f > fmax) THEN
            STOP 'ACCEPT_REJECT: Error, your function is not bounded by fmax'
         ELSE IF (y <= f) THEN
            accept_reject = x
            EXIT
         END IF

      END DO

   END FUNCTION accept_reject

END MODULE random_numbers

module HMx_wrapper
    use iso_c_binding,  only : c_int, c_double, c_float, c_bool, c_loc, c_ptr, c_f_pointer
    use array_operations, only: is_in_array
    use HMx, only: calculate_HMx, calculate_HMx_old, halomod, assign_halomod, init_halomod, &
                    HMCode2016, HMCode2016_CAMB, HMCode2020, &
                    HMx2020_matter_w_temp_scaling, HMx2020_matter_pressure_w_temp_scaling, &
                    field_dmonly, field_matter, field_cdm, field_gas, field_stars, field_electron_pressure
    use cosmology_functions, only: cosmology, assign_cosmology, init_cosmology, init_external_linear_power_tables, norm_none, itk_external
    use constants

    IMPLICIT NONE

    INTEGER(kind=c_int), BIND(c) :: constant_HMCode2016 = HMCode2016
    INTEGER(kind=c_int), BIND(c) :: constant_HMCode2016_CAMB = HMCode2016_CAMB
    INTEGER(kind=c_int), BIND(c) :: constant_HMCode2020 = HMCode2020
    INTEGER(kind=c_int), BIND(c) :: constant_HMx2020_matter_with_temperature_scaling = HMx2020_matter_w_temp_scaling
    INTEGER(kind=c_int), BIND(c) :: constant_HMx2020_matter_pressure_with_temperature_scaling = HMx2020_matter_pressure_w_temp_scaling
    INTEGER(kind=c_int), BIND(c) :: constant_field_dmonly = field_dmonly
    INTEGER(kind=c_int), BIND(c) :: constant_field_matter = field_matter
    INTEGER(kind=c_int), BIND(c) :: constant_field_cdm = field_cdm
    INTEGER(kind=c_int), BIND(c) :: constant_field_gas = field_gas
    INTEGER(kind=c_int), BIND(c) :: constant_field_stars = field_stars
    INTEGER(kind=c_int), BIND(c) :: constant_field_electron_pressure = field_electron_pressure

    contains


        function run_HMx(Om_m, Om_b, Om_w, m_nu, &
                           h, ns, sigma8, w, wa, &
                           halo_model_mode, Theat, eta0, As, &
                           nf, ifield, &
                           nk, k, &
                           na, a, &
                           nk_plin, na_plin, pk_lin, &
                           nf1_pk, nf2_pk, nk_pk, na_pk, pk_hmx, &
                           verbose) result(status) bind(c, name="run_HMx") 
            
            REAL(kind=c_double), INTENT(IN) :: Om_m, Om_b, Om_w, m_nu        ! Primary parameters
            REAL(kind=c_double), INTENT(IN) :: h, ns, sigma8, w, wa           ! Primary parameters
            
            INTEGER(kind=c_int), INTENT(IN) :: halo_model_mode              ! Halo model mode
            REAL(kind=c_double), INTENT(IN) :: Theat, eta0, As               ! Halo model parameters

            INTEGER(kind=c_int), INTENT(IN) :: nf                       ! Number of different fields
            INTEGER(kind=c_int), INTENT(IN) :: ifield(nf)               ! Indices for different fields
            INTEGER(kind=c_int), INTENT(IN) :: nk                       ! Number of requested k points
            REAL(kind=c_double), INTENT(IN) :: k(nk)                    ! Requested k array [h/Mpc]
            INTEGER(kind=c_int), INTENT(IN) :: na                       ! Number of requested a points
            REAL(kind=c_double), INTENT(IN) :: a(na)                    ! Requested a array
            INTEGER(kind=c_int), INTENT(IN) :: nk_plin, na_plin         ! Number of p_lin points
            REAL(kind=c_double), INTENT(IN) :: pk_lin(nk_plin, na_plin) ! p_lin array
            INTEGER(kind=c_int), INTENT(IN) :: nf1_pk, nf2_pk, nk_pk, na_pk
            REAL(kind=c_double), INTENT(OUT) :: pk_hmx(nf1_pk, nf2_pk, nk_pk, na_pk) ! Pow(f1,f2,k,a)

            
            LOGICAL(kind=c_bool), INTENT(IN) :: verbose

            INTEGER(kind=c_int) :: status
            
            INTEGER :: icosmo, ihm, i
            TYPE(halomod) :: hmod   ! Halo model
            TYPE(cosmology) :: cosm ! Cosmology


            ! Working arrays
            REAL, ALLOCATABLE :: pow_li(:, :)       ! Pow(k,a)
            REAL, ALLOCATABLE :: pow_2h(:, :, :, :) ! Pow(f1,f2,k,a)
            REAL, ALLOCATABLE :: pow_1h(:, :, :, :) ! Pow(f1,f2,k,a)
            REAL, ALLOCATABLE :: pow_hm(:, :, :, :) ! Pow(f1,f2,k,a)

            if(nk /= nk_pk) then
                write(*,*) "Inconsistent requested k array sizes:", nk, nk_pk
                status = 1
                return
            end if

            if(na /= na_pk) then
                write(*,*) "Inconsistent requested a array sizes:", na, na_pk
                status = 1
                return
            end if

            if(nk /= nk_plin) then
                write(*,*) "Inconsistent plin k array sizes:", nk, nk_plin
                status = 1
                return
            end if

            if(na /= na_plin) then
                write(*,*) "Inconsistent plin a array sizes:", na, na_plin
                status = 1
                return
            end if

            ! write(*,*) "Input:"
            ! write(*,*) "k:", k
            ! write(*,*) "a:", a
            ! write(*,*) "pk_lin:", pk_lin
            ! write(*,*) "k**3", k**3
            ! write(*,*) "pi:", pi, (2*pi**2)
            ! write(*,*) "Delta_lin(a=1):", pk_lin(:,na_plin)*k**3/(2*pi**2)
            ! STOP

            ! For cosmology
            icosmo = 1 ! 'boring' cosmology
            CALL assign_cosmology(icosmo, cosm, LOGICAL(verbose))

            cosm%Om_m = Om_m
            cosm%Om_b = Om_b
            cosm%Om_w = Om_w
            cosm%Om_v = 0.0

            cosm%m_nu = m_nu

            cosm%h = h
            cosm%ns = ns
            cosm%w = w
            cosm%wa = wa

            cosm%sig8 = sigma8

            cosm%norm_method = norm_none
            cosm%itk = itk_external
            cosm%has_power = .true.

            call init_external_linear_power_tables(cosm, k, a, pk_lin)
            
            ! ! Copy in linear power
            
            ! cosm%nk_plin = nk_plin
            ! cosm%na_plin = na_plin

            ! if(.not. allocated(cosm%k_plin)) allocate(cosm%log_k_plin(nk))
            ! if(.not. allocated(cosm%a_plin)) allocate(cosm%log_a_plin(na))
            ! if(.not. allocated(cosm%plin)) allocate(cosm%log_plin(nk_plin))
            ! if(.not. allocated(cosm%plina)) allocate(cosm%log_plina(nk_plin, na_plin))
            ! cosm%log_k_plin = log(k)
            ! cosm%log_plin = log(pk_lin(:,na_plin)*k**3/(2*pi**2))
            ! cosm%log_a_plin = log(a)
            ! forall (i=1:nk_plin) cosm%log_plina(i,:) = log(pk_lin(i,:)*k(i)**3/(2*pi**2))

            ! if(m_nu > 0.0) then
            !     ! Need to deal with scale-depedent growth
            !     if(nq /= nk_Tcold) then
            !         write(*,*) "Inconsistent q (Tcold) array sizes:", nq, nk_Tcold
            !         status = 1
            !         return
            !     end if
    
            !     if(na /= na_Tcold) then
            !         write(*,*) "Inconsistent a (Tcold)  array sizes:", na, na_Tcold
            !         status = 1
            !         return
            !     end if
            !     if(.not. allocated(cosm%log_k_Tcold)) allocate(cosm%log_k_Tcold(nq))
            !     if(.not. allocated(cosm%Tcold)) allocate(cosm%Tcold(nk_Tcold, na_Tcold))
            !     cosm%log_k_Tcold = log(q)
            !     cosm%Tcold = Tcold
            ! end if

            ! write(*,*) "cosm structure:"
            ! write(*,*) "cosm%log_k_plin:", cosm%log_k_plin
            ! write(*,*) "cosm%log_plin:", cosm%log_plin
            ! write(*,*) "cosm%log_a_plin:", cosm%log_a_plin
            ! write(*,*) "cosm%log_plina:", cosm%log_plina

            cosm%Theat = Theat

            CALL init_cosmology(cosm)

            ! For halo model
            ihm = halo_model_mode
            CALL assign_halomod(ihm, hmod, LOGICAL(verbose))

            if(is_in_array(halo_model_mode, [HMCode2016, HMCode2016_CAMB, HMCode2020])) then
                hmod%eta0 = eta0
                hmod%As = As
            end if

            ! if(halo_model_mode == HMCode2016_CAMB) then
            !     ! Try to match to the CAMB version of HMCode
            !     ! CAMB version of HMcode (July 2019)
            !     hmod%mmin = 1e0  ! Lower mass limit for integration [Msun/h]
            !     hmod%mmax = 1e18 ! Upper mass limit for integration [Msun/h]  
            !     hmod%n = 256     ! Number of points in halo mass
            ! end if

            allocate(pow_li(nk, na), pow_2h(nf, nf, nk, na), pow_1h(nf, nf, nk, na), pow_hm(nf, nf, nk, na))


            call calculate_HMx_old(ifield, nf, k, nk, a, na, pow_li, pow_2h, pow_1h, pow_hm, hmod, cosm, LOGICAL(verbose))

            forall (i=1:nk_pk) pk_hmx(:,:,i,:) = pow_hm(:,:,i,:)/(k(i)**3/(2*pi**2))

            if(allocated(pow_li)) deallocate(pow_li)
            if(allocated(pow_2h)) deallocate(pow_2h)
            if(allocated(pow_1h)) deallocate(pow_1h)
            if(allocated(pow_hm)) deallocate(pow_hm)

            status = 0
        end function

end module

MODULE cosmic_emu_stuff

   ! TODO: Could remove depdence on coosmology_functions and have internal cosmology type for emulator

   USE file_info
   USE basic_operations
   USE array_operations
   USE string_operations
   USE cosmology_functions
   USE interpolate
   USE table_integer

   IMPLICIT NONE

   PRIVATE

   ! Public functions
   PUBLIC :: get_CosmicEmu_power_z
   PUBLIC :: get_FrankenEmu_power_z
   PUBLIC :: get_MiraTitan_power_z
   PUBLIC :: get_emulator_power
   PUBLIC :: calculate_Emulator_power

   ! Emulator versions
   PUBLIC :: emulator_CosmicEmu
   PUBLIC :: emulator_FrankenEmu
   PUBLIC :: emulator_MiraTitan
   PUBLIC :: emulator_Euclid
   PUBLIC :: emulator_BACCO
   PUBLIC :: emulator_NGenHALOFIT

   ! Emulator versions
   INTEGER, PARAMETER :: emulator_CosmicEmu = 1
   INTEGER, PARAMETER :: emulator_FrankenEmu = 2
   INTEGER, PARAMETER :: emulator_MiraTitan = 3
   INTEGER, PARAMETER :: emulator_Euclid = 4
   INTEGER, PARAMETER :: emulator_BACCO = 5
   INTEGER, PARAMETER :: emulator_NGenHALOFIT = 6

   ! Cosmic Emu
   REAL, PARAMETER :: kmin_rebin_CosmicEmu = 1e-2
   REAL, PARAMETER :: kmax_rebin_CosmicEmu = 1.
   !REAL, PARAMETER :: kmax_rebin_CosmicEmu = 2.7 ! This is the maximum
   !REAL, PARAMETER :: kmax_rebin_CosmicEmu = 0.2 ! Perturbation-theory studies
   INTEGER, PARAMETER :: nk_rebin_CosmicEmu = 129
   CHARACTER(len=256), PARAMETER :: params_CosmicEmu = 'emu_params.txt'
   CHARACTER(len=256), PARAMETER :: output_CosmicEmu = 'emu_power.dat'
   CHARACTER(len=256), PARAMETER :: exe_CosmicEmu = '/Users/Mead/Physics/CosmicEmu/emu.exe'
   INTEGER, PARAMETER :: nh_CosmicEmu = 10   ! Length of header
   INTEGER, PARAMETER :: hl_CosmicEmu = 8    ! Line that h in on'
   REAL, PARAMETER :: eps_h_CosmicEmu = 3e-3 ! Tolerance for how close 'h' needs to be to that derived from r_sound

   ! Franken Emu
   REAL, PARAMETER :: kmin_rebin_FrankenEmu = 1e-2
   REAL, PARAMETER :: kmax_rebin_FrankenEmu = 10.
   INTEGER, PARAMETER :: nk_rebin_FrankenEmu = 129
   CHARACTER(len=256), PARAMETER :: params_FrankenEmu = 'emu_params.txt'
   CHARACTER(len=256), PARAMETER :: output_FrankenEmu = 'emu_power.dat'
   CHARACTER(len=256), PARAMETER :: exe_FrankenEmu = '/Users/Mead/Physics/FrankenEmu/emu.exe'

   ! Mira Titan
   REAL, PARAMETER :: kmin_rebin_MiraTitan = 1e-2
   REAL, PARAMETER :: kmax_rebin_MiraTitan = 7.
   INTEGER, PARAMETER :: nk_rebin_MiraTitan = 129
   CHARACTER(len=256), PARAMETER :: params_MiraTitan = 'xstar.dat'
   CHARACTER(len=256), PARAMETER :: output_MiraTitan = 'EMU0.txt'
   CHARACTER(len=256), PARAMETER :: exe_MiraTitan = '/Users/Mead/Physics/MiraTitan/P_tot/emu.exe'

   ! Euclid Emulator
   CHARACTER(len=256), PARAMETER :: exe_Euclid = '/Users/Mead/Physics/EuclidEmulator2/ee2.exe'
   CHARACTER(len=256), PARAMETER :: dir_Euclid = '/Users/Mead/Physics/EuclidEmulator2/'
   CHARACTER(len=256), PARAMETER :: outdir_Euclid = trim(dir_Euclid)//'Mead/'
   CHARACTER(len=256), PARAMETER :: outbase_Euclid = 'temp'
   CHARACTER(len=256), PARAMETER :: outfile_Euclid = trim(outbase_Euclid)//'0.dat'

   ! BACCO
   CHARACTER(len=256), PARAMETER :: exe_BACCO = '/Users/Mead/Physics/BACCO/run_BACCO.py'
   CHARACTER(len=256), PARAMETER :: outfile_BACCO = '/Users/Mead/Physics/BACCO/results.dat'

    ! NGenHALOFIT
   CHARACTER(len=256), PARAMETER :: dir_NGenHALOFIT = '/Users/Mead/Physics/NGenHalofit/'
   CHARACTER(len=256), PARAMETER :: exe_NGenHALOFIT = trim(dir_NGenHALOFIT)//'NGenHalofit.exe' 
   CHARACTER(len=256), PARAMETER :: dir_temp_NGenHALOFIT = trim(dir_NGenHALOFIT)//'Mead/'
   CHARACTER(len=256), PARAMETER :: linfile_NGenHALOFIT = 'linear_power.dat'
   CHARACTER(len=256), PARAMETER :: linfilefull_NGenHALOFIT = trim(dir_temp_NGenHALOFIT)//trim(linfile_NGenHALOFIT)
   CHARACTER(len=256), PARAMETER :: inifile_NGenHALOFIT = trim(dir_temp_NGenHALOFIT)//'input_file.dat'
   CHARACTER(len=256), PARAMETER :: expfile_NGenHALOFIT = trim(dir_temp_NGenHALOFIT)//'expansion_file.dat'
   CHARACTER(len=256), PARAMETER :: powbase_NGenHALOFIT = 'HALOFIT_power'
   CHARACTER(len=256), PARAMETER :: MPTbase_NGenHALOFIT = 'MPT_power'
   CHARACTER(len=256), PARAMETER :: vardir_NGenHALOFIT = trim(dir_NGenHALOFIT)//'DATAPlinCAMB/'
   CHARACTER(len=256), PARAMETER :: varbase_NGenHALOFIT = 'Planck2013.Step_ByHand.HighAcc_matterpower'
   REAL, PARAMETER :: kmin_lin_NGenHALOFIT = 1e-3
   REAL, PARAMETER :: kmax_lin_NGenHALOFIT = 1e2
   INTEGER, PARAMETER :: nk_plin_NGenHALOFIT = 129
   REAL, PARAMETER :: As_NGenHALOFIT = 2.14485e-9
   REAL, PARAMETER :: kpiv_noh_default_NGenHALOFIT = 0.05
   REAL, PARAMETER :: eps_kpiv_NGenHALOFIT = 1e-4
   REAL, PARAMETER :: alin_NGenHALOFIT = 1.
   INTEGER, PARAMETER :: flag_NGenHALOFIT = flag_matter
   INTEGER, PARAMETER :: iorder_interp_NGenHALOFIT = 3
   INTEGER, PARAMETER :: ifind_interp_NGenHALOFIT = ifind_split
   INTEGER, PARAMETER :: iinterp_interp_NGenHALOFIT = iinterp_Lagrange
   REAL, PARAMETER :: w_min_NGenHALOFIT = -1.05
   REAL, PARAMETER :: w_max_NGenHALOFIT = -0.95
   REAL, PARAMETER :: wa_min_NGenHALOFIT = -0.4
   REAL, PARAMETER :: wa_max_NGenHALOFIT = 0.4
   REAL, PARAMETER :: Om_m_min_NGenHALOFIT = 0.21
   REAL, PARAMETER :: Om_m_max_NGenHALOFIT = 0.4
   REAL, PARAMETER :: wc_min_NGenHALOFIT = 0.1
   REAL, PARAMETER :: wc_max_NGenHALOFIT = 0.13
   REAL, PARAMETER :: wb_min_NGenHALOFIT = 0.02
   REAL, PARAMETER :: wb_max_NGenHALOFIT = 0.04
   REAL, PARAMETER :: ns_min_NGenHALOFIT = 0.85
   REAL, PARAMETER :: ns_max_NGenHALOFIT = 1.05
   REAL, PARAMETER :: As_min_NGenHALOFIT = 1.72e-9
   REAL, PARAMETER :: As_max_NGenHALOFIT = 2.58e-9
   REAL, PARAMETER :: nrun_min_NGenHALOFIT = -0.2
   REAL, PARAMETER :: nrun_max_NGenHALOFIT = 0.2

   ! Rebinnig
   LOGICAL, PARAMETER :: logk_interp_emulator = .TRUE.
   LOGICAL, PARAMETER :: logPk_interp_emulator = .TRUE.
   LOGICAL, PARAMETER :: logBk_interp_emulator = .FALSE.
   INTEGER, PARAMETER :: iorder_rebin = 3
   INTEGER, PARAMETER :: ifind_rebin = ifind_split
   INTEGER, PARAMETER :: iinterp_rebin = iinterp_Lagrange

CONTAINS

   SUBROUTINE calculate_Emulator_power(k, a, Pk, cosm, version, verbose)

      REAL, INTENT(IN) :: k(:)
      REAL, INTENT(IN) :: a(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:, :)
      TYPE(cosmology), INTENT(INOUT) :: cosm
      INTEGER, INTENT(IN) :: version
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose

      IF (is_in_array(version, [emulator_CosmicEmu, emulator_FrankenEmu, emulator_MiraTitan])) THEN
         CALL calculate_CosmicEmulator_power(k, a, Pk, cosm, version, verbose)
      ELSE IF (version == emulator_Euclid) THEN
         CALL calculate_EuclidEmulator_power(k, a, Pk, cosm)
      ELSE IF (version == emulator_BACCO) THEN
         CALL calculate_BACCO_power(k, a, Pk, cosm)
      ELSE IF (version == emulator_NGenHALOFIT) THEN
         CALL calculate_NGenHALOFIT(k, a, Pk, cosm)
      ELSE
         STOP 'CALCULATE_EMULATOR_POWER: Error, emulator version not recognised'
      END IF

   END SUBROUTINE calculate_Emulator_power

   SUBROUTINE calculate_NGenHALOFIT(k, a, Pk, cosm)

      REAL, INTENT(IN) :: k(:)
      REAL, INTENT(IN) :: a(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:, :)
      TYPE(cosmology), INTENT(INOUT) :: cosm
      INTEGER :: nk, na, ia
      REAL :: kmin, kmax
      REAL, ALLOCATABLE :: k_HF(:), Pk_HF(:, :)
      INTEGER, PARAMETER :: iorder = iorder_interp_NGenHALOFIT
      INTEGER, PARAMETER :: ifind = ifind_interp_NGenHALOFIT
      INTEGER, PARAMETER :: iinterp = iinterp_interp_NGenHALOFIT

      ! Array sizes
      nk = size(k)
      na = size(a)

      ! Run N-Gen HALOFIT
      ! TODO: Should nk here be the same as in the desired k array?
      kmin = k(1)
      kmax = k(nk)
      CALL run_NgenHALOFIT(kmin, kmax, nk, k_HF, a, Pk_HF, cosm)

      ! Interpolate results on to my k array
      ALLOCATE(Pk(nk, na))
      DO ia = 1, na
         CALL interpolate_array(k_HF, Pk_HF(:, ia), k, Pk(:, ia), iorder, ifind, iinterp, logx=.TRUE., logy=.TRUE.)
      END DO

   END SUBROUTINE calculate_NGenHALOFIT

   SUBROUTINE run_NGenHALOFIT(kmin, kmax, nk, k, a, Pk, cosm)

      USE camb_stuff
      REAL, INTENT(IN) :: kmin
      REAL, INTENT(IN) :: kmax
      INTEGER, INTENT(IN) :: nk
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, INTENT(IN) :: a(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:, :)
      TYPE(cosmology), INTENT(INOUT) :: cosm
      INTEGER :: ik
      CHARACTER(len=256), PARAMETER :: exe = exe_NGenHALOFIT
      CHARACTER(len=256), PARAMETER :: dir = dir_temp_NGenHALOFIT
      CHARACTER(len=256), PARAMETER :: linfile = linfilefull_NGenHALOFIT
      CHARACTER(len=256), PARAMETER :: inifile = inifile_NGenHALOFIT
      CHARACTER(len=256), PARAMETER :: expfile = expfile_NGenHALOFIT
      REAL, PARAMETER :: kmin_lin = kmin_lin_NGenHALOFIT
      REAL, PARAMETER :: kmax_lin = kmax_lin_NGenHALOFIT
      INTEGER, PARAMETER :: nk_lin = nk_plin_NGenHALOFIT
      REAL, PARAMETER :: alin = alin_NGenHALOFIT
      INTEGER, PARAMETER :: flag = flag_NGenHALOFIT
      REAL, PARAMETER :: kpiv_noh_default = kpiv_noh_default_NGenHALOFIT
      REAL, PARAMETER :: eps_kpiv = eps_kpiv_NGenHALOFIT
      REAL, PARAMETER :: w_min = w_min_NGenHALOFIT
      REAL, PARAMETER :: w_max = w_max_NGenHALOFIT
      REAL, PARAMETER :: wa_min = wa_min_NGenHALOFIT
      REAL, PARAMETER :: wa_max = wa_max_NGenHALOFIT
      REAL, PARAMETER :: Om_m_min = Om_m_min_NGenHALOFIT
      REAL, PARAMETER :: Om_m_max = Om_m_max_NGenHALOFIT
      REAL, PARAMETER :: wc_min = wc_min_NGenHALOFIT
      REAL, PARAMETER :: wc_max = wc_max_NGenHALOFIT
      REAL, PARAMETER :: wb_min = wb_min_NGenHALOFIT
      REAL, PARAMETER :: wb_max = wb_max_NGenHALOFIT
      REAL, PARAMETER :: ns_min = ns_min_NGenHALOFIT
      REAL, PARAMETER :: ns_max = ns_max_NGenHALOFIT
      REAL, PARAMETER :: As_min = As_min_NGenHALOFIT
      REAL, PARAMETER :: As_max = As_max_NGenHALOFIT
      REAL, PARAMETER :: nrun_min = nrun_min_NGenHALOFIT
      REAL, PARAMETER :: nrun_max = nrun_max_NGenHALOFIT

      ! Checks
      IF (.NOT. cosm%is_init) STOP 'RUN_NGENHALOFIT: Error, cosmology is not initialised'
      IF (cosm%k /= 0.) WRITE(*, *) 'RUN_NGENHALOFIT: Warning, NGenHalofit only supports flat cosmologies'
      IF (cosm%m_nu /= 0.) WRITE(*, *) 'RUN_NGENHALOFIT: Warning, NGenHalofit does not support massive neutrino cosmologies'
      IF (.NOT. requal(cosm%kpiv*cosm%h, kpiv_noh_default, eps_kpiv)) THEN
        WRITE(*, *) 'RUN_NGENHALOFIT: kpiv [h/Mpc]:', cosm%kpiv
        WRITE(*, *) 'RUN_NGENHALOFIT: kpiv [1/Mpc]:', cosm%kpiv*cosm%h
        STOP 'RUN_NGENHALOFIT: Error, NGenHalofit assumes pivot scale of 0.05 Mpc^-1'
      END IF

      ! Needs to be called for As to be correct
      IF (.NOT. cosm%is_normalised) CALL normalise_power(cosm)

      ! Check parameter range
      IF (.NOT. between(cosm%w, w_min, w_max)) WRITE (*, *) 'RUN_NGENHALOFIT: Warning, w is outside boundary'
      IF (.NOT. between(cosm%wa, wa_min, wa_max)) WRITE (*, *) 'RUN_NGENHALOFIT: Warning, wa is outside boundary'
      IF (.NOT. between(cosm%Om_m, Om_m_min, Om_m_max)) WRITE (*, *) 'RUN_NGENHALOFIT: Warning, Omega_m is outside boundary'
      IF (.NOT. between(cosm%Om_c*cosm%h**2, wc_min, wc_max)) WRITE (*, *) 'RUN_NGENHALOFIT: Warning, omega_c is outside boundary'
      IF (.NOT. between(cosm%Om_b*cosm%h**2, wb_min, wb_max)) WRITE (*, *) 'RUN_NGENHALOFIT: Warning, omega_b is outside boundary'
      IF (.NOT. between(cosm%ns, ns_min, ns_max)) WRITE (*, *) 'RUN_NGENHALOFIT: Warning, ns is outside boundary'
      IF (.NOT. between(cosm%As, As_min, As_max)) WRITE (*, *) 'RUN_NGENHALOFIT: Warning, As is outside boundary'
      IF (.NOT. between(cosm%nrun, nrun_min, nrun_max)) WRITE (*, *) 'RUN_NGENHALOFIT: Warning, alpha is outside boundary'

      ! Remove any previous files
      CALL EXECUTE_COMMAND_LINE('rm -rf '//trim(dir)//'*')

      ! Write the ini file and list of expansion factors
      CALL write_NGenHALOFIT_ini_file(kmin, kmax, nk, cosm, inifile, dir)
      CALL write_NGenHALOFIT_exp_file(a, expfile)

      ! Write a CAMB format linear power spectrum
      ! TODO: It is a bit lazy to re-use the k, Pk arrays here
      CALL fill_array(kmin_lin, kmax_lin, k, nk_lin, ilog=.TRUE.)
      ALLOCATE(Pk(nk_lin, 1))
      DO ik = 1, nk_lin
         Pk(ik, 1) = plin(k(ik), alin, flag, cosm)
      END DO
      CALL write_CAMB_Pk(k, Pk(:, 1), linfile, header=.FALSE.)
      DEALLOCATE(k, Pk)

      ! Run NGenHALOFIT
      CALL EXECUTE_COMMAND_LINE('cd '//trim(dir_NGenHALOFIT)//' && '//trim(exe)//' '//trim(inifile)//' '//trim(expfile)//' > /dev/null')

      ! Read in the power data
      CALL read_NGenHALOFIT_power(k, a, Pk)

   END SUBROUTINE run_NGenHALOFIT

   SUBROUTINE write_NGenHALOFIT_ini_file(kmin, kmax, nk, cosm, outfile, dir)

      REAL, INTENT(IN) :: kmin
      REAL, INTENT(IN) :: kmax
      INTEGER, INTENT(IN) :: nk
      TYPE(cosmology), INTENT(IN) :: cosm
      CHARACTER(len=256), INTENT(IN) :: outfile
      CHARACTER(len=256), INTENT(IN) :: dir
      INTEGER :: u
      LOGICAL, PARAMETER :: logk = .TRUE.
      REAL, PARAMETER :: As = As_NGenHALOFIT
      CHARACTER(len=256), PARAMETER :: powbase = powbase_NGenHALOFIT
      CHARACTER(len=256), PARAMETER :: MPTbase = MPTbase_NGenHALOFIT
      CHARACTER(len=256), PARAMETER :: linfile = linfile_NGenHALOFIT
      CHARACTER(len=256), PARAMETER :: vardir = vardir_NGenHALOFIT
      CHARACTER(len=256), PARAMETER :: varbase = varbase_NGenHALOFIT

      OPEN(newunit=u, file=outfile)

      ! Cosmology
      WRITE (u, *) 'aexp 1.0'
      WRITE (u, *) 'w0', cosm%w
      WRITE (u, *) 'w1', cosm%wa
      WRITE (u, *) 'om_ch20', cosm%Om_c*cosm%h**2
      WRITE (u, *) 'om_bh20', cosm%Om_b*cosm%h**2
      WRITE (u, *) 'om_DE0', 1.-cosm%Om_m
      WRITE (u, *) 'As', cosm%As/As
      WRITE (u, *) 'pindex', cosm%ns
      WRITE (u, *) 'running', cosm%nrun

      ! Input parameters
      WRITE (u, *) 'nPkOut', nk
      WRITE (u, *) 'rkOutMIN', kmin
      WRITE (u, *) 'rkOutMAX', kmax
      IF (logk) THEN
         WRITE (u, *) 'iLogOrLin 1'
      ELSE
         WRITE (u, *) 'iLogOrLin 0'
      END IF
      WRITE (u, *) 'iGenEffSpecTarget	1'
      WRITE (u, *) 'iGenEffSpecVar	0'

      ! File handlers
      WRITE (u, *) 'OutputDir ', trim(dir)
      WRITE (u, *) 'OutputFileBase ', trim(powbase)
      WRITE (u, *) 'OutputMPTFileBase ', trim(MPTbase)
      WRITE (u, *) 'PowDirTarget ', trim(dir)
      WRITE (u, *) 'PowFileTarget ', trim(linfile)
      WRITE (u, *) 'PowDirVar ', trim(vardir)
      WRITE (u, *) 'PowFileBaseVar ', trim(varbase)

      CLOSE(u)

   END SUBROUTINE write_NGenHALOFIT_ini_file

   SUBROUTINE write_NGenHALOFIT_exp_file(a, outfile)

      REAL, INTENT(IN) :: a(:)
      CHARACTER(len=256), INTENT(IN) :: outfile
      INTEGER :: u
      INTEGER :: ia

      ! Write a file of scale factors with one scale factor per line
      OPEN(newunit=u, file=outfile)
      DO ia = 1, size(a)
         WRITE (u, *) a(ia)
      END DO
      CLOSE(u)

   END SUBROUTINE write_NGenHALOFIT_exp_file

   SUBROUTINE read_NGenHALOFIT_power(k, a, Pk)

      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, INTENT(IN) :: a(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:, :)
      REAL :: crap
      INTEGER :: ik, ia, nk, na
      INTEGER :: u
      CHARACTER(len=256) :: infile
      CHARACTER(len=256), PARAMETER :: inbase = trim(dir_temp_NGenHALOFIT)//trim(powbase_NGenHALOFIT)

      ! Loop over scale factors
      na = size(a)
      DO ia = 1, na

         ! Get the infile name and allocate arrays if necessary
         infile = trim(inbase)//'.'//trim(integer_to_string(ia-1))//'.dat'
         IF (ia == 1) THEN
            nk = file_length(infile)
            ALLOCATE(k(nk), Pk(nk, na))
         END IF

         ! Read in NGenHalofit power spectrum
         OPEN(newunit=u, file=infile)
         DO ik = 1, size(k)
            !READ(u, *) k(ik), crap, Pk(ik, ia) ! Column 3 is Takahashi HALOFIT
            READ(u, *) k(ik), crap, crap, Pk(ik, ia) ! Column 4 is NGenHALOFIT
         END DO
         CLOSE(u)

         ! Convert P(k) to Delta^2(k)
         Pk(:, ia) = Delta_Pk(Pk(:, ia), k)

      END DO

   END SUBROUTINE read_NGenHALOFIT_power

   SUBROUTINE calculate_BACCO_power(k, a, Pk, cosm)

      ! NOTE: BACCO calculates things for the cold matter power spectrum
      REAL, INTENT(IN) :: k(:)
      REAL, INTENT(IN) :: a(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:, :)    
      TYPE(cosmology), INTENT(INOUT) :: cosm
      REAL, ALLOCATABLE :: k_emu(:), Bk_emu(:), Pk_mm_lin(:, :), Pk_cc_lin(:, :)
      INTEGER :: ik, ia, nk, na
      CHARACTER(len=256) :: corrfile = trim(outfile_BACCO)
      INTEGER, PARAMETER :: iorder = iorder_rebin
      INTEGER, PARAMETER :: ifind = ifind_rebin
      INTEGER, PARAMETER :: iinterp = iinterp_rebin
      LOGICAL, PARAMETER :: logk_interp = logk_interp_emulator
      LOGICAL, PARAMETER :: logBk_interp = logBk_interp_emulator

      ! Allocate array for the output power spectrumm
      nk = size(k)
      na = size(a)
      ALLOCATE(Pk(nk, na))

      ! Calculate the linear power
      ! NOTE: This calculates the linear matter-matter power, but BACCO only considers cold matter
      CALL calculate_plin(k, a, Pk_mm_lin, flag_matter, cosm)
      CALL calculate_plin(k, a, Pk_cc_lin, flag_cold, cosm)

      ! Run the emulator and interpolate the correction from the EE k to the input k
      DO ia = 1, na
         CALL run_BACCO(a(ia), cosm)
         CALL read_BACCO_correction(k_emu, Bk_emu, corrfile)
         CALL interpolate_array(k_emu, Bk_emu, k, Pk(:, ia), iorder, ifind, iinterp, logk_interp, logBk_interp)
         DO ik = 1, nk
            IF (k(ik) < k_emu(1)) Pk(ik, ia) = 1.
         END DO
      END DO

      ! Multiply the correction by the linear power to get the non-linear spectrum
      ! NOTE: Apply correction to cold spectrum only, then add residual from neutrinos
      ! NOTE: P_mm = P_cc + 2P_nc + P_nn; for both non-linear and linear
      ! NOTE: P_mm - P_cc = 2P_nc + P_nn; so making assumption that P_nc and P_nn are both linear
      Pk = Pk_cc_lin*Pk+Pk_mm_lin-Pk_cc_lin

   END SUBROUTINE calculate_BACCO_power

   SUBROUTINE run_BACCO(a, cosm)

      REAL, INTENT(IN) :: a
      TYPE(cosmology), INTENT(IN) :: cosm
      CHARACTER(len=256) :: command, c, s8, b, ns, h, nu, w, wa, aexp
      CHARACTER(len=256), PARAMETER :: exe = exe_BACCO
      CHARACTER(len=256), PARAMETER :: outfile = outfile_BACCO

      ! Checks
      IF (cosm%k /= 0.) STOP 'RUN_BACCO: Error, does not support curved models'

      ! Remove previous data files
      CALL EXECUTE_COMMAND_LINE('rm -f '//trim(outfile))

      ! Commands
      c = ' '//trim(real_to_string(cosm%Om_c+cosm%Om_b, 1, 5))
      s8 = ' '//trim(real_to_string(cosm%sig8*(1.-cosm%f_nu), 1, 5))
      b = ' '//trim(real_to_string(cosm%Om_b, 1, 5))
      ns = ' '//trim(real_to_string(cosm%ns, 1, 5))
      h = ' '//trim(real_to_string(cosm%h, 1, 5))
      nu = ' '//trim(real_to_string(cosm%m_nu, 1, 5))
      w = ' '//trim(real_to_string(cosm%w, 1, 5))
      wa = ' '//trim(real_to_string(cosm%wa, 1, 5))
      aexp = ' '//trim(real_to_string(a, 1, 5))
      command = 'python3 '//trim(exe)//trim(c)//trim(s8)//trim(b)//trim(ns)//trim(h)//trim(nu)//trim(w)//trim(wa)//trim(aexp)

      ! Run the emulator
      CALL EXECUTE_COMMAND_LINE(trim(command)//' > /dev/null')

   END SUBROUTINE run_BACCO

   SUBROUTINE read_BACCO_correction(k, Bk, infile)

      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Bk(:)
      CHARACTER(len=*), INTENT(IN) :: infile
      INTEGER :: ik, nk, u

      ! Allocate arrays (remember one-line header)
      nk = file_length(infile)
      ALLOCATE(k(nk), Bk(nk))

      ! Read in non-linear correction data
      OPEN(newunit=u, file=infile)
      DO ik = 1, nk
         READ(u, *) k(ik), Bk(ik)
      END DO
      CLOSE(u)

   END SUBROUTINE read_BACCO_correction

   SUBROUTINE calculate_EuclidEmulator_power(k, a, Pk, cosm)

      REAL, INTENT(IN) :: k(:)
      REAL, INTENT(IN) :: a(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:, :)    
      TYPE(cosmology), INTENT(INOUT) :: cosm
      REAL, ALLOCATABLE :: k_emu(:), Bk_emu(:), Pk_lin(:, :)
      INTEGER :: ik, ia, nk, na
      CHARACTER(len=256) :: corrfile = trim(outdir_Euclid)//trim(outfile_Euclid)
      INTEGER, PARAMETER :: iorder = iorder_rebin
      INTEGER, PARAMETER :: ifind = ifind_rebin
      INTEGER, PARAMETER :: iinterp = iinterp_rebin
      LOGICAL, PARAMETER :: logk_interp = logk_interp_emulator
      LOGICAL, PARAMETER :: logBk_interp = logBk_interp_emulator

      ! Allocate array for the output power spectrumm
      nk = size(k)
      na = size(a)
      ALLOCATE(Pk(nk, na))

      ! Calculate the linear power
      ! NOTE: Do this before calling the emulator to make sure that As is set
      CALL calculate_plin(k, a, Pk_lin, flag_matter, cosm)

      ! Run the emulator and interpolate the correction from the EE k to the input k
      DO ia = 1, na
         CALL run_EuclidEumulator(a(ia), cosm)
         CALL read_EuclidEmulator_correction(k_emu, Bk_emu, corrfile)
         CALL interpolate_array(k_emu, Bk_emu, k, Pk(:, ia), iorder, ifind, iinterp, logk_interp, logBk_interp)
         DO ik = 1, nk
            IF (k(ik) < k_emu(1)) Pk(ik, ia) = 1.
         END DO
      END DO

      ! Multiply the correction by the linear power to get the non-linear spectrum
      Pk = Pk_lin*Pk

   END SUBROUTINE calculate_EuclidEmulator_power

   SUBROUTINE run_EuclidEumulator(a, cosm)

      REAL, INTENT(IN) :: a
      TYPE(cosmology), INTENT(IN) :: cosm
      CHARACTER(len=256) :: command, b, m, s, n, h, w, wa, As, z, dir, out
      CHARACTER(len=256), PARAMETER :: exe = exe_Euclid
      CHARACTER(len=256), PARAMETER :: basedir = dir_Euclid
      CHARACTER(len=256), PARAMETER :: outdir = outdir_Euclid
      CHARACTER(len=256), PARAMETER :: outbase = outbase_Euclid
      CHARACTER(len=256), PARAMETER :: outfile = outfile_Euclid

      ! Checks
      IF (cosm%k /= 0.) STOP 'RUN_EUCLIDEMULATOR: Error, does not support curved models'

      ! Remove previous data files
      CALL EXECUTE_COMMAND_LINE('rm -f '//trim(outdir)//trim(outfile))

      ! Commands
      b = ' -b '//trim(real_to_string(cosm%Om_b, 1, 5))
      m = ' -m '//trim(real_to_string(cosm%Om_m, 1, 5))
      s = ' -s '//trim(real_to_string(cosm%m_nu, 1, 5))
      n = ' -n '//trim(real_to_string(cosm%ns, 1, 5))
      h = ' -H '//trim(real_to_string(cosm%h, 1, 5))
      w = ' -W '//trim(real_to_string(cosm%w, 1, 5))
      wa = ' -w '//trim(real_to_string(cosm%wa, 1, 5))
      As = ' -A '//trim(exp_to_string(cosm%As, 1, 5, -9))
      z = ' -z '//trim(real_to_string(redshift_a(a), 2, 5))
      dir = ' -d '//trim(outdir)
      out = ' -o '//trim(outbase)
      command = trim(exe)//trim(b)//trim(m)//trim(s)//trim(n)//trim(h)//trim(w)//trim(wa)//trim(As)//trim(z)//trim(dir)//trim(out)

      ! Run the emulator
      CALL EXECUTE_COMMAND_LINE('cd '//trim(basedir)//' && '//trim(command)//' > /dev/null')

   END SUBROUTINE run_EuclidEumulator

   SUBROUTINE read_EuclidEmulator_correction(k, Bk, infile)

      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Bk(:)
      CHARACTER(len=*), INTENT(IN) :: infile
      INTEGER :: ik, nk, u

      ! Allocate arrays (remember one-line header)
      nk = file_length(infile)-1
      ALLOCATE(k(nk), Bk(nk))

      ! Read in non-linear correction data
      OPEN(newunit=u, file=infile)
      READ(u, *) ! Bypass one-line header
      DO ik = 1, nk
         READ(u, *) k(ik), Bk(ik)
      END DO
      CLOSE(u)

   END SUBROUTINE read_EuclidEmulator_correction

   SUBROUTINE calculate_CosmicEmulator_power(k, a, Pk, cosm, version, verbose)

      REAL, INTENT(IN) :: k(:)
      REAL, INTENT(IN) :: a(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:, :)    
      TYPE(cosmology), INTENT(INOUT) :: cosm
      INTEGER, INTENT(IN) :: version
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      REAL, ALLOCATABLE :: k_emu(:), Pk_emu(:, :)
      INTEGER :: ia, nk, na
      INTEGER, PARAMETER :: iorder = iorder_rebin
      INTEGER, PARAMETER :: ifind = ifind_rebin
      INTEGER, PARAMETER :: iinterp = iinterp_rebin
      LOGICAL, PARAMETER :: logk_interp = logk_interp_emulator
      LOGICAL, PARAMETER :: logPk_interp = logPk_interp_emulator

      nk = size(k)
      na = size(a)
      ALLOCATE(Pk(nk, na))

      CALL get_emulator_power(k_emu, a, Pk_emu, nk, cosm, version, rebin=.FALSE., verbose=verbose)

      DO ia = 1, na
         CALL interpolate_array(k_emu, Pk_emu(:, ia), k, Pk(:, ia), iorder, ifind, iinterp, logk_interp, logPk_interp)
      END DO

   END SUBROUTINE calculate_CosmicEmulator_power

   SUBROUTINE get_emulator_power(k, a, Pk, nk, cosm, version, rebin, verbose)

      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, INTENT(IN) :: a(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: Pk(:, :)
      INTEGER, INTENT(OUT) :: nk
      TYPE(cosmology), INTENT(IN) :: cosm   
      INTEGER, INTENT(IN) :: version
      LOGICAL, OPTIONAL, INTENT(IN) :: rebin
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      INTEGER :: ia, na
      REAL :: z
      REAL, ALLOCATABLE :: k_emu(:), Pk_emu(:)

      na = size(a)

      DO ia = 1, na

         z = redshift_a(a(ia))

         IF (version == emulator_CosmicEmu) THEN
            CALL get_CosmicEmu_power_z(k_emu, Pk_emu, nk, z, cosm, rebin, verbose)
         ELSE IF (version == emulator_FrankenEmu) THEN
            CALL get_FrankenEmu_power_z(k_emu, Pk_emu, nk, z, cosm, rebin, verbose)
         ELSE IF (version == emulator_MiraTitan) THEN
            CALL get_MiraTitan_power_z(k_emu, Pk_emu, nk, z, cosm, rebin, verbose)
         ELSE
            STOP 'GET_EMULATOR_POWER: Error, version not specified correctly'
         END IF

         IF (.NOT. allocated(k))  ALLOCATE(k(nk))
         IF (.NOT. allocated(Pk)) ALLOCATE(Pk(nk, na))

         k = k_emu
         Pk(:, ia) = Pk_emu

      END DO

   END SUBROUTINE get_emulator_power

   SUBROUTINE rebin_emulator(kmin, kmax, nk, k, Pk)

      REAL, INTENT(IN) :: kmin
      REAL, INTENT(IN) :: kmax
      INTEGER, INTENT(IN) :: nk
      REAL, ALLOCATABLE, INTENT(INOUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(INOUT) :: Pk(:)
      INTEGER, PARAMETER :: iorder = iorder_rebin
      INTEGER, PARAMETER :: ifind = ifind_rebin
      INTEGER, PARAMETER :: iinterp = iinterp_rebin

      CALL rebin_array(kmin, kmax, nk, k, Pk, &
         iorder_rebin, &
         ifind_rebin, &
         iinterp_rebin, &
         logx=.TRUE., &
         logf=.TRUE. &
         )

   END SUBROUTINE rebin_emulator

   SUBROUTINE get_CosmicEmu_power_z(k, P, n, z, cosm, rebin, verbose)
    
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: P(:)
      INTEGER, INTENT(OUT) :: n
      REAL, INTENT(IN) :: z
      TYPE(cosmology), INTENT(IN) :: cosm
      LOGICAL, OPTIONAL, INTENT(IN) :: rebin
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      INTEGER :: i
      CHARACTER(len=256) :: crap
      REAL :: h
      INTEGER, PARAMETER :: nh = nh_CosmicEmu ! Length of header
      INTEGER, PARAMETER :: hl = hl_CosmicEmu ! Line that h in on
      CHARACTER(len=256), PARAMETER :: params = params_CosmicEmu
      CHARACTER(len=256), PARAMETER :: output = output_CosmicEmu
      CHARACTER(len=256), PARAMETER :: exe = exe_CosmicEmu
      REAL, PARAMETER :: eps_h = eps_h_CosmicEmu
      REAL, PARAMETER :: kmin_rebin = kmin_rebin_CosmicEmu
      REAL, PARAMETER :: kmax_rebin = kmax_rebin_CosmicEmu   
      INTEGER, PARAMETER :: nk_rebin = nk_rebin_CosmicEmu

      ! Remove previous parameter and power file
      CALL EXECUTE_COMMAND_LINE('rm -rf '//trim(params))
      CALL EXECUTE_COMMAND_LINE('rm -rf '//trim(output))

      ! Write a new parameter file
      OPEN (7, file=params)
      WRITE (7, fmt='(A20,7F10.5)') trim(output), cosm%om_m*cosm%h**2, cosm%om_b*cosm%h**2, cosm%ns, cosm%sig8, cosm%w, z
      CLOSE (7)

      IF (present_and_correct(verbose)) THEN
         CALL EXECUTE_COMMAND_LINE(trim(exe)//' '//trim(params))
      ELSE
         CALL EXECUTE_COMMAND_LINE(trim(exe)//' '//trim(params)//' > /dev/null')
      END IF

      ! Get length of emu file
      n = file_length(output)
      n = n-nh
      IF (ALLOCATED(k)) DEALLOCATE (k)
      IF (ALLOCATED(P)) DEALLOCATE (P)
      ALLOCATE (k(n), P(n))

      ! Write useful things to screen
      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'GET_COSMICEMU_POWER_Z: z:', z
         WRITE (*, *) 'GET_COSMICEMU_POWER_Z: P(k) file length:', n
         WRITE (*, *) 'GET_COSMICEMU_POWER_Z: Reading in P(k): ', trim(output)
      END IF

      ! Read in data file
      OPEN (7, file=output)
      DO i = 1-nh, n
         IF (i == hl-nh) THEN
            READ (7, *) crap, crap, crap, crap, crap, crap, crap, crap, h
            IF (present_and_correct(verbose)) THEN
               WRITE (*, *) 'GET_COSMICEMU_POWER_Z: CMB derived h:', h
               WRITE (*, *) 'GET_COSMICEMU_POWER_Z: Cosmology h:', cosm%h
               WRITE (*, *) 'GET_COSMICEMU_POWER_Z: h ratio:', cosm%h/h
            END IF
            IF (.NOT. requal(h, cosm%h, eps_h)) STOP 'GET_COSMIC_EMU_POWER_Z: Error, h values differ'
         ELSE IF (i < 1) THEN
            READ (7, *)
         ELSE
            READ (7, *) k(i), P(i)
         END IF
      END DO
      CLOSE (7)

      ! Convert k to k/h
      k = k/cosm%h

      IF (present_and_correct(rebin)) THEN
         IF (present_and_correct(verbose)) THEN
            WRITE (*, *) 'GET_COSMICEMU_POWER_Z: Rebinning power'
         END IF
         CALL rebin_emulator(kmin_rebin, kmax_rebin, nk_rebin, k, P)
         n = nk_rebin
      END IF

      ! Done
      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'GET_COSMICEMU_POWER_Z: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE get_CosmicEmu_power_z

   SUBROUTINE get_FrankenEmu_power_z(k, P, n, z, cosm, rebin, verbose)

      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: P(:)
      INTEGER, INTENT(OUT) :: n
      REAL, INTENT(IN) :: z
      TYPE(cosmology), INTENT(IN) :: cosm
      LOGICAL, OPTIONAL, INTENT(IN) :: rebin
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      INTEGER :: i
      INTEGER, PARAMETER :: nh = 5 ! Length of header
      CHARACTER(len=256), PARAMETER :: params = params_FrankenEmu
      CHARACTER(len=256), PARAMETER :: output = output_FrankenEmu
      CHARACTER(len=256), PARAMETER :: exe = exe_FrankenEmu
      REAL, PARAMETER :: kmin_rebin = kmin_rebin_FrankenEmu
      REAL, PARAMETER :: kmax_rebin = kmax_rebin_FrankenEmu
      INTEGER, PARAMETER :: nk_rebin = nk_rebin_FrankenEmu

      ! Remove previous parameter and power file
      CALL EXECUTE_COMMAND_LINE('rm -rf '//trim(params))
      CALL EXECUTE_COMMAND_LINE('rm -rf '//trim(output))

      ! Write a new parameter file
      OPEN (7, file=params)
      WRITE (7, fmt='(A20,7F10.5)') trim(output), cosm%om_m*cosm%h**2, cosm%om_b*cosm%h**2, cosm%ns, -cosm%w, cosm%sig8, cosm%h, z
      CLOSE (7)

      IF (present_and_correct(verbose)) THEN
         CALL EXECUTE_COMMAND_LINE(trim(exe)//' '//trim(params))
      ELSE
         CALL EXECUTE_COMMAND_LINE(trim(exe)//' '//trim(params)//' > /dev/null')
      END IF

      ! Get length of emu file
      n = file_length(output)
      n = n-nh
      IF (ALLOCATED(k)) DEALLOCATE (k)
      IF (ALLOCATED(P)) DEALLOCATE (P)
      ALLOCATE (k(n), P(n))

      ! Write useful things to screen
      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'GET_FRANKENEMU_POWER_Z: z:', z
         WRITE (*, *) 'GET_FRANKENEMU_POWER_Z: P(k) file length:', n
         WRITE (*, *) 'GET_FRANKENEMU_POWER_Z: Reading in P(k): ', trim(output)
      END IF

      ! Read in data file
      OPEN (7, file=output)
      DO i = 1-nh, n
         IF (i < 1) THEN
            READ (7, *)
         ELSE
            READ (7, *) k(i), P(i)
         END IF
      END DO
      CLOSE (7)

      ! Convert k to k/h
      k = k/cosm%h

      IF (present_and_correct(rebin)) THEN
         IF (present_and_correct(verbose)) THEN
            WRITE (*, *) 'GET_COSMICEMU_POWER_Z: Rebinning power'
         END IF
         CALL rebin_emulator(kmin_rebin, kmax_rebin, nk_rebin, k, P)
         n = nk_rebin
      END IF

      ! Done
      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'GET_FRANKENEMU_POWER_Z: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE get_FrankenEmu_power_z

   SUBROUTINE get_MiraTitan_power_z(k, P, n, z, cosm, rebin, verbose)

      USE constants
      REAL, ALLOCATABLE, INTENT(OUT) :: k(:)
      REAL, ALLOCATABLE, INTENT(OUT) :: P(:)
      INTEGER, INTENT(OUT) :: n
      REAL, INTENT(IN) :: z
      TYPE(cosmology), INTENT(IN) :: cosm
      LOGICAL, OPTIONAL, INTENT(IN) :: rebin
      LOGICAL, OPTIONAL, INTENT(IN) :: verbose
      INTEGER :: i
      REAL, PARAMETER :: kmin_rebin = kmin_rebin_MiraTitan
      REAL, PARAMETER :: kmax_rebin = kmax_rebin_MiraTitan
      INTEGER, PARAMETER :: nk_rebin = nk_rebin_MiraTitan
      CHARACTER(len=256), PARAMETER :: params = params_MiraTitan
      CHARACTER(len=256), PARAMETER :: output = output_MiraTitan
      CHARACTER(len=256), PARAMETER :: exe = exe_MiraTitan

      ! Remove previous parameter and power file
      CALL EXECUTE_COMMAND_LINE('rm -rf '//trim(params))
      CALL EXECUTE_COMMAND_LINE('rm -rf '//trim(output))

      OPEN (7, file=params)
      WRITE (7, *) (cosm%Om_m*cosm%h**2), (cosm%Om_b*cosm%h**2), cosm%sig8, &
         cosm%h, cosm%ns, cosm%w, cosm%wa, (cosm%om_nu*cosm%h**2), z
      CLOSE (7)

      IF (present_and_correct(verbose)) THEN
         CALL EXECUTE_COMMAND_LINE(trim(exe)//' '//trim(params))
      ELSE
         CALL EXECUTE_COMMAND_LINE(trim(exe)//' '//trim(params)//' > /dev/null')
      END IF

      n = file_length(output)
      IF (ALLOCATED(k)) DEALLOCATE (k)
      IF (ALLOCATED(P)) DEALLOCATE (P)
      ALLOCATE (k(n), P(n))

      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'GET_MIRATITAN_POWER_Z: z:', z
         WRITE (*, *) 'GET_MIRATITAN_POWER_Z: P(k) file length:', n
         WRITE (*, *) 'GET_MIRATITAN_POWER_Z: Reading in P(k)'
      END IF

      OPEN (7, file=output)
      DO i = 1, n
         READ (7, *) k(i), P(i)
      END DO
      CLOSE (7)

      ! Convert P(k) to Delta^2(k)
      P = Delta_Pk(P, k)

      ! Convert k to k/h
      k = k/cosm%h

      IF (present_and_correct(rebin)) THEN
         IF (present_and_correct(verbose)) THEN
            WRITE (*, *) 'GET_COSMICEMU_POWER_Z: Rebinning power'
         END IF
         CALL rebin_emulator(kmin_rebin, kmax_rebin, nk_rebin, k, P)
         n = nk_rebin
      END IF

      IF (present_and_correct(verbose)) THEN
         WRITE (*, *) 'GET_MIRATITAN_POWER_Z: Done'
         WRITE (*, *)
      END IF

   END SUBROUTINE get_MiraTitan_power_z

END MODULE cosmic_emu_stuff

MODULE interpolate

   ! TODO: Combine the integer finding that is carried out separately in 'find' and 'evaluate_interpolator'
   ! TODO: Combine the interpolation that is carried out separatly in 'find' and 'evaluate_interpolator'
   ! TODO: Functions to return min/max x, y, ... values from interpolators

   USE basic_operations
   USE array_operations
   USE table_integer
   USE special_functions

   IMPLICIT NONE

   PRIVATE

   ! Functions
   PUBLIC :: find
   PUBLIC :: interpolate_array
   PUBLIC :: rebin_array
   PUBLIC :: init_interpolator
   PUBLIC :: evaluate_interpolator
   PUBLIC :: inverse_interpolator

   ! Switches for interpolation polynomials
   PUBLIC :: iinterp_polynomial
   PUBLIC :: iinterp_Lagrange
   PUBLIC :: iinterp_centred

   ! Switches for extrapolation
   PUBLIC :: iextrap_no
   PUBLIC :: iextrap_std
   PUBLIC :: iextrap_lin
   PUBLIC :: iextrap_zero
   PUBLIC :: iextrap_near

   ! Types
   PUBLIC :: interpolator1D
   PUBLIC :: interpolator2D
   PUBLIC :: interpolator3D

   ! Interpolation methods
   INTEGER, PARAMETER :: iinterp_polynomial = 1
   INTEGER, PARAMETER :: iinterp_Lagrange = 2
   INTEGER, PARAMETER :: iinterp_centred = 3

   ! Extrapolation methods
   INTEGER, PARAMETER :: iextrap_no = 0
   INTEGER, PARAMETER :: iextrap_std = 1
   INTEGER, PARAMETER :: iextrap_lin = 2
   INTEGER, PARAMETER :: iextrap_zero = 3
   INTEGER, PARAMETER :: iextrap_near = 4

   ! Default schemes
   INTEGER, PARAMETER :: ifind_interpolator_default = ifind_split
   INTEGER, PARAMETER :: ifind_inverse_interpolator = ifind_split
   INTEGER, PARAMETER :: iinterp_inverse_interpolator = iinterp_Lagrange

   INTERFACE find
      MODULE PROCEDURE find_1D
      MODULE PROCEDURE find_2D
      MODULE PROCEDURE find_3D
   END INTERFACE find

   INTERFACE init_interpolator
      MODULE PROCEDURE init_interpolator_1D
      MODULE PROCEDURE init_interpolator_2D
      MODULE PROCEDURE init_interpolator_3D
   END INTERFACE init_interpolator

   INTERFACE evaluate_interpolator
      MODULE PROCEDURE evaluate_interpolator_1D
      MODULE PROCEDURE evaluate_interpolator_2D
      MODULE PROCEDURE evaluate_interpolator_3D
   END INTERFACE evaluate_interpolator

   INTERFACE inverse_interpolator
      MODULE PROCEDURE inverse_interpolator_1D
   END INTERFACE inverse_interpolator

   TYPE interpolator1D
      REAL, ALLOCATABLE :: x(:), x0(:)
      REAL, ALLOCATABLE :: f(:)
      REAL, ALLOCATABLE :: a0(:), a1(:), a2(:), a3(:)
      REAL :: xmin, xmax
      INTEGER :: iorder, iextrap
      INTEGER :: ifind
      INTEGER :: n
      LOGICAL :: logx, logf
      LOGICAL :: store
   END TYPE interpolator1D

   TYPE interpolator2D
      REAL, ALLOCATABLE :: x(:), y(:)
      REAL, ALLOCATABLE :: f(:, :)
      REAL, ALLOCATABLE :: x0(:, :), y0(:, :), xl0(:, :), yl0(:, :)
      REAL, ALLOCATABLE :: ax0(:, :), ax1(:, :), ax2(:, :), ax3(:, :)
      REAL, ALLOCATABLE :: ay0(:, :), ay1(:, :), ay2(:, :), ay3(:, :)
      REAL, ALLOCATABLE :: bx0(:, :), bx1(:, :), by0(:, :), by1(:, :)
      REAL :: xmin, xmax, ymin, ymax
      INTEGER :: iorder, iextrap
      INTEGER :: ifindx, ifindy 
      INTEGER :: nx, ny
      LOGICAL :: logx, logy, logf
      LOGICAL :: store
      TYPE(interpolator1D) :: interp1D
   END TYPE interpolator2D

   TYPE interpolator3D
      REAL, ALLOCATABLE :: x(:), y(:), z(:)
      REAL, ALLOCATABLE :: f(:, :, :)
      !REAL, ALLOCATABLE :: x0(:, :), y0(:, :), xl0(:, :), yl0(:, :)
      !REAL, ALLOCATABLE :: ax0(:, :), ax1(:, :), ax2(:, :), ax3(:, :)
      !REAL, ALLOCATABLE :: ay0(:, :), ay1(:, :), ay2(:, :), ay3(:, :)
      !REAL, ALLOCATABLE :: bx0(:, :), bx1(:, :), by0(:, :), by1(:, :)
      REAL :: xmin, xmax, ymin, ymax, zmin, zmax
      INTEGER :: iorder, iextrap
      INTEGER :: ifindx, ifindy, ifindz
      INTEGER :: nx, ny, nz
      LOGICAL :: logx, logy, logz, logf
      LOGICAL :: store
   END TYPE interpolator3D

CONTAINS

   REAL FUNCTION find_1D(x, xin, yin, n, iorder, ifind, iinterp)

      ! Given two arrays x and y this routine interpolates to find the y_i value at position x_i
      ! Care should be chosen to insert x, xtab, ytab as log if this might give beter results
      ! Extrapolates if the value is off either end of the array   
      ! If the value required is off the table edge the extrapolation is always linear
      REAL, INTENT(IN) :: x
      INTEGER, INTENT(IN) :: n
      REAL, INTENT(IN) :: xin(n)
      REAL, INTENT(IN) :: yin(n)
      INTEGER, INTENT(IN) :: iorder
      INTEGER, INTENT(IN) :: ifind
      INTEGER, INTENT(IN) :: iinterp
      REAL ::  xtab(n), ytab(n)
      REAL :: a0, a1, a2, a3
      REAL :: x1, x2, x3, x4
      REAL :: y1, y2, y3, y4
      REAL :: L1, L2
      REAL :: dx, x0
      INTEGER :: i

      ! iorder = 0 => constant interpolation (histogram data)
      ! iorder = 1 => linear interpolation
      ! iorder = 2 => quadratic interpolation
      ! iorder = 3 => cubic interpolation

      ! ifind = 1 => find x in xtab quickly assuming the table is linearly spaced
      ! ifind = 2 => find x in xtab by crudely searching from x(1) to x(n)
      ! ifind = 3 => find x in xtab using midpoint splitting (iterations=ceiling(log2(n)))

      ! iinterp = 1 => Uses standard polynomials for interpolation
      ! iinterp = 2 => Uses Lagrange polynomials for interpolation
      ! iinterp = 3 => Uses centred polynomials for interpolation

      xtab = xin
      ytab = yin

      ! Reverse the arrays in this case
      IF (xtab(1) > xtab(n)) THEN       
         CALL reverse_array(xtab)
         CALL reverse_array(ytab)
      END IF

      IF(iorder == 0) THEN

         dx = xtab(2)-xtab(1) ! Assumes bins are equally spaced
         xtab = xtab - dx/2.  ! Assumes that x coordinates give left edge of histogram
         
         IF(x < xtab(1)) THEN
            ! Outside lower boundary
            find_1D = 0.
         ELSE IF(x >= xtab(n)+dx) THEN
            ! Outside upper boundary
            find_1D = 0.
         ELSE
            i = find_table_integer(x, xtab, ifind)
            find_1D = ytab(i)
         END IF

      ELSE

         IF (x < xtab(1)) THEN

            ! Do a linear extrapolation beyond the table boundary

            x1 = xtab(1)
            x2 = xtab(2)

            y1 = ytab(1)
            y2 = ytab(2)

            IF (iinterp == iinterp_polynomial) THEN
               CALL fix_polynomial(a1, a0, [x1, x2], [y1, y2])        
               find_1D = polynomial(x, a1, a0)
            ELSE IF (iinterp == iinterp_Lagrange) THEN
               find_1D = Lagrange_polynomial(x, [x1, x2], [y1, y2])
            ELSE
               STOP 'FIND_1D: Error, method not specified correctly'
            END IF

         ELSE IF (x > xtab(n)) THEN

            ! Do a linear extrapolation beyond the table boundary

            x1 = xtab(n-1)
            x2 = xtab(n)

            y1 = ytab(n-1)
            y2 = ytab(n)

            IF (iinterp == iinterp_polynomial) THEN
               CALL fix_polynomial(a1, a0, [x1, x2], [y1, y2])
               find_1D = polynomial(x, a1, a0)
            ELSE IF (iinterp == iinterp_centred) THEN
               x0 = (x1+x2)/2.
               CALL fix_centred_polynomial(a1, a0, x0, [x1, x2], [y1, y2])
               find_1D = centred_polynomial(x, x0, a1, a0)
            ELSE IF (iinterp == iinterp_Lagrange) THEN
               find_1D = Lagrange_polynomial(x, [x1, x2], [y1, y2])
            ELSE
               STOP 'FIND_1D: Error, method not specified correctly'
            END IF

         ELSE IF (iorder == 1) THEN

            IF (n < 2) STOP 'FIND_1D: Not enough points in your table for linear interpolation'

            IF (x <= xtab(2)) THEN

               x1 = xtab(1)
               x2 = xtab(2)

               y1 = ytab(1)
               y2 = ytab(2)

            ELSE IF (x >= xtab(n-1)) THEN

               x1 = xtab(n-1)
               x2 = xtab(n)

               y1 = ytab(n-1)
               y2 = ytab(n)

            ELSE

               i = find_table_integer(x, xtab, ifind)

               x1 = xtab(i)
               x2 = xtab(i+1)

               y1 = ytab(i)
               y2 = ytab(i+1)

            END IF

            IF (iinterp == iinterp_polynomial) THEN
               CALL fix_polynomial(a1, a0, [x1, x2], [y1, y2])  
               find_1D = polynomial(x, a1, a0)
            ELSE IF (iinterp == iinterp_centred) THEN
               x0 = (x1+x2)/2.
               CALL fix_centred_polynomial(a1, a0, x0, [x1, x2], [y1, y2])
               find_1D = centred_polynomial(x, x0, a1, a0)
            ELSE IF (iinterp == iinterp_Lagrange) THEN
               find_1D = Lagrange_polynomial(x, [x1, x2], [y1, y2])
            ELSE
               STOP 'FIND_1D: Error, method not specified correctly'
            END IF

         ELSE IF (iorder == 2) THEN

            IF (n < 3) STOP 'FIND_1D: Not enough points in your table'

            IF (x <= xtab(2) .OR. x >= xtab(n-1)) THEN

               IF (x <= xtab(2)) THEN

                  x1 = xtab(1)
                  x2 = xtab(2)
                  x3 = xtab(3)

                  y1 = ytab(1)
                  y2 = ytab(2)
                  y3 = ytab(3)

               ELSE IF (x >= xtab(n-1)) THEN

                  x1 = xtab(n-2)
                  x2 = xtab(n-1)
                  x3 = xtab(n)

                  y1 = ytab(n-2)
                  y2 = ytab(n-1)
                  y3 = ytab(n)

               ELSE

                  STOP 'FIND_1D: Error, something went wrong'

               END IF

               IF (iinterp == iinterp_polynomial) THEN
                  CALL fix_polynomial(a2, a1, a0, [x1, x2, x3], [y1, y2, y3])
                  find_1D = polynomial(x, a2, a1, a0)
               ELSE IF (iinterp == iinterp_centred) THEN
                  x0 = (x1+x2+x3)/3.
                  CALL fix_centred_polynomial(a2, a1, a0, x0, [x1, x2, x3], [y1, y2, y3])
                  find_1D = centred_polynomial(x, x0, a2, a1, a0)
               ELSE IF (iinterp == iinterp_Lagrange) THEN
                  find_1D = Lagrange_polynomial(x, [x1, x2, x3], [y1, y2, y3])
               ELSE
                  STOP 'FIND_1D: Error, method not specified correctly'
               END IF

            ELSE

               i = find_table_integer(x, xtab, ifind)

               x1 = xtab(i-1)
               x2 = xtab(i)
               x3 = xtab(i+1)
               x4 = xtab(i+2)

               y1 = ytab(i-1)
               y2 = ytab(i)
               y3 = ytab(i+1)
               y4 = ytab(i+2)

               IF (iinterp == iinterp_polynomial) THEN
                  ! In this case take the average of two separate quadratic spline values
                  find_1D = 0.
                  CALL fix_polynomial(a2, a1, a0, [x1, x2, x3], [y1, y2, y3])     
                  find_1D = find_1D+polynomial(x, a2, a1, a0)/2.
                  CALL fix_polynomial(a2, a1, a0, [x2, x3, x4], [y2, y3, y4])
                  find_1D = find_1D+polynomial(x, a2, a1, a0)/2.
               ELSE IF (iinterp == iinterp_centred) THEN
                  ! In this case take the average of two separate quadratic spline values
                  find_1D = 0.
                  x0 = (x1+x2+x3)/3.
                  CALL fix_centred_polynomial(a2, a1, a0, x0, [x1, x2, x3], [y1, y2, y3])     
                  find_1D = find_1D+centred_polynomial(x, x0, a2, a1, a0)/2.
                  x0 = (x2+x3+x4)/3.
                  CALL fix_centred_polynomial(a2, a1, a0, x0, [x2, x3, x4], [y2, y3, y4])
                  find_1D = find_1D+centred_polynomial(x, x0, a2, a1, a0)/2.
               ELSE IF (iinterp == iinterp_Lagrange) THEN
                  ! In this case take the average of two quadratic Lagrange polynomials
                  L1 = Lagrange_polynomial(x, [x1, x2, x3], [y1, y2, y3])
                  L2 = Lagrange_polynomial(x, [x2, x3, x4], [y2, y3, y4])
                  find_1D = (L1+L2)/2.
               ELSE
                  STOP 'FIND_1D: Error, method not specified correctly'
               END IF

            END IF

         ELSE IF (iorder == 3) THEN

            IF (n < 4) STOP 'FIND_1D: Not enough points in your table'

            IF (x <= xtab(3)) THEN

               x1 = xtab(1)
               x2 = xtab(2)
               x3 = xtab(3)
               x4 = xtab(4)

               y1 = ytab(1)
               y2 = ytab(2)
               y3 = ytab(3)
               y4 = ytab(4)

            ELSE IF (x >= xtab(n-2)) THEN

               x1 = xtab(n-3)
               x2 = xtab(n-2)
               x3 = xtab(n-1)
               x4 = xtab(n)

               y1 = ytab(n-3)
               y2 = ytab(n-2)
               y3 = ytab(n-1)
               y4 = ytab(n)

            ELSE

               i = find_table_integer(x, xtab, ifind)

               x1 = xtab(i-1)
               x2 = xtab(i)
               x3 = xtab(i+1)
               x4 = xtab(i+2)

               y1 = ytab(i-1)
               y2 = ytab(i)
               y3 = ytab(i+1)
               y4 = ytab(i+2)

            END IF

            IF (iinterp == iinterp_polynomial) THEN
               CALL fix_polynomial(a3, a2, a1, a0, [x1, x2, x3, x4], [y1, y2, y3, y4])
               find_1D = polynomial(x, a3, a2, a1, a0)
            ELSE IF (iinterp == iinterp_centred) THEN
               x0 = (x1+x2+x3+x4)/4.
               CALL fix_centred_polynomial(a3, a2, a1, a0, x0, [x1, x2, x3, x4], [y1, y2, y3, y4])
               find_1D = centred_polynomial(x, x0, a3, a2, a1, a0)
            ELSE IF (iinterp == iinterp_Lagrange) THEN
               find_1D = Lagrange_polynomial(x, [x1, x2, x3, x4], [y1, y2, y3, y4])
            ELSE
               STOP 'FIND_1D: Error, method not specified correctly'
            END IF

         ELSE

            STOP 'FIND_1D: Error, interpolation order specified incorrectly'

         END IF

      END IF

   END FUNCTION find_1D

   REAL FUNCTION find_2D(x, xin, y, yin, fin, nx, ny, iorder, ifindx, ifindy, iinterp)

      ! A 2D interpolation routine to find value f(x,y) at position x, y
      ! Care should be chosen to insert x, xtab, ytab as log if this might give better results
      ! Extrapolates if the value is off either end of the array
      ! If the value required is off the table edge the extrapolation is always linear
      ! TODO: Loops over coordinates to avoid repetition?
      INTEGER, INTENT(IN) :: nx
      INTEGER, INTENT(IN) :: ny
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xin(nx)
      REAL, INTENT(IN) :: y
      REAL, INTENT(IN) :: yin(ny)
      REAL, INTENT(IN) :: fin(nx, ny)
      INTEGER, INTENT(IN) :: iorder
      INTEGER, INTENT(IN) :: ifindx
      INTEGER, INTENT(IN) :: ifindy
      INTEGER, INTENT(IN) :: iinterp
      REAL ::  xtab(nx), ytab(ny), ftab(nx, ny)
      REAL :: a3, a2, a1, a0
      REAL :: x1, x2, x3, x4
      REAL :: y1, y2, y3, y4
      REAL :: f11, f12, f13, f14
      REAL :: f21, f22, f23, f24
      REAL :: f31, f32, f33, f34
      REAL :: f41, f42, f43, f44
      REAL :: f10, f20, f30, f40
      REAL :: f01, f02, f03, f04
      INTEGER :: i1, i2, i3, i4
      INTEGER :: j1, j2, j3, j4
      REAL :: findx, findy, V(2,2)
      INTEGER :: i, j, ix, iy, ix1, ix2, iy1, iy2
      LOGICAL, PARAMETER :: xycubic = .FALSE.

      ! iorder = 1 => linear interpolation
      ! iorder = 2 => quadratic interpolation
      ! iorder = 3 => cubic interpolation

      ! ifind = 1 => find x in xtab by crudely searching from x(1) to x(n)
      ! ifind = 2 => find x in xtab quickly assuming the table is linearly spaced
      ! ifind = 3 => find x in xtab using midpoint splitting (iterations=ceiling(log2(n)))

      ! iinterp = 1 => Uses cubic polynomials for interpolation
      ! iinterp = 2 => Uses Lagrange polynomials for interpolation
      IF (iinterp == iinterp_Lagrange) STOP 'FIND_2D: No Lagrange polynomials for you'

      xtab = xin
      ytab = yin
      ftab = fin

      !IF (xtab(1) > xtab(nx)) STOP 'FIND_2D: x array in wrong order'
      IF (xtab(1) > xtab(nx)) THEN
         CALL reverse_array(xtab)
         CALL reverse_array(ftab, 1)
      END IF

      !IF (ytab(1) > ytab(ny)) STOP 'FIND_2D: y array in wrong order'
      IF (ytab(1) > ytab(ny)) THEN
         CALL reverse_array(ytab)
         CALL reverse_array(ftab, 2)
      END IF

      IF(iorder == 0) THEN

         ix = find_table_integer(x, xtab, ifindx)
         IF(ix == 0) ix = 1
         iy = find_table_integer(y, ytab, ifindy)
         IF(iy == 0) iy = 1

         find_2D = fin(ix, iy)

      ELSE IF(iorder == 1) THEN

         IF (nx < 2) STOP 'FIND_2D: Not enough x points in your array for linear interpolation'
         IF (ny < 2) STOP 'FIND_2D: Not enough y points in your array for linear interpolation'

         !! Get the x,y values !!

         ! Get the integer coordinates in the x direction
         ix = find_table_integer(x, xtab, ifindx)
         IF(ix==0) THEN
            ix=1
         ELSE IF(ix==nx) THEN
            ix=nx-1
         END IF
         ix1 = ix
         ix2 = ix+1

         ! Get the x values at the corners
         x1 = xtab(ix1)
         x2 = xtab(ix2)

         ! Get the integer coordinates in the y direction
         iy = find_table_integer(y, ytab, ifindy)
         IF(iy==0) THEN
            iy=1
         ELSE IF(iy==ny) THEN
            iy=ny-1
         END IF
         iy1 = iy
         iy2 = iy+1

         ! Get the y values at the corners
         y1 = ytab(iy1)
         y2 = ytab(iy2)

         ! Interpolation is function values at corners weighted by opposite area
         ! TODO: Clever loop here? Maybe not, its nice and transparent without the loop
         V(1, 1) = (x2-x)*(y2-y)*ftab(ix1, iy1)
         V(1, 2) = (x2-x)*(y-y1)*ftab(ix1, iy2)
         V(2, 1) = (x-x1)*(y2-y)*ftab(ix2, iy1)
         V(2, 2) = (x-x1)*(y-y1)*ftab(ix2, iy2)

         ! Normalisation
         find_2D = sum(V)/((x2-x1)*(y2-y1))

      ELSE IF (iorder == 3) THEN

         ! No cubic extrapolation implemented if the desired point is outside x AND y array boundary corners
         IF ((x < xtab(1) .OR. x > xtab(nx)) .AND. (y > ytab(ny) .OR. y < ytab(1))) THEN
            WRITE (*, *) 'FIND_2D: array xmin:', xtab(1)
            WRITE (*, *) 'FIND_2D: array xmax:', xtab(nx)
            WRITE (*, *) 'FIND_2D: requested x:', x
            WRITE (*, *) 'FIND_2D: array ymin:', ytab(1)
            WRITE (*, *) 'FIND_2D: array ymax:', ytab(ny)
            WRITE (*, *) 'FIND_2D: requested y:', y
            STOP 'FIND_2D: Desired point is outside both x and y array range'
         END IF

         IF (x < xtab(1) .OR. x > xtab(nx)) THEN

            IF (nx < 2) STOP 'FIND_2D: Not enough x points in your array for linear interpolation'
            IF (ny < 4) STOP 'FIND_2D: Not enough y points in your array for cubic interpolation'

            ! x is off the table edge

            IF (x < xtab(1)) THEN
               i1 = 1
               i2 = 2
            ELSE
               i1 = nx-1
               i2 = nx
            END IF

            x1 = xtab(i1)
            x2 = xtab(i2)

            IF (y <= ytab(4)) THEN
               j = 2
            ELSE IF (y >= ytab(ny-3)) THEN
               j = ny-2
            ELSE
               j = find_table_integer(y, ytab, ifindy)
            END IF

            j1 = j-1
            j2 = j
            j3 = j+1
            j4 = j+2

            y1 = ytab(j1)
            y2 = ytab(j2)
            y3 = ytab(j3)
            y4 = ytab(j4)

            f11 = ftab(i1, j1)
            f12 = ftab(i1, j2)
            f13 = ftab(i1, j3)
            f14 = ftab(i1, j4)

            f21 = ftab(i2, j1)
            f22 = ftab(i2, j2)
            f23 = ftab(i2, j3)
            f24 = ftab(i2, j4)

            !! y interpolation

            CALL fix_polynomial(a3, a2, a1, a0, [y1, y2, y3, y4], [f11, f12, f13, f14])
            f10 = polynomial(y, a3, a2, a1, a0)

            CALL fix_polynomial(a3, a2, a1, a0, [y1, y2, y3, y4], [f21, f22, f23, f24])      
            f20 = polynomial(y, a3, a2, a1, a0)

            !!

            !! x interpolation

            CALL fix_polynomial(a1, a0, [x1, x2], [f10, f20])
            find_2D = polynomial(x, a1, a0)

            !!

         ELSE IF (y < ytab(1) .OR. y > ytab(ny)) THEN

            ! y is off the table edge

            IF (nx < 4) STOP 'FIND_2D: Not enough x points in your array for cubic interpolation'
            IF (ny < 2) STOP 'FIND_2D: Not enough y points in your array for linear interpolation'

            IF (x <= xtab(4)) THEN
               i = 2
            ELSE IF (x >= xtab(nx-3)) THEN
               i = nx-2
            ELSE
               i = find_table_integer(x, xtab, ifindx)
            END IF

            i1 = i-1
            i2 = i
            i3 = i+1
            i4 = i+2

            x1 = xtab(i1)
            x2 = xtab(i2)
            x3 = xtab(i3)
            x4 = xtab(i4)

            IF (y < ytab(1)) THEN
               j1 = 1
               j2 = 2
            ELSE
               j1 = ny-1
               j2 = ny
            END IF

            y1 = ytab(j1)
            y2 = ytab(j2)

            f11 = ftab(i1, j1)
            f21 = ftab(i2, j1)
            f31 = ftab(i3, j1)
            f41 = ftab(i4, j1)

            f12 = ftab(i1, j2)
            f22 = ftab(i2, j2)
            f32 = ftab(i3, j2)
            f42 = ftab(i4, j2)

            ! x interpolation

            CALL fix_polynomial(a3, a2, a1, a0, [x1, x2, x3, x4], [f11, f21, f31, f41])
            f01 = polynomial(x, a3, a2, a1, a0)

            CALL fix_polynomial(a3, a2, a1, a0, [x1, x2, x3, x4], [f12, f22, f32, f42])     
            f02 = polynomial(x, a3, a2, a1, a0)

            ! y interpolation

            CALL fix_polynomial(a1, a0, [y1, y2], [f01, f02])
            find_2D = polynomial(y, a1, a0)

         ELSE

            ! Points exists within table boundardies (normal)

            IF (nx < 4) STOP 'FIND_2D: Not enough x points in your array for cubic interpolation'
            IF (ny < 4) STOP 'FIND_2D: Not enough y points in your array for cubic interpolation'

            IF (x <= xtab(4)) THEN
               i = 2
            ELSE IF (x >= xtab(nx-3)) THEN
               i = nx-2
            ELSE
               i = find_table_integer(x, xtab, ifindx)
            END IF

            i1 = i-1
            i2 = i
            i3 = i+1
            i4 = i+2

            x1 = xtab(i1)
            x2 = xtab(i2)
            x3 = xtab(i3)
            x4 = xtab(i4)

            IF (y <= ytab(4)) THEN
               j = 2
            ELSE IF (y >= ytab(ny-3)) THEN
               j = ny-2
            ELSE
               j = find_table_integer(y, ytab, ifindy)
            END IF

            j1 = j-1
            j2 = j
            j3 = j+1
            j4 = j+2

            y1 = ytab(j1)
            y2 = ytab(j2)
            y3 = ytab(j3)
            y4 = ytab(j4)

            !

            f11 = ftab(i1, j1)
            f12 = ftab(i1, j2)
            f13 = ftab(i1, j3)
            f14 = ftab(i1, j4)

            f21 = ftab(i2, j1)
            f22 = ftab(i2, j2)
            f23 = ftab(i2, j3)
            f24 = ftab(i2, j4)

            f31 = ftab(i3, j1)
            f32 = ftab(i3, j2)
            f33 = ftab(i3, j3)
            f34 = ftab(i3, j4)

            f41 = ftab(i4, j1)
            f42 = ftab(i4, j2)
            f43 = ftab(i4, j3)
            f44 = ftab(i4, j4)

            ! x interpolation

            CALL fix_polynomial(a3, a2, a1, a0, [x1, x2, x3, x4], [f11, f21, f31, f41])
            f01 = polynomial(x, a3, a2, a1, a0)

            CALL fix_polynomial(a3, a2, a1, a0, [x1, x2, x3, x4], [f12, f22, f32, f42]) 
            f02 = polynomial(x, a3, a2, a1, a0)

            CALL fix_polynomial(a3, a2, a1, a0, [x1, x2, x3, x4], [f13, f23, f33, f43])        
            f03 = polynomial(x, a3, a2, a1, a0)

            CALL fix_polynomial(a3, a2, a1, a0, [x1, x2, x3, x4], [f14, f24, f34, f44])
            f04 = polynomial(x, a3, a2, a1, a0)
            
            CALL fix_polynomial(a3, a2, a1, a0, [y1, y2, y3, y4], [f01, f02, f03, f04])
            findy = polynomial(y, a3, a2, a1, a0)

            IF(xycubic) THEN
            
               ! y interpolation

               CALL fix_polynomial(a3, a2, a1, a0, [y1, y2, y3, y4], [f11, f12, f13, f14])
               f10 = polynomial(y, a3, a2, a1, a0)

               CALL fix_polynomial(a3, a2, a1, a0, [y1, y2, y3, y4], [f21, f22, f23, f24])
               f20 = polynomial(y, a3, a2, a1, a0)

               CALL fix_polynomial(a3, a2, a1, a0, [y1, y2, y3, y4], [f31, f32, f33, f34])
               f30 = polynomial(y, a3, a2, a1, a0)

               CALL fix_polynomial(a3, a2, a1, a0, [y1, y2, y3, y4], [f41, f42, f43, f44])
               f40 = polynomial(y, a3, a2, a1, a0)

               CALL fix_polynomial(a3, a2, a1, a0, [x1, x2, x3, x4], [f10, f20, f30, f40])
               findx = polynomial(x, a3, a2, a1, a0)

               ! Final result is an average over each direction

            ELSE

               findx = findy

            END IF

            find_2D = (findx+findy)/2.

         END IF

      ELSE

         WRITE(*, *) 'FIND_2D: Order:', iorder
         STOP 'FIND_2D: Order not supported'

      END IF

   END FUNCTION find_2D

   REAL FUNCTION find_3D(x, xin, y, yin, z, zin, fin, nx, ny, nz, iorder, ifindx, ifindy, ifindz, iinterp)

      ! A 3D interpolation routine to find value f(x,y,z) given a function evalated on arrays
      ! The linear version implemented here is also know as 'trilinear interpolation'
      INTEGER, INTENT(IN) :: nx
      INTEGER, INTENT(IN) :: ny
      INTEGER, INTENT(IN) :: nz
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: xin(nx)
      REAL, INTENT(IN) :: y
      REAL, INTENT(IN) :: yin(ny)
      REAL, INTENT(IN) :: z
      REAL, INTENT(IN) :: zin(nz)
      REAL, INTENT(IN) :: fin(nx, ny, nz)
      INTEGER, INTENT(IN) :: iorder
      INTEGER, INTENT(IN) :: ifindx
      INTEGER, INTENT(IN) :: ifindy
      INTEGER, INTENT(IN) :: ifindz
      INTEGER, INTENT(IN) :: iinterp
      REAL :: xx(3), x12(3, 2), Dx(3)
      INTEGER :: ix(3), ix12(3, 2), nnx(3)
      INTEGER :: i, j, k, ii, jj, kk, d, di
      REAL :: F(2, 2, 2)
      REAL :: V(2, 2, 2)

      ! If the value required is off the table edge then this will halt

      ! iorder = 0 => nearest-neighbour interpolation
      ! iorder = 1 => linear interpolation

      ! ifind = 1 => find x in xtab by crudely searching from x(1) to x(n)
      ! ifind = 2 => find x in xtab quickly assuming the table is linearly spaced
      ! ifind = 3 => find x in xtab using midpoint splitting (iterations=ceiling(log2(n)))

      ! iinterp = 1 => Use polynomials for interpolation

      IF (iinterp .NE. 1) STOP 'FIND_3D: No Lagrange polynomials for you, only regular polynomails, iinterp=1'

      IF (xin(1) > xin(nx)) STOP 'FIND_3D: x array in wrong order'
      IF (yin(1) > yin(ny)) STOP 'FIND_3D: y array in wrong order'
      IF (zin(1) > zin(nz)) STOP 'FIND_3D: z array in wrong order'

      IF(iorder == 0) THEN

         DO d = 1, 3
            IF(d == 1) ix(d) = find_table_integer(x, xin, ifindx)
            IF(d == 2) ix(d) = find_table_integer(y, yin, ifindy)
            IF(d == 3) ix(d) = find_table_integer(z, zin, ifindz)
         END DO

         DO d = 1, 3
            IF(ix(d) == 0) ix(d)=1
         END DO

         find_3D = fin(ix(1), ix(2), ix(3))

      ELSE IF (iorder == 1) THEN

         xx(1) = x
         xx(2) = y
         xx(3) = z

         nnx(1) = nx
         nnx(2) = ny
         nnx(3) = nz

         DO d = 1, 3
            IF (nnx(d) < 2) STOP 'FIND_3D: Not enough points in your array for linear interpolation'
         END DO

         !! Get the x,y,z values !!

         ! Get the integer coordinates in each direction
         DO d = 1, 3

            ! Get the integer coordinates of the 'cube' corners that encompass the point in each dimensions
            IF(d == 1) ix(1) = find_table_integer(x, xin, ifindx)
            IF(d == 2) ix(2) = find_table_integer(y, yin, ifindy)
            IF(d == 3) ix(3) = find_table_integer(z, zin, ifindz)

            ! Correct for the case of these integers coordinates being at the edge of the box
            IF(ix(d) == 0) THEN
               ix(d) = 1
            ELSE IF(ix(d) == nnx(d)) THEN
               ix(d) = nnx(d)-1
            END IF
            ix12(d, 1) = ix(d)
            ix12(d, 2) = ix(d)+1

            ! Get the function value at the corners of the 'cube'
            IF(d == 1) THEN
               x12(d, 1) = xin(ix12(d, 1))
               x12(d, 2) = xin(ix12(d, 2))
            ELSE IF(d == 2) THEN
               x12(d, 1) = yin(ix12(d, 1))
               x12(d, 2) = yin(ix12(d, 2))
            ELSE IF(d == 3) THEN
               x12(d, 1) = zin(ix12(d, 1))
               x12(d, 2) = zin(ix12(d, 2))
            END IF

         END DO 

         ! Do the interpolation
         DO k = 1, 2
            DO j = 1, 2
               DO i = 1, 2

                  ! Evaluate the function at the cube corners
                  F(i, j, k) = fin(ix12(1, i), ix12(2, j), ix12(3, k))

                  ! Calculate the volume of the solid in the opposite corner
                  ii = 3-i ! Swaps 1 <--> 2 (e.g., ii is 2 if i is 1 and visa versa)
                  jj = 3-j ! Swaps 1 <--> 2
                  kk = 3-k ! Swaps 1 <--> 2
                  DO d = 1, 3
                     IF(d == 1) THEN
                        di = ii
                     ELSE IF(d == 2) THEN
                        di = jj
                     ELSE IF(d == 3) THEN
                        di = kk
                     ELSE
                        STOP 'FIND_3D: Error, something is very wrong'
                     END IF
                     Dx(d) = (x12(d,di)-xx(d))*(2*di-3) ! Last part gets the sign right (x2-x) or (x-x1), not negatives (x-x2)!!
                  END DO

                  ! Weight the corner function values by their corresponding weights (opposite cubeoid)
                  V(i, j, k) = F(i, j, k)
                  DO d = 1, 3
                     V(i, j, k)=V(i, j, k)*Dx(d)
                  END DO

               END DO
            END DO
         END DO

         ! Finally normalise the result by dividing by the cube volume
         find_3D = sum(V)
         DO d = 1,3
            find_3D = find_3D/(x12(d,2)-x12(d,1))
         END DO

      ELSE

         STOP 'FIND_3D: order for interpolation not specified correctly, only linear implemented'

      END IF

   END FUNCTION find_3D

   SUBROUTINE interpolate_array(x_old, y_old, x_new, y_new, iorder, ifind, iinterp, logx, logy)

      ! Interpolates array 'x1-y1' onto new 'x' values x2 and output y2
      ! TODO: This could be more efficient because it currently does 'find integer' every time
      REAL, INTENT(IN) :: x_old(:)
      REAL, INTENT(IN) :: y_old(:)
      REAL, INTENT(IN) :: x_new(:)
      REAL, INTENT(OUT) :: y_new(:)
      INTEGER, INTENT(IN) :: iorder
      INTEGER, INTENT(IN) :: ifind
      INTEGER, INTENT(IN) :: iinterp
      LOGICAL, OPTIONAL, INTENT(IN) :: logx
      LOGICAL, OPTIONAL, INTENT(IN) :: logy
      REAL, ALLOCATABLE :: xx_old(:), yy_old(:)
      REAL :: xx
      INTEGER :: i, n_old, n_new

      n_old = size(x_old)
      IF (n_old /= size(y_old)) STOP 'INTERPOLATE_ARRAY: error, x_old and y_old must be the same size'

      n_new = size(x_new)
      IF (n_new /= size(y_new)) STOP 'INTERPOLATE_ARRAY: error, x_new and y_new must be the same size'

      IF (present_and_correct(logx)) THEN
         xx_old = log(x_old)
      ELSE
         xx_old = x_old
      END IF

      IF (present_and_correct(logy)) THEN
         yy_old = log(y_old)
      ELSE
         yy_old = y_old
      END IF
    
      DO i = 1, n_new
         IF (present_and_correct(logx)) THEN
            xx = log(x_new(i))
         ELSE
            xx = x_new(i)
         END IF
         y_new(i) = find(xx, xx_old, yy_old, n_old, iorder, ifind, iinterp)
      END DO

      IF (present_and_correct(logy)) THEN
         y_new = exp(y_new)
      END IF

   END SUBROUTINE interpolate_array

   SUBROUTINE rebin_array(xmin_new, xmax_new, n_new, x, f, iorder, ifind, iinterp, logx, logf)

      ! TODO: Remove. Interpolate array should be sufficient
      REAL, INTENT(IN) :: xmin_new
      REAL, INTENT(IN) :: xmax_new
      INTEGER, INTENT(IN) :: n_new
      REAL, ALLOCATABLE, INTENT(INOUT) :: x(:)
      REAL, ALLOCATABLE, INTENT(INOUT) :: f(:)
      INTEGER, INTENT(IN) :: iorder
      INTEGER, INTENT(IN) :: ifind
      INTEGER, INTENT(IN) :: iinterp
      LOGICAL, OPTIONAL, INTENT(IN) :: logx
      LOGICAL, OPTIONAL, INTENT(IN) :: logf
      REAL, ALLOCATABLE :: x_old(:), f_old(:)
      INTEGER :: n_old

      n_old = size(x)
      IF (n_old /= size(f, 1)) STOP 'REBIN_ARRAY: Error, x and f must be the same size'

      x_old = x
      f_old = f

      IF (present_and_correct(logx)) THEN
         CALL fill_array_log(xmin_new, xmax_new, x, n_new)
      ELSE
         CALL fill_array(xmin_new, xmax_new, x, n_new)
      END IF
      DEALLOCATE(f)
      ALLOCATE(f(n_new))

      CALL interpolate_array(x_old, f_old, x, f, iorder, ifind, iinterp, logx, logf)

   END SUBROUTINE rebin_array

   SUBROUTINE init_interpolator_1D(x, f, interp, iorder, iextrap, store, logx, logf)

      ! Initialise an interpolator
      ! TODO: Should be loops and arrays rather than x1, x2, x3, x4 etc.
      REAL, INTENT(IN) :: x(:)                  ! Input data x
      REAL, INTENT(IN) :: f(:)                  ! Input data f(x)
      TYPE(interpolator1D), INTENT(OUT) :: interp ! Interpolator type
      INTEGER, INTENT(IN) :: iorder             ! Order at which to create interpolator   
      INTEGER, INTENT(IN) :: iextrap            ! Extrapolation scheme
      LOGICAL, INTENT(IN) :: store              ! Do we store values
      LOGICAL, OPTIONAL, INTENT(IN) :: logx     ! Should interpolator take the logarithm of x?
      LOGICAL, OPTIONAL, INTENT(IN) :: logf     ! Should interpolator take the logarithm of f(x)?
      REAL, ALLOCATABLE :: xx(:), ff(:)
      REAL :: a0, a1, a2, a3
      REAL :: b0, b1, b2
      REAL :: f1, f2, f3, f4
      REAL :: x1, x2, x3, x4
      REAL :: xm
      INTEGER :: i, n, ii, nn
      INTEGER :: i1, i2, i3, i4
      INTEGER, PARAMETER :: ifind_default = ifind_interpolator_default

      ! Should the first and last sections of cubic interpolation be quadratic
      LOGICAL, PARAMETER :: quadratic_end_cubic = .FALSE. 

      ! Deallocate arrays if they are already allocated
      CALL if_allocated_deallocate(interp%x)
      CALL if_allocated_deallocate(interp%x0)
      CALL if_allocated_deallocate(interp%a0)
      CALL if_allocated_deallocate(interp%a1)
      CALL if_allocated_deallocate(interp%a2)
      CALL if_allocated_deallocate(interp%a3)

      ! Check the sizes of the input data arrays
      n = size(x)
      IF (n /= size(f)) STOP 'INIT_INTERPOLATOR_1D: Error, input x and f data should be the same size'
      interp%n = n

      IF (n == 1) THEN
         STOP 'INIT_INTERPOLATOR_1D: Error, array is size 1'
      ELSE IF (n < iorder+1) THEN
         STOP 'INIT_INTERPOLATOR_1D: Error, not enough points for your order of interpolation'
      ELSE

         ! Set the internal variables
         interp%iextrap = iextrap
         interp%iorder = iorder

         ! Fill the internal arrays
         xx = x
         ff = f

         ! Reverse x and f if necessary
         IF (xx(1) > xx(n)) THEN
            CALL reverse_array(xx)
            CALL reverse_array(ff)
         END IF

         ! Set the internal xmin and xmax
         interp%xmin = xx(1)
         interp%xmax = xx(n)

         ! Sort out logs and x arrays
         IF (present_and_correct(logx)) THEN
            xx = log(xx)
            interp%logx = .TRUE.
         ELSE
            interp%logx = .FALSE.
         END IF

         ! Sort out logs and f array
         IF (present_and_correct(logf)) THEN
            ff = log(ff)
            interp%logf = .TRUE.
         ELSE
            interp%logf = .FALSE.
         END IF
         
         ! If the x data is regular spaced then remember this, otherwise default find
         IF (regular_spacing(xx)) THEN
            interp%ifind = ifind_linear
         ELSE
            interp%ifind = ifind_default
         END IF
         interp%store = store

         ! Set the internal 
         interp%x = xx
         interp%f = ff

         IF (interp%store) THEN

            ! Allocate arrays for the interpolator coefficients
            IF (iextrap == iextrap_lin) THEN
               nn = n+1
            ELSE
               nn = n-1
            END IF
            ALLOCATE(interp%a0(nn), interp%a1(nn))
            interp%a0 = 0.
            interp%a1 = 0.
            IF (iorder >= 2) THEN
               ALLOCATE(interp%a2(nn))
               interp%a2 = 0.
            END IF
            IF (iorder >= 3) THEN
               ALLOCATE(interp%a3(nn))
               interp%a3 = 0.
            END IF
            ALLOCATE(interp%x0(nn))

            ! Default values because a3, a2 will be zero for linear polynomials
            a0 = 0.
            a1 = 0.
            a2 = 0.
            a3 = 0.

            ! Default values
            x1 = 0.
            x2 = 0.
            x3 = 0.
            x4 = 0.
            
            ! Default values
            f1 = 0.
            f2 = 0.
            f3 = 0.
            f4 = 0.

            ! Loop over all n-1 sections of the input data
            DO i = 0, n

               IF ((i == 0 .OR. i == n) .AND. iextrap /= iextrap_lin) CYCLE

               IF (iorder == 1 .OR. ((i == 0 .OR. i == n) .AND. iextrap == iextrap_lin)) THEN

                  IF (i == 0) THEN
                     i1 = 1
                     i2 = 2
                  ELSE IF (i == n) THEN
                     i1 = n-1
                     i2 = n
                  ELSE
                     i1 = i
                     i2 = i+1
                  END IF

                  x1 = xx(i1)
                  x2 = xx(i2)

                  f1 = ff(i1)
                  f2 = ff(i2)
                  
                  xm = (x1+x2)/2.
                  CALL fix_centred_polynomial(a1, a0, xm, [x1, x2], [f1, f2])

               ELSE IF (iorder == 2) THEN

                  i1 = i-1
                  i2 = i
                  i3 = i+1
                  i4 = i+2
                  IF (i == 1) THEN
                     i1 = i1+1
                     i2 = i2+1
                     i3 = i3+1
                     i4 = 0
                  ELSE IF (i == n-1) THEN
                     i1 = i1-1
                     i2 = i2-1
                     i3 = i3-1
                     i4 = 0
                  END IF

                  x1 = xx(i1)
                  x2 = xx(i2)
                  x3 = xx(i3)
                  IF (i4 .NE. 0) x4 = xx(i4)

                  f1 = ff(i1)
                  f2 = ff(i2)
                  f3 = ff(i3)
                  IF (i4 .NE. 0) f4 = ff(i4)

                  CALL fix_polynomial(a2, a1, a0, [x1, x2, x3], [f1, f2, f3])
                  IF (i4 .NE. 0) THEN
                     CALL fix_polynomial(b2, b1, b0, [x2, x3, x4], [f2, f3, f4])
                     a2 = (a2+b2)/2.
                     a1 = (a1+b1)/2.
                     a0 = (a0+b0)/2.
                  END IF

               ELSE IF (iorder == 3) THEN

                  ! Deal with the indices for the first and last section and general case
                  i1 = i-1
                  i2 = i
                  i3 = i+1
                  i4 = i+2
                  IF (i == 1) THEN
                     ! Should be 1, 2, 3, 4
                     i1 = i1+1
                     i2 = i2+1 
                     i3 = i3+1 
                     i4 = i4+1 
                  ELSE IF (i == n-1) THEN
                     ! Should be n-3, n-2, n-1, n
                     i1 = i1-1
                     i2 = i2-1
                     i3 = i3-1
                     i4 = i4-1
                  END IF

                  x1 = xx(i1)
                  x2 = xx(i2)
                  x3 = xx(i3)
                  x4 = xx(i4)

                  f1 = ff(i1)
                  f2 = ff(i2)
                  f3 = ff(i3)
                  f4 = ff(i4)

                  xm = (xx(i)+xx(i+1))/2.
                  IF (quadratic_end_cubic .AND. i == 1) THEN
                     CALL fix_centred_polynomial(a2, a1, a0, xm, [x1, x2, x3], [f1, f2, f3]) 
                     a3 = 0.
                  ELSE IF (quadratic_end_cubic .AND. i == n-1) THEN
                     CALL fix_centred_polynomial(a2, a1, a0, xm, [x2, x3, x4], [f2, f3, f4]) 
                     a3 = 0.
                  ELSE
                     CALL fix_centred_polynomial(a3, a2, a1, a0, xm, [x1, x2, x3, x4], [f1, f2, f3, f4])  
                  END IF    

               ELSE

                  STOP 'INIT_INTERPOLATOR: Error, your order is not supported'

               END IF

               ! Fill the polynomial coefficients in the interpolation type
               IF (iextrap == iextrap_lin) THEN
                  ii = i+1
               ELSE
                  ii = i
               END IF
               interp%x0(ii) = xm
               interp%a0(ii) = a0
               interp%a1(ii) = a1
               IF(iorder >= 2 .AND. (i .NE. 0 .AND. i .NE. n)) interp%a2(ii) = a2
               IF(iorder >= 3 .AND. (i .NE. 0 .AND. i .NE. n)) interp%a3(ii) = a3

            END DO

         END IF

      END IF

   END SUBROUTINE init_interpolator_1D

   REAL FUNCTION evaluate_interpolator_1D(x, interp)

      ! Evaluates the value f(x) from the interpolator
      REAL, INTENT(IN) :: x
      TYPE(interpolator1D), INTENT(IN) :: interp
      INTEGER :: i, n
      REAL :: xx

      ! Change input x to log if necessary
      xx = x
      IF (interp%logx) xx = log(xx)

      n = interp%n

      IF (interp%store) THEN

         ! Calculate the index to use
         IF (xx < interp%x(1)) THEN
            IF (interp%iextrap == iextrap_no) THEN
               STOP 'EVALUATE_INTERPOLATOR_1D: Error, desired x value is below range'
            ELSE IF(interp%iextrap == iextrap_std) THEN
               i = 1
            ELSE IF (interp%iextrap == iextrap_lin) THEN
               i = 0
            ELSE IF (interp%iextrap == iextrap_zero) THEN
               evaluate_interpolator_1D = 0.
               RETURN
            ELSE IF (interp%iextrap == iextrap_near) THEN
               evaluate_interpolator_1D = interp%f(1)
               IF (interp%logf) evaluate_interpolator_1D = exp(evaluate_interpolator_1D)
               RETURN
            ELSE
               STOP 'EVALUATE_INTERPOLATOR_1D: Error, extrapolation scheme specified incorrectly'
            END IF
         ELSE IF (xx == interp%x(n)) THEN
            i = n-1 ! Cannot use find_table_integer here because this would return 'n', rather than 'n-1'
         ELSE IF (xx > interp%x(n)) THEN
            IF (interp%iextrap == iextrap_no) THEN
               STOP 'EVALUATE_INTERPOLATOR_1D: Error, desired x value is above range'
            ELSE IF (interp%iextrap == iextrap_std) THEN
               i = n-1
            ELSE IF(interp%iextrap == iextrap_lin) THEN
               i = n
            ELSE IF (interp%iextrap == iextrap_zero) THEN
               evaluate_interpolator_1D = 0.
               RETURN
            ELSE IF (interp%iextrap == iextrap_near) THEN
               evaluate_interpolator_1D = interp%f(n)
               RETURN
            ELSE
               STOP 'EVALUATE_INTERPOLATOR_1D: Error, extrapolation scheme specified incorrectly'
            END IF
         ELSE
            i = find_table_integer(xx, interp%x, interp%ifind)
         END IF

         IF (interp%iextrap == iextrap_lin) i = i+1

         ! Evaluate the interpolation
         IF (interp%iorder == 1) THEN
            evaluate_interpolator_1D = centred_polynomial(xx, interp%x0(i), interp%a1(i), interp%a0(i))
         ELSE IF (interp%iorder == 2) THEN
            evaluate_interpolator_1D = centred_polynomial(xx, interp%x0(i), interp%a2(i), interp%a1(i), interp%a0(i))
         ELSE IF (interp%iorder == 3) THEN
            evaluate_interpolator_1D = centred_polynomial(xx, interp%x0(i), interp%a3(i), interp%a2(i), interp%a1(i), interp%a0(i))
         ELSE
            STOP 'EVALUATE_INTERPOLATOR_1D: Error, your polynomial order is not supported'
         END IF

      ELSE
         evaluate_interpolator_1D = find(xx, interp%x, interp%f, interp%n, interp%iorder, interp%ifind, iinterp_Lagrange)
      END IF

      ! Exponentiate result if necessary
      IF (interp%logf) evaluate_interpolator_1D = exp(evaluate_interpolator_1D)

   END FUNCTION evaluate_interpolator_1D

   REAL FUNCTION inverse_interpolator_1D(f, interp)

      ! If y = f(x) this returns x = f^-1(y), where y = f
      REAL, INTENT(IN) :: f
      TYPE(interpolator1D), INTENT(IN) :: interp
      REAL :: ff, x
      INTEGER :: ifind = ifind_inverse_interpolator
      INTEGER :: iinterp = iinterp_inverse_interpolator

      IF (interp%logf) ff = log(f)
      x = find(ff, interp%f, interp%x, interp%n, interp%iorder, ifind, iinterp)

      IF(interp%logx) THEN
         inverse_interpolator_1D = exp(x)
      ELSE
         inverse_interpolator_1D = x
      END IF

   END FUNCTION inverse_interpolator_1D

   SUBROUTINE init_interpolator_2D(x, y, f, interp, iorder, iextrap, store, logx, logy, logf)

      ! Initialise a 2D interpolator
      ! TODO: Should end sections be quadratic when doing cubic interpolation?
      ! TODO: Linear extrapolation unnecessarily fills entire centre of array with linear interpolation
      ! TODO: Linear extrapolation only needs to do rows ix = 1, nx-1, nx and same for y
      REAL, INTENT(IN) :: x(:)                    ! Input data x
      REAL, INTENT(IN) :: y(:)                    ! Input data y
      REAL, INTENT(IN) :: f(:, :)                 ! Input data f(x, y)
      TYPE(interpolator2D), INTENT(OUT) :: interp ! Interpolator type
      INTEGER, INTENT(IN) :: iorder               ! Order at which to create interpolator     
      INTEGER, INTENT(IN) :: iextrap              ! Should interpolator extrapolate beyond x and y?
      LOGICAL, INTENT(IN) :: store                ! Should we store polynomial coefficients?
      LOGICAL, OPTIONAL, INTENT(IN) :: logx       ! Should interpolator take the logarithm of x?
      LOGICAL, OPTIONAL, INTENT(IN) :: logy       ! Should interpolator take the logarithm of y?
      LOGICAL, OPTIONAL, INTENT(IN) :: logf       ! Should interpolator take the logarithm of f?
      INTEGER :: ix, iy, nx, ny
      INTEGER :: jx(4), jy(4)
      INTEGER :: i
      REAL :: xx(4), yy(4), fx(4), fy(4)
      REAL :: x0, y0
      REAL :: a0, a1, a2, a3
      INTEGER, PARAMETER :: ifind_default = ifind_interpolator_default

      CALL if_allocated_deallocate(interp%x)
      CALL if_allocated_deallocate(interp%y)
      CALL if_allocated_deallocate(interp%f)
      CALL if_allocated_deallocate(interp%ax0)
      CALL if_allocated_deallocate(interp%ax1)
      CALL if_allocated_deallocate(interp%ax2)
      CALL if_allocated_deallocate(interp%ax3)
      CALL if_allocated_deallocate(interp%ay0)
      CALL if_allocated_deallocate(interp%ay1)
      CALL if_allocated_deallocate(interp%ay2)
      CALL if_allocated_deallocate(interp%ay3)

      IF (iorder > 3 .OR. iorder < 0) STOP 'INIT_INTERPOLATOR_2D: Error, this order is not supported'

      ! Check array sizes
      nx = size(x)
      IF(nx /= size(f, 1)) STOP 'INIT_INTERPOLATOR_2D: Error, x should be the same size as first dimension of f'
      interp%nx = nx
      ny = size(y)
      IF(ny /= size(f, 2)) STOP 'INIT_INTERPOLATOR_2D: Error, y should be the same size as second dimension of f'
      interp%ny = ny

      IF (nx == 1 .AND. ny == 1) THEN
         STOP 'INIT_INTERPOLATOR_2D: Error, your array is 1 x 1'
      ELSE IF (nx == 1) THEN
         CALL init_interpolator_1D(y, f(1, :), interp%interp1D, iorder, iextrap, store, logy, logf)
      ELSE IF (ny == 1) THEN
         CALL init_interpolator_1D(x, f(:, 1), interp%interp1D, iorder, iextrap, store, logx, logf)
      ELSE IF (nx < iorder+1 .OR. ny < iorder+1) THEN
         STOP 'INIT_INTERPOLATOR_2D: Error, you do not have enough points for the order of interpolatation'
      ELSE

         ! Sort out x axis      
         IF(present_and_correct(logx)) THEN
            interp%x = log(x)
            interp%logx = .TRUE.
         ELSE
            interp%x = x
            interp%logx = .FALSE.
         END IF
         IF (regular_spacing(interp%x)) THEN
            interp%ifindx = ifind_linear
         ELSE
            interp%ifindx = ifind_default
         END IF

         ! Sort out y axis     
         IF(present_and_correct(logy)) THEN
            interp%y = log(y)
            interp%logy = .TRUE.
         ELSE
            interp%y = y
            interp%logy = .FALSE.
         END IF
         IF (regular_spacing(interp%y)) THEN
            interp%ifindy = ifind_linear
         ELSE
            interp%ifindy = ifind_default
         END IF

         ! Sort out f
         IF(present_and_correct(logf)) THEN
            interp%f = log(f)
            interp%logf = .TRUE.
         ELSE
            interp%f = f
            interp%logf = .FALSE.
         END IF

         ! Reverse arrays if necessary
         IF (interp%x(1) > interp%x(nx)) THEN
            CALL reverse_array(interp%x)
            CALL reverse_array(interp%f, 1)
         END IF
         IF (interp%y(1) > interp%y(ny)) THEN
            CALL reverse_array(interp%y)
            CALL reverse_array(interp%f, 2)
         END IF

         ! Set the interp%xmin, xmax, ymin, ymax values
         interp%xmin = interp%x(1)
         interp%xmax = interp%x(nx)
         interp%ymin = interp%y(1)
         interp%ymax = interp%y(ny)
         IF (interp%logx) THEN
            interp%xmin = exp(interp%xmin)
            interp%xmax = exp(interp%xmax)
         END IF
         IF (interp%logy) THEN
            interp%ymin = exp(interp%ymin)
            interp%ymax = exp(interp%ymax)
         END IF

         ! Set internal variables
         interp%iorder = iorder
         interp%iextrap = iextrap
         interp%store = store

         IF (interp%store) THEN 

            ALLOCATE(interp%x0(nx-1, ny), interp%y0(nx, ny-1))
            ALLOCATE(interp%ax0(nx-1, ny), interp%ax1(nx-1, ny), interp%ax2(nx-1, ny), interp%ax3(nx-1, ny))
            ALLOCATE(interp%ay0(nx, ny-1), interp%ay1(nx, ny-1), interp%ay2(nx, ny-1), interp%ay3(nx, ny-1))
            interp%x0 = 0.
            interp%ax0 = 0.
            interp%ax1 = 0.
            interp%ax2 = 0.
            interp%ax3 = 0.
            interp%y0 = 0.
            interp%ay0 = 0.
            interp%ay1 = 0.
            interp%ay2 = 0.
            interp%ay3 = 0.
            
            IF ((interp%iorder == 1) .OR. (iextrap == iextrap_lin)) THEN

               DO iy = 1, ny

                  ! TODO: This should work, but it does not
                  !IF (iorder > 1 .AND. iy > 2 .AND. iy < ny-1) CYCLE

                  DO ix = 1, nx

                     ! TODO: This should work, but it does not
                     !IF (iorder > 1 .AND. ix > 2 .AND. ix < nx-1) CYCLE

                     IF (ix /= nx) THEN

                        ! Indices run sequentially but must be within 1, nx
                        DO i = 1, 2
                           jx(i) = ix+i-1
                        END DO

                        ! Get x values and function values running along x direction
                        DO i = 1, 2
                           xx(i) = interp%x(jx(i))
                           fx(i) = interp%f(jx(i), iy)
                        END DO

                        ! Calculate the mid point for polynomial
                        x0 = (xx(1)+xx(2))/2.
                        interp%x0(ix, iy) = x0

                        ! Fix polynomial along the x direction
                        CALL fix_centred_polynomial(a1, a0, x0, xx, fx)
                        interp%ax1(ix, iy) = a1
                        interp%ax0(ix, iy) = a0

                     END IF

                     IF (iy /= ny) THEN

                        ! Indices run sequentially but must be within 1, ny
                        DO i = 1, 2
                           jy(i) = iy+i-1
                        END DO

                        ! Get y values and function values running along y direction
                        DO i = 1, 2
                           yy(i) = interp%y(jy(i))
                           fy(i) = interp%f(ix, jy(i))
                        END DO

                        ! Calculate the mid point for polynomial
                        y0 = (yy(1)+yy(2))/2.
                        interp%y0(ix, iy) = y0

                        ! Fix polynomial along the y direction
                        CALL fix_centred_polynomial(a1, a0, y0, yy, fy)
                        interp%ay1(ix, iy) = a1
                        interp%ay0(ix, iy) = a0

                     END IF

                  END DO
               END DO

               IF ((iextrap == iextrap_lin) .AND. (iorder > 1)) THEN

                  interp%bx0 = interp%ax0
                  interp%by0 = interp%ay0
                  interp%bx1 = interp%ax1
                  interp%by1 = interp%ay1
                  interp%xl0 = interp%x0
                  interp%yl0 = interp%y0

               END IF

            END IF

            IF (interp%iorder == 2 .OR. interp%iorder == 3) THEN

               DO iy = 1, ny
                  DO ix = 1, nx

                     IF (ix /= nx) THEN

                        ! Indices run sequentially but must be within 1, nx
                        DO i = 1, 4
                           jx(i) = ix+(i-2)
                        END DO
                        IF (ix == 1)    jx = jx+1
                        IF (ix == nx-1) jx = jx-1

                        ! Get x values and function values running along x direction
                        DO i = 1, 4
                           xx(i) = interp%x(jx(i))
                           fx(i) = interp%f(jx(i), iy)
                        END DO

                        ! Calculate the mid point for polynomial
                        x0 = (xx(2)+xx(3))/2.
                        interp%x0(ix, iy) = x0

                        ! Fix polynomial along the x direction
                        CALL fix_centred_polynomial(a3, a2, a1, a0, x0, xx, fx)
                        interp%ax3(ix, iy) = a3
                        interp%ax2(ix, iy) = a2
                        interp%ax1(ix, iy) = a1
                        interp%ax0(ix, iy) = a0

                     END IF

                     IF (iy /= ny) THEN

                        ! Indices run sequentially but must be within 1, ny
                        DO i = 1, 4
                           jy(i) = iy+(i-2)
                        END DO
                        IF (iy == 1)    jy = jy+1
                        IF (iy == ny-1) jy = jy-1

                        ! Get y values and function values running along y direction
                        DO i = 1, 4
                           yy(i) = interp%y(jy(i))
                           fy(i) = interp%f(ix, jy(i))
                        END DO

                        ! Calculate the mid point for polynomial
                        y0 = (yy(2)+yy(3))/2.
                        interp%y0(ix, iy) = y0

                        ! Fix polynomial along the y direction
                        CALL fix_centred_polynomial(a3, a2, a1, a0, y0, yy, fy)
                        interp%ay3(ix, iy) = a3
                        interp%ay2(ix, iy) = a2
                        interp%ay1(ix, iy) = a1
                        interp%ay0(ix, iy) = a0

                     END IF

                  END DO
               END DO

            END IF
            
         END IF

      END IF

   END SUBROUTINE init_interpolator_2D

   REAL FUNCTION evaluate_interpolator_2D(x, y, interp)

      ! TODO: Quadratics at end sections?
      ! TODO: Should linear interpolation turn of xycubic?
      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: y
      TYPE(interpolator2D), INTENT(IN) :: interp
      INTEGER, PARAMETER :: iinterp = iinterp_polynomial ! No Lagrange polynomials in 2D
      INTEGER :: ix, iy, nx, ny, i, j, mx, my
      REAL :: xx, yy, ffx, ffy
      REAL :: a3, a2, a1, a0, x0, y0
      INTEGER, ALLOCATABLE :: jx(:), jy(:)
      REAL, ALLOCATABLE :: fx(:), fy(:), xxx(:), yyy(:)
      LOGICAL :: outx, outy
      LOGICAL, PARAMETER :: xycubic = .FALSE.

      xx = x
      IF (interp%logx) xx = log(xx)
      nx = interp%nx

      yy = y
      IF (interp%logy) yy = log(yy)
      ny = interp%ny

      IF (nx == 1) THEN

         ! Function is actually 1D in y, so evaluate this
         evaluate_interpolator_2D = evaluate_interpolator_1D(y, interp%interp1D)

      ELSE IF (ny == 1) THEN

         ! Function is actually 1D in x, so evaluate this
         evaluate_interpolator_2D = evaluate_interpolator_1D(x, interp%interp1D)

      ELSE IF (interp%store) THEN

         IF (xx < interp%x(1) .OR. xx > interp%x(nx)) THEN
            outx = .TRUE.
         ELSE
            outx = .FALSE.
            END IF
         IF (yy < interp%y(1) .OR. yy > interp%y(ny)) THEN
            outy = .TRUE.
         ELSE
            outy = .FALSE.
         END IF

         IF (outx .OR. outy) THEN
            IF (interp%iextrap == iextrap_no) THEN
               STOP 'EVALUATE_INTERPOLATOR_2D: Error, point is outside interpolator range'
            ELSE IF (interp%iextrap == iextrap_zero) THEN
               evaluate_interpolator_2D = 0.
               RETURN
            ELSE IF (interp%iextrap == iextrap_near) THEN
               ix = find_table_integer(xx, interp%x, interp%ifindx)
               iy = find_table_integer(yy, interp%y, interp%ifindy)
               evaluate_interpolator_2D = interp%f(ix, iy)
               IF(interp%logf) evaluate_interpolator_2D = exp(evaluate_interpolator_2D)
               RETURN
            END IF
         END IF

         IF (interp%iorder == 1 .OR. interp%iorder == 2) THEN
            mx = 2
            my = 2
         ELSE IF (interp%iorder == 3) THEN
            IF (outx) THEN
               mx = 2
            ELSE
               mx = 4
            END IF
            IF (outy) THEN
               my = 2
            ELSE
               my = 4
            END IF
         ELSE
            STOP 'EVALUATE_INTERPOLATOR_2D: Error, something went wrong with iorder'
         END IF
         ALLOCATE(jx(mx), fx(mx), xxx(mx))
         ALLOCATE(jy(my), fy(my), yyy(my))

         ix = find_table_integer(xx, interp%x, interp%ifindx)
         IF (ix == 0)  ix = 1
         IF (ix == nx) ix = nx-1
         IF (mx == 2) THEN
            jx(1) = ix
            jx(2) = ix+1
         ELSE IF (mx == 4) THEN
            DO i = 1, mx
               jx(i) = ix+(i-2)
            END DO
            IF (ix == 1)    jx = jx+1
            IF (ix == nx-1) jx = jx-1  
         ELSE
            STOP 'EVALUATE_INTERPOLATOR_2D: Error, something went wrong with iorder'
         END IF

         iy = find_table_integer(yy, interp%y, interp%ifindy)
         IF (iy == 0)  iy = 1
         IF (iy == ny) iy = ny-1
         IF (my == 2) THEN
            jy(1) = iy
            jy(2) = iy+1
         ELSE IF (my == 4) THEN 
            DO i = 1, my
               jy(i) = iy+(i-2)
            END DO 
            IF (iy == 1)    jy = jy+1
            IF (iy == ny-1) jy = jy-1
         ELSE
            STOP 'EVALUATE_INTERPOLATOR_2D: Error, something went wrong with iorder'
         END IF
         
         DO i = 1, mx
            j = jx(i)
            xxx(i) = interp%x(j)
            IF (interp%iorder .NE. 1 .AND. interp%iextrap == iextrap_lin .AND. outy) THEN
               y0 = interp%yl0(j, iy)
               a3 = 0.
               a2 = 0.
               a1 = interp%by1(j, iy)
               a0 = interp%by0(j, iy)
            ELSE
               y0 = interp%y0(j, iy)
               a3 = interp%ay3(j, iy)
               a2 = interp%ay2(j, iy)
               a1 = interp%ay1(j, iy)
               a0 = interp%ay0(j, iy)
            END IF
            fx(i) = centred_polynomial(yy, y0, a3, a2, a1, a0)
         END DO
         ffy = Lagrange_polynomial(xx, xxx, fx)

         IF (xycubic) THEN
            DO i = 1, my
               j = jy(i)
               yyy(i) = interp%y(j)
               IF (interp%iorder .NE. 1 .AND. interp%iextrap == iextrap_lin .AND. outx) THEN
                  x0 = interp%xl0(ix, j)
                  a3 = 0.
                  a2 = 0.
                  a1 = interp%bx1(ix, j)
                  a0 = interp%bx0(ix, j)
               ELSE
                  x0 = interp%x0(ix, j)
                  a3 = interp%ax3(ix, j)
                  a2 = interp%ax2(ix, j)
                  a1 = interp%ax1(ix, j)
                  a0 = interp%ax0(ix, j)
               END IF
               fy(i) = centred_polynomial(xx, x0, a3, a2, a1, a0)                  
            END DO
            ffx = Lagrange_polynomial(yy, yyy, fy)
         ELSE
            ffx = ffy               
         END IF

         evaluate_interpolator_2D = (ffx+ffy)/2.
         IF (interp%logf) evaluate_interpolator_2D = exp(evaluate_interpolator_2D)

      ELSE

         evaluate_interpolator_2D = find(xx, interp%x, yy, interp%y, interp%f, interp%nx, interp%ny, &
                     interp%iorder, &
                     interp%ifindx, &
                     interp%ifindy, &
                     iinterp) 
         IF (interp%logf) evaluate_interpolator_2D = exp(evaluate_interpolator_2D)

      END IF

   END FUNCTION evaluate_interpolator_2D

   SUBROUTINE init_interpolator_3D(x, y, z, f, interp, iorder, iextrap, store, logx, logy, logz, logf)

      ! Initialise a 3D interpolator
      ! TODO: Checks on array sizes
      ! TODO: Remove unnecessary ALLOCATE statements
      REAL, INTENT(IN) :: x(:)                    ! Input data x
      REAL, INTENT(IN) :: y(:)                    ! Input data y
      REAL, INTENT(IN) :: z(:)                    ! Input data z
      REAL, INTENT(IN) :: f(:, :, :)              ! Input data f(x, y, z)
      TYPE(interpolator3D), INTENT(OUT) :: interp ! Interpolator type
      INTEGER, INTENT(IN) :: iorder               ! Order at which to create interpolator     
      INTEGER, INTENT(IN) :: iextrap              ! Should interpolator extrapolate beyond x and y?
      LOGICAL, INTENT(IN) :: store                ! Should we store polynomial coefficients?
      LOGICAL, OPTIONAL, INTENT(IN) :: logx       ! Should interpolator take the logarithm of x?
      LOGICAL, OPTIONAL, INTENT(IN) :: logy       ! Should interpolator take the logarithm of y?
      LOGICAL, OPTIONAL, INTENT(IN) :: logz       ! Should interpolator take the logarithm of z?
      LOGICAL, OPTIONAL, INTENT(IN) :: logf       ! Should interpolator take the logarithm of f?
      INTEGER :: nx, ny, nz
      INTEGER, PARAMETER :: ifind_default = ifind_interpolator_default

      CALL if_allocated_deallocate(interp%x)
      CALL if_allocated_deallocate(interp%y)
      CALL if_allocated_deallocate(interp%z)
      CALL if_allocated_deallocate(interp%f)

      IF (iorder > 3 .OR. iorder < 0) STOP 'INIT_INTERPOLATOR_2D: Error, this order is not supported'

      ! Sort out x axis
      nx = size(x)
      IF(nx /= size(f, 1)) STOP 'INIT_INTERPOLATOR_2D: Error, x should be the same size as first dimension of f'
      interp%nx = nx
      ALLOCATE(interp%x(nx))
      IF(present_and_correct(logx)) THEN
         interp%x = log(x)
         interp%logx = .TRUE.
      ELSE
         interp%x = x
         interp%logx = .FALSE.
      END IF
      IF (regular_spacing(interp%x)) THEN
         interp%ifindx = ifind_linear
      ELSE
         interp%ifindx = ifind_default
      END IF

      ! Sort out y axis
      ny = size(y)
      IF(ny /= size(f, 2)) STOP 'INIT_INTERPOLATOR_3D: Error, y should be the same size as second dimension of f'
      interp%ny = ny
      ALLOCATE(interp%y(ny))
      IF(present_and_correct(logy)) THEN
         interp%y = log(y)
         interp%logy = .TRUE.
      ELSE
         interp%y = y
         interp%logy = .FALSE.
      END IF
      IF (regular_spacing(interp%y)) THEN
         interp%ifindy = ifind_linear
      ELSE
         interp%ifindy = ifind_default
      END IF

      ! Sort out z axis
      nz = size(z)
      IF(nz /= size(f, 3)) STOP 'INIT_INTERPOLATOR_3D: Error, z should be the same size as third dimension of f'
      interp%nz = nz
      ALLOCATE(interp%z(nz))
      IF(present_and_correct(logz)) THEN
         interp%z = log(z)
         interp%logz = .TRUE.
      ELSE
         interp%z = z
         interp%logz = .FALSE.
      END IF
      IF (regular_spacing(interp%z)) THEN
         interp%ifindz = ifind_linear
      ELSE
         interp%ifindz = ifind_default
      END IF

      ! Sort out f
      ALLOCATE(interp%f(nx, ny, nz))
      IF(present_and_correct(logf)) THEN
         interp%f = log(f)
         interp%logf = .TRUE.
      ELSE
         interp%f = f
         interp%logf = .FALSE.
      END IF

      ! Reverse arrays if necessary
      IF (interp%x(1) > interp%x(nx)) THEN
         CALL reverse_array(interp%x)
         CALL reverse_array(interp%f, 1)
      END IF
      IF (interp%y(1) > interp%y(ny)) THEN
         CALL reverse_array(interp%y)
         CALL reverse_array(interp%f, 2)
      END IF
      IF (interp%z(1) > interp%z(nz)) THEN
         CALL reverse_array(interp%z)
         CALL reverse_array(interp%f, 3)
      END IF

      ! Set the interp%xmin, xmax, ymin, ymax values
      interp%xmin = interp%x(1)
      interp%xmax = interp%x(nx)
      interp%ymin = interp%y(1)
      interp%ymax = interp%y(ny)
      interp%zmin = interp%z(1)
      interp%zmax = interp%z(nz)
      IF (interp%logx) THEN
         interp%xmin = exp(interp%xmin)
         interp%xmax = exp(interp%xmax)
      END IF
      IF (interp%logy) THEN
         interp%ymin = exp(interp%ymin)
         interp%ymax = exp(interp%ymax)
      END IF
      IF (interp%logz) THEN
         interp%zmin = exp(interp%zmin)
         interp%zmax = exp(interp%zmax)
      END IF

      ! Set internal variables
      interp%iorder = iorder
      interp%iextrap = iextrap
      interp%store = store

   END SUBROUTINE init_interpolator_3D

   REAL FUNCTION evaluate_interpolator_3D(x, y, z, interp)

      REAL, INTENT(IN) :: x
      REAL, INTENT(IN) :: y
      REAL, INTENT(IN) :: z
      TYPE(interpolator3D), INTENT(IN) :: interp
      REAL :: xx, yy, zz
      INTEGER :: nx, ny, nz
      INTEGER :: iorder
      INTEGER, PARAMETER :: iinterp = iinterp_polynomial ! No Lagrange polynomials in 3D
      LOGICAL, PARAMETER :: xycubic = .FALSE.

      xx = x
      IF (interp%logx) xx = log(xx)
      nx = interp%nx

      yy = y
      IF (interp%logy) yy = log(yy)
      ny = interp%ny

      zz = z
      IF (interp%logz) zz = log(zz)
      nz = interp%nz

      IF (interp%store) THEN

         ! IF (outside_array_range(xx, interp%x) .OR. outside_array_range(yy, interp%y) .OR. outside_array_range(zz, interp%z)) THEN

         !    IF (interp%iextrap == iextrap_no) THEN
         !       STOP 'EVALUATE_INTERPOLATOR_3D: Error, you have requested a point outside the range of the interpolator'
         !    ELSE IF (interp%iextrap == iextrap_zero) THEN
         !       evaluate_interpolator_3D = 0.
         !    ELSE IF (interp%iextrap == iextrap_near) THEN
         !       STOP 'EVALUATE_INTERPOLATOR_3D: Error, nearest extrapolation not implemented yet'
         !    ELSE IF (interp%iextrap == iextrap_lin) THEN
         !       STOP 'EVALUATE_INTERPOLATOR_3D: Error, linear extrapolation not implemented yet'
         !    ELSE IF (interp%iextrap == iextrap_std) THEN
         !       STOP 'EVALUATE_INTERPOLATOR_3D: Error, standard extrapolation not implemented yet'
         !    ELSE
         !       STOP 'EVALUATE_INTERPOLATOR_3D: Something went wrong with extrapolation methods'
         !    END IF

         ! ELSE

         STOP 'EVALUATE_INTERPOLATOR_3D: Storage of interpolator not implemented yet'

         ! END IF

      ELSE

         IF (is_in_array(interp%iextrap, [iextrap_lin, iextrap_no, iextrap_zero, iextrap_near]) .AND. &
            (outside_array_range(xx, interp%x) .OR. outside_array_range(yy, interp%y) .OR. outside_array_range(zz, interp%z))) THEN

            IF (interp%iextrap == iextrap_no) THEN
               STOP 'EVALUATE_INTERPOLATOR_3D: Error, you have requested a point outside the range of the interpolator'
            ELSE IF (interp%iextrap == iextrap_zero) THEN
               evaluate_interpolator_3D = 0.
               RETURN
            ELSE IF (interp%iextrap == iextrap_lin) THEN
               iorder = 1
            ELSE IF (interp%iextrap == iextrap_near) THEN
               iorder = 0
            ELSE
               STOP 'EVALUATE_INTERPOLATOR_3D: Something went wrong with extrapolation methods'
            END IF

         ELSE

            iorder = interp%iorder

         END IF

            evaluate_interpolator_3D = find(xx, interp%x, yy, interp%y, zz, interp%z, interp%f, &
                        interp%nx, interp%ny, interp%nz, &
                        iorder, &
                        interp%ifindx, &
                        interp%ifindy, &
                        interp%ifindz, &
                        iinterp)

      END IF

      IF (interp%logf) evaluate_interpolator_3D = exp(evaluate_interpolator_3D)

   END FUNCTION evaluate_interpolator_3D

END MODULE interpolate
